import Vue from "vue";
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
}
var tuiDatePicker = { exports: {} };
var tuiTimePicker = { exports: {} };
/*!
 * TOAST UI Time Picker
 * @version 2.1.6
 * @license MIT
 */
var hasRequiredTuiTimePicker;
function requireTuiTimePicker() {
  if (hasRequiredTuiTimePicker)
    return tuiTimePicker.exports;
  hasRequiredTuiTimePicker = 1;
  (function(module, exports) {
    (function webpackUniversalModuleDefinition(root, factory) {
      module.exports = factory();
    })(window, function() {
      return function(modules) {
        var installedModules = {};
        function __webpack_require__(moduleId) {
          if (installedModules[moduleId]) {
            return installedModules[moduleId].exports;
          }
          var module2 = installedModules[moduleId] = {
            i: moduleId,
            l: false,
            exports: {}
          };
          modules[moduleId].call(module2.exports, module2, module2.exports, __webpack_require__);
          module2.l = true;
          return module2.exports;
        }
        __webpack_require__.m = modules;
        __webpack_require__.c = installedModules;
        __webpack_require__.d = function(exports2, name, getter) {
          if (!__webpack_require__.o(exports2, name)) {
            Object.defineProperty(exports2, name, { enumerable: true, get: getter });
          }
        };
        __webpack_require__.r = function(exports2) {
          if (typeof Symbol !== "undefined" && Symbol.toStringTag) {
            Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
          }
          Object.defineProperty(exports2, "__esModule", { value: true });
        };
        __webpack_require__.t = function(value, mode) {
          if (mode & 1)
            value = __webpack_require__(value);
          if (mode & 8)
            return value;
          if (mode & 4 && typeof value === "object" && value && value.__esModule)
            return value;
          var ns = /* @__PURE__ */ Object.create(null);
          __webpack_require__.r(ns);
          Object.defineProperty(ns, "default", { enumerable: true, value });
          if (mode & 2 && typeof value != "string")
            for (var key in value)
              __webpack_require__.d(ns, key, function(key2) {
                return value[key2];
              }.bind(null, key));
          return ns;
        };
        __webpack_require__.n = function(module2) {
          var getter = module2 && module2.__esModule ? function getDefault() {
            return module2["default"];
          } : function getModuleExports() {
            return module2;
          };
          __webpack_require__.d(getter, "a", getter);
          return getter;
        };
        __webpack_require__.o = function(object, property) {
          return Object.prototype.hasOwnProperty.call(object, property);
        };
        __webpack_require__.p = "dist";
        return __webpack_require__(__webpack_require__.s = 20);
      }([
        function(module2, exports2, __webpack_require__) {
          var isArray = __webpack_require__(3);
          function inArray(searchElement, array, startIndex) {
            var i;
            var length;
            startIndex = startIndex || 0;
            if (!isArray(array)) {
              return -1;
            }
            if (Array.prototype.indexOf) {
              return Array.prototype.indexOf.call(array, searchElement, startIndex);
            }
            length = array.length;
            for (i = startIndex; startIndex >= 0 && i < length; i += 1) {
              if (array[i] === searchElement) {
                return i;
              }
            }
            return -1;
          }
          module2.exports = inArray;
        },
        function(module2, exports2, __webpack_require__) {
          function forEachArray(arr, iteratee, context) {
            var index = 0;
            var len = arr.length;
            context = context || null;
            for (; index < len; index += 1) {
              if (iteratee.call(context, arr[index], index, arr) === false) {
                break;
              }
            }
          }
          module2.exports = forEachArray;
        },
        function(module2, exports2, __webpack_require__) {
          function extend(target, objects) {
            var hasOwnProp = Object.prototype.hasOwnProperty;
            var source, prop, i, len;
            for (i = 1, len = arguments.length; i < len; i += 1) {
              source = arguments[i];
              for (prop in source) {
                if (hasOwnProp.call(source, prop)) {
                  target[prop] = source[prop];
                }
              }
            }
            return target;
          }
          module2.exports = extend;
        },
        function(module2, exports2, __webpack_require__) {
          function isArray(obj) {
            return obj instanceof Array;
          }
          module2.exports = isArray;
        },
        function(module2, exports2, __webpack_require__) {
          var isArray = __webpack_require__(3);
          var forEachArray = __webpack_require__(1);
          var forEachOwnProperties = __webpack_require__(16);
          function forEach(obj, iteratee, context) {
            if (isArray(obj)) {
              forEachArray(obj, iteratee, context);
            } else {
              forEachOwnProperties(obj, iteratee, context);
            }
          }
          module2.exports = forEach;
        },
        function(module2, exports2, __webpack_require__) {
          function isUndefined(obj) {
            return obj === void 0;
          }
          module2.exports = isUndefined;
        },
        function(module2, exports2, __webpack_require__) {
          function isString(obj) {
            return typeof obj === "string" || obj instanceof String;
          }
          module2.exports = isString;
        },
        function(module2, exports2, __webpack_require__) {
          var inArray = __webpack_require__(0);
          var forEach = __webpack_require__(4);
          var isArray = __webpack_require__(3);
          var isString = __webpack_require__(6);
          var extend = __webpack_require__(2);
          var EXPRESSION_REGEXP = /{{\s?|\s?}}/g;
          var BRACKET_NOTATION_REGEXP = /^[a-zA-Z0-9_@]+\[[a-zA-Z0-9_@"']+\]$/;
          var BRACKET_REGEXP = /\[\s?|\s?\]/;
          var DOT_NOTATION_REGEXP = /^[a-zA-Z_]+\.[a-zA-Z_]+$/;
          var DOT_REGEXP = /\./;
          var STRING_NOTATION_REGEXP = /^["']\w+["']$/;
          var STRING_REGEXP = /"|'/g;
          var NUMBER_REGEXP = /^-?\d+\.?\d*$/;
          var EXPRESSION_INTERVAL = 2;
          var BLOCK_HELPERS = {
            "if": handleIf,
            "each": handleEach,
            "with": handleWith
          };
          var isValidSplit = "a".split(/a/).length === 3;
          var splitByRegExp = function() {
            if (isValidSplit) {
              return function(text, regexp) {
                return text.split(regexp);
              };
            }
            return function(text, regexp) {
              var result = [];
              var prevIndex = 0;
              var match, index;
              if (!regexp.global) {
                regexp = new RegExp(regexp, "g");
              }
              match = regexp.exec(text);
              while (match !== null) {
                index = match.index;
                result.push(text.slice(prevIndex, index));
                prevIndex = index + match[0].length;
                match = regexp.exec(text);
              }
              result.push(text.slice(prevIndex));
              return result;
            };
          }();
          function getValueFromContext(exp, context) {
            var splitedExps;
            var value = context[exp];
            if (exp === "true") {
              value = true;
            } else if (exp === "false") {
              value = false;
            } else if (STRING_NOTATION_REGEXP.test(exp)) {
              value = exp.replace(STRING_REGEXP, "");
            } else if (BRACKET_NOTATION_REGEXP.test(exp)) {
              splitedExps = exp.split(BRACKET_REGEXP);
              value = getValueFromContext(splitedExps[0], context)[getValueFromContext(splitedExps[1], context)];
            } else if (DOT_NOTATION_REGEXP.test(exp)) {
              splitedExps = exp.split(DOT_REGEXP);
              value = getValueFromContext(splitedExps[0], context)[splitedExps[1]];
            } else if (NUMBER_REGEXP.test(exp)) {
              value = parseFloat(exp);
            }
            return value;
          }
          function extractElseif(ifExps, sourcesInsideBlock) {
            var exps = [ifExps];
            var sourcesInsideIf = [];
            var otherIfCount = 0;
            var start = 0;
            forEach(sourcesInsideBlock, function(source, index) {
              if (source.indexOf("if") === 0) {
                otherIfCount += 1;
              } else if (source === "/if") {
                otherIfCount -= 1;
              } else if (!otherIfCount && (source.indexOf("elseif") === 0 || source === "else")) {
                exps.push(source === "else" ? ["true"] : source.split(" ").slice(1));
                sourcesInsideIf.push(sourcesInsideBlock.slice(start, index));
                start = index + 1;
              }
            });
            sourcesInsideIf.push(sourcesInsideBlock.slice(start));
            return {
              exps,
              sourcesInsideIf
            };
          }
          function handleIf(exps, sourcesInsideBlock, context) {
            var analyzed = extractElseif(exps, sourcesInsideBlock);
            var result = false;
            var compiledSource = "";
            forEach(analyzed.exps, function(exp, index) {
              result = handleExpression(exp, context);
              if (result) {
                compiledSource = compile(analyzed.sourcesInsideIf[index], context);
              }
              return !result;
            });
            return compiledSource;
          }
          function handleEach(exps, sourcesInsideBlock, context) {
            var collection = handleExpression(exps, context);
            var additionalKey = isArray(collection) ? "@index" : "@key";
            var additionalContext = {};
            var result = "";
            forEach(collection, function(item, key) {
              additionalContext[additionalKey] = key;
              additionalContext["@this"] = item;
              extend(context, additionalContext);
              result += compile(sourcesInsideBlock.slice(), context);
            });
            return result;
          }
          function handleWith(exps, sourcesInsideBlock, context) {
            var asIndex = inArray("as", exps);
            var alias = exps[asIndex + 1];
            var result = handleExpression(exps.slice(0, asIndex), context);
            var additionalContext = {};
            additionalContext[alias] = result;
            return compile(sourcesInsideBlock, extend(context, additionalContext)) || "";
          }
          function extractSourcesInsideBlock(sources, start, end) {
            var sourcesInsideBlock = sources.splice(start + 1, end - start);
            sourcesInsideBlock.pop();
            return sourcesInsideBlock;
          }
          function handleBlockHelper(helperKeyword, sourcesToEnd, context) {
            var executeBlockHelper = BLOCK_HELPERS[helperKeyword];
            var helperCount = 1;
            var startBlockIndex = 0;
            var endBlockIndex;
            var index = startBlockIndex + EXPRESSION_INTERVAL;
            var expression = sourcesToEnd[index];
            while (helperCount && isString(expression)) {
              if (expression.indexOf(helperKeyword) === 0) {
                helperCount += 1;
              } else if (expression.indexOf("/" + helperKeyword) === 0) {
                helperCount -= 1;
                endBlockIndex = index;
              }
              index += EXPRESSION_INTERVAL;
              expression = sourcesToEnd[index];
            }
            if (helperCount) {
              throw Error(helperKeyword + " needs {{/" + helperKeyword + "}} expression.");
            }
            sourcesToEnd[startBlockIndex] = executeBlockHelper(
              sourcesToEnd[startBlockIndex].split(" ").slice(1),
              extractSourcesInsideBlock(sourcesToEnd, startBlockIndex, endBlockIndex),
              context
            );
            return sourcesToEnd;
          }
          function handleExpression(exps, context) {
            var result = getValueFromContext(exps[0], context);
            if (result instanceof Function) {
              return executeFunction(result, exps.slice(1), context);
            }
            return result;
          }
          function executeFunction(helper, argExps, context) {
            var args = [];
            forEach(argExps, function(exp) {
              args.push(getValueFromContext(exp, context));
            });
            return helper.apply(null, args);
          }
          function compile(sources, context) {
            var index = 1;
            var expression = sources[index];
            var exps, firstExp, result;
            while (isString(expression)) {
              exps = expression.split(" ");
              firstExp = exps[0];
              if (BLOCK_HELPERS[firstExp]) {
                result = handleBlockHelper(firstExp, sources.splice(index, sources.length - index), context);
                sources = sources.concat(result);
              } else {
                sources[index] = handleExpression(exps, context);
              }
              index += EXPRESSION_INTERVAL;
              expression = sources[index];
            }
            return sources.join("");
          }
          function template(text, context) {
            return compile(splitByRegExp(text, EXPRESSION_REGEXP), context);
          }
          module2.exports = template;
        },
        function(module2, exports2, __webpack_require__) {
          var extend = __webpack_require__(2);
          var isExisty = __webpack_require__(23);
          var isString = __webpack_require__(6);
          var isObject = __webpack_require__(25);
          var isArray = __webpack_require__(3);
          var isFunction = __webpack_require__(26);
          var forEach = __webpack_require__(4);
          var R_EVENTNAME_SPLIT = /\s+/g;
          function CustomEvents() {
            this.events = null;
            this.contexts = null;
          }
          CustomEvents.mixin = function(func) {
            extend(func.prototype, CustomEvents.prototype);
          };
          CustomEvents.prototype._getHandlerItem = function(handler, context) {
            var item = { handler };
            if (context) {
              item.context = context;
            }
            return item;
          };
          CustomEvents.prototype._safeEvent = function(eventName) {
            var events = this.events;
            var byName;
            if (!events) {
              events = this.events = {};
            }
            if (eventName) {
              byName = events[eventName];
              if (!byName) {
                byName = [];
                events[eventName] = byName;
              }
              events = byName;
            }
            return events;
          };
          CustomEvents.prototype._safeContext = function() {
            var context = this.contexts;
            if (!context) {
              context = this.contexts = [];
            }
            return context;
          };
          CustomEvents.prototype._indexOfContext = function(ctx) {
            var context = this._safeContext();
            var index = 0;
            while (context[index]) {
              if (ctx === context[index][0]) {
                return index;
              }
              index += 1;
            }
            return -1;
          };
          CustomEvents.prototype._memorizeContext = function(ctx) {
            var context, index;
            if (!isExisty(ctx)) {
              return;
            }
            context = this._safeContext();
            index = this._indexOfContext(ctx);
            if (index > -1) {
              context[index][1] += 1;
            } else {
              context.push([ctx, 1]);
            }
          };
          CustomEvents.prototype._forgetContext = function(ctx) {
            var context, contextIndex;
            if (!isExisty(ctx)) {
              return;
            }
            context = this._safeContext();
            contextIndex = this._indexOfContext(ctx);
            if (contextIndex > -1) {
              context[contextIndex][1] -= 1;
              if (context[contextIndex][1] <= 0) {
                context.splice(contextIndex, 1);
              }
            }
          };
          CustomEvents.prototype._bindEvent = function(eventName, handler, context) {
            var events = this._safeEvent(eventName);
            this._memorizeContext(context);
            events.push(this._getHandlerItem(handler, context));
          };
          CustomEvents.prototype.on = function(eventName, handler, context) {
            var self2 = this;
            if (isString(eventName)) {
              eventName = eventName.split(R_EVENTNAME_SPLIT);
              forEach(eventName, function(name) {
                self2._bindEvent(name, handler, context);
              });
            } else if (isObject(eventName)) {
              context = handler;
              forEach(eventName, function(func, name) {
                self2.on(name, func, context);
              });
            }
          };
          CustomEvents.prototype.once = function(eventName, handler, context) {
            var self2 = this;
            if (isObject(eventName)) {
              context = handler;
              forEach(eventName, function(func, name) {
                self2.once(name, func, context);
              });
              return;
            }
            function onceHandler() {
              handler.apply(context, arguments);
              self2.off(eventName, onceHandler, context);
            }
            this.on(eventName, onceHandler, context);
          };
          CustomEvents.prototype._spliceMatches = function(arr, predicate) {
            var i = 0;
            var len;
            if (!isArray(arr)) {
              return;
            }
            for (len = arr.length; i < len; i += 1) {
              if (predicate(arr[i]) === true) {
                arr.splice(i, 1);
                len -= 1;
                i -= 1;
              }
            }
          };
          CustomEvents.prototype._matchHandler = function(handler) {
            var self2 = this;
            return function(item) {
              var needRemove = handler === item.handler;
              if (needRemove) {
                self2._forgetContext(item.context);
              }
              return needRemove;
            };
          };
          CustomEvents.prototype._matchContext = function(context) {
            var self2 = this;
            return function(item) {
              var needRemove = context === item.context;
              if (needRemove) {
                self2._forgetContext(item.context);
              }
              return needRemove;
            };
          };
          CustomEvents.prototype._matchHandlerAndContext = function(handler, context) {
            var self2 = this;
            return function(item) {
              var matchHandler = handler === item.handler;
              var matchContext = context === item.context;
              var needRemove = matchHandler && matchContext;
              if (needRemove) {
                self2._forgetContext(item.context);
              }
              return needRemove;
            };
          };
          CustomEvents.prototype._offByEventName = function(eventName, handler) {
            var self2 = this;
            var andByHandler = isFunction(handler);
            var matchHandler = self2._matchHandler(handler);
            eventName = eventName.split(R_EVENTNAME_SPLIT);
            forEach(eventName, function(name) {
              var handlerItems = self2._safeEvent(name);
              if (andByHandler) {
                self2._spliceMatches(handlerItems, matchHandler);
              } else {
                forEach(handlerItems, function(item) {
                  self2._forgetContext(item.context);
                });
                self2.events[name] = [];
              }
            });
          };
          CustomEvents.prototype._offByHandler = function(handler) {
            var self2 = this;
            var matchHandler = this._matchHandler(handler);
            forEach(this._safeEvent(), function(handlerItems) {
              self2._spliceMatches(handlerItems, matchHandler);
            });
          };
          CustomEvents.prototype._offByObject = function(obj, handler) {
            var self2 = this;
            var matchFunc;
            if (this._indexOfContext(obj) < 0) {
              forEach(obj, function(func, name) {
                self2.off(name, func);
              });
            } else if (isString(handler)) {
              matchFunc = this._matchContext(obj);
              self2._spliceMatches(this._safeEvent(handler), matchFunc);
            } else if (isFunction(handler)) {
              matchFunc = this._matchHandlerAndContext(handler, obj);
              forEach(this._safeEvent(), function(handlerItems) {
                self2._spliceMatches(handlerItems, matchFunc);
              });
            } else {
              matchFunc = this._matchContext(obj);
              forEach(this._safeEvent(), function(handlerItems) {
                self2._spliceMatches(handlerItems, matchFunc);
              });
            }
          };
          CustomEvents.prototype.off = function(eventName, handler) {
            if (isString(eventName)) {
              this._offByEventName(eventName, handler);
            } else if (!arguments.length) {
              this.events = {};
              this.contexts = [];
            } else if (isFunction(eventName)) {
              this._offByHandler(eventName);
            } else if (isObject(eventName)) {
              this._offByObject(eventName, handler);
            }
          };
          CustomEvents.prototype.fire = function(eventName) {
            this.invoke.apply(this, arguments);
          };
          CustomEvents.prototype.invoke = function(eventName) {
            var events, args, index, item;
            if (!this.hasListener(eventName)) {
              return true;
            }
            events = this._safeEvent(eventName);
            args = Array.prototype.slice.call(arguments, 1);
            index = 0;
            while (events[index]) {
              item = events[index];
              if (item.handler.apply(item.context, args) === false) {
                return false;
              }
              index += 1;
            }
            return true;
          };
          CustomEvents.prototype.hasListener = function(eventName) {
            return this.getListenerLength(eventName) > 0;
          };
          CustomEvents.prototype.getListenerLength = function(eventName) {
            var events = this._safeEvent(eventName);
            return events.length;
          };
          module2.exports = CustomEvents;
        },
        function(module2, exports2, __webpack_require__) {
          var inherit = __webpack_require__(27);
          var extend = __webpack_require__(2);
          function defineClass(parent, props) {
            var obj;
            if (!props) {
              props = parent;
              parent = null;
            }
            obj = props.init || function() {
            };
            if (parent) {
              inherit(obj, parent);
            }
            if (props.hasOwnProperty("static")) {
              extend(obj, props["static"]);
              delete props["static"];
            }
            extend(obj.prototype, props);
            return obj;
          }
          module2.exports = defineClass;
        },
        function(module2, exports2, __webpack_require__) {
          var isString = __webpack_require__(6);
          var forEach = __webpack_require__(4);
          var safeEvent = __webpack_require__(17);
          function on2(element, types, handler, context) {
            if (isString(types)) {
              forEach(types.split(/\s+/g), function(type) {
                bindEvent(element, type, handler, context);
              });
              return;
            }
            forEach(types, function(func, type) {
              bindEvent(element, type, func, handler);
            });
          }
          function bindEvent(element, type, handler, context) {
            function eventHandler(e) {
              handler.call(context || element, e || window.event);
            }
            if ("addEventListener" in element) {
              element.addEventListener(type, eventHandler);
            } else if ("attachEvent" in element) {
              element.attachEvent("on" + type, eventHandler);
            }
            memorizeHandler(element, type, handler, eventHandler);
          }
          function memorizeHandler(element, type, handler, wrappedHandler) {
            var events = safeEvent(element, type);
            var existInEvents = false;
            forEach(events, function(obj) {
              if (obj.handler === handler) {
                existInEvents = true;
                return false;
              }
              return true;
            });
            if (!existInEvents) {
              events.push({
                handler,
                wrappedHandler
              });
            }
          }
          module2.exports = on2;
        },
        function(module2, exports2, __webpack_require__) {
          var isString = __webpack_require__(6);
          var forEach = __webpack_require__(4);
          var safeEvent = __webpack_require__(17);
          function off(element, types, handler) {
            if (isString(types)) {
              forEach(types.split(/\s+/g), function(type) {
                unbindEvent(element, type, handler);
              });
              return;
            }
            forEach(types, function(func, type) {
              unbindEvent(element, type, func);
            });
          }
          function unbindEvent(element, type, handler) {
            var events = safeEvent(element, type);
            var index;
            if (!handler) {
              forEach(events, function(item) {
                removeHandler(element, type, item.wrappedHandler);
              });
              events.splice(0, events.length);
            } else {
              forEach(events, function(item, idx) {
                if (handler === item.handler) {
                  removeHandler(element, type, item.wrappedHandler);
                  index = idx;
                  return false;
                }
                return true;
              });
              events.splice(index, 1);
            }
          }
          function removeHandler(element, type, handler) {
            if ("removeEventListener" in element) {
              element.removeEventListener(type, handler);
            } else if ("detachEvent" in element) {
              element.detachEvent("on" + type, handler);
            }
          }
          module2.exports = off;
        },
        function(module2, exports2, __webpack_require__) {
          var matches = __webpack_require__(30);
          function closest(element, selector) {
            var parent = element.parentNode;
            if (matches(element, selector)) {
              return element;
            }
            while (parent && parent !== document) {
              if (matches(parent, selector)) {
                return parent;
              }
              parent = parent.parentNode;
            }
            return null;
          }
          module2.exports = closest;
        },
        function(module2, exports2, __webpack_require__) {
          function removeElement(element) {
            if (element && element.parentNode) {
              element.parentNode.removeChild(element);
            }
          }
          module2.exports = removeElement;
        },
        function(module2, exports2, __webpack_require__) {
          function isHTMLNode(html) {
            if (typeof HTMLElement === "object") {
              return html && (html instanceof HTMLElement || !!html.nodeType);
            }
            return !!(html && html.nodeType);
          }
          module2.exports = isHTMLNode;
        },
        function(module2, exports2, __webpack_require__) {
          var inArray = __webpack_require__(0);
          var forEachArray = __webpack_require__(1);
          var sendHostname = __webpack_require__(35);
          var uniqueId = 0;
          var utils = {
            getUniqueId: function() {
              uniqueId += 1;
              return uniqueId;
            },
            formatTime: function(value, format) {
              var PADDING_ZERO_TYPES = ["hh", "mm"];
              value = String(value);
              return inArray(format, PADDING_ZERO_TYPES) >= 0 && value.length === 1 ? "0" + value : value;
            },
            getMeridiemHour: function(hour) {
              hour %= 12;
              if (hour === 0) {
                hour = 12;
              }
              return hour;
            },
            getRangeArr: function(start, end, step) {
              var arr = [];
              var i;
              step = step || 1;
              if (start > end) {
                for (i = end; i >= start; i -= step) {
                  arr.push(i);
                }
              } else {
                for (i = start; i <= end; i += step) {
                  arr.push(i);
                }
              }
              return arr;
            },
            fill: function(start, end, value, target) {
              var arr = target || [];
              var replaceEnd = Math.min(arr.length - 1, end);
              var i;
              for (i = start; i <= replaceEnd; i += 1) {
                arr[i] = value;
              }
              for (i = replaceEnd; i <= end; i += 1) {
                arr.push(value);
              }
              return arr;
            },
            getTarget: function(ev) {
              return ev.target || ev.srcElement;
            },
            sendHostName: function() {
              sendHostname("time-picker", "UA-129987462-1");
            },
            getDisabledMinuteArr: function(enableRanges, minuteStep) {
              var arr = this.fill(0, Math.floor(60 / minuteStep) - 2, false);
              function setDisabled(enableRange) {
                var beginDisabledMinute = Math.ceil(enableRange.begin / minuteStep);
                var endDisabledMinute = Math.floor(enableRange.end / minuteStep);
                arr = this.fill(beginDisabledMinute, endDisabledMinute, true, arr);
              }
              forEachArray(enableRanges, setDisabled.bind(this));
              return arr;
            },
            setDisabled: function(el2, isDisabled) {
              el2.disabled = isDisabled;
            }
          };
          module2.exports = utils;
        },
        function(module2, exports2, __webpack_require__) {
          function forEachOwnProperties(obj, iteratee, context) {
            var key;
            context = context || null;
            for (key in obj) {
              if (obj.hasOwnProperty(key)) {
                if (iteratee.call(context, obj[key], key, obj) === false) {
                  break;
                }
              }
            }
          }
          module2.exports = forEachOwnProperties;
        },
        function(module2, exports2, __webpack_require__) {
          var EVENT_KEY = "_feEventKey";
          function safeEvent(element, type) {
            var events = element[EVENT_KEY];
            var handlers;
            if (!events) {
              events = element[EVENT_KEY] = {};
            }
            handlers = events[type];
            if (!handlers) {
              handlers = events[type] = [];
            }
            return handlers;
          }
          module2.exports = safeEvent;
        },
        function(module2, exports2, __webpack_require__) {
          var isUndefined = __webpack_require__(5);
          function getClass(element) {
            if (!element || !element.className) {
              return "";
            }
            if (isUndefined(element.className.baseVal)) {
              return element.className;
            }
            return element.className.baseVal;
          }
          module2.exports = getClass;
        },
        function(module2, exports2, __webpack_require__) {
          var isArray = __webpack_require__(3);
          var isUndefined = __webpack_require__(5);
          function setClassName(element, cssClass) {
            cssClass = isArray(cssClass) ? cssClass.join(" ") : cssClass;
            cssClass = cssClass.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
            if (isUndefined(element.className.baseVal)) {
              element.className = cssClass;
              return;
            }
            element.className.baseVal = cssClass;
          }
          module2.exports = setClassName;
        },
        function(module2, exports2, __webpack_require__) {
          __webpack_require__(21);
          module2.exports = __webpack_require__(22);
        },
        function(module2, exports2, __webpack_require__) {
        },
        function(module2, exports2, __webpack_require__) {
          var inArray = __webpack_require__(0);
          var forEachArray = __webpack_require__(1);
          var CustomEvents = __webpack_require__(8);
          var defineClass = __webpack_require__(9);
          var extend = __webpack_require__(2);
          var on2 = __webpack_require__(10);
          var off = __webpack_require__(11);
          var addClass = __webpack_require__(29);
          var closest = __webpack_require__(12);
          var removeElement = __webpack_require__(13);
          var removeClass = __webpack_require__(32);
          var isHTMLNode = __webpack_require__(14);
          var isNumber = __webpack_require__(33);
          var Spinbox = __webpack_require__(34);
          var Selectbox = __webpack_require__(38);
          var util = __webpack_require__(15);
          var localeTexts = __webpack_require__(40);
          var tmpl = __webpack_require__(41);
          var meridiemTmpl = __webpack_require__(42);
          var SELECTOR_HOUR_ELEMENT = ".tui-timepicker-hour";
          var SELECTOR_MINUTE_ELEMENT = ".tui-timepicker-minute";
          var SELECTOR_MERIDIEM_ELEMENT = ".tui-timepicker-meridiem";
          var CLASS_NAME_LEFT_MERIDIEM = "tui-has-left";
          var CLASS_NAME_HIDDEN = "tui-hidden";
          var CLASS_NAME_CHECKED = "tui-timepicker-meridiem-checked";
          var INPUT_TYPE_SPINBOX = "spinbox";
          var INPUT_TYPE_SELECTBOX = "selectbox";
          var START_NUMBER_OF_TIME = 0;
          var END_NUMBER_OF_MINUTE = 59;
          var END_NUMBER_OF_HOUR = 23;
          var END_NUMBER_OF_HOUR_WITH_MERIDIEM = 12;
          var mergeDefaultOptions = function(options) {
            return extend(
              {
                language: "en",
                initialHour: 0,
                initialMinute: 0,
                showMeridiem: true,
                inputType: "selectbox",
                hourStep: 1,
                minuteStep: 1,
                meridiemPosition: "right",
                format: "h:m",
                disabledHours: [],
                disabledMinutes: {},
                usageStatistics: true
              },
              options
            );
          };
          var TimePicker = defineClass(
            {
              static: {
                localeTexts
              },
              init: function(container, options) {
                options = mergeDefaultOptions(options);
                this.id = util.getUniqueId();
                this.container = isHTMLNode(container) ? container : document.querySelector(container);
                this.element = null;
                this.meridiemElement = null;
                this.amEl = null;
                this.pmEl = null;
                this.showMeridiem = options.showMeridiem;
                this.meridiemPosition = options.meridiemPosition;
                this.hourInput = null;
                this.minuteInput = null;
                this.hour = options.initialHour;
                this.minute = options.initialMinute;
                this.hourStep = options.hourStep;
                this.minuteStep = options.minuteStep;
                this.disabledHours = options.disabledHours;
                this.disabledMinutes = options.disabledMinutes;
                this.inputType = options.inputType;
                this.localeText = localeTexts[options.language];
                this.format = this.getValidTimeFormat(options.format);
                this.render();
                this.setEvents();
                if (options.usageStatistics) {
                  util.sendHostName();
                }
              },
              setEvents: function() {
                this.hourInput.on("change", this.onChangeTimeInput, this);
                this.minuteInput.on("change", this.onChangeTimeInput, this);
                if (this.showMeridiem) {
                  if (this.inputType === INPUT_TYPE_SELECTBOX) {
                    on2(this.meridiemElement.querySelector("select"), "change", this.onChangeMeridiem, this);
                  } else if (this.inputType === INPUT_TYPE_SPINBOX) {
                    on2(this.meridiemElement, "click", this.onChangeMeridiem, this);
                  }
                }
              },
              removeEvents: function() {
                this.off();
                this.hourInput.destroy();
                this.minuteInput.destroy();
                if (this.showMeridiem) {
                  if (this.inputType === INPUT_TYPE_SELECTBOX) {
                    off(this.meridiemElement.querySelector("select"), "change", this.onChangeMeridiem, this);
                  } else if (this.inputType === INPUT_TYPE_SPINBOX) {
                    off(this.meridiemElement, "click", this.onChangeMeridiem, this);
                  }
                }
              },
              render: function() {
                var context = {
                  showMeridiem: this.showMeridiem,
                  isSpinbox: this.inputType === "spinbox"
                };
                if (this.showMeridiem) {
                  extend(context, {
                    meridiemElement: this.makeMeridiemHTML()
                  });
                }
                if (this.element) {
                  removeElement(this.element);
                }
                this.container.innerHTML = tmpl(context);
                this.element = this.container.firstChild;
                this.renderTimeInputs();
                if (this.showMeridiem) {
                  this.setMeridiemElement();
                }
              },
              setMeridiemElement: function() {
                if (this.meridiemPosition === "left") {
                  addClass(this.element, CLASS_NAME_LEFT_MERIDIEM);
                }
                this.meridiemElement = this.element.querySelector(SELECTOR_MERIDIEM_ELEMENT);
                this.amEl = this.meridiemElement.querySelector('[value="AM"]');
                this.pmEl = this.meridiemElement.querySelector('[value="PM"]');
                this.syncToMeridiemElements();
              },
              makeMeridiemHTML: function() {
                var localeText = this.localeText;
                return meridiemTmpl({
                  am: localeText.am,
                  pm: localeText.pm,
                  radioId: this.id,
                  isSpinbox: this.inputType === "spinbox"
                });
              },
              renderTimeInputs: function() {
                var hour = this.hour;
                var showMeridiem = this.showMeridiem;
                var hourElement = this.element.querySelector(SELECTOR_HOUR_ELEMENT);
                var minuteElement = this.element.querySelector(SELECTOR_MINUTE_ELEMENT);
                var BoxComponent = this.inputType.toLowerCase() === "selectbox" ? Selectbox : Spinbox;
                var formatExplode = this.format.split(":");
                var hourItems = this.getHourItems();
                if (showMeridiem) {
                  hour = util.getMeridiemHour(hour);
                }
                this.hourInput = new BoxComponent(hourElement, {
                  initialValue: hour,
                  items: hourItems,
                  format: formatExplode[0],
                  disabledItems: this.makeDisabledStatItems(hourItems)
                });
                this.minuteInput = new BoxComponent(minuteElement, {
                  initialValue: this.minute,
                  items: this.getMinuteItems(),
                  format: formatExplode[1]
                });
              },
              makeDisabledStatItems: function(hourItems) {
                var result = [];
                var disabledHours = this.disabledHours.slice();
                if (this.showMeridiem) {
                  disabledHours = this.meridiemableTime(disabledHours);
                }
                forEachArray(hourItems, function(hour) {
                  result.push(inArray(hour, disabledHours) >= 0);
                });
                return result;
              },
              meridiemableTime: function(disabledHours) {
                var diffHour = 0;
                var startHour = 0;
                var endHour = 11;
                var result = [];
                if (this.hour >= 12) {
                  diffHour = 12;
                  startHour = 12;
                  endHour = 23;
                }
                forEachArray(disabledHours, function(hour) {
                  if (hour >= startHour && hour <= endHour) {
                    result.push(hour - diffHour === 0 ? 12 : hour - diffHour);
                  }
                });
                return result;
              },
              getValidTimeFormat: function(format) {
                if (!format.match(/^[h]{1,2}:[m]{1,2}$/i)) {
                  return "h:m";
                }
                return format.toLowerCase();
              },
              syncToMeridiemElements: function() {
                var selectedEl = this.hour >= 12 ? this.pmEl : this.amEl;
                var notSelectedEl = selectedEl === this.pmEl ? this.amEl : this.pmEl;
                selectedEl.setAttribute("selected", true);
                selectedEl.setAttribute("checked", true);
                addClass(selectedEl, CLASS_NAME_CHECKED);
                notSelectedEl.removeAttribute("selected");
                notSelectedEl.removeAttribute("checked");
                removeClass(notSelectedEl, CLASS_NAME_CHECKED);
              },
              syncToInputs: function() {
                var hour = this.hour;
                var minute = this.minute;
                if (this.showMeridiem) {
                  hour = util.getMeridiemHour(hour);
                }
                this.hourInput.setValue(hour, true);
                this.minuteInput.setValue(minute, true);
              },
              onChangeMeridiem: function(ev) {
                var hour = this.hour;
                var target = util.getTarget(ev);
                if (target.value && closest(target, SELECTOR_MERIDIEM_ELEMENT)) {
                  hour = this.to24Hour(target.value === "PM", hour);
                  this.setTime(hour, this.minute);
                  this.setDisabledHours();
                  this.setDisabledMinutes(hour);
                }
              },
              onChangeTimeInput: function() {
                var hour = this.hourInput.getValue();
                var minute = this.minuteInput.getValue();
                var isPM = this.hour >= 12;
                if (this.showMeridiem) {
                  hour = this.to24Hour(isPM, hour);
                }
                this.setTime(hour, minute);
                this.setDisabledMinutes(hour);
              },
              to24Hour: function(isPM, hour) {
                hour %= 12;
                if (isPM) {
                  hour += 12;
                }
                return hour;
              },
              setDisabledHours: function() {
                var hourItems = this.getHourItems();
                var disabledItems = this.makeDisabledStatItems(hourItems);
                this.hourInput.setDisabledItems(disabledItems);
              },
              setDisabledMinutes: function(hour) {
                var disabledItems;
                disabledItems = this.disabledMinutes[hour] || [];
                this.minuteInput.setDisabledItems(disabledItems);
              },
              getHourItems: function() {
                var step = this.hourStep;
                return this.showMeridiem ? util.getRangeArr(1, 12, step) : util.getRangeArr(0, 23, step);
              },
              getMinuteItems: function() {
                return util.getRangeArr(0, 59, this.minuteStep);
              },
              validItems: function(hour, minute) {
                if (!isNumber(hour) || !isNumber(minute)) {
                  return false;
                }
                if (this.showMeridiem) {
                  hour = util.getMeridiemHour(hour);
                }
                return inArray(hour, this.getHourItems()) > -1 && inArray(minute, this.getMinuteItems()) > -1;
              },
              setHourStep: function(step) {
                this.hourStep = step;
                this.hourInput.fire("changeItems", this.getHourItems());
              },
              getHourStep: function() {
                return this.hourStep;
              },
              setMinuteStep: function(step) {
                this.minuteStep = step;
                this.minuteInput.fire("changeItems", this.getMinuteItems());
              },
              getMinuteStep: function() {
                return this.minuteStep;
              },
              show: function() {
                removeClass(this.element, CLASS_NAME_HIDDEN);
              },
              hide: function() {
                addClass(this.element, CLASS_NAME_HIDDEN);
              },
              setHour: function(hour) {
                return this.setTime(hour, this.minute);
              },
              setMinute: function(minute) {
                return this.setTime(this.hour, minute);
              },
              setTime: function(hour, minute, silent) {
                if (!this.validItems(hour, minute)) {
                  return;
                }
                this.hour = hour;
                this.minute = minute;
                this.syncToInputs();
                if (this.showMeridiem) {
                  this.syncToMeridiemElements();
                }
                if (!silent) {
                  this.fire("change", {
                    hour: this.hour,
                    minute: this.minute
                  });
                }
              },
              setRange: function(begin, end) {
                var beginHour = begin.hour;
                var beginMin = begin.minute;
                var endHour, endMin;
                if (!this.isValidRange(begin, end)) {
                  return;
                }
                if (end) {
                  endHour = end.hour;
                  endMin = end.minute;
                }
                this.setRangeHour(beginHour, endHour);
                this.setRangeMinute(beginHour, beginMin, endHour, endMin);
                this.applyRange(beginHour, beginMin, endHour);
              },
              setRangeHour: function(beginHour, endHour) {
                var disabledHours = util.getRangeArr(START_NUMBER_OF_TIME, beginHour - 1);
                if (endHour) {
                  disabledHours = disabledHours.concat(util.getRangeArr(endHour + 1, END_NUMBER_OF_HOUR));
                }
                this.disabledHours = disabledHours.slice();
              },
              setRangeMinute: function(beginHour, beginMin, endHour, endMin) {
                var disabledMinRanges = [];
                if (!beginHour && !beginMin) {
                  return;
                }
                disabledMinRanges.push({
                  begin: START_NUMBER_OF_TIME,
                  end: beginMin
                });
                if (endHour && endMin) {
                  disabledMinRanges.push({
                    begin: endMin,
                    end: END_NUMBER_OF_MINUTE
                  });
                  if (beginHour === endHour) {
                    this.disabledMinutes[beginHour] = util.getDisabledMinuteArr(disabledMinRanges, this.minuteStep).slice();
                    return;
                  }
                  this.disabledMinutes[endHour] = util.getDisabledMinuteArr([disabledMinRanges[1]], this.minuteStep).slice();
                }
                this.disabledMinutes[beginHour] = util.getDisabledMinuteArr([disabledMinRanges[0]], this.minuteStep).slice();
              },
              applyRange: function(beginHour, beginMin, endHour) {
                var targetMinuteIndex = Math.ceil(beginMin / this.minuteStep);
                var targetHour = beginHour;
                var targetMinute = targetMinuteIndex * this.minuteStep;
                var diffFromSelectableMinute;
                if (this.isLaterThanSetTime(beginHour, beginMin)) {
                  if (this.disabledMinutes[targetHour][targetMinuteIndex]) {
                    diffFromSelectableMinute = this.disabledMinutes[targetHour].slice(targetMinuteIndex).findIndex(function(isMinuteDisabled) {
                      return !isMinuteDisabled;
                    }) * this.minuteStep;
                    targetMinute = diffFromSelectableMinute >= 0 ? targetMinute + diffFromSelectableMinute : 60;
                  }
                  if (this.hourStep !== 1 && beginHour % this.hourStep !== 1 || targetMinute >= 60) {
                    targetHour = beginHour + beginHour % this.hourStep + 1;
                    targetMinute = 0;
                  }
                  this.setTime(targetHour, targetMinute);
                }
                this.setDisabledHours();
                this.setDisabledMinutes(this.hour);
                if (this.showMeridiem) {
                  this.syncToMeridiemElements();
                  util.setDisabled(this.amEl, beginHour >= END_NUMBER_OF_HOUR_WITH_MERIDIEM);
                  util.setDisabled(this.pmEl, endHour < END_NUMBER_OF_HOUR_WITH_MERIDIEM);
                }
              },
              resetMinuteRange: function() {
                var i;
                this.disabledMinutes = {};
                for (i = 0; i <= END_NUMBER_OF_HOUR; i += 1) {
                  this.setDisabledMinutes(this.hour);
                }
              },
              isValidRange: function(begin, end) {
                var beginHour = begin.hour;
                var beginMin = begin.minute;
                var endHour, endMin;
                if (!this.isValidTime(beginHour, beginMin)) {
                  return false;
                }
                if (!end) {
                  return true;
                }
                endHour = end.hour;
                endMin = end.minute;
                return this.isValidTime(endHour, endMin) && this.compareTimes(begin, end) > 0;
              },
              isValidTime: function(hour, minute) {
                return hour >= START_NUMBER_OF_TIME && hour <= END_NUMBER_OF_HOUR && minute >= START_NUMBER_OF_TIME && minute <= END_NUMBER_OF_MINUTE;
              },
              isLaterThanSetTime: function(hour, minute) {
                return hour > this.hour || hour === this.hour && minute > this.minute;
              },
              compareTimes: function(begin, end) {
                var first = new Date(0);
                var second = new Date(0);
                first.setHours(begin.hour, begin.minute);
                second.setHours(end.hour, end.minute);
                return second.getTime() - first.getTime();
              },
              getHour: function() {
                return this.hour;
              },
              getMinute: function() {
                return this.minute;
              },
              changeLanguage: function(language) {
                this.localeText = localeTexts[language];
                this.render();
              },
              destroy: function() {
                this.removeEvents();
                removeElement(this.element);
                this.container = this.showMeridiem = this.hourInput = this.minuteInput = this.hour = this.minute = this.inputType = this.element = this.meridiemElement = this.amEl = this.pmEl = null;
              }
            }
          );
          CustomEvents.mixin(TimePicker);
          module2.exports = TimePicker;
        },
        function(module2, exports2, __webpack_require__) {
          var isUndefined = __webpack_require__(5);
          var isNull = __webpack_require__(24);
          function isExisty(param) {
            return !isUndefined(param) && !isNull(param);
          }
          module2.exports = isExisty;
        },
        function(module2, exports2, __webpack_require__) {
          function isNull(obj) {
            return obj === null;
          }
          module2.exports = isNull;
        },
        function(module2, exports2, __webpack_require__) {
          function isObject(obj) {
            return obj === Object(obj);
          }
          module2.exports = isObject;
        },
        function(module2, exports2, __webpack_require__) {
          function isFunction(obj) {
            return obj instanceof Function;
          }
          module2.exports = isFunction;
        },
        function(module2, exports2, __webpack_require__) {
          var createObject = __webpack_require__(28);
          function inherit(subType, superType) {
            var prototype = createObject(superType.prototype);
            prototype.constructor = subType;
            subType.prototype = prototype;
          }
          module2.exports = inherit;
        },
        function(module2, exports2, __webpack_require__) {
          function createObject(obj) {
            function F2() {
            }
            F2.prototype = obj;
            return new F2();
          }
          module2.exports = createObject;
        },
        function(module2, exports2, __webpack_require__) {
          var forEach = __webpack_require__(4);
          var inArray = __webpack_require__(0);
          var getClass = __webpack_require__(18);
          var setClassName = __webpack_require__(19);
          function addClass(element) {
            var cssClass = Array.prototype.slice.call(arguments, 1);
            var classList = element.classList;
            var newClass = [];
            var origin;
            if (classList) {
              forEach(cssClass, function(name) {
                element.classList.add(name);
              });
              return;
            }
            origin = getClass(element);
            if (origin) {
              cssClass = [].concat(origin.split(/\s+/), cssClass);
            }
            forEach(cssClass, function(cls) {
              if (inArray(cls, newClass) < 0) {
                newClass.push(cls);
              }
            });
            setClassName(element, newClass);
          }
          module2.exports = addClass;
        },
        function(module2, exports2, __webpack_require__) {
          var inArray = __webpack_require__(0);
          var toArray = __webpack_require__(31);
          var elProto = Element.prototype;
          var matchSelector = elProto.matches || elProto.webkitMatchesSelector || elProto.mozMatchesSelector || elProto.msMatchesSelector || function(selector) {
            var doc = this.document || this.ownerDocument;
            return inArray(this, toArray(doc.querySelectorAll(selector))) > -1;
          };
          function matches(element, selector) {
            return matchSelector.call(element, selector);
          }
          module2.exports = matches;
        },
        function(module2, exports2, __webpack_require__) {
          var forEachArray = __webpack_require__(1);
          function toArray(arrayLike) {
            var arr;
            try {
              arr = Array.prototype.slice.call(arrayLike);
            } catch (e) {
              arr = [];
              forEachArray(arrayLike, function(value) {
                arr.push(value);
              });
            }
            return arr;
          }
          module2.exports = toArray;
        },
        function(module2, exports2, __webpack_require__) {
          var forEachArray = __webpack_require__(1);
          var inArray = __webpack_require__(0);
          var getClass = __webpack_require__(18);
          var setClassName = __webpack_require__(19);
          function removeClass(element) {
            var cssClass = Array.prototype.slice.call(arguments, 1);
            var classList = element.classList;
            var origin, newClass;
            if (classList) {
              forEachArray(cssClass, function(name) {
                classList.remove(name);
              });
              return;
            }
            origin = getClass(element).split(/\s+/);
            newClass = [];
            forEachArray(origin, function(name) {
              if (inArray(name, cssClass) < 0) {
                newClass.push(name);
              }
            });
            setClassName(element, newClass);
          }
          module2.exports = removeClass;
        },
        function(module2, exports2, __webpack_require__) {
          function isNumber(obj) {
            return typeof obj === "number" || obj instanceof Number;
          }
          module2.exports = isNumber;
        },
        function(module2, exports2, __webpack_require__) {
          var inArray = __webpack_require__(0);
          var forEachArray = __webpack_require__(1);
          var CustomEvents = __webpack_require__(8);
          var defineClass = __webpack_require__(9);
          var extend = __webpack_require__(2);
          var on2 = __webpack_require__(10);
          var off = __webpack_require__(11);
          var closest = __webpack_require__(12);
          var removeElement = __webpack_require__(13);
          var isHTMLNode = __webpack_require__(14);
          var util = __webpack_require__(15);
          var tmpl = __webpack_require__(37);
          var SELECTOR_UP_BUTTON = ".tui-timepicker-btn-up";
          var SELECTOR_DOWN_BUTTON = ".tui-timepicker-btn-down";
          var Spinbox = defineClass(
            {
              init: function(container, options) {
                options = extend(
                  {
                    items: []
                  },
                  options
                );
                this._container = isHTMLNode(container) ? container : document.querySelector(container);
                this._element = null;
                this._inputElement = null;
                this._items = options.items;
                this._disabledItems = options.disabledItems || [];
                this._selectedIndex = Math.max(0, inArray(options.initialValue, this._items));
                this._format = options.format;
                this._render();
                this._setEvents();
              },
              _render: function() {
                var index = inArray(this.getValue(), this._items);
                var context;
                if (this._disabledItems[index]) {
                  this._selectedIndex = this._findEnabledIndex();
                }
                context = {
                  maxLength: this._getMaxLength(),
                  initialValue: this.getValue(),
                  format: this._format,
                  formatTime: util.formatTime
                };
                this._container.innerHTML = tmpl(context);
                this._element = this._container.firstChild;
                this._inputElement = this._element.querySelector("input");
              },
              _findEnabledIndex: function() {
                return inArray(false, this._disabledItems);
              },
              _getMaxLength: function() {
                var lengths = [];
                forEachArray(this._items, function(item) {
                  lengths.push(String(item).length);
                });
                return Math.max.apply(null, lengths);
              },
              setDisabledItems: function(disabledItems) {
                this._disabledItems = disabledItems;
                this._changeToInputValue();
              },
              _setEvents: function() {
                on2(this._container, "click", this._onClickHandler, this);
                on2(this._inputElement, "keydown", this._onKeydownInputElement, this);
                on2(this._inputElement, "change", this._onChangeHandler, this);
                this.on(
                  "changeItems",
                  function(items) {
                    this._items = items;
                    this._render();
                  },
                  this
                );
              },
              _removeEvents: function() {
                this.off();
                off(this._container, "click", this._onClickHandler, this);
                off(this._inputElement, "keydown", this._onKeydownInputElement, this);
                off(this._inputElement, "change", this._onChangeHandler, this);
              },
              _onClickHandler: function(ev) {
                var target = util.getTarget(ev);
                if (closest(target, SELECTOR_DOWN_BUTTON)) {
                  this._setNextValue(true);
                } else if (closest(target, SELECTOR_UP_BUTTON)) {
                  this._setNextValue(false);
                }
              },
              _setNextValue: function(isDown) {
                var index = this._selectedIndex;
                if (isDown) {
                  index = index ? index - 1 : this._items.length - 1;
                } else {
                  index = index < this._items.length - 1 ? index + 1 : 0;
                }
                if (this._disabledItems[index]) {
                  this._selectedIndex = index;
                  this._setNextValue(isDown);
                } else {
                  this.setValue(this._items[index]);
                }
              },
              _onKeydownInputElement: function(ev) {
                var keyCode = ev.which || ev.keyCode;
                var isDown;
                if (closest(util.getTarget(ev), "input")) {
                  switch (keyCode) {
                    case 38:
                      isDown = false;
                      break;
                    case 40:
                      isDown = true;
                      break;
                    default:
                      return;
                  }
                  this._setNextValue(isDown);
                }
              },
              _onChangeHandler: function(ev) {
                if (closest(util.getTarget(ev), "input")) {
                  this._changeToInputValue();
                }
              },
              _changeToInputValue: function(silent) {
                var newValue = Number(this._inputElement.value);
                var newIndex = inArray(newValue, this._items);
                if (this._disabledItems[newIndex]) {
                  newIndex = this._findEnabledIndex();
                  newValue = this._items[newIndex];
                } else if (newIndex === this._selectedIndex) {
                  return;
                }
                if (newIndex === -1) {
                  this.setValue(this._items[this._selectedIndex], silent);
                } else {
                  this._selectedIndex = newIndex;
                  if (!silent) {
                    this.fire("change", {
                      value: newValue
                    });
                  }
                }
              },
              setValue: function(value, silent) {
                this._inputElement.value = util.formatTime(value, this._format);
                this._changeToInputValue(silent);
              },
              getValue: function() {
                return this._items[this._selectedIndex];
              },
              destroy: function() {
                this._removeEvents();
                removeElement(this._element);
                this._container = this._element = this._inputElement = this._items = this._selectedIndex = null;
              }
            }
          );
          CustomEvents.mixin(Spinbox);
          module2.exports = Spinbox;
        },
        function(module2, exports2, __webpack_require__) {
          var isUndefined = __webpack_require__(5);
          var imagePing = __webpack_require__(36);
          var ms7days = 7 * 24 * 60 * 60 * 1e3;
          function isExpired(date) {
            var now = new Date().getTime();
            return now - date > ms7days;
          }
          function sendHostname(appName, trackingId) {
            var url = "https://www.google-analytics.com/collect";
            var hostname = location.hostname;
            var hitType = "event";
            var eventCategory = "use";
            var applicationKeyForStorage = "TOAST UI " + appName + " for " + hostname + ": Statistics";
            var date = window.localStorage.getItem(applicationKeyForStorage);
            if (!isUndefined(window.tui) && window.tui.usageStatistics === false) {
              return;
            }
            if (date && !isExpired(date)) {
              return;
            }
            window.localStorage.setItem(applicationKeyForStorage, new Date().getTime());
            setTimeout(function() {
              if (document.readyState === "interactive" || document.readyState === "complete") {
                imagePing(url, {
                  v: 1,
                  t: hitType,
                  tid: trackingId,
                  cid: hostname,
                  dp: hostname,
                  dh: appName,
                  el: appName,
                  ec: eventCategory
                });
              }
            }, 1e3);
          }
          module2.exports = sendHostname;
        },
        function(module2, exports2, __webpack_require__) {
          var forEachOwnProperties = __webpack_require__(16);
          function imagePing(url, trackingInfo) {
            var trackingElement = document.createElement("img");
            var queryString = "";
            forEachOwnProperties(trackingInfo, function(value, key) {
              queryString += "&" + key + "=" + value;
            });
            queryString = queryString.substring(1);
            trackingElement.src = url + "?" + queryString;
            trackingElement.style.display = "none";
            document.body.appendChild(trackingElement);
            document.body.removeChild(trackingElement);
            return trackingElement;
          }
          module2.exports = imagePing;
        },
        function(module2, exports2, __webpack_require__) {
          var template = __webpack_require__(7);
          module2.exports = function(context) {
            var source = '<div class="tui-timepicker-btn-area">  <input type="text" class="tui-timepicker-spinbox-input"        maxlength="{{maxLength}}"        size="{{maxLength}}"        value="{{formatTime initialValue format}}"        aria-label="TimePicker spinbox value">  <button type="button" class="tui-timepicker-btn tui-timepicker-btn-up">    <span class="tui-ico-t-btn">Increase</span>  </button>  <button type="button" class="tui-timepicker-btn tui-timepicker-btn-down">    <span class="tui-ico-t-btn">Decrease</span>  </button></div>';
            return template(source, context);
          };
        },
        function(module2, exports2, __webpack_require__) {
          var inArray = __webpack_require__(0);
          var CustomEvents = __webpack_require__(8);
          var defineClass = __webpack_require__(9);
          var extend = __webpack_require__(2);
          var on2 = __webpack_require__(10);
          var off = __webpack_require__(11);
          var closest = __webpack_require__(12);
          var removeElement = __webpack_require__(13);
          var isHTMLNode = __webpack_require__(14);
          var util = __webpack_require__(15);
          var tmpl = __webpack_require__(39);
          var Selectbox = defineClass(
            {
              init: function(container, options) {
                options = extend(
                  {
                    items: []
                  },
                  options
                );
                this._container = isHTMLNode(container) ? container : document.querySelector(container);
                this._items = options.items || [];
                this._disabledItems = options.disabledItems || [];
                this._selectedIndex = Math.max(0, inArray(options.initialValue, this._items));
                this._format = options.format;
                this._element = null;
                this._render();
                this._setEvents();
              },
              _render: function() {
                var context;
                this._changeEnabledIndex();
                context = {
                  items: this._items,
                  format: this._format,
                  initialValue: this.getValue(),
                  disabledItems: this._disabledItems,
                  formatTime: util.formatTime,
                  equals: function(a, b) {
                    return a === b;
                  }
                };
                if (this._element) {
                  this._removeElement();
                }
                this._container.innerHTML = tmpl(context);
                this._element = this._container.firstChild;
                on2(this._element, "change", this._onChangeHandler, this);
              },
              _changeEnabledIndex: function() {
                var index = inArray(this.getValue(), this._items);
                if (this._disabledItems[index]) {
                  this._selectedIndex = inArray(false, this._disabledItems);
                }
              },
              setDisabledItems: function(disabledItems) {
                this._disabledItems = disabledItems;
                this._render();
              },
              _setEvents: function() {
                this.on(
                  "changeItems",
                  function(items) {
                    this._items = items;
                    this._render();
                  },
                  this
                );
              },
              _removeEvents: function() {
                this.off();
              },
              _removeElement: function() {
                off(this._element, "change", this._onChangeHandler, this);
                removeElement(this._element);
              },
              _onChangeHandler: function(ev) {
                if (closest(util.getTarget(ev), "select")) {
                  this._setNewValue();
                }
              },
              _setNewValue: function(silent) {
                var newValue = Number(this._element.value);
                this._selectedIndex = inArray(newValue, this._items);
                if (!silent) {
                  this.fire("change", {
                    value: newValue
                  });
                }
              },
              getValue: function() {
                return this._items[this._selectedIndex];
              },
              setValue: function(value, silent) {
                var newIndex = inArray(value, this._items);
                if (newIndex > -1 && newIndex !== this._selectedIndex) {
                  this._selectedIndex = newIndex;
                  this._element.value = value;
                  this._setNewValue(silent);
                }
              },
              destroy: function() {
                this._removeEvents();
                this._removeElement();
                this._container = this._items = this._selectedIndex = this._element = null;
              }
            }
          );
          CustomEvents.mixin(Selectbox);
          module2.exports = Selectbox;
        },
        function(module2, exports2, __webpack_require__) {
          var template = __webpack_require__(7);
          module2.exports = function(context) {
            var source = '<select class="tui-timepicker-select" aria-label="Time">  {{each items}}    {{if equals initialValue @this}}      <option value="{{@this}}" selected {{if disabledItems[@index]}}disabled{{/if}}>{{formatTime @this format}}</option>    {{else}}      <option value="{{@this}}" {{if disabledItems[@index]}}disabled{{/if}}>{{formatTime @this format}}</option>    {{/if}}  {{/each}}</select>';
            return template(source, context);
          };
        },
        function(module2, exports2, __webpack_require__) {
          module2.exports = {
            en: {
              am: "AM",
              pm: "PM"
            },
            ko: {
              am: "\uC624\uC804",
              pm: "\uC624\uD6C4"
            }
          };
        },
        function(module2, exports2, __webpack_require__) {
          var template = __webpack_require__(7);
          module2.exports = function(context) {
            var source = '<div class="tui-timepicker">  <div class="tui-timepicker-body">    <div class="tui-timepicker-row">      {{if isSpinbox}}        <div class="tui-timepicker-column tui-timepicker-spinbox tui-timepicker-hour"></div>        <span class="tui-timepicker-column tui-timepicker-colon"><span class="tui-ico-colon">:</span></span>        <div class="tui-timepicker-column tui-timepicker-spinbox tui-timepicker-minute"></div>        {{if showMeridiem}}          {{meridiemElement}}        {{/if}}      {{else}}        <div class="tui-timepicker-column tui-timepicker-selectbox tui-timepicker-hour"></div>        <span class="tui-timepicker-column tui-timepicker-colon"><span class="tui-ico-colon">:</span></span>        <div class="tui-timepicker-column tui-timepicker-selectbox tui-timepicker-minute"></div>        {{if showMeridiem}}          {{meridiemElement}}        {{/if}}      {{/if}}    </div>  </div></div>';
            return template(source, context);
          };
        },
        function(module2, exports2, __webpack_require__) {
          var template = __webpack_require__(7);
          module2.exports = function(context) {
            var source = '{{if isSpinbox}}  <div class="tui-timepicker-column tui-timepicker-checkbox tui-timepicker-meridiem">    <div class="tui-timepicker-check-area">      <ul class="tui-timepicker-check-lst">        <li class="tui-timepicker-check">          <div class="tui-timepicker-radio">            <input type="radio"                  name="optionsRadios-{{radioId}}"                  value="AM"                  class="tui-timepicker-radio-am"                  id="tui-timepicker-radio-am-{{radioId}}">            <label for="tui-timepicker-radio-am-{{radioId}}" class="tui-timepicker-radio-label">              <span class="tui-timepicker-input-radio"></span>{{am}}            </label>          </div>        </li>        <li class="tui-timepicker-check">          <div class="tui-timepicker-radio">            <input type="radio"                  name="optionsRadios-{{radioId}}"                  value="PM"                  class="tui-timepicker-radio-pm"                  id="tui-timepicker-radio-pm-{{radioId}}">            <label for="tui-timepicker-radio-pm-{{radioId}}" class="tui-timepicker-radio-label">              <span class="tui-timepicker-input-radio"></span>{{pm}}            </label>          </div>        </li>      </ul>    </div>  </div>{{else}}  <div class="tui-timepicker-column tui-timepicker-selectbox tui-is-add-picker tui-timepicker-meridiem">    <select class="tui-timepicker-select" aria-label="AM/PM">      <option value="AM">{{am}}</option>      <option value="PM">{{pm}}</option>    </select>  </div>{{/if}}';
            return template(source, context);
          };
        }
      ]);
    });
  })(tuiTimePicker);
  return tuiTimePicker.exports;
}
/*!
 * TOAST UI Date Picker
 * @version 4.3.3
 * @author NHN Cloud. FE Development Lab <dl_javascript@nhn.com>
 * @license MIT
 */
(function(module, exports) {
  (function webpackUniversalModuleDefinition(root, factory) {
    module.exports = factory(requireTuiTimePicker());
  })(window, function(__WEBPACK_EXTERNAL_MODULE__43__) {
    return function(modules) {
      var installedModules = {};
      function __webpack_require__(moduleId) {
        if (installedModules[moduleId]) {
          return installedModules[moduleId].exports;
        }
        var module2 = installedModules[moduleId] = {
          i: moduleId,
          l: false,
          exports: {}
        };
        modules[moduleId].call(module2.exports, module2, module2.exports, __webpack_require__);
        module2.l = true;
        return module2.exports;
      }
      __webpack_require__.m = modules;
      __webpack_require__.c = installedModules;
      __webpack_require__.d = function(exports2, name, getter) {
        if (!__webpack_require__.o(exports2, name)) {
          Object.defineProperty(exports2, name, { enumerable: true, get: getter });
        }
      };
      __webpack_require__.r = function(exports2) {
        if (typeof Symbol !== "undefined" && Symbol.toStringTag) {
          Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
        }
        Object.defineProperty(exports2, "__esModule", { value: true });
      };
      __webpack_require__.t = function(value, mode) {
        if (mode & 1)
          value = __webpack_require__(value);
        if (mode & 8)
          return value;
        if (mode & 4 && typeof value === "object" && value && value.__esModule)
          return value;
        var ns = /* @__PURE__ */ Object.create(null);
        __webpack_require__.r(ns);
        Object.defineProperty(ns, "default", { enumerable: true, value });
        if (mode & 2 && typeof value != "string")
          for (var key in value)
            __webpack_require__.d(ns, key, function(key2) {
              return value[key2];
            }.bind(null, key));
        return ns;
      };
      __webpack_require__.n = function(module2) {
        var getter = module2 && module2.__esModule ? function getDefault() {
          return module2["default"];
        } : function getModuleExports() {
          return module2;
        };
        __webpack_require__.d(getter, "a", getter);
        return getter;
      };
      __webpack_require__.o = function(object, property) {
        return Object.prototype.hasOwnProperty.call(object, property);
      };
      __webpack_require__.p = "dist";
      return __webpack_require__(__webpack_require__.s = 34);
    }([
      function(module2, exports2, __webpack_require__) {
        var inherit = __webpack_require__(35);
        var extend = __webpack_require__(7);
        function defineClass(parent, props) {
          var obj;
          if (!props) {
            props = parent;
            parent = null;
          }
          obj = props.init || function() {
          };
          if (parent) {
            inherit(obj, parent);
          }
          if (props.hasOwnProperty("static")) {
            extend(obj, props["static"]);
            delete props["static"];
          }
          extend(obj.prototype, props);
          return obj;
        }
        module2.exports = defineClass;
      },
      function(module2, exports2, __webpack_require__) {
        module2.exports = {
          TYPE_DATE: "date",
          TYPE_MONTH: "month",
          TYPE_YEAR: "year",
          TYPE_HOUR: "hour",
          TYPE_MINUTE: "minute",
          TYPE_MERIDIEM: "meridiem",
          MIN_DATE: new Date(1900, 0, 1),
          MAX_DATE: new Date(2999, 11, 31),
          DEFAULT_LANGUAGE_TYPE: "en",
          CLASS_NAME_SELECTED: "tui-is-selected",
          CLASS_NAME_PREV_MONTH_BTN: "tui-calendar-btn-prev-month",
          CLASS_NAME_PREV_YEAR_BTN: "tui-calendar-btn-prev-year",
          CLASS_NAME_NEXT_YEAR_BTN: "tui-calendar-btn-next-year",
          CLASS_NAME_NEXT_MONTH_BTN: "tui-calendar-btn-next-month",
          CLASS_NAME_TITLE_TODAY: "tui-calendar-title-today",
          DEFAULT_WEEK_START_DAY: "Sun",
          WEEK_START_DAY_MAP: {
            sun: 0,
            mon: 1,
            tue: 2,
            wed: 3,
            thu: 4,
            fri: 5,
            sat: 6
          }
        };
      },
      function(module2, exports2, __webpack_require__) {
        function forEachArray(arr, iteratee, context) {
          var index = 0;
          var len = arr.length;
          context = context || null;
          for (; index < len; index += 1) {
            if (iteratee.call(context, arr[index], index, arr) === false) {
              break;
            }
          }
        }
        module2.exports = forEachArray;
      },
      function(module2, exports2, __webpack_require__) {
        var isArray = __webpack_require__(6);
        function inArray(searchElement, array, startIndex) {
          var i;
          var length;
          startIndex = startIndex || 0;
          if (!isArray(array)) {
            return -1;
          }
          if (Array.prototype.indexOf) {
            return Array.prototype.indexOf.call(array, searchElement, startIndex);
          }
          length = array.length;
          for (i = startIndex; startIndex >= 0 && i < length; i += 1) {
            if (array[i] === searchElement) {
              return i;
            }
          }
          return -1;
        }
        module2.exports = inArray;
      },
      function(module2, exports2, __webpack_require__) {
        var forEachArray = __webpack_require__(2);
        var isHTMLNode = __webpack_require__(46);
        var sendHostname = __webpack_require__(47);
        var currentId = 0;
        var utils = {
          getTarget: function(ev) {
            return ev.target || ev.srcElement;
          },
          getElement: function(param) {
            return isHTMLNode(param) ? param : document.querySelector(param);
          },
          getSelector: function(elem) {
            var selector = "";
            if (elem.id) {
              selector = "#" + elem.id;
            } else if (elem.className) {
              selector = "." + elem.className.split(" ")[0];
            }
            return selector;
          },
          generateId: function() {
            currentId += 1;
            return currentId;
          },
          filter: function(arr, iteratee) {
            var result = [];
            forEachArray(arr, function(item) {
              if (iteratee(item)) {
                result.push(item);
              }
            });
            return result;
          },
          sendHostName: function() {
            sendHostname("date-picker", "UA-129987462-1");
          }
        };
        module2.exports = utils;
      },
      function(module2, exports2, __webpack_require__) {
        var isDate = __webpack_require__(28);
        var isNumber = __webpack_require__(15);
        var constants = __webpack_require__(1);
        var TYPE_DATE = constants.TYPE_DATE;
        var TYPE_MONTH = constants.TYPE_MONTH;
        var TYPE_YEAR = constants.TYPE_YEAR;
        var utils = {
          getWeeksCount: function(year, month) {
            var firstDay = utils.getFirstDay(year, month), lastDate = utils.getLastDayInMonth(year, month);
            return Math.ceil((firstDay + lastDate) / 7);
          },
          isValidDate: function(date) {
            return isDate(date) && !isNaN(date.getTime());
          },
          getFirstDay: function(year, month) {
            return new Date(year, month - 1, 1).getDay();
          },
          getFirstDayTimestamp: function(year, month) {
            return new Date(year, month, 1).getTime();
          },
          getLastDayInMonth: function(year, month) {
            return new Date(year, month, 0).getDate();
          },
          prependLeadingZero: function(number) {
            var prefix = "";
            if (number < 10) {
              prefix = "0";
            }
            return prefix + number;
          },
          getMeridiemHour: function(hour) {
            hour %= 12;
            if (hour === 0) {
              hour = 12;
            }
            return hour;
          },
          getSafeNumber: function(any, defaultNumber) {
            if (isNaN(defaultNumber) || !isNumber(defaultNumber)) {
              throw Error("The defaultNumber must be a valid number.");
            }
            if (isNaN(any)) {
              return defaultNumber;
            }
            return Number(any);
          },
          getDateOfWeek: function(year, month, weekNumber, dayNumber) {
            var firstDayOfMonth = new Date(year, month - 1).getDay();
            var dateOffset = firstDayOfMonth - dayNumber - 1;
            return new Date(year, month - 1, weekNumber * 7 - dateOffset);
          },
          getRangeArr: function(start, end) {
            var arr = [];
            var i;
            if (start > end) {
              for (i = end; i >= start; i -= 1) {
                arr.push(i);
              }
            } else {
              for (i = start; i <= end; i += 1) {
                arr.push(i);
              }
            }
            return arr;
          },
          cloneWithStartOf: function(date, type) {
            type = type || TYPE_DATE;
            date = new Date(date);
            date.setHours(0, 0, 0, 0);
            switch (type) {
              case TYPE_DATE:
                break;
              case TYPE_MONTH:
                date.setDate(1);
                break;
              case TYPE_YEAR:
                date.setMonth(0, 1);
                break;
              default:
                throw Error("Unsupported type: " + type);
            }
            return date;
          },
          cloneWithEndOf: function(date, type) {
            type = type || TYPE_DATE;
            date = new Date(date);
            date.setHours(23, 59, 59, 999);
            switch (type) {
              case TYPE_DATE:
                break;
              case TYPE_MONTH:
                date.setMonth(date.getMonth() + 1, 0);
                break;
              case TYPE_YEAR:
                date.setMonth(11, 31);
                break;
              default:
                throw Error("Unsupported type: " + type);
            }
            return date;
          },
          compare: function(dateA, dateB, cmpLevel) {
            var aTimestamp, bTimestamp;
            if (!(utils.isValidDate(dateA) && utils.isValidDate(dateB))) {
              return NaN;
            }
            if (!cmpLevel) {
              aTimestamp = dateA.getTime();
              bTimestamp = dateB.getTime();
            } else {
              aTimestamp = utils.cloneWithStartOf(dateA, cmpLevel).getTime();
              bTimestamp = utils.cloneWithStartOf(dateB, cmpLevel).getTime();
            }
            if (aTimestamp > bTimestamp) {
              return 1;
            }
            return aTimestamp === bTimestamp ? 0 : -1;
          },
          isSame: function(dateA, dateB, cmpLevel) {
            return utils.compare(dateA, dateB, cmpLevel) === 0;
          },
          inRange: function(start, end, target, cmpLevel) {
            return utils.compare(start, target, cmpLevel) < 1 && utils.compare(end, target, cmpLevel) > -1;
          }
        };
        module2.exports = utils;
      },
      function(module2, exports2, __webpack_require__) {
        function isArray(obj) {
          return obj instanceof Array;
        }
        module2.exports = isArray;
      },
      function(module2, exports2, __webpack_require__) {
        function extend(target, objects) {
          var hasOwnProp = Object.prototype.hasOwnProperty;
          var source, prop, i, len;
          for (i = 1, len = arguments.length; i < len; i += 1) {
            source = arguments[i];
            for (prop in source) {
              if (hasOwnProp.call(source, prop)) {
                target[prop] = source[prop];
              }
            }
          }
          return target;
        }
        module2.exports = extend;
      },
      function(module2, exports2, __webpack_require__) {
        var extend = __webpack_require__(7);
        var isExisty = __webpack_require__(37);
        var isString = __webpack_require__(13);
        var isObject = __webpack_require__(22);
        var isArray = __webpack_require__(6);
        var isFunction = __webpack_require__(39);
        var forEach = __webpack_require__(9);
        var R_EVENTNAME_SPLIT = /\s+/g;
        function CustomEvents() {
          this.events = null;
          this.contexts = null;
        }
        CustomEvents.mixin = function(func) {
          extend(func.prototype, CustomEvents.prototype);
        };
        CustomEvents.prototype._getHandlerItem = function(handler, context) {
          var item = { handler };
          if (context) {
            item.context = context;
          }
          return item;
        };
        CustomEvents.prototype._safeEvent = function(eventName) {
          var events = this.events;
          var byName;
          if (!events) {
            events = this.events = {};
          }
          if (eventName) {
            byName = events[eventName];
            if (!byName) {
              byName = [];
              events[eventName] = byName;
            }
            events = byName;
          }
          return events;
        };
        CustomEvents.prototype._safeContext = function() {
          var context = this.contexts;
          if (!context) {
            context = this.contexts = [];
          }
          return context;
        };
        CustomEvents.prototype._indexOfContext = function(ctx) {
          var context = this._safeContext();
          var index = 0;
          while (context[index]) {
            if (ctx === context[index][0]) {
              return index;
            }
            index += 1;
          }
          return -1;
        };
        CustomEvents.prototype._memorizeContext = function(ctx) {
          var context, index;
          if (!isExisty(ctx)) {
            return;
          }
          context = this._safeContext();
          index = this._indexOfContext(ctx);
          if (index > -1) {
            context[index][1] += 1;
          } else {
            context.push([ctx, 1]);
          }
        };
        CustomEvents.prototype._forgetContext = function(ctx) {
          var context, contextIndex;
          if (!isExisty(ctx)) {
            return;
          }
          context = this._safeContext();
          contextIndex = this._indexOfContext(ctx);
          if (contextIndex > -1) {
            context[contextIndex][1] -= 1;
            if (context[contextIndex][1] <= 0) {
              context.splice(contextIndex, 1);
            }
          }
        };
        CustomEvents.prototype._bindEvent = function(eventName, handler, context) {
          var events = this._safeEvent(eventName);
          this._memorizeContext(context);
          events.push(this._getHandlerItem(handler, context));
        };
        CustomEvents.prototype.on = function(eventName, handler, context) {
          var self2 = this;
          if (isString(eventName)) {
            eventName = eventName.split(R_EVENTNAME_SPLIT);
            forEach(eventName, function(name) {
              self2._bindEvent(name, handler, context);
            });
          } else if (isObject(eventName)) {
            context = handler;
            forEach(eventName, function(func, name) {
              self2.on(name, func, context);
            });
          }
        };
        CustomEvents.prototype.once = function(eventName, handler, context) {
          var self2 = this;
          if (isObject(eventName)) {
            context = handler;
            forEach(eventName, function(func, name) {
              self2.once(name, func, context);
            });
            return;
          }
          function onceHandler() {
            handler.apply(context, arguments);
            self2.off(eventName, onceHandler, context);
          }
          this.on(eventName, onceHandler, context);
        };
        CustomEvents.prototype._spliceMatches = function(arr, predicate) {
          var i = 0;
          var len;
          if (!isArray(arr)) {
            return;
          }
          for (len = arr.length; i < len; i += 1) {
            if (predicate(arr[i]) === true) {
              arr.splice(i, 1);
              len -= 1;
              i -= 1;
            }
          }
        };
        CustomEvents.prototype._matchHandler = function(handler) {
          var self2 = this;
          return function(item) {
            var needRemove = handler === item.handler;
            if (needRemove) {
              self2._forgetContext(item.context);
            }
            return needRemove;
          };
        };
        CustomEvents.prototype._matchContext = function(context) {
          var self2 = this;
          return function(item) {
            var needRemove = context === item.context;
            if (needRemove) {
              self2._forgetContext(item.context);
            }
            return needRemove;
          };
        };
        CustomEvents.prototype._matchHandlerAndContext = function(handler, context) {
          var self2 = this;
          return function(item) {
            var matchHandler = handler === item.handler;
            var matchContext = context === item.context;
            var needRemove = matchHandler && matchContext;
            if (needRemove) {
              self2._forgetContext(item.context);
            }
            return needRemove;
          };
        };
        CustomEvents.prototype._offByEventName = function(eventName, handler) {
          var self2 = this;
          var andByHandler = isFunction(handler);
          var matchHandler = self2._matchHandler(handler);
          eventName = eventName.split(R_EVENTNAME_SPLIT);
          forEach(eventName, function(name) {
            var handlerItems = self2._safeEvent(name);
            if (andByHandler) {
              self2._spliceMatches(handlerItems, matchHandler);
            } else {
              forEach(handlerItems, function(item) {
                self2._forgetContext(item.context);
              });
              self2.events[name] = [];
            }
          });
        };
        CustomEvents.prototype._offByHandler = function(handler) {
          var self2 = this;
          var matchHandler = this._matchHandler(handler);
          forEach(this._safeEvent(), function(handlerItems) {
            self2._spliceMatches(handlerItems, matchHandler);
          });
        };
        CustomEvents.prototype._offByObject = function(obj, handler) {
          var self2 = this;
          var matchFunc;
          if (this._indexOfContext(obj) < 0) {
            forEach(obj, function(func, name) {
              self2.off(name, func);
            });
          } else if (isString(handler)) {
            matchFunc = this._matchContext(obj);
            self2._spliceMatches(this._safeEvent(handler), matchFunc);
          } else if (isFunction(handler)) {
            matchFunc = this._matchHandlerAndContext(handler, obj);
            forEach(this._safeEvent(), function(handlerItems) {
              self2._spliceMatches(handlerItems, matchFunc);
            });
          } else {
            matchFunc = this._matchContext(obj);
            forEach(this._safeEvent(), function(handlerItems) {
              self2._spliceMatches(handlerItems, matchFunc);
            });
          }
        };
        CustomEvents.prototype.off = function(eventName, handler) {
          if (isString(eventName)) {
            this._offByEventName(eventName, handler);
          } else if (!arguments.length) {
            this.events = {};
            this.contexts = [];
          } else if (isFunction(eventName)) {
            this._offByHandler(eventName);
          } else if (isObject(eventName)) {
            this._offByObject(eventName, handler);
          }
        };
        CustomEvents.prototype.fire = function(eventName) {
          this.invoke.apply(this, arguments);
        };
        CustomEvents.prototype.invoke = function(eventName) {
          var events, args, index, item;
          if (!this.hasListener(eventName)) {
            return true;
          }
          events = this._safeEvent(eventName);
          args = Array.prototype.slice.call(arguments, 1);
          index = 0;
          while (events[index]) {
            item = events[index];
            if (item.handler.apply(item.context, args) === false) {
              return false;
            }
            index += 1;
          }
          return true;
        };
        CustomEvents.prototype.hasListener = function(eventName) {
          return this.getListenerLength(eventName) > 0;
        };
        CustomEvents.prototype.getListenerLength = function(eventName) {
          var events = this._safeEvent(eventName);
          return events.length;
        };
        module2.exports = CustomEvents;
      },
      function(module2, exports2, __webpack_require__) {
        var isArray = __webpack_require__(6);
        var forEachArray = __webpack_require__(2);
        var forEachOwnProperties = __webpack_require__(23);
        function forEach(obj, iteratee, context) {
          if (isArray(obj)) {
            forEachArray(obj, iteratee, context);
          } else {
            forEachOwnProperties(obj, iteratee, context);
          }
        }
        module2.exports = forEach;
      },
      function(module2, exports2, __webpack_require__) {
        module2.exports = {
          en: {
            titles: {
              DD: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
              D: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
              MMM: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
              MMMM: [
                "January",
                "February",
                "March",
                "April",
                "May",
                "June",
                "July",
                "August",
                "September",
                "October",
                "November",
                "December"
              ]
            },
            titleFormat: "MMMM yyyy",
            todayFormat: "To\\d\\ay: DD, MMMM d, yyyy",
            time: "Time",
            date: "Date"
          },
          ko: {
            titles: {
              DD: ["\uC77C\uC694\uC77C", "\uC6D4\uC694\uC77C", "\uD654\uC694\uC77C", "\uC218\uC694\uC77C", "\uBAA9\uC694\uC77C", "\uAE08\uC694\uC77C", "\uD1A0\uC694\uC77C"],
              D: ["\uC77C", "\uC6D4", "\uD654", "\uC218", "\uBAA9", "\uAE08", "\uD1A0"],
              MMM: ["1\uC6D4", "2\uC6D4", "3\uC6D4", "4\uC6D4", "5\uC6D4", "6\uC6D4", "7\uC6D4", "8\uC6D4", "9\uC6D4", "10\uC6D4", "11\uC6D4", "12\uC6D4"],
              MMMM: ["1\uC6D4", "2\uC6D4", "3\uC6D4", "4\uC6D4", "5\uC6D4", "6\uC6D4", "7\uC6D4", "8\uC6D4", "9\uC6D4", "10\uC6D4", "11\uC6D4", "12\uC6D4"]
            },
            titleFormat: "yyyy.MM",
            todayFormat: "\uC624\uB298: yyyy.MM.dd (D)",
            date: "\uB0A0\uC9DC",
            time: "\uC2DC\uAC04"
          }
        };
      },
      function(module2, exports2, __webpack_require__) {
        var inArray = __webpack_require__(3);
        var forEach = __webpack_require__(9);
        var isArray = __webpack_require__(6);
        var isString = __webpack_require__(13);
        var extend = __webpack_require__(7);
        var EXPRESSION_REGEXP = /{{\s?|\s?}}/g;
        var BRACKET_NOTATION_REGEXP = /^[a-zA-Z0-9_@]+\[[a-zA-Z0-9_@"']+\]$/;
        var BRACKET_REGEXP = /\[\s?|\s?\]/;
        var DOT_NOTATION_REGEXP = /^[a-zA-Z_]+\.[a-zA-Z_]+$/;
        var DOT_REGEXP = /\./;
        var STRING_NOTATION_REGEXP = /^["']\w+["']$/;
        var STRING_REGEXP = /"|'/g;
        var NUMBER_REGEXP = /^-?\d+\.?\d*$/;
        var EXPRESSION_INTERVAL = 2;
        var BLOCK_HELPERS = {
          "if": handleIf,
          "each": handleEach,
          "with": handleWith
        };
        var isValidSplit = "a".split(/a/).length === 3;
        var splitByRegExp = function() {
          if (isValidSplit) {
            return function(text, regexp) {
              return text.split(regexp);
            };
          }
          return function(text, regexp) {
            var result = [];
            var prevIndex = 0;
            var match, index;
            if (!regexp.global) {
              regexp = new RegExp(regexp, "g");
            }
            match = regexp.exec(text);
            while (match !== null) {
              index = match.index;
              result.push(text.slice(prevIndex, index));
              prevIndex = index + match[0].length;
              match = regexp.exec(text);
            }
            result.push(text.slice(prevIndex));
            return result;
          };
        }();
        function getValueFromContext(exp, context) {
          var splitedExps;
          var value = context[exp];
          if (exp === "true") {
            value = true;
          } else if (exp === "false") {
            value = false;
          } else if (STRING_NOTATION_REGEXP.test(exp)) {
            value = exp.replace(STRING_REGEXP, "");
          } else if (BRACKET_NOTATION_REGEXP.test(exp)) {
            splitedExps = exp.split(BRACKET_REGEXP);
            value = getValueFromContext(splitedExps[0], context)[getValueFromContext(splitedExps[1], context)];
          } else if (DOT_NOTATION_REGEXP.test(exp)) {
            splitedExps = exp.split(DOT_REGEXP);
            value = getValueFromContext(splitedExps[0], context)[splitedExps[1]];
          } else if (NUMBER_REGEXP.test(exp)) {
            value = parseFloat(exp);
          }
          return value;
        }
        function extractElseif(ifExps, sourcesInsideBlock) {
          var exps = [ifExps];
          var sourcesInsideIf = [];
          var otherIfCount = 0;
          var start = 0;
          forEach(sourcesInsideBlock, function(source, index) {
            if (source.indexOf("if") === 0) {
              otherIfCount += 1;
            } else if (source === "/if") {
              otherIfCount -= 1;
            } else if (!otherIfCount && (source.indexOf("elseif") === 0 || source === "else")) {
              exps.push(source === "else" ? ["true"] : source.split(" ").slice(1));
              sourcesInsideIf.push(sourcesInsideBlock.slice(start, index));
              start = index + 1;
            }
          });
          sourcesInsideIf.push(sourcesInsideBlock.slice(start));
          return {
            exps,
            sourcesInsideIf
          };
        }
        function handleIf(exps, sourcesInsideBlock, context) {
          var analyzed = extractElseif(exps, sourcesInsideBlock);
          var result = false;
          var compiledSource = "";
          forEach(analyzed.exps, function(exp, index) {
            result = handleExpression(exp, context);
            if (result) {
              compiledSource = compile(analyzed.sourcesInsideIf[index], context);
            }
            return !result;
          });
          return compiledSource;
        }
        function handleEach(exps, sourcesInsideBlock, context) {
          var collection = handleExpression(exps, context);
          var additionalKey = isArray(collection) ? "@index" : "@key";
          var additionalContext = {};
          var result = "";
          forEach(collection, function(item, key) {
            additionalContext[additionalKey] = key;
            additionalContext["@this"] = item;
            extend(context, additionalContext);
            result += compile(sourcesInsideBlock.slice(), context);
          });
          return result;
        }
        function handleWith(exps, sourcesInsideBlock, context) {
          var asIndex = inArray("as", exps);
          var alias = exps[asIndex + 1];
          var result = handleExpression(exps.slice(0, asIndex), context);
          var additionalContext = {};
          additionalContext[alias] = result;
          return compile(sourcesInsideBlock, extend(context, additionalContext)) || "";
        }
        function extractSourcesInsideBlock(sources, start, end) {
          var sourcesInsideBlock = sources.splice(start + 1, end - start);
          sourcesInsideBlock.pop();
          return sourcesInsideBlock;
        }
        function handleBlockHelper(helperKeyword, sourcesToEnd, context) {
          var executeBlockHelper = BLOCK_HELPERS[helperKeyword];
          var helperCount = 1;
          var startBlockIndex = 0;
          var endBlockIndex;
          var index = startBlockIndex + EXPRESSION_INTERVAL;
          var expression = sourcesToEnd[index];
          while (helperCount && isString(expression)) {
            if (expression.indexOf(helperKeyword) === 0) {
              helperCount += 1;
            } else if (expression.indexOf("/" + helperKeyword) === 0) {
              helperCount -= 1;
              endBlockIndex = index;
            }
            index += EXPRESSION_INTERVAL;
            expression = sourcesToEnd[index];
          }
          if (helperCount) {
            throw Error(helperKeyword + " needs {{/" + helperKeyword + "}} expression.");
          }
          sourcesToEnd[startBlockIndex] = executeBlockHelper(
            sourcesToEnd[startBlockIndex].split(" ").slice(1),
            extractSourcesInsideBlock(sourcesToEnd, startBlockIndex, endBlockIndex),
            context
          );
          return sourcesToEnd;
        }
        function handleExpression(exps, context) {
          var result = getValueFromContext(exps[0], context);
          if (result instanceof Function) {
            return executeFunction(result, exps.slice(1), context);
          }
          return result;
        }
        function executeFunction(helper, argExps, context) {
          var args = [];
          forEach(argExps, function(exp) {
            args.push(getValueFromContext(exp, context));
          });
          return helper.apply(null, args);
        }
        function compile(sources, context) {
          var index = 1;
          var expression = sources[index];
          var exps, firstExp, result;
          while (isString(expression)) {
            exps = expression.split(" ");
            firstExp = exps[0];
            if (BLOCK_HELPERS[firstExp]) {
              result = handleBlockHelper(firstExp, sources.splice(index, sources.length - index), context);
              sources = sources.concat(result);
            } else {
              sources[index] = handleExpression(exps, context);
            }
            index += EXPRESSION_INTERVAL;
            expression = sources[index];
          }
          return sources.join("");
        }
        function template(text, context) {
          return compile(splitByRegExp(text, EXPRESSION_REGEXP), context);
        }
        module2.exports = template;
      },
      function(module2, exports2, __webpack_require__) {
        function isUndefined(obj) {
          return obj === void 0;
        }
        module2.exports = isUndefined;
      },
      function(module2, exports2, __webpack_require__) {
        function isString(obj) {
          return typeof obj === "string" || obj instanceof String;
        }
        module2.exports = isString;
      },
      function(module2, exports2, __webpack_require__) {
        function removeElement(element) {
          if (element && element.parentNode) {
            element.parentNode.removeChild(element);
          }
        }
        module2.exports = removeElement;
      },
      function(module2, exports2, __webpack_require__) {
        function isNumber(obj) {
          return typeof obj === "number" || obj instanceof Number;
        }
        module2.exports = isNumber;
      },
      function(module2, exports2, __webpack_require__) {
        var forEach = __webpack_require__(9);
        var inArray = __webpack_require__(3);
        var getClass = __webpack_require__(17);
        var setClassName = __webpack_require__(24);
        function addClass(element) {
          var cssClass = Array.prototype.slice.call(arguments, 1);
          var classList = element.classList;
          var newClass = [];
          var origin;
          if (classList) {
            forEach(cssClass, function(name) {
              element.classList.add(name);
            });
            return;
          }
          origin = getClass(element);
          if (origin) {
            cssClass = [].concat(origin.split(/\s+/), cssClass);
          }
          forEach(cssClass, function(cls) {
            if (inArray(cls, newClass) < 0) {
              newClass.push(cls);
            }
          });
          setClassName(element, newClass);
        }
        module2.exports = addClass;
      },
      function(module2, exports2, __webpack_require__) {
        var isUndefined = __webpack_require__(12);
        function getClass(element) {
          if (!element || !element.className) {
            return "";
          }
          if (isUndefined(element.className.baseVal)) {
            return element.className;
          }
          return element.className.baseVal;
        }
        module2.exports = getClass;
      },
      function(module2, exports2, __webpack_require__) {
        var forEachArray = __webpack_require__(2);
        var inArray = __webpack_require__(3);
        var getClass = __webpack_require__(17);
        var setClassName = __webpack_require__(24);
        function removeClass(element) {
          var cssClass = Array.prototype.slice.call(arguments, 1);
          var classList = element.classList;
          var origin, newClass;
          if (classList) {
            forEachArray(cssClass, function(name) {
              classList.remove(name);
            });
            return;
          }
          origin = getClass(element).split(/\s+/);
          newClass = [];
          forEachArray(origin, function(name) {
            if (inArray(name, cssClass) < 0) {
              newClass.push(name);
            }
          });
          setClassName(element, newClass);
        }
        module2.exports = removeClass;
      },
      function(module2, exports2, __webpack_require__) {
        var on2 = __webpack_require__(31);
        var off = __webpack_require__(33);
        var mouseTouchEvent = {
          _isMobile: function() {
            return /Android|BlackBerry|iPhone|iPad|iPod|Opera Mini|IEMobile|WPDesktop/i.test(
              navigator.userAgent
            );
          }(),
          _getEventType: function(type) {
            if (this._isMobile) {
              if (type === "mousedown") {
                type = "touchstart";
              } else if (type === "click") {
                type = "touchend";
              }
            }
            return type;
          },
          on: function(element, type, handler, context) {
            on2(element, this._getEventType(type), handler, context);
          },
          off: function(element, type, handler) {
            off(element, this._getEventType(type), handler);
          }
        };
        module2.exports = mouseTouchEvent;
      },
      function(module2, exports2, __webpack_require__) {
        var defineClass = __webpack_require__(0);
        var removeElement = __webpack_require__(14);
        var localeText = __webpack_require__(10);
        var DEFAULT_LANGUAGE_TYPE = __webpack_require__(1).DEFAULT_LANGUAGE_TYPE;
        var LayerBase = defineClass(
          {
            init: function(language) {
              language = language || DEFAULT_LANGUAGE_TYPE;
              this._element = null;
              this._localeText = localeText[language];
              this._type = "base";
            },
            _makeContext: function() {
              throwOverrideError(this.getType(), "_makeContext");
            },
            render: function() {
              throwOverrideError(this.getType(), "render");
            },
            getDateElements: function() {
              throwOverrideError(this.getType(), "getDateElements");
            },
            getType: function() {
              return this._type;
            },
            changeLanguage: function(language) {
              this._localeText = localeText[language];
            },
            remove: function() {
              if (this._element) {
                removeElement(this._element);
              }
              this._element = null;
            }
          }
        );
        function throwOverrideError(layerType, methodName) {
          throw new Error(layerType + ' layer does not have the "' + methodName + '" method.');
        }
        module2.exports = LayerBase;
      },
      function(module2, exports2, __webpack_require__) {
        var inArray = __webpack_require__(3);
        var forEachArray = __webpack_require__(2);
        var defineClass = __webpack_require__(0);
        var CustomEvents = __webpack_require__(8);
        var addClass = __webpack_require__(16);
        var closest = __webpack_require__(25);
        var getData = __webpack_require__(26);
        var hasClass = __webpack_require__(27);
        var removeClass = __webpack_require__(18);
        var removeElement = __webpack_require__(14);
        var extend = __webpack_require__(7);
        var isArray = __webpack_require__(6);
        var isDate = __webpack_require__(28);
        var isNumber = __webpack_require__(15);
        var isObject = __webpack_require__(22);
        var TimePicker = __webpack_require__(43);
        var Calendar2 = __webpack_require__(29);
        var RangeModel = __webpack_require__(56);
        var constants = __webpack_require__(1);
        var localeTexts = __webpack_require__(10);
        var dateUtil = __webpack_require__(5);
        var util = __webpack_require__(4);
        var mouseTouchEvent = __webpack_require__(19);
        var tmpl = __webpack_require__(58);
        var DatePickerInput = __webpack_require__(59);
        var DEFAULT_WEEK_START_DAY = constants.DEFAULT_WEEK_START_DAY;
        var DEFAULT_LANGUAGE_TYPE = constants.DEFAULT_LANGUAGE_TYPE;
        var TYPE_DATE = constants.TYPE_DATE;
        var TYPE_MONTH = constants.TYPE_MONTH;
        var TYPE_YEAR = constants.TYPE_YEAR;
        var CLASS_NAME_NEXT_YEAR_BTN = constants.CLASS_NAME_NEXT_YEAR_BTN;
        var CLASS_NAME_NEXT_MONTH_BTN = constants.CLASS_NAME_NEXT_MONTH_BTN;
        var CLASS_NAME_PREV_YEAR_BTN = constants.CLASS_NAME_PREV_YEAR_BTN;
        var CLASS_NAME_PREV_MONTH_BTN = constants.CLASS_NAME_PREV_MONTH_BTN;
        var CLASS_NAME_SELECTED = constants.CLASS_NAME_SELECTED;
        var CLASS_NAME_TITLE_TODAY = constants.CLASS_NAME_TITLE_TODAY;
        var CLASS_NAME_SELECTABLE = "tui-is-selectable";
        var CLASS_NAME_BLOCKED = "tui-is-blocked";
        var CLASS_NAME_CHECKED = "tui-is-checked";
        var CLASS_NAME_SELECTOR_BUTTON = "tui-datepicker-selector-button";
        var CLASS_NAME_TODAY = "tui-calendar-today";
        var CLASS_NAME_HIDDEN = "tui-hidden";
        var SELECTOR_BODY = ".tui-datepicker-body";
        var SELECTOR_DATE_ICO = ".tui-ico-date";
        var SELECTOR_CALENDAR_TITLE = ".tui-calendar-title";
        var SELECTOR_CALENDAR_CONTAINER = ".tui-calendar-container";
        var SELECTOR_TIMEPICKER_CONTAINER = ".tui-timepicker-container";
        var mergeDefaultOption = function(option) {
          option = extend(
            {
              language: DEFAULT_LANGUAGE_TYPE,
              calendar: {},
              input: {
                element: null,
                format: null
              },
              timePicker: null,
              date: null,
              showAlways: false,
              type: TYPE_DATE,
              selectableRanges: null,
              openers: [],
              autoClose: true,
              usageStatistics: true,
              weekStartDay: DEFAULT_WEEK_START_DAY
            },
            option
          );
          option.selectableRanges = option.selectableRanges || [[constants.MIN_DATE, constants.MAX_DATE]];
          if (!isObject(option.calendar)) {
            throw new Error("Calendar option must be an object");
          }
          if (!isObject(option.input)) {
            throw new Error("Input option must be an object");
          }
          if (!isArray(option.selectableRanges)) {
            throw new Error("Selectable-ranges must be a 2d-array");
          }
          option.localeText = localeTexts[option.language];
          option.calendar.language = option.language;
          option.calendar.type = option.type;
          option.timePicker = option.timePicker || option.timepicker;
          return option;
        };
        var DatePicker = defineClass(
          {
            static: {
              localeTexts
            },
            init: function(container, options) {
              options = mergeDefaultOption(options);
              this._language = options.language;
              this._container = util.getElement(container);
              this._container.innerHTML = tmpl(
                extend(options, {
                  isTab: options.timePicker && options.timePicker.layoutType === "tab"
                })
              );
              this._element = this._container.firstChild;
              this._calendar = new Calendar2(
                this._element.querySelector(SELECTOR_CALENDAR_CONTAINER),
                extend(options.calendar, {
                  usageStatistics: options.usageStatistics,
                  weekStartDay: options.weekStartDay
                })
              );
              this._timePicker = null;
              this._datepickerInput = null;
              this._date = null;
              this._rangeModel = null;
              this._openers = [];
              this._isEnabled = true;
              this._id = "tui-datepicker-" + util.generateId();
              this._type = options.type;
              this.showAlways = options.showAlways;
              this.autoClose = options.autoClose;
              this._initializeDatePicker(options);
            },
            _initializeDatePicker: function(option) {
              this.setRanges(option.selectableRanges);
              this._setEvents();
              this._initTimePicker(option.timePicker, option.usageStatistics);
              this.setInput(option.input.element);
              this.setDateFormat(option.input.format);
              this.setDate(option.date);
              forEachArray(option.openers, this.addOpener, this);
              if (!this.showAlways) {
                this._hide();
              }
              if (this.getType() === TYPE_DATE) {
                addClass(this._element.querySelector(SELECTOR_BODY), "tui-datepicker-type-date");
              }
            },
            _setEvents: function() {
              mouseTouchEvent.on(this._element, "click", this._onClickHandler, this);
              this._calendar.on("draw", this._onDrawCalendar, this);
            },
            _removeEvents: function() {
              mouseTouchEvent.off(this._element, "click", this._onClickHandler, this);
              this._calendar.off();
            },
            _setDocumentEvents: function() {
              mouseTouchEvent.on(document, "mousedown", this._onMousedownDocument, this);
            },
            _removeDocumentEvents: function() {
              mouseTouchEvent.off(document, "mousedown", this._onMousedownDocument);
            },
            _setOpenerEvents: function(opener) {
              mouseTouchEvent.on(opener, "click", this.toggle, this);
            },
            _removeOpenerEvents: function(opener) {
              mouseTouchEvent.off(opener, "click", this.toggle);
            },
            _initTimePicker: function(opTimePicker, usageStatistics) {
              var layoutType;
              if (!opTimePicker) {
                return;
              }
              layoutType = opTimePicker.layoutType || "";
              if (isObject(opTimePicker)) {
                opTimePicker.usageStatistics = usageStatistics;
              } else {
                opTimePicker = {
                  usageStatistics
                };
              }
              this._timePicker = new TimePicker(
                this._element.querySelector(SELECTOR_TIMEPICKER_CONTAINER),
                opTimePicker
              );
              if (layoutType.toLowerCase() === "tab") {
                this._timePicker.hide();
              }
              this._timePicker.on(
                "change",
                function(ev) {
                  var prevDate;
                  if (this._date) {
                    prevDate = new Date(this._date);
                    this.setDate(prevDate.setHours(ev.hour, ev.minute));
                  }
                },
                this
              );
            },
            _changePicker: function(target) {
              var btnSelector = "." + CLASS_NAME_SELECTOR_BUTTON;
              var selectedBtn = closest(target, btnSelector);
              var isDateElement = !!selectedBtn.querySelector(SELECTOR_DATE_ICO);
              if (isDateElement) {
                this._calendar.show();
                this._timePicker.hide();
              } else {
                this._calendar.hide();
                this._timePicker.show();
              }
              removeClass(this._element.querySelector("." + CLASS_NAME_CHECKED), CLASS_NAME_CHECKED);
              addClass(selectedBtn, CLASS_NAME_CHECKED);
            },
            _isOpener: function(element) {
              var el2 = util.getElement(element);
              return inArray(el2, this._openers) > -1;
            },
            _setTodayClassName: function(el2) {
              var timestamp, isToday;
              if (this.getCalendarType() !== TYPE_DATE) {
                return;
              }
              timestamp = Number(getData(el2, "timestamp"));
              isToday = timestamp === new Date().setHours(0, 0, 0, 0);
              if (isToday) {
                addClass(el2, CLASS_NAME_TODAY);
              } else {
                removeClass(el2, CLASS_NAME_TODAY);
              }
            },
            _setSelectableClassName: function(el2) {
              var elDate = new Date(Number(getData(el2, "timestamp")));
              if (this._isSelectableOnCalendar(elDate)) {
                addClass(el2, CLASS_NAME_SELECTABLE);
                removeClass(el2, CLASS_NAME_BLOCKED);
              } else {
                removeClass(el2, CLASS_NAME_SELECTABLE);
                addClass(el2, CLASS_NAME_BLOCKED);
              }
            },
            _setSelectedClassName: function(el2) {
              var elDate = new Date(Number(getData(el2, "timestamp")));
              if (this._isSelectedOnCalendar(elDate)) {
                addClass(el2, CLASS_NAME_SELECTED);
              } else {
                removeClass(el2, CLASS_NAME_SELECTED);
              }
            },
            _isSelectableOnCalendar: function(date) {
              var type = this.getCalendarType();
              var start = dateUtil.cloneWithStartOf(date, type).getTime();
              var end = dateUtil.cloneWithEndOf(date, type).getTime();
              return this._rangeModel.hasOverlap(start, end);
            },
            _isSelectedOnCalendar: function(date) {
              var curDate = this.getDate();
              var calendarType = this.getCalendarType();
              return curDate && dateUtil.isSame(curDate, date, calendarType);
            },
            _show: function() {
              removeClass(this._element, CLASS_NAME_HIDDEN);
            },
            _hide: function() {
              addClass(this._element, CLASS_NAME_HIDDEN);
            },
            _syncToInput: function() {
              if (!this._date) {
                return;
              }
              this._datepickerInput.setDate(this._date);
            },
            _syncFromInput: function(shouldRollback) {
              var isFailed = false;
              var date;
              try {
                date = this._datepickerInput.getDate();
                if (this.isSelectable(date)) {
                  if (this._timePicker) {
                    this._timePicker.setTime(date.getHours(), date.getMinutes());
                  }
                  this.setDate(date);
                } else {
                  isFailed = true;
                }
              } catch (err) {
                this.fire("error", {
                  type: "ParsingError",
                  message: err.message
                });
                isFailed = true;
              } finally {
                if (isFailed) {
                  if (shouldRollback) {
                    this._syncToInput();
                  } else {
                    this.setNull();
                  }
                }
              }
            },
            _onMousedownDocument: function(ev) {
              var target = util.getTarget(ev);
              var selector = util.getSelector(target);
              var isContain = selector ? this._element.querySelector(selector) : false;
              var isInput = this._datepickerInput.is(target);
              var isInOpener = inArray(target, this._openers) > -1;
              var shouldClose = !(this.showAlways || isInput || isContain || isInOpener);
              if (shouldClose) {
                this.close();
              }
            },
            _onClickHandler: function(ev) {
              var target = util.getTarget(ev);
              if (closest(target, "." + CLASS_NAME_SELECTABLE)) {
                ev.preventDefault();
                this._updateDate(target);
              } else if (closest(target, "." + CLASS_NAME_TITLE_TODAY)) {
                ev.preventDefault();
                this._updateDateToToday();
              } else if (closest(target, SELECTOR_CALENDAR_TITLE)) {
                this.drawUpperCalendar(this._date);
              } else if (closest(target, "." + CLASS_NAME_SELECTOR_BUTTON)) {
                this._changePicker(target);
              }
            },
            _updateDateToToday: function() {
              this.setDate(Date.now());
              this.close();
            },
            _updateDate: function(target) {
              var timestamp = Number(getData(target, "timestamp"));
              var newDate = new Date(timestamp);
              var timePicker = this._timePicker;
              var prevDate = this._date;
              var calendarType = this.getCalendarType();
              var pickerType = this.getType();
              if (calendarType !== pickerType) {
                this.drawLowerCalendar(newDate);
              } else {
                if (timePicker) {
                  newDate.setHours(timePicker.getHour(), timePicker.getMinute());
                } else if (prevDate) {
                  newDate.setHours(prevDate.getHours(), prevDate.getMinutes());
                }
                this.setDate(newDate);
                if (!this.showAlways && this.autoClose) {
                  this.close();
                }
              }
            },
            _onDrawCalendar: function(eventData) {
              forEachArray(
                eventData.dateElements,
                function(el2) {
                  this._setTodayClassName(el2);
                  this._setSelectableClassName(el2);
                  this._setSelectedClassName(el2);
                },
                this
              );
              this._setDisplayHeadButtons();
              this.fire("draw", eventData);
            },
            _setDisplayHeadButtons: function() {
              var customStep = 60;
              var nextYearDate = this._calendar.getNextYearDate(
                this.getCalendarType() === TYPE_YEAR ? customStep : null
              );
              var prevYearDate = this._calendar.getPrevYearDate(
                this.getCalendarType() === TYPE_YEAR ? -customStep : null
              );
              var maxTimestamp = this._rangeModel.getMaximumValue();
              var minTimestamp = this._rangeModel.getMinimumValue();
              var nextYearBtn = this._element.querySelector("." + CLASS_NAME_NEXT_YEAR_BTN);
              var prevYearBtn = this._element.querySelector("." + CLASS_NAME_PREV_YEAR_BTN);
              var nextMonthDate, prevMonthDate, nextMonBtn, prevMonBtn;
              if (this.getCalendarType() === TYPE_DATE) {
                nextMonthDate = dateUtil.cloneWithStartOf(this._calendar.getNextDate(), TYPE_MONTH);
                prevMonthDate = dateUtil.cloneWithEndOf(this._calendar.getPrevDate(), TYPE_MONTH);
                nextMonBtn = this._element.querySelector("." + CLASS_NAME_NEXT_MONTH_BTN);
                prevMonBtn = this._element.querySelector("." + CLASS_NAME_PREV_MONTH_BTN);
                this._setDisplay(nextMonBtn, nextMonthDate.getTime() <= maxTimestamp);
                this._setDisplay(prevMonBtn, prevMonthDate.getTime() >= minTimestamp);
                prevYearDate.setDate(1);
                nextYearDate.setDate(1);
              } else {
                prevYearDate.setMonth(12, 0);
                nextYearDate.setMonth(0, 1);
              }
              this._setDisplay(nextYearBtn, nextYearDate.getTime() <= maxTimestamp);
              this._setDisplay(prevYearBtn, prevYearDate.getTime() >= minTimestamp);
            },
            _setDisplay: function(el2, shouldShow) {
              if (el2) {
                if (shouldShow) {
                  removeClass(el2, CLASS_NAME_HIDDEN);
                } else {
                  addClass(el2, CLASS_NAME_HIDDEN);
                }
              }
            },
            _onChangeInput: function() {
              this._syncFromInput(true);
            },
            _isChanged: function(date) {
              var prevDate = this.getDate();
              return !prevDate || date.getTime() !== prevDate.getTime();
            },
            _refreshFromRanges: function() {
              if (!this.isSelectable(this._date)) {
                this.setNull();
              } else {
                this._calendar.draw();
              }
            },
            getCalendarType: function() {
              return this._calendar.getType();
            },
            getType: function() {
              return this._type;
            },
            isSelectable: function(date) {
              var type = this.getType();
              var start, end;
              if (!dateUtil.isValidDate(date)) {
                return false;
              }
              start = dateUtil.cloneWithStartOf(date, type).getTime();
              end = dateUtil.cloneWithEndOf(date, type).getTime();
              return this._rangeModel.hasOverlap(start, end);
            },
            isSelected: function(date) {
              return dateUtil.isValidDate(date) && dateUtil.isSame(this._date, date, this.getType());
            },
            setRanges: function(ranges) {
              var result = [];
              forEachArray(ranges, function(range) {
                var start = new Date(range[0]).getTime();
                var end = new Date(range[1]).getTime();
                result.push([start, end]);
              });
              this._rangeModel = new RangeModel(result);
              this._refreshFromRanges();
            },
            setType: function(type) {
              this._type = type;
            },
            addRange: function(start, end) {
              start = new Date(start).getTime();
              end = new Date(end).getTime();
              this._rangeModel.add(start, end);
              this._refreshFromRanges();
            },
            removeRange: function(start, end, type) {
              start = new Date(start);
              end = new Date(end);
              if (type) {
                start = dateUtil.cloneWithStartOf(start, type);
                end = dateUtil.cloneWithEndOf(end, type);
              }
              this._rangeModel.exclude(start.getTime(), end.getTime());
              this._refreshFromRanges();
            },
            addOpener: function(opener) {
              opener = util.getElement(opener);
              if (!this._isOpener(opener)) {
                this._openers.push(opener);
                this._setOpenerEvents(opener);
              }
            },
            removeOpener: function(opener) {
              var index;
              opener = util.getElement(opener);
              index = inArray(opener, this._openers);
              if (index > -1) {
                this._removeOpenerEvents(opener);
                this._openers.splice(index, 1);
              }
            },
            removeAllOpeners: function() {
              forEachArray(
                this._openers,
                function(opener) {
                  this._removeOpenerEvents(opener);
                },
                this
              );
              this._openers = [];
            },
            open: function() {
              if (this.isOpened() || !this._isEnabled) {
                return;
              }
              this._calendar.draw({
                date: this._date,
                type: this._type
              });
              this._show();
              if (!this.showAlways) {
                this._setDocumentEvents();
              }
              this.fire("open");
            },
            drawUpperCalendar: function(date) {
              var calendarType = this.getCalendarType();
              if (calendarType === TYPE_DATE) {
                this._calendar.draw({
                  date,
                  type: TYPE_MONTH
                });
              } else if (calendarType === TYPE_MONTH) {
                this._calendar.draw({
                  date,
                  type: TYPE_YEAR
                });
              }
            },
            drawLowerCalendar: function(date) {
              var calendarType = this.getCalendarType();
              var pickerType = this.getType();
              var isLast = calendarType === pickerType;
              if (isLast) {
                return;
              }
              if (calendarType === TYPE_MONTH) {
                this._calendar.draw({
                  date,
                  type: TYPE_DATE
                });
              } else if (calendarType === TYPE_YEAR) {
                this._calendar.draw({
                  date,
                  type: TYPE_MONTH
                });
              }
            },
            close: function() {
              if (!this.isOpened()) {
                return;
              }
              this._removeDocumentEvents();
              this._hide();
              this.fire("close");
            },
            toggle: function() {
              if (this.isOpened()) {
                this.close();
              } else {
                this.open();
              }
            },
            getDate: function() {
              if (!this._date) {
                return null;
              }
              return new Date(this._date);
            },
            setDate: function(date, silent) {
              var isValidInput, newDate, shouldUpdate;
              if (date === null) {
                this.setNull();
                return;
              }
              isValidInput = isNumber(date) || isDate(date);
              newDate = new Date(date);
              shouldUpdate = isValidInput && this._isChanged(newDate) && this.isSelectable(newDate);
              if (shouldUpdate) {
                newDate = new Date(date);
                this._date = newDate;
                this._calendar.draw({ date: newDate });
                if (this._timePicker) {
                  this._timePicker.setTime(newDate.getHours(), newDate.getMinutes(), true);
                }
                this._syncToInput();
                if (!silent) {
                  this.fire("change");
                }
              }
            },
            setNull: function() {
              var calendarDate = this._calendar.getDate();
              var isChagned = this._date !== null;
              this._date = null;
              if (this._datepickerInput) {
                this._datepickerInput.clearText();
              }
              if (this._timePicker) {
                this._timePicker.setTime(0, 0);
              }
              if (!this.isSelectable(calendarDate)) {
                this._calendar.draw({
                  date: new Date(this._rangeModel.getMinimumValue())
                });
              } else {
                this._calendar.draw();
              }
              if (isChagned) {
                this.fire("change");
              }
            },
            setDateFormat: function(format) {
              this._datepickerInput.setFormat(format);
              this._syncToInput();
            },
            isOpened: function() {
              return !hasClass(this._element, CLASS_NAME_HIDDEN);
            },
            getTimePicker: function() {
              return this._timePicker;
            },
            getCalendar: function() {
              return this._calendar;
            },
            getLocaleText: function() {
              return localeTexts[this._language] || localeTexts[DEFAULT_LANGUAGE_TYPE];
            },
            setInput: function(element, options) {
              var prev = this._datepickerInput;
              var localeText = this.getLocaleText();
              var prevFormat;
              options = options || {};
              if (prev) {
                prevFormat = prev.getFormat();
                prev.destroy();
              }
              this._datepickerInput = new DatePickerInput(element, {
                format: options.format || prevFormat,
                id: this._id,
                localeText
              });
              this._datepickerInput.on(
                {
                  change: this._onChangeInput,
                  click: this.open
                },
                this
              );
              if (options.syncFromInput) {
                this._syncFromInput();
              } else {
                this._syncToInput();
              }
            },
            enable: function() {
              if (this._isEnabled) {
                return;
              }
              this._isEnabled = true;
              this._datepickerInput.enable();
              forEachArray(
                this._openers,
                function(opener) {
                  opener.removeAttribute("disabled");
                  this._setOpenerEvents(opener);
                },
                this
              );
            },
            disable: function() {
              if (!this._isEnabled) {
                return;
              }
              this._isEnabled = false;
              this.close();
              this._datepickerInput.disable();
              forEachArray(
                this._openers,
                function(opener) {
                  opener.setAttribute("disabled", true);
                  this._removeOpenerEvents(opener);
                },
                this
              );
            },
            isDisabled: function() {
              return !this._isEnabled;
            },
            addCssClass: function(className) {
              addClass(this._element, className);
            },
            removeCssClass: function(className) {
              removeClass(this._element, className);
            },
            getDateElements: function() {
              return this._calendar.getDateElements();
            },
            findOverlappedRange: function(startDate, endDate) {
              var startTimestamp = new Date(startDate).getTime();
              var endTimestamp = new Date(endDate).getTime();
              var overlappedRange = this._rangeModel.findOverlappedRange(startTimestamp, endTimestamp);
              return [new Date(overlappedRange[0]), new Date(overlappedRange[1])];
            },
            changeLanguage: function(language) {
              this._language = language;
              this._calendar.changeLanguage(this._language);
              this._datepickerInput.changeLocaleTitles(this.getLocaleText().titles);
              this.setDateFormat(this._datepickerInput.getFormat());
              if (this._timePicker) {
                this._timePicker.changeLanguage(this._language);
              }
            },
            destroy: function() {
              this._removeDocumentEvents();
              this._calendar.destroy();
              if (this._timePicker) {
                this._timePicker.destroy();
              }
              if (this._datepickerInput) {
                this._datepickerInput.destroy();
              }
              this._removeEvents();
              removeElement(this._element);
              this.removeAllOpeners();
              this._calendar = this._timePicker = this._datepickerInput = this._container = this._element = this._date = this._rangeModel = this._openers = this._isEnabled = this._id = null;
            }
          }
        );
        CustomEvents.mixin(DatePicker);
        module2.exports = DatePicker;
      },
      function(module2, exports2, __webpack_require__) {
        function isObject(obj) {
          return obj === Object(obj);
        }
        module2.exports = isObject;
      },
      function(module2, exports2, __webpack_require__) {
        function forEachOwnProperties(obj, iteratee, context) {
          var key;
          context = context || null;
          for (key in obj) {
            if (obj.hasOwnProperty(key)) {
              if (iteratee.call(context, obj[key], key, obj) === false) {
                break;
              }
            }
          }
        }
        module2.exports = forEachOwnProperties;
      },
      function(module2, exports2, __webpack_require__) {
        var isArray = __webpack_require__(6);
        var isUndefined = __webpack_require__(12);
        function setClassName(element, cssClass) {
          cssClass = isArray(cssClass) ? cssClass.join(" ") : cssClass;
          cssClass = cssClass.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
          if (isUndefined(element.className.baseVal)) {
            element.className = cssClass;
            return;
          }
          element.className.baseVal = cssClass;
        }
        module2.exports = setClassName;
      },
      function(module2, exports2, __webpack_require__) {
        var matches = __webpack_require__(40);
        function closest(element, selector) {
          var parent = element.parentNode;
          if (matches(element, selector)) {
            return element;
          }
          while (parent && parent !== document) {
            if (matches(parent, selector)) {
              return parent;
            }
            parent = parent.parentNode;
          }
          return null;
        }
        module2.exports = closest;
      },
      function(module2, exports2, __webpack_require__) {
        var convertToKebabCase = __webpack_require__(42);
        function getData(element, key) {
          if (element.dataset) {
            return element.dataset[key];
          }
          return element.getAttribute("data-" + convertToKebabCase(key));
        }
        module2.exports = getData;
      },
      function(module2, exports2, __webpack_require__) {
        var inArray = __webpack_require__(3);
        var getClass = __webpack_require__(17);
        function hasClass(element, cssClass) {
          var origin;
          if (element.classList) {
            return element.classList.contains(cssClass);
          }
          origin = getClass(element).split(/\s+/);
          return inArray(cssClass, origin) > -1;
        }
        module2.exports = hasClass;
      },
      function(module2, exports2, __webpack_require__) {
        function isDate(obj) {
          return obj instanceof Date;
        }
        module2.exports = isDate;
      },
      function(module2, exports2, __webpack_require__) {
        var defineClass = __webpack_require__(0);
        var CustomEvents = __webpack_require__(8);
        var addClass = __webpack_require__(16);
        var hasClass = __webpack_require__(27);
        var removeClass = __webpack_require__(18);
        var removeElement = __webpack_require__(14);
        var extend = __webpack_require__(7);
        var Header = __webpack_require__(44);
        var Body = __webpack_require__(49);
        var localeTexts = __webpack_require__(10);
        var constants = __webpack_require__(1);
        var dateUtil = __webpack_require__(5);
        var util = __webpack_require__(4);
        var DEFAULT_WEEK_START_DAY = constants.DEFAULT_WEEK_START_DAY;
        var DEFAULT_LANGUAGE_TYPE = constants.DEFAULT_LANGUAGE_TYPE;
        var TYPE_DATE = constants.TYPE_DATE;
        var TYPE_MONTH = constants.TYPE_MONTH;
        var TYPE_YEAR = constants.TYPE_YEAR;
        var CLASS_NAME_PREV_MONTH_BTN = constants.CLASS_NAME_PREV_MONTH_BTN;
        var CLASS_NAME_PREV_YEAR_BTN = constants.CLASS_NAME_PREV_YEAR_BTN;
        var CLASS_NAME_NEXT_YEAR_BTN = constants.CLASS_NAME_NEXT_YEAR_BTN;
        var CLASS_NAME_NEXT_MONTH_BTN = constants.CLASS_NAME_NEXT_MONTH_BTN;
        var CLASS_NAME_CALENDAR_MONTH = "tui-calendar-month";
        var CLASS_NAME_CALENDAR_YEAR = "tui-calendar-year";
        var CLASS_NAME_HIDDEN = "tui-hidden";
        var HEADER_SELECTOR = ".tui-calendar-header";
        var BODY_SELECTOR = ".tui-calendar-body";
        var Calendar2 = defineClass(
          {
            static: {
              localeTexts
            },
            init: function(container, options) {
              options = extend(
                {
                  language: DEFAULT_LANGUAGE_TYPE,
                  showToday: true,
                  showJumpButtons: false,
                  date: new Date(),
                  type: TYPE_DATE,
                  usageStatistics: true,
                  weekStartDay: DEFAULT_WEEK_START_DAY
                },
                options
              );
              this._container = util.getElement(container);
              this._container.innerHTML = '<div class="tui-calendar">    <div class="tui-calendar-header"></div>    <div class="tui-calendar-body"></div></div>';
              this._element = this._container.firstChild;
              this._date = null;
              this._type = null;
              this._header = null;
              this._body = null;
              this._initHeader(options);
              this._initBody(options);
              this.draw({
                date: options.date,
                type: options.type
              });
              if (options.usageStatistics) {
                util.sendHostName();
              }
            },
            _initHeader: function(options) {
              var headerContainer = this._element.querySelector(HEADER_SELECTOR);
              this._header = new Header(headerContainer, options);
              this._header.on(
                "click",
                function(ev) {
                  var target = util.getTarget(ev);
                  if (hasClass(target, CLASS_NAME_PREV_MONTH_BTN)) {
                    this.drawPrev();
                  } else if (hasClass(target, CLASS_NAME_PREV_YEAR_BTN)) {
                    this._onClickPrevYear();
                  } else if (hasClass(target, CLASS_NAME_NEXT_MONTH_BTN)) {
                    this.drawNext();
                  } else if (hasClass(target, CLASS_NAME_NEXT_YEAR_BTN)) {
                    this._onClickNextYear();
                  }
                },
                this
              );
            },
            _initBody: function(options) {
              var bodyContainer = this._element.querySelector(BODY_SELECTOR);
              this._body = new Body(bodyContainer, options);
            },
            _onClickPrevYear: function() {
              if (this.getType() === TYPE_DATE) {
                this.draw({
                  date: this._getRelativeDate(-12)
                });
              } else {
                this.drawPrev();
              }
            },
            _onClickNextYear: function() {
              if (this.getType() === TYPE_DATE) {
                this.draw({
                  date: this._getRelativeDate(12)
                });
              } else {
                this.drawNext();
              }
            },
            _isValidType: function(type) {
              return type === TYPE_DATE || type === TYPE_MONTH || type === TYPE_YEAR;
            },
            _shouldUpdate: function(date, type) {
              var prevDate = this._date;
              if (!dateUtil.isValidDate(date)) {
                throw new Error("Invalid date");
              }
              if (!this._isValidType(type)) {
                throw new Error("Invalid layer type");
              }
              return !prevDate || prevDate.getFullYear() !== date.getFullYear() || prevDate.getMonth() !== date.getMonth() || this.getType() !== type;
            },
            _render: function() {
              var date = this._date;
              var type = this.getType();
              this._header.render(date, type);
              this._body.render(date, type);
              removeClass(this._element, CLASS_NAME_CALENDAR_MONTH, CLASS_NAME_CALENDAR_YEAR);
              switch (type) {
                case TYPE_MONTH:
                  addClass(this._element, CLASS_NAME_CALENDAR_MONTH);
                  break;
                case TYPE_YEAR:
                  addClass(this._element, CLASS_NAME_CALENDAR_YEAR);
                  break;
              }
            },
            _getRelativeDate: function(step) {
              var prev = this._date;
              return new Date(prev.getFullYear(), prev.getMonth() + step);
            },
            draw: function(options) {
              var date, type;
              options = options || {};
              date = options.date || this._date;
              type = (options.type || this.getType()).toLowerCase();
              if (this._shouldUpdate(date, type)) {
                this._date = date;
                this._type = type;
                this._render();
              }
              this.fire("draw", {
                date: this._date,
                type,
                dateElements: this._body.getDateElements()
              });
            },
            show: function() {
              removeClass(this._element, CLASS_NAME_HIDDEN);
            },
            hide: function() {
              addClass(this._element, CLASS_NAME_HIDDEN);
            },
            drawNext: function() {
              this.draw({
                date: this.getNextDate()
              });
            },
            drawPrev: function() {
              this.draw({
                date: this.getPrevDate()
              });
            },
            getNextDate: function() {
              if (this.getType() === TYPE_DATE) {
                return this._getRelativeDate(1);
              }
              return this.getNextYearDate();
            },
            getPrevDate: function() {
              if (this.getType() === TYPE_DATE) {
                return this._getRelativeDate(-1);
              }
              return this.getPrevYearDate();
            },
            getNextYearDate: function(customStep) {
              if (customStep) {
                return this._getRelativeDate(customStep);
              }
              switch (this.getType()) {
                case TYPE_DATE:
                case TYPE_MONTH:
                  return this._getRelativeDate(12);
                case TYPE_YEAR:
                  return this._getRelativeDate(108);
                default:
                  throw new Error("Unknown layer type");
              }
            },
            getPrevYearDate: function(customStep) {
              if (customStep) {
                return this._getRelativeDate(customStep);
              }
              switch (this.getType()) {
                case TYPE_DATE:
                case TYPE_MONTH:
                  return this._getRelativeDate(-12);
                case TYPE_YEAR:
                  return this._getRelativeDate(-108);
                default:
                  throw new Error("Unknown layer type");
              }
            },
            changeLanguage: function(language) {
              this._header.changeLanguage(language);
              this._body.changeLanguage(language);
              this._render();
            },
            getDate: function() {
              return new Date(this._date);
            },
            getType: function() {
              return this._type;
            },
            getDateElements: function() {
              return this._body.getDateElements();
            },
            addCssClass: function(className) {
              addClass(this._element, className);
            },
            removeCssClass: function(className) {
              removeClass(this._element, className);
            },
            destroy: function() {
              this._header.destroy();
              this._body.destroy();
              removeElement(this._element);
              this._type = this._date = this._container = this._element = this._header = this._body = null;
            }
          }
        );
        CustomEvents.mixin(Calendar2);
        module2.exports = Calendar2;
      },
      function(module2, exports2, __webpack_require__) {
        var inArray = __webpack_require__(3);
        var forEachArray = __webpack_require__(2);
        var defineClass = __webpack_require__(0);
        var util = __webpack_require__(4);
        var dateUtil = __webpack_require__(5);
        var constants = __webpack_require__(1);
        var localeTexts = __webpack_require__(10);
        var rFormableKeys = /\\?(yyyy|yy|mmmm|mmm|mm|m|dd|d|hh|h|a)/gi;
        var mapForConverting = {
          yyyy: {
            expression: "(\\d{4}|\\d{2})",
            type: constants.TYPE_YEAR
          },
          yy: {
            expression: "(\\d{4}|\\d{2})",
            type: constants.TYPE_YEAR
          },
          y: {
            expression: "(\\d{4}|\\d{2})",
            type: constants.TYPE_YEAR
          },
          M: {
            expression: "(1[012]|0[1-9]|[1-9])",
            type: constants.TYPE_MONTH
          },
          MM: {
            expression: "(1[012]|0[1-9]|[1-9])",
            type: constants.TYPE_MONTH
          },
          MMM: {
            expression: "(1[012]|0[1-9]|[1-9])",
            type: constants.TYPE_MONTH
          },
          MMMM: {
            expression: "(1[012]|0[1-9]|[1-9])",
            type: constants.TYPE_MONTH
          },
          mmm: {
            expression: "(1[012]|0[1-9]|[1-9])",
            type: constants.TYPE_MONTH
          },
          mmmm: {
            expression: "(1[012]|0[1-9]|[1-9])",
            type: constants.TYPE_MONTH
          },
          dd: {
            expression: "([12]\\d{1}|3[01]|0[1-9]|[1-9])",
            type: constants.TYPE_DATE
          },
          d: {
            expression: "([12]\\d{1}|3[01]|0[1-9]|[1-9])",
            type: constants.TYPE_DATE
          },
          D: {
            expression: "([12]\\d{1}|3[01]|0[1-9]|[1-9])",
            type: constants.TYPE_DATE
          },
          DD: {
            expression: "([12]\\d{1}|3[01]|0[1-9]|[1-9])",
            type: constants.TYPE_DATE
          },
          h: {
            expression: "(d{1}|0\\d{1}|1\\d{1}|2[0123])",
            type: constants.TYPE_HOUR
          },
          hh: {
            expression: "(d{1}|[01]\\d{1}|2[0123])",
            type: constants.TYPE_HOUR
          },
          H: {
            expression: "(d{1}|0\\d{1}|1\\d{1}|2[0123])",
            type: constants.TYPE_HOUR
          },
          HH: {
            expression: "(d{1}|[01]\\d{1}|2[0123])",
            type: constants.TYPE_HOUR
          },
          m: {
            expression: "(d{1}|[012345]\\d{1})",
            type: constants.TYPE_MINUTE
          },
          mm: {
            expression: "(d{1}|[012345]\\d{1})",
            type: constants.TYPE_MINUTE
          },
          a: {
            expression: "([ap]m)",
            type: constants.TYPE_MERIDIEM
          },
          A: {
            expression: "([ap]m)",
            type: constants.TYPE_MERIDIEM
          }
        };
        var DateTimeFormatter = defineClass(
          {
            init: function(rawStr, titles) {
              this._rawStr = rawStr;
              this._keyOrder = null;
              this._regExp = null;
              this._titles = titles || localeTexts.en.titles;
              this._parseFormat();
            },
            _parseFormat: function() {
              var regExpStr = "^";
              var matchedKeys = this._rawStr.match(rFormableKeys);
              var keyOrder = [];
              matchedKeys = util.filter(matchedKeys, function(key) {
                return key[0] !== "\\";
              });
              forEachArray(matchedKeys, function(key, index) {
                if (!/m/i.test(key)) {
                  key = key.toLowerCase();
                }
                regExpStr += mapForConverting[key].expression + "[\\D\\s]*";
                keyOrder[index] = mapForConverting[key].type;
              });
              regExpStr += "$";
              this._keyOrder = keyOrder;
              this._regExp = new RegExp(regExpStr, "gi");
            },
            parse: function(str) {
              var dateHash = {
                year: 0,
                month: 1,
                date: 1,
                hour: 0,
                minute: 0
              };
              var hasMeridiem = false;
              var isPM = false;
              var matched;
              this._regExp.lastIndex = 0;
              matched = this._regExp.exec(str);
              if (!matched) {
                throw Error('DateTimeFormatter: Not matched - "' + str + '"');
              }
              forEachArray(this._keyOrder, function(name, index) {
                var value = matched[index + 1];
                if (name === constants.TYPE_MERIDIEM && /[ap]m/i.test(value)) {
                  hasMeridiem = true;
                  isPM = /pm/i.test(value);
                } else {
                  value = Number(value);
                  if (value !== 0 && !value) {
                    throw Error("DateTimeFormatter: Unknown value - " + matched[index + 1]);
                  }
                  if (name === constants.TYPE_YEAR && value < 100) {
                    value += 2e3;
                  }
                  dateHash[name] = value;
                }
              });
              if (hasMeridiem) {
                isPM = isPM || dateHash.hour > 12;
                dateHash.hour %= 12;
                if (isPM) {
                  dateHash.hour += 12;
                }
              }
              return new Date(
                dateHash.year,
                dateHash.month - 1,
                dateHash.date,
                dateHash.hour,
                dateHash.minute
              );
            },
            getRawString: function() {
              return this._rawStr;
            },
            format: function(dateObj) {
              var year = dateObj.getFullYear();
              var month = dateObj.getMonth() + 1;
              var dayInMonth = dateObj.getDate();
              var day = dateObj.getDay();
              var hour = dateObj.getHours();
              var minute = dateObj.getMinutes();
              var meridiem = "a";
              var replaceMap;
              if (inArray(constants.TYPE_MERIDIEM, this._keyOrder) > -1) {
                meridiem = hour >= 12 ? "pm" : "am";
                hour = dateUtil.getMeridiemHour(hour);
              }
              replaceMap = {
                yyyy: year,
                yy: String(year).substr(2, 2),
                M: month,
                MM: dateUtil.prependLeadingZero(month),
                MMM: this._titles.MMM[month - 1],
                MMMM: this._titles.MMMM[month - 1],
                d: dayInMonth,
                dd: dateUtil.prependLeadingZero(dayInMonth),
                D: this._titles.D[day],
                DD: this._titles.DD[day],
                hh: dateUtil.prependLeadingZero(hour),
                h: hour,
                mm: dateUtil.prependLeadingZero(minute),
                m: minute,
                A: meridiem.toUpperCase(),
                a: meridiem
              };
              return this._rawStr.replace(rFormableKeys, function(key) {
                if (key[0] === "\\") {
                  return key.substr(1);
                }
                return replaceMap[key] || replaceMap[key.toLowerCase()] || "";
              });
            }
          }
        );
        module2.exports = DateTimeFormatter;
      },
      function(module2, exports2, __webpack_require__) {
        var isString = __webpack_require__(13);
        var forEach = __webpack_require__(9);
        var safeEvent = __webpack_require__(32);
        function on2(element, types, handler, context) {
          if (isString(types)) {
            forEach(types.split(/\s+/g), function(type) {
              bindEvent(element, type, handler, context);
            });
            return;
          }
          forEach(types, function(func, type) {
            bindEvent(element, type, func, handler);
          });
        }
        function bindEvent(element, type, handler, context) {
          function eventHandler(e) {
            handler.call(context || element, e || window.event);
          }
          if ("addEventListener" in element) {
            element.addEventListener(type, eventHandler);
          } else if ("attachEvent" in element) {
            element.attachEvent("on" + type, eventHandler);
          }
          memorizeHandler(element, type, handler, eventHandler);
        }
        function memorizeHandler(element, type, handler, wrappedHandler) {
          var events = safeEvent(element, type);
          var existInEvents = false;
          forEach(events, function(obj) {
            if (obj.handler === handler) {
              existInEvents = true;
              return false;
            }
            return true;
          });
          if (!existInEvents) {
            events.push({
              handler,
              wrappedHandler
            });
          }
        }
        module2.exports = on2;
      },
      function(module2, exports2, __webpack_require__) {
        var EVENT_KEY = "_feEventKey";
        function safeEvent(element, type) {
          var events = element[EVENT_KEY];
          var handlers;
          if (!events) {
            events = element[EVENT_KEY] = {};
          }
          handlers = events[type];
          if (!handlers) {
            handlers = events[type] = [];
          }
          return handlers;
        }
        module2.exports = safeEvent;
      },
      function(module2, exports2, __webpack_require__) {
        var isString = __webpack_require__(13);
        var forEach = __webpack_require__(9);
        var safeEvent = __webpack_require__(32);
        function off(element, types, handler) {
          if (isString(types)) {
            forEach(types.split(/\s+/g), function(type) {
              unbindEvent(element, type, handler);
            });
            return;
          }
          forEach(types, function(func, type) {
            unbindEvent(element, type, func);
          });
        }
        function unbindEvent(element, type, handler) {
          var events = safeEvent(element, type);
          var index;
          if (!handler) {
            forEach(events, function(item) {
              removeHandler(element, type, item.wrappedHandler);
            });
            events.splice(0, events.length);
          } else {
            forEach(events, function(item, idx) {
              if (handler === item.handler) {
                removeHandler(element, type, item.wrappedHandler);
                index = idx;
                return false;
              }
              return true;
            });
            events.splice(index, 1);
          }
        }
        function removeHandler(element, type, handler) {
          if ("removeEventListener" in element) {
            element.removeEventListener(type, handler);
          } else if ("detachEvent" in element) {
            element.detachEvent("on" + type, handler);
          }
        }
        module2.exports = off;
      },
      function(module2, exports2, __webpack_require__) {
        var DatePicker = __webpack_require__(21);
        var DateRangePicker = __webpack_require__(60);
        var Calendar2 = __webpack_require__(29);
        __webpack_require__(61);
        DatePicker.createCalendar = function(wrapperElement, options) {
          return new Calendar2(wrapperElement, options);
        };
        DatePicker.createRangePicker = function(options) {
          return new DateRangePicker(options);
        };
        module2.exports = DatePicker;
      },
      function(module2, exports2, __webpack_require__) {
        var createObject = __webpack_require__(36);
        function inherit(subType, superType) {
          var prototype = createObject(superType.prototype);
          prototype.constructor = subType;
          subType.prototype = prototype;
        }
        module2.exports = inherit;
      },
      function(module2, exports2, __webpack_require__) {
        function createObject(obj) {
          function F2() {
          }
          F2.prototype = obj;
          return new F2();
        }
        module2.exports = createObject;
      },
      function(module2, exports2, __webpack_require__) {
        var isUndefined = __webpack_require__(12);
        var isNull = __webpack_require__(38);
        function isExisty(param) {
          return !isUndefined(param) && !isNull(param);
        }
        module2.exports = isExisty;
      },
      function(module2, exports2, __webpack_require__) {
        function isNull(obj) {
          return obj === null;
        }
        module2.exports = isNull;
      },
      function(module2, exports2, __webpack_require__) {
        function isFunction(obj) {
          return obj instanceof Function;
        }
        module2.exports = isFunction;
      },
      function(module2, exports2, __webpack_require__) {
        var inArray = __webpack_require__(3);
        var toArray = __webpack_require__(41);
        var elProto = Element.prototype;
        var matchSelector = elProto.matches || elProto.webkitMatchesSelector || elProto.mozMatchesSelector || elProto.msMatchesSelector || function(selector) {
          var doc = this.document || this.ownerDocument;
          return inArray(this, toArray(doc.querySelectorAll(selector))) > -1;
        };
        function matches(element, selector) {
          return matchSelector.call(element, selector);
        }
        module2.exports = matches;
      },
      function(module2, exports2, __webpack_require__) {
        var forEachArray = __webpack_require__(2);
        function toArray(arrayLike) {
          var arr;
          try {
            arr = Array.prototype.slice.call(arrayLike);
          } catch (e) {
            arr = [];
            forEachArray(arrayLike, function(value) {
              arr.push(value);
            });
          }
          return arr;
        }
        module2.exports = toArray;
      },
      function(module2, exports2, __webpack_require__) {
        function convertToKebabCase(key) {
          return key.replace(/([A-Z])/g, function(match) {
            return "-" + match.toLowerCase();
          });
        }
        module2.exports = convertToKebabCase;
      },
      function(module2, exports2) {
        module2.exports = __WEBPACK_EXTERNAL_MODULE__43__;
      },
      function(module2, exports2, __webpack_require__) {
        var defineClass = __webpack_require__(0);
        var CustomEvents = __webpack_require__(8);
        var closest = __webpack_require__(25);
        var removeElement = __webpack_require__(14);
        var localeTexts = __webpack_require__(10);
        var headerTmpl = __webpack_require__(45);
        var DateTimeFormatter = __webpack_require__(30);
        var constants = __webpack_require__(1);
        var util = __webpack_require__(4);
        var mouseTouchEvent = __webpack_require__(19);
        var TYPE_DATE = constants.TYPE_DATE;
        var TYPE_MONTH = constants.TYPE_MONTH;
        var TYPE_YEAR = constants.TYPE_YEAR;
        var CLASS_NAME_TITLE_MONTH = "tui-calendar-title-month";
        var CLASS_NAME_TITLE_YEAR = "tui-calendar-title-year";
        var CLASS_NAME_TITLE_YEAR_TO_YEAR = "tui-calendar-title-year-to-year";
        var SELECTOR_INNER_ELEM = ".tui-calendar-header-inner";
        var SELECTOR_INFO_ELEM = ".tui-calendar-header-info";
        var SELECTOR_BTN = ".tui-calendar-btn";
        var YEAR_TITLE_FORMAT = "yyyy";
        var Header = defineClass(
          {
            init: function(container, option) {
              this._container = util.getElement(container);
              this._innerElement = null;
              this._infoElement = null;
              this._showToday = option.showToday;
              this._showJumpButtons = option.showJumpButtons;
              this._yearMonthTitleFormatter = null;
              this._yearTitleFormatter = null;
              this._todayFormatter = null;
              this._setFormatters(localeTexts[option.language]);
              this._setEvents(option);
            },
            _setFormatters: function(localeText) {
              this._yearMonthTitleFormatter = new DateTimeFormatter(
                localeText.titleFormat,
                localeText.titles
              );
              this._yearTitleFormatter = new DateTimeFormatter(YEAR_TITLE_FORMAT, localeText.titles);
              this._todayFormatter = new DateTimeFormatter(localeText.todayFormat, localeText.titles);
            },
            _setEvents: function() {
              mouseTouchEvent.on(this._container, "click", this._onClickHandler, this);
            },
            _removeEvents: function() {
              this.off();
              mouseTouchEvent.off(this._container, "click", this._onClickHandler);
            },
            _onClickHandler: function(ev) {
              var target = util.getTarget(ev);
              if (closest(target, SELECTOR_BTN)) {
                this.fire("click", ev);
              }
            },
            _getTitleClass: function(type) {
              switch (type) {
                case TYPE_DATE:
                  return CLASS_NAME_TITLE_MONTH;
                case TYPE_MONTH:
                  return CLASS_NAME_TITLE_YEAR;
                case TYPE_YEAR:
                  return CLASS_NAME_TITLE_YEAR_TO_YEAR;
                default:
                  return "";
              }
            },
            _getTitleText: function(date, type) {
              var currentYear, start, end;
              switch (type) {
                case TYPE_DATE:
                  return this._yearMonthTitleFormatter.format(date);
                case TYPE_MONTH:
                  return this._yearTitleFormatter.format(date);
                case TYPE_YEAR:
                  currentYear = date.getFullYear();
                  start = new Date(currentYear - 4, 0, 1);
                  end = new Date(currentYear + 4, 0, 1);
                  return this._yearTitleFormatter.format(start) + " - " + this._yearTitleFormatter.format(end);
                default:
                  return "";
              }
            },
            changeLanguage: function(language) {
              this._setFormatters(localeTexts[language]);
            },
            render: function(date, type) {
              var context = {
                showToday: this._showToday,
                showJumpButtons: this._showJumpButtons,
                todayText: this._todayFormatter.format(new Date()),
                isDateCalendar: type === TYPE_DATE,
                titleClass: this._getTitleClass(type),
                title: this._getTitleText(date, type)
              };
              this._container.innerHTML = headerTmpl(context).replace(/^\s+|\s+$/g, "");
              this._innerElement = this._container.querySelector(SELECTOR_INNER_ELEM);
              if (context.showToday) {
                this._infoElement = this._container.querySelector(SELECTOR_INFO_ELEM);
              }
            },
            destroy: function() {
              this._removeEvents();
              removeElement(this._innerElement);
              removeElement(this._infoElement);
              this._container = this._showToday = this._showJumpButtons = this._yearMonthTitleFormatter = this._yearTitleFormatter = this._todayFormatter = this._innerElement = this._infoElement = null;
            }
          }
        );
        CustomEvents.mixin(Header);
        module2.exports = Header;
      },
      function(module2, exports2, __webpack_require__) {
        var template = __webpack_require__(11);
        module2.exports = function(context) {
          var source = '{{if isDateCalendar}}  {{if showJumpButtons}}    <div class="tui-calendar-header-inner tui-calendar-has-btns">      <button class="tui-calendar-btn tui-calendar-btn-prev-year">Prev year</button>      <button class="tui-calendar-btn tui-calendar-btn-prev-month">Prev month</button>      <em class="tui-calendar-title {{titleClass}}">{{title}}</em>      <button class="tui-calendar-btn tui-calendar-btn-next-month">Next month</button>      <button class="tui-calendar-btn tui-calendar-btn-next-year">Next year</button>    </div>  {{else}}    <div class="tui-calendar-header-inner">      <button class="tui-calendar-btn tui-calendar-btn-prev-month">Prev month</button>      <em class="tui-calendar-title {{titleClass}}">{{title}}</em>      <button class="tui-calendar-btn tui-calendar-btn-next-month">Next month</button>    </div>  {{/if}}{{else}}  <div class="tui-calendar-header-inner">    <button class="tui-calendar-btn tui-calendar-btn-prev-year">Prev year</button>    <em class="tui-calendar-title {{titleClass}}">{{title}}</em>    <button class="tui-calendar-btn tui-calendar-btn-next-year">Next year</button>  </div>{{/if}}{{if showToday}}  <div class="tui-calendar-header-info">    <p class="tui-calendar-title-today">{{todayText}}</p>  </div>{{/if}}';
          return template(source, context);
        };
      },
      function(module2, exports2, __webpack_require__) {
        function isHTMLNode(html) {
          if (typeof HTMLElement === "object") {
            return html && (html instanceof HTMLElement || !!html.nodeType);
          }
          return !!(html && html.nodeType);
        }
        module2.exports = isHTMLNode;
      },
      function(module2, exports2, __webpack_require__) {
        var isUndefined = __webpack_require__(12);
        var imagePing = __webpack_require__(48);
        var ms7days = 7 * 24 * 60 * 60 * 1e3;
        function isExpired(date) {
          var now = new Date().getTime();
          return now - date > ms7days;
        }
        function sendHostname(appName, trackingId) {
          var url = "https://www.google-analytics.com/collect";
          var hostname = location.hostname;
          var hitType = "event";
          var eventCategory = "use";
          var applicationKeyForStorage = "TOAST UI " + appName + " for " + hostname + ": Statistics";
          var date = window.localStorage.getItem(applicationKeyForStorage);
          if (!isUndefined(window.tui) && window.tui.usageStatistics === false) {
            return;
          }
          if (date && !isExpired(date)) {
            return;
          }
          window.localStorage.setItem(applicationKeyForStorage, new Date().getTime());
          setTimeout(function() {
            if (document.readyState === "interactive" || document.readyState === "complete") {
              imagePing(url, {
                v: 1,
                t: hitType,
                tid: trackingId,
                cid: hostname,
                dp: hostname,
                dh: appName,
                el: appName,
                ec: eventCategory
              });
            }
          }, 1e3);
        }
        module2.exports = sendHostname;
      },
      function(module2, exports2, __webpack_require__) {
        var forEachOwnProperties = __webpack_require__(23);
        function imagePing(url, trackingInfo) {
          var trackingElement = document.createElement("img");
          var queryString = "";
          forEachOwnProperties(trackingInfo, function(value, key) {
            queryString += "&" + key + "=" + value;
          });
          queryString = queryString.substring(1);
          trackingElement.src = url + "?" + queryString;
          trackingElement.style.display = "none";
          document.body.appendChild(trackingElement);
          document.body.removeChild(trackingElement);
          return trackingElement;
        }
        module2.exports = imagePing;
      },
      function(module2, exports2, __webpack_require__) {
        var forEachArray = __webpack_require__(2);
        var defineClass = __webpack_require__(0);
        var DateLayer = __webpack_require__(50);
        var MonthLayer = __webpack_require__(52);
        var YearLayer = __webpack_require__(54);
        var constants = __webpack_require__(1);
        var TYPE_DATE = constants.TYPE_DATE;
        var TYPE_MONTH = constants.TYPE_MONTH;
        var TYPE_YEAR = constants.TYPE_YEAR;
        var Body = defineClass(
          {
            init: function(bodyContainer, options) {
              var language = options.language;
              var weekStartDay = options.weekStartDay;
              this._container = bodyContainer;
              this._dateLayer = new DateLayer(language, weekStartDay);
              this._monthLayer = new MonthLayer(language);
              this._yearLayer = new YearLayer(language);
              this._currentLayer = this._dateLayer;
            },
            _getLayer: function(type) {
              switch (type) {
                case TYPE_DATE:
                  return this._dateLayer;
                case TYPE_MONTH:
                  return this._monthLayer;
                case TYPE_YEAR:
                  return this._yearLayer;
                default:
                  return this._currentLayer;
              }
            },
            _eachLayer: function(fn2) {
              forEachArray([this._dateLayer, this._monthLayer, this._yearLayer], fn2);
            },
            changeLanguage: function(language) {
              this._eachLayer(function(layer) {
                layer.changeLanguage(language);
              });
            },
            render: function(date, type) {
              var nextLayer = this._getLayer(type);
              var prevLayer = this._currentLayer;
              prevLayer.remove();
              nextLayer.render(date, this._container);
              this._currentLayer = nextLayer;
            },
            getDateElements: function() {
              return this._currentLayer.getDateElements();
            },
            destroy: function() {
              this._eachLayer(function(layer) {
                layer.remove();
              });
              this._container = this._currentLayer = this._dateLayer = this._monthLayer = this._yearLayer = null;
            }
          }
        );
        module2.exports = Body;
      },
      function(module2, exports2, __webpack_require__) {
        var defineClass = __webpack_require__(0);
        var dateUtil = __webpack_require__(5);
        var bodyTmpl = __webpack_require__(51);
        var LayerBase = __webpack_require__(20);
        var TYPE_DATE = __webpack_require__(1).TYPE_DATE;
        var WEEK_START_DAY_MAP = __webpack_require__(1).WEEK_START_DAY_MAP;
        var DATE_SELECTOR = ".tui-calendar-date";
        var DAYS_OF_WEEK = 7;
        var DateLayer = defineClass(
          LayerBase,
          {
            init: function(language, weekStartDay) {
              LayerBase.call(this, language);
              this.weekStartDay = WEEK_START_DAY_MAP[String(weekStartDay).toLowerCase()] || 0;
            },
            _type: TYPE_DATE,
            _makeContext: function(date) {
              var daysShort = this._localeText.titles.D;
              var year, month, days, i;
              date = date || new Date();
              year = date.getFullYear();
              month = date.getMonth() + 1;
              if (this.weekStartDay) {
                days = daysShort.slice();
                for (i = 0; i < this.weekStartDay; i += 1) {
                  days.push(days.shift());
                }
                daysShort = days;
              }
              return {
                Sun: daysShort[0],
                Mon: daysShort[1],
                Tue: daysShort[2],
                Wed: daysShort[3],
                Thu: daysShort[4],
                Fri: daysShort[5],
                Sat: daysShort[6],
                year,
                month,
                weeks: this._getWeeks(year, month)
              };
            },
            _getWeeks: function(year, month) {
              var weekNumber = 0;
              var weeksCount = 6;
              var weeks = [];
              var week, dates, i;
              while (weekNumber < weeksCount) {
                dates = [];
                for (i = this.weekStartDay; i < DAYS_OF_WEEK + this.weekStartDay; i += 1) {
                  dates.push(dateUtil.getDateOfWeek(year, month, weekNumber, i));
                }
                week = this._getWeek(year, month, dates);
                if (this.weekStartDay && !_isFirstWeek(weekNumber, week[0].dayInMonth)) {
                  weeks.push(this._getFirstWeek(year, month));
                  weeksCount -= 1;
                }
                weeks.push(week);
                weekNumber += 1;
              }
              return weeks;
            },
            _getWeek: function(currentYear, currentMonth, dates) {
              var firstDateOfCurrentMonth = new Date(currentYear, currentMonth - 1, 1);
              var lastDateOfCurrentMonth = new Date(currentYear, currentMonth, 0);
              var contexts = [];
              var i = 0;
              var length = dates.length;
              var date, className;
              for (; i < length; i += 1) {
                className = "tui-calendar-date";
                date = dates[i];
                if (date < firstDateOfCurrentMonth) {
                  className += " tui-calendar-prev-month";
                }
                if (date > lastDateOfCurrentMonth) {
                  className += " tui-calendar-next-month";
                }
                if (date.getDay() === 0) {
                  className += " tui-calendar-sun";
                } else if (date.getDay() === 6) {
                  className += " tui-calendar-sat";
                }
                contexts.push({
                  dayInMonth: date.getDate(),
                  className,
                  timestamp: date.getTime()
                });
              }
              return contexts;
            },
            render: function(date, container) {
              var context = this._makeContext(date);
              container.innerHTML = bodyTmpl(context);
              this._element = container.firstChild;
            },
            getDateElements: function() {
              return this._element.querySelectorAll(DATE_SELECTOR);
            },
            _getFirstWeek: function(year, month) {
              var firstWeekDates = [];
              var i;
              for (i = this.weekStartDay; i < DAYS_OF_WEEK + this.weekStartDay; i += 1) {
                firstWeekDates.push(dateUtil.getDateOfWeek(year, month, -1, i));
              }
              return this._getWeek(year, month, firstWeekDates);
            }
          }
        );
        function _isFirstWeek(weekIndex, dayInMonth) {
          return weekIndex || dayInMonth === 1 || dayInMonth > DAYS_OF_WEEK;
        }
        module2.exports = DateLayer;
      },
      function(module2, exports2, __webpack_require__) {
        var template = __webpack_require__(11);
        module2.exports = function(context) {
          var source = '<table class="tui-calendar-body-inner" cellspacing="0" cellpadding="0">  <caption><span>Dates</span></caption>  <thead class="tui-calendar-body-header">    <tr>      <th class="tui-sun" scope="col">{{Sun}}</th>      <th scope="col">{{Mon}}</th>      <th scope="col">{{Tue}}</th>      <th scope="col">{{Wed}}</th>      <th scope="col">{{Thu}}</th>      <th scope="col">{{Fri}}</th>      <th class="tui-sat" scope="col">{{Sat}}</th>    </tr>  </thead>  <tbody>    {{each weeks}}    <tr class="tui-calendar-week">      {{each @this}}      <td class="{{@this["className"]}}" data-timestamp="{{@this["timestamp"]}}">{{@this["dayInMonth"]}}</td>      {{/each}}    </tr>    {{/each}}  </tbody></table>';
          return template(source, context);
        };
      },
      function(module2, exports2, __webpack_require__) {
        var defineClass = __webpack_require__(0);
        var bodyTmpl = __webpack_require__(53);
        var LayerBase = __webpack_require__(20);
        var TYPE_MONTH = __webpack_require__(1).TYPE_MONTH;
        var dateUtil = __webpack_require__(5);
        var DATE_SELECTOR = ".tui-calendar-month";
        var MonthLayer = defineClass(
          LayerBase,
          {
            init: function(language) {
              LayerBase.call(this, language);
            },
            _type: TYPE_MONTH,
            _makeContext: function(date) {
              var monthsShort = this._localeText.titles.MMM;
              return {
                year: date.getFullYear(),
                Jan: monthsShort[0],
                Feb: monthsShort[1],
                Mar: monthsShort[2],
                Apr: monthsShort[3],
                May: monthsShort[4],
                Jun: monthsShort[5],
                Jul: monthsShort[6],
                Aug: monthsShort[7],
                Sep: monthsShort[8],
                Oct: monthsShort[9],
                Nov: monthsShort[10],
                Dec: monthsShort[11],
                getFirstDayTimestamp: dateUtil.getFirstDayTimestamp
              };
            },
            render: function(date, container) {
              var context = this._makeContext(date);
              container.innerHTML = bodyTmpl(context);
              this._element = container.firstChild;
            },
            getDateElements: function() {
              return this._element.querySelectorAll(DATE_SELECTOR);
            }
          }
        );
        module2.exports = MonthLayer;
      },
      function(module2, exports2, __webpack_require__) {
        var template = __webpack_require__(11);
        module2.exports = function(context) {
          var source = '<table class="tui-calendar-body-inner">  <caption><span>Months</span></caption>  <tbody>    <tr class="tui-calendar-month-group">      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 0}}>{{Jan}}</td>      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 1}}>{{Feb}}</td>      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 2}}>{{Mar}}</td>      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 3}}>{{Apr}}</td>    </tr>    <tr class="tui-calendar-month-group">      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 4}}>{{May}}</td>      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 5}}>{{Jun}}</td>      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 6}}>{{Jul}}</td>      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 7}}>{{Aug}}</td>    </tr>    <tr class="tui-calendar-month-group">      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 8}}>{{Sep}}</td>      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 9}}>{{Oct}}</td>      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 10}}>{{Nov}}</td>      <td class="tui-calendar-month" data-timestamp={{getFirstDayTimestamp year 11}}>{{Dec}}</td>    </tr>  </tbody></table>';
          return template(source, context);
        };
      },
      function(module2, exports2, __webpack_require__) {
        var defineClass = __webpack_require__(0);
        var bodyTmpl = __webpack_require__(55);
        var LayerBase = __webpack_require__(20);
        var TYPE_YEAR = __webpack_require__(1).TYPE_YEAR;
        var dateUtil = __webpack_require__(5);
        var DATE_SELECTOR = ".tui-calendar-year";
        var YearLayer = defineClass(
          LayerBase,
          {
            init: function(language) {
              LayerBase.call(this, language);
            },
            _type: TYPE_YEAR,
            _makeContext: function(date) {
              var year = date.getFullYear();
              return {
                yearGroups: [
                  dateUtil.getRangeArr(year - 4, year - 2),
                  dateUtil.getRangeArr(year - 1, year + 1),
                  dateUtil.getRangeArr(year + 2, year + 4)
                ],
                getFirstDayTimestamp: dateUtil.getFirstDayTimestamp
              };
            },
            render: function(date, container) {
              var context = this._makeContext(date);
              container.innerHTML = bodyTmpl(context);
              this._element = container.firstChild;
            },
            getDateElements: function() {
              return this._element.querySelectorAll(DATE_SELECTOR);
            }
          }
        );
        module2.exports = YearLayer;
      },
      function(module2, exports2, __webpack_require__) {
        var template = __webpack_require__(11);
        module2.exports = function(context) {
          var source = '<table class="tui-calendar-body-inner">  <caption><span>Years</span></caption>  <tbody>    {{each yearGroups}}    <tr class="tui-calendar-year-group">      {{each @this}}      <td class="tui-calendar-year" data-timestamp={{getFirstDayTimestamp @this 0}}>        {{@this}}      </td>      {{/each}}    </tr>    {{/each}}  </tbody></table>';
          return template(source, context);
        };
      },
      function(module2, exports2, __webpack_require__) {
        var forEachArray = __webpack_require__(2);
        var defineClass = __webpack_require__(0);
        var isNumber = __webpack_require__(15);
        var Range = __webpack_require__(57);
        var util = __webpack_require__(4);
        var RangeModel = defineClass(
          {
            init: function(ranges) {
              ranges = ranges || [];
              this._ranges = [];
              forEachArray(
                ranges,
                function(range) {
                  this.add(range[0], range[1]);
                },
                this
              );
            },
            contains: function(start, end) {
              var i = 0;
              var length = this._ranges.length;
              var range;
              for (; i < length; i += 1) {
                range = this._ranges[i];
                if (range.contains(start, end)) {
                  return true;
                }
              }
              return false;
            },
            hasOverlap: function(start, end) {
              var i = 0;
              var length = this._ranges.length;
              var range;
              for (; i < length; i += 1) {
                range = this._ranges[i];
                if (range.isOverlapped(start, end)) {
                  return true;
                }
              }
              return false;
            },
            add: function(start, end) {
              var overlapped = false;
              var i = 0;
              var len = this._ranges.length;
              var range;
              for (; i < len; i += 1) {
                range = this._ranges[i];
                overlapped = range.isOverlapped(start, end);
                if (overlapped) {
                  range.merge(start, end);
                  break;
                }
                if (start < range.start) {
                  break;
                }
              }
              if (!overlapped) {
                this._ranges.splice(i, 0, new Range(start, end));
              }
            },
            getMinimumValue: function() {
              return this._ranges[0].start;
            },
            getMaximumValue: function() {
              var length = this._ranges.length;
              return this._ranges[length - 1].end;
            },
            exclude: function(start, end) {
              if (!isNumber(end)) {
                end = start;
              }
              forEachArray(
                this._ranges,
                function(range) {
                  var rangeEnd;
                  if (range.isOverlapped(start, end)) {
                    rangeEnd = range.end;
                    range.exclude(start, end);
                    if (end + 1 <= rangeEnd) {
                      this.add(end + 1, rangeEnd);
                    }
                  }
                },
                this
              );
              this._ranges = util.filter(this._ranges, function(range) {
                return !range.isEmpty();
              });
            },
            findOverlappedRange: function(start, end) {
              var i = 0;
              var len = this._ranges.length;
              var range;
              for (; i < len; i += 1) {
                range = this._ranges[i];
                if (range.isOverlapped(start, end)) {
                  return [range.start, range.end];
                }
              }
              return null;
            }
          }
        );
        module2.exports = RangeModel;
      },
      function(module2, exports2, __webpack_require__) {
        var defineClass = __webpack_require__(0);
        var isNumber = __webpack_require__(15);
        var Range = defineClass(
          {
            init: function(start, end) {
              this.setRange(start, end);
            },
            setRange: function(start, end) {
              if (!isNumber(end)) {
                end = start;
              }
              this.start = Math.min(start, end);
              this.end = Math.max(start, end);
            },
            merge: function(start, end) {
              if (!isNumber(start) || !isNumber(end) || !this.isOverlapped(start, end)) {
                return;
              }
              this.start = Math.min(start, this.start);
              this.end = Math.max(end, this.end);
            },
            isEmpty: function() {
              return !isNumber(this.start) || !isNumber(this.end);
            },
            setEmpty: function() {
              this.start = this.end = null;
            },
            contains: function(start, end) {
              if (!isNumber(end)) {
                end = start;
              }
              return this.start <= start && end <= this.end;
            },
            isOverlapped: function(start, end) {
              if (!isNumber(end)) {
                end = start;
              }
              return this.start <= end && this.end >= start;
            },
            exclude: function(start, end) {
              if (start <= this.start && end >= this.end) {
                this.setEmpty();
              } else if (this.contains(start)) {
                this.setRange(this.start, start - 1);
              } else if (this.contains(end)) {
                this.setRange(end + 1, this.end);
              }
            }
          }
        );
        module2.exports = Range;
      },
      function(module2, exports2, __webpack_require__) {
        var template = __webpack_require__(11);
        module2.exports = function(context) {
          var source = '<div class="tui-datepicker">  {{if timePicker}}    {{if isTab}}      <div class="tui-datepicker-selector">        <button type="button" class="tui-datepicker-selector-button tui-is-checked" aria-label="selected">          <span class="tui-ico-date"></span>{{localeText["date"]}}        </button>        <button type="button" class="tui-datepicker-selector-button">          <span class="tui-ico-time"></span>{{localeText["time"]}}        </button>      </div>      <div class="tui-datepicker-body">        <div class="tui-calendar-container"></div>        <div class="tui-timepicker-container"></div>      </div>    {{else}}      <div class="tui-datepicker-body">        <div class="tui-calendar-container"></div>      </div>      <div class="tui-datepicker-footer">        <div class="tui-timepicker-container"></div>      </div>    {{/if}}  {{else}}    <div class="tui-datepicker-body">      <div class="tui-calendar-container"></div>    </div>  {{/if}}</div>';
          return template(source, context);
        };
      },
      function(module2, exports2, __webpack_require__) {
        var defineClass = __webpack_require__(0);
        var CustomEvents = __webpack_require__(8);
        var on2 = __webpack_require__(31);
        var off = __webpack_require__(33);
        var DateTimeFormatter = __webpack_require__(30);
        var mouseTouchEvent = __webpack_require__(19);
        var util = __webpack_require__(4);
        var DEFAULT_FORMAT = "yyyy-MM-dd";
        var DatePickerInput = defineClass(
          {
            init: function(inputElement, option) {
              option.format = option.format || DEFAULT_FORMAT;
              this._input = util.getElement(inputElement);
              this._id = option.id;
              this._titles = option.localeText.titles;
              this._formatter = new DateTimeFormatter(option.format, this._titles);
              this._setEvents();
            },
            changeLocaleTitles: function(titles) {
              this._titles = titles;
            },
            _setEvents: function() {
              if (this._input) {
                on2(this._input, "change", this._onChangeHandler, this);
                mouseTouchEvent.on(this._input, "click", this._onClickHandler, this);
              }
            },
            _removeEvents: function() {
              this.off();
              if (this._input) {
                off(this._input, "change", this._onChangeHandler);
                mouseTouchEvent.off(this._input, "click", this._onClickHandler);
              }
            },
            _onChangeHandler: function() {
              this.fire("change");
            },
            _onClickHandler: function() {
              this.fire("click");
            },
            is: function(el2) {
              return this._input === el2;
            },
            enable: function() {
              if (this._input) {
                this._input.removeAttribute("disabled");
              }
            },
            disable: function() {
              if (this._input) {
                this._input.setAttribute("disabled", true);
              }
            },
            getFormat: function() {
              return this._formatter.getRawString();
            },
            setFormat: function(format) {
              if (!format) {
                return;
              }
              this._formatter = new DateTimeFormatter(format, this._titles);
            },
            clearText: function() {
              if (this._input) {
                this._input.value = "";
              }
            },
            setDate: function(date) {
              if (this._input) {
                this._input.value = this._formatter.format(date);
              }
            },
            getDate: function() {
              var value = "";
              if (this._input) {
                value = this._input.value;
              }
              return this._formatter.parse(value);
            },
            destroy: function() {
              this._removeEvents();
              this._input = this._id = this._formatter = null;
            }
          }
        );
        CustomEvents.mixin(DatePickerInput);
        module2.exports = DatePickerInput;
      },
      function(module2, exports2, __webpack_require__) {
        var forEachArray = __webpack_require__(2);
        var defineClass = __webpack_require__(0);
        var CustomEvents = __webpack_require__(8);
        var addClass = __webpack_require__(16);
        var getData = __webpack_require__(26);
        var removeClass = __webpack_require__(18);
        var extend = __webpack_require__(7);
        var DatePicker = __webpack_require__(21);
        var dateUtil = __webpack_require__(5);
        var constants = __webpack_require__(1);
        var util = __webpack_require__(4);
        var CLASS_NAME_RANGE_PICKER = "tui-rangepicker";
        var CLASS_NAME_SELECTED = constants.CLASS_NAME_SELECTED;
        var CLASS_NAME_SELECTED_RANGE = "tui-is-selected-range";
        var DateRangePicker = defineClass(
          {
            init: function(options) {
              var startpickerOpt, endpickerOpt;
              options = options || {};
              startpickerOpt = options.startpicker;
              endpickerOpt = options.endpicker;
              if (!startpickerOpt) {
                throw new Error('The "startpicker" option is required.');
              }
              if (!endpickerOpt) {
                throw new Error('The "endpicker" option is required.');
              }
              this._startpicker = null;
              this._endpicker = null;
              this._isRangeSet = false;
              this._preEndPickerDate = new Date().getDate();
              this._initializePickers(options);
              this._syncRangesToEndpicker();
            },
            _initializePickers: function(options) {
              var startpickerContainer = util.getElement(options.startpicker.container);
              var endpickerContainer = util.getElement(options.endpicker.container);
              var startInput = util.getElement(options.startpicker.input);
              var endInput = util.getElement(options.endpicker.input);
              var startpickerOpt = extend({}, options, {
                input: {
                  element: startInput,
                  format: options.format
                },
                date: options.startpicker.date,
                weekStartDay: options.startpicker.weekStartDay
              });
              var endpickerOpt = extend({}, options, {
                input: {
                  element: endInput,
                  format: options.format
                },
                date: options.endpicker.date,
                weekStartDay: options.endpicker.weekStartDay
              });
              this._startpicker = new DatePicker(startpickerContainer, startpickerOpt);
              this._startpicker.addCssClass(CLASS_NAME_RANGE_PICKER);
              this._startpicker.on("change", this._onChangeStartpicker, this);
              this._startpicker.on("draw", this._onDrawPicker, this);
              this._endpicker = new DatePicker(endpickerContainer, endpickerOpt);
              this._endpicker.addCssClass(CLASS_NAME_RANGE_PICKER);
              this._endpicker.on("change", this._onChangeEndpicker, this);
              this._endpicker.on("draw", this._onDrawPicker, this);
            },
            _onDrawPicker: function(eventData) {
              var calendarType = eventData.type;
              var startDate = this._startpicker.getDate();
              var endDate = this._endpicker.getDate();
              if (!startDate) {
                return;
              }
              if (!endDate) {
                endDate = new Date(NaN);
              }
              forEachArray(
                eventData.dateElements,
                function(el2) {
                  var elDate = new Date(Number(getData(el2, "timestamp")));
                  var isInRange = dateUtil.inRange(startDate, endDate, elDate, calendarType);
                  var isSelected = dateUtil.isSame(startDate, elDate, calendarType) || dateUtil.isSame(endDate, elDate, calendarType);
                  this._setRangeClass(el2, isInRange);
                  this._setSelectedClass(el2, isSelected);
                },
                this
              );
            },
            _setRangeClass: function(el2, isInRange) {
              if (isInRange) {
                addClass(el2, CLASS_NAME_SELECTED_RANGE);
              } else {
                removeClass(el2, CLASS_NAME_SELECTED_RANGE);
              }
            },
            _setSelectedClass: function(el2, isSelected) {
              if (isSelected) {
                addClass(el2, CLASS_NAME_SELECTED);
              } else {
                removeClass(el2, CLASS_NAME_SELECTED);
              }
            },
            _syncRangesToEndpicker: function() {
              var startDate = this._startpicker.getDate();
              var overlappedRange;
              if (startDate) {
                overlappedRange = this._startpicker.findOverlappedRange(
                  dateUtil.cloneWithStartOf(startDate).getTime(),
                  dateUtil.cloneWithEndOf(startDate).getTime()
                );
                this._endpicker.enable();
                this._endpicker.setRanges([[startDate.getTime(), overlappedRange[1].getTime()]]);
                this._setTimeRangeOnEndPicker();
              } else {
                this._endpicker.setNull();
                this._endpicker.disable();
              }
            },
            _onChangeStartpicker: function() {
              this._syncRangesToEndpicker();
              this.fire("change:start");
            },
            _onChangeEndpicker: function() {
              var date;
              var endPickerDate = this._endpicker.getDate();
              if (endPickerDate) {
                date = endPickerDate.getDate();
                if (this._preEndPickerDate !== date) {
                  this._setTimeRangeOnEndPicker();
                }
                this._preEndPickerDate = date;
              } else {
                this._preEndPickerDate = null;
              }
              this.fire("change:end");
            },
            _isStartAndEndDateSame: function() {
              return !!this._endpicker.getDate() && !!this._startpicker.getDate() && dateUtil.compare(
                this._endpicker.getDate(),
                this._startpicker.getDate(),
                constants.TYPE_DATE
              ) === 0;
            },
            _setTimeRangeOnEndPicker: function() {
              var pickerDate, timeRange, timeRangeToSet;
              var endTimePicker = this._endpicker._timePicker;
              if (!endTimePicker) {
                return;
              }
              pickerDate = this._endpicker.getDate() || this._startpicker.getDate();
              timeRange = this._getTimeRangeFromStartPicker();
              timeRangeToSet = pickerDate && timeRange[pickerDate.getDate()];
              if (this._isStartAndEndDateSame() && timeRangeToSet) {
                endTimePicker.setRange(timeRangeToSet);
                this._isRangeSet = true;
              } else if (this._isRangeSet) {
                endTimePicker.setRange({ hour: 0, minute: 0 });
                endTimePicker.resetMinuteRange();
                this._isRangeSet = false;
              }
            },
            _getTimeRangeFromStartPicker: function() {
              var startDate = this._startpicker.getDate();
              var timeRange = {};
              timeRange[startDate.getDate()] = {
                hour: startDate.getHours(),
                minute: startDate.getMinutes()
              };
              return timeRange;
            },
            getStartpicker: function() {
              return this._startpicker;
            },
            getEndpicker: function() {
              return this._endpicker;
            },
            setStartDate: function(date) {
              this._startpicker.setDate(date);
            },
            getStartDate: function() {
              return this._startpicker.getDate();
            },
            getEndDate: function() {
              return this._endpicker.getDate();
            },
            setEndDate: function(date) {
              this._endpicker.setDate(date);
            },
            setRanges: function(ranges) {
              this._startpicker.setRanges(ranges);
              this._syncRangesToEndpicker();
            },
            addRange: function(start, end) {
              this._startpicker.addRange(start, end);
              this._syncRangesToEndpicker();
            },
            removeRange: function(start, end, type) {
              this._startpicker.removeRange(start, end, type);
              this._syncRangesToEndpicker();
            },
            changeLanguage: function(language) {
              this._startpicker.changeLanguage(language);
              this._endpicker.changeLanguage(language);
            },
            destroy: function() {
              this.off();
              this._startpicker.destroy();
              this._endpicker.destroy();
              this._startpicker = this._endpicker = null;
            }
          }
        );
        CustomEvents.mixin(DateRangePicker);
        module2.exports = DateRangePicker;
      },
      function(module2, exports2, __webpack_require__) {
      }
    ]);
  });
})(tuiDatePicker);
const tu = /* @__PURE__ */ getDefaultExportFromCjs(tuiDatePicker.exports);
var Jl = Object.defineProperty, Ql = Object.defineProperties;
var eu = Object.getOwnPropertyDescriptors;
var Xn = Object.getOwnPropertySymbols;
var vs = Object.prototype.hasOwnProperty, ys = Object.prototype.propertyIsEnumerable;
var _s = (e, t, n) => t in e ? Jl(e, t, { enumerable: true, configurable: true, writable: true, value: n }) : e[t] = n, L = (e, t) => {
  for (var n in t || (t = {}))
    vs.call(t, n) && _s(e, n, t[n]);
  if (Xn)
    for (var n of Xn(t))
      ys.call(t, n) && _s(e, n, t[n]);
  return e;
}, ce = (e, t) => Ql(e, eu(t));
var Kn = (e, t) => {
  var n = {};
  for (var o in e)
    vs.call(e, o) && t.indexOf(o) < 0 && (n[o] = e[o]);
  if (e != null && Xn)
    for (var o of Xn(e))
      t.indexOf(o) < 0 && ys.call(e, o) && (n[o] = e[o]);
  return n;
};
/*!
 * TOAST UI Calendar 2nd Edition
 * @version 1.0.1 | Wed Apr 17 2024
 * @author lqjun <1120948897@qq.com>
 * @license MIT
 */
var Ln, B, Ca, Nt, ws, ka, Nr, ei, Ir, Mr, Na, kn = {}, Ia = [], nu = /acit|ex(?:s|g|n|p|$)|rph|grid|ows|mnc|ntw|ine[ch]|zoo|^ord|itera/i, Ao = Array.isArray;
function ut(e, t) {
  for (var n in t)
    e[n] = t[n];
  return e;
}
function Ma(e) {
  var t = e.parentNode;
  t && t.removeChild(e);
}
function d(e, t, n) {
  var o, r, i, s = {};
  for (i in t)
    i == "key" ? o = t[i] : i == "ref" ? r = t[i] : s[i] = t[i];
  if (arguments.length > 2 && (s.children = arguments.length > 3 ? Ln.call(arguments, 2) : n), typeof e == "function" && e.defaultProps != null)
    for (i in e.defaultProps)
      s[i] === void 0 && (s[i] = e.defaultProps[i]);
  return Sn(e, s, o, r, null);
}
function Sn(e, t, n, o, r) {
  var i = { type: e, props: t, key: n, ref: o, __k: null, __: null, __b: 0, __e: null, __d: void 0, __c: null, constructor: void 0, __v: r == null ? ++Ca : r, __i: -1, __u: 0 };
  return r == null && B.vnode != null && B.vnode(i), i;
}
function ke(e) {
  return e.children;
}
function dt(e, t) {
  this.props = e, this.context = t;
}
function It(e, t) {
  if (t == null)
    return e.__ ? It(e.__, e.__i + 1) : null;
  for (var n; t < e.__k.length; t++)
    if ((n = e.__k[t]) != null && n.__e != null)
      return n.__e;
  return typeof e.type == "function" ? It(e) : null;
}
function Aa(e) {
  var t, n;
  if ((e = e.__) != null && e.__c != null) {
    for (e.__e = e.__c.base = null, t = 0; t < e.__k.length; t++)
      if ((n = e.__k[t]) != null && n.__e != null) {
        e.__e = e.__c.base = n.__e;
        break;
      }
    return Aa(e);
  }
}
function Ar(e) {
  (!e.__d && (e.__d = true) && Nt.push(e) && !mo.__r++ || ws !== B.debounceRendering) && ((ws = B.debounceRendering) || ka)(mo);
}
function mo() {
  var e, t, n, o, r, i, s, a;
  for (Nt.sort(Nr); e = Nt.shift(); )
    e.__d && (t = Nt.length, o = void 0, i = (r = (n = e).__v).__e, s = [], a = [], n.__P && ((o = ut({}, r)).__v = r.__v + 1, B.vnode && B.vnode(o), ti(n.__P, o, r, n.__n, n.__P.ownerSVGElement !== void 0, 32 & r.__u ? [i] : null, s, i == null ? It(r) : i, !!(32 & r.__u), a), o.__v = r.__v, o.__.__k[o.__i] = o, Ra(s, o, a), o.__e != i && Aa(o)), Nt.length > t && Nt.sort(Nr));
  mo.__r = 0;
}
function xa(e, t, n, o, r, i, s, a, c, l, f) {
  var u, p, h, m, w, v = o && o.__k || Ia, _ = t.length;
  for (n.__d = c, ou(n, t, v), c = n.__d, u = 0; u < _; u++)
    (h = n.__k[u]) != null && typeof h != "boolean" && typeof h != "function" && (p = h.__i === -1 ? kn : v[h.__i] || kn, h.__i = u, ti(e, h, p, r, i, s, a, c, l, f), m = h.__e, h.ref && p.ref != h.ref && (p.ref && ni(p.ref, null, h), f.push(h.ref, h.__c || m, h)), w == null && m != null && (w = m), 65536 & h.__u || p.__k === h.__k ? (c && !c.isConnected && (c = It(p)), c = Oa(h, c, e)) : typeof h.type == "function" && h.__d !== void 0 ? c = h.__d : m && (c = m.nextSibling), h.__d = void 0, h.__u &= -196609);
  n.__d = c, n.__e = w;
}
function ou(e, t, n) {
  var o, r, i, s, a, c = t.length, l = n.length, f = l, u = 0;
  for (e.__k = [], o = 0; o < c; o++)
    s = o + u, (r = e.__k[o] = (r = t[o]) == null || typeof r == "boolean" || typeof r == "function" ? null : typeof r == "string" || typeof r == "number" || typeof r == "bigint" || r.constructor == String ? Sn(null, r, null, null, null) : Ao(r) ? Sn(ke, { children: r }, null, null, null) : r.constructor === void 0 && r.__b > 0 ? Sn(r.type, r.props, r.key, r.ref ? r.ref : null, r.__v) : r) != null ? (r.__ = e, r.__b = e.__b + 1, a = ru(r, n, s, f), r.__i = a, i = null, a !== -1 && (f--, (i = n[a]) && (i.__u |= 131072)), i == null || i.__v === null ? (a == -1 && u--, typeof r.type != "function" && (r.__u |= 65536)) : a !== s && (a === s + 1 ? u++ : a > s ? f > c - s ? u += a - s : u-- : a < s ? a == s - 1 && (u = a - s) : u = 0, a !== o + u && (r.__u |= 65536))) : (i = n[s]) && i.key == null && i.__e && (131072 & i.__u) == 0 && (i.__e == e.__d && (e.__d = It(i)), xr(i, i, false), n[s] = null, f--);
  if (f)
    for (o = 0; o < l; o++)
      (i = n[o]) != null && (131072 & i.__u) == 0 && (i.__e == e.__d && (e.__d = It(i)), xr(i, i));
}
function Oa(e, t, n) {
  var o, r;
  if (typeof e.type == "function") {
    for (o = e.__k, r = 0; o && r < o.length; r++)
      o[r] && (o[r].__ = e, t = Oa(o[r], t, n));
    return t;
  }
  e.__e != t && (n.insertBefore(e.__e, t || null), t = e.__e);
  do
    t = t && t.nextSibling;
  while (t != null && t.nodeType === 8);
  return t;
}
function Nn(e, t) {
  return t = t || [], e == null || typeof e == "boolean" || (Ao(e) ? e.some(function(n) {
    Nn(n, t);
  }) : t.push(e)), t;
}
function ru(e, t, n, o) {
  var r = e.key, i = e.type, s = n - 1, a = n + 1, c = t[n];
  if (c === null || c && r == c.key && i === c.type && (131072 & c.__u) == 0)
    return n;
  if (o > (c != null && (131072 & c.__u) == 0 ? 1 : 0))
    for (; s >= 0 || a < t.length; ) {
      if (s >= 0) {
        if ((c = t[s]) && (131072 & c.__u) == 0 && r == c.key && i === c.type)
          return s;
        s--;
      }
      if (a < t.length) {
        if ((c = t[a]) && (131072 & c.__u) == 0 && r == c.key && i === c.type)
          return a;
        a++;
      }
    }
  return -1;
}
function Es(e, t, n) {
  t[0] === "-" ? e.setProperty(t, n == null ? "" : n) : e[t] = n == null ? "" : typeof n != "number" || nu.test(t) ? n : n + "px";
}
function qn(e, t, n, o, r) {
  var i;
  e:
    if (t === "style")
      if (typeof n == "string")
        e.style.cssText = n;
      else {
        if (typeof o == "string" && (e.style.cssText = o = ""), o)
          for (t in o)
            n && t in n || Es(e.style, t, "");
        if (n)
          for (t in n)
            o && n[t] === o[t] || Es(e.style, t, n[t]);
      }
    else if (t[0] === "o" && t[1] === "n")
      i = t !== (t = t.replace(/(PointerCapture)$|Capture$/i, "$1")), t = t.toLowerCase() in e || t === "onFocusOut" || t === "onFocusIn" ? t.toLowerCase().slice(2) : t.slice(2), e.l || (e.l = {}), e.l[t + i] = n, n ? o ? n.u = o.u : (n.u = ei, e.addEventListener(t, i ? Mr : Ir, i)) : e.removeEventListener(t, i ? Mr : Ir, i);
    else {
      if (r)
        t = t.replace(/xlink(H|:h)/, "h").replace(/sName$/, "s");
      else if (t != "width" && t != "height" && t != "href" && t != "list" && t != "form" && t != "tabIndex" && t != "download" && t != "rowSpan" && t != "colSpan" && t != "role" && t in e)
        try {
          e[t] = n == null ? "" : n;
          break e;
        } catch (s) {
        }
      typeof n == "function" || (n == null || n === false && t[4] !== "-" ? e.removeAttribute(t) : e.setAttribute(t, n));
    }
}
function Ds(e) {
  return function(t) {
    if (this.l) {
      var n = this.l[t.type + e];
      if (t.t == null)
        t.t = ei++;
      else if (t.t < n.u)
        return;
      return n(B.event ? B.event(t) : t);
    }
  };
}
function ti(e, t, n, o, r, i, s, a, c, l) {
  var f, u, p, h, m, w, v, _, E, S, b, D, A, T, k, M = t.type;
  if (t.constructor !== void 0)
    return null;
  128 & n.__u && (c = !!(32 & n.__u), i = [a = t.__e = n.__e]), (f = B.__b) && f(t);
  e:
    if (typeof M == "function")
      try {
        if (_ = t.props, E = (f = M.contextType) && o[f.__c], S = f ? E ? E.props.value : f.__ : o, n.__c ? v = (u = t.__c = n.__c).__ = u.__E : ("prototype" in M && M.prototype.render ? t.__c = u = new M(_, S) : (t.__c = u = new dt(_, S), u.constructor = M, u.render = su), E && E.sub(u), u.props = _, u.state || (u.state = {}), u.context = S, u.__n = o, p = u.__d = true, u.__h = [], u._sb = []), u.__s == null && (u.__s = u.state), M.getDerivedStateFromProps != null && (u.__s == u.state && (u.__s = ut({}, u.__s)), ut(u.__s, M.getDerivedStateFromProps(_, u.__s))), h = u.props, m = u.state, u.__v = t, p)
          M.getDerivedStateFromProps == null && u.componentWillMount != null && u.componentWillMount(), u.componentDidMount != null && u.__h.push(u.componentDidMount);
        else {
          if (M.getDerivedStateFromProps == null && _ !== h && u.componentWillReceiveProps != null && u.componentWillReceiveProps(_, S), !u.__e && (u.shouldComponentUpdate != null && u.shouldComponentUpdate(_, u.__s, S) === false || t.__v === n.__v)) {
            for (t.__v !== n.__v && (u.props = _, u.state = u.__s, u.__d = false), t.__e = n.__e, t.__k = n.__k, t.__k.forEach(function(N) {
              N && (N.__ = t);
            }), b = 0; b < u._sb.length; b++)
              u.__h.push(u._sb[b]);
            u._sb = [], u.__h.length && s.push(u);
            break e;
          }
          u.componentWillUpdate != null && u.componentWillUpdate(_, u.__s, S), u.componentDidUpdate != null && u.__h.push(function() {
            u.componentDidUpdate(h, m, w);
          });
        }
        if (u.context = S, u.props = _, u.__P = e, u.__e = false, D = B.__r, A = 0, "prototype" in M && M.prototype.render) {
          for (u.state = u.__s, u.__d = false, D && D(t), f = u.render(u.props, u.state, u.context), T = 0; T < u._sb.length; T++)
            u.__h.push(u._sb[T]);
          u._sb = [];
        } else
          do
            u.__d = false, D && D(t), f = u.render(u.props, u.state, u.context), u.state = u.__s;
          while (u.__d && ++A < 25);
        u.state = u.__s, u.getChildContext != null && (o = ut(ut({}, o), u.getChildContext())), p || u.getSnapshotBeforeUpdate == null || (w = u.getSnapshotBeforeUpdate(h, m)), xa(e, Ao(k = f != null && f.type === ke && f.key == null ? f.props.children : f) ? k : [k], t, n, o, r, i, s, a, c, l), u.base = t.__e, t.__u &= -161, u.__h.length && s.push(u), v && (u.__E = u.__ = null);
      } catch (N) {
        t.__v = null, c || i != null ? (t.__e = a, t.__u |= c ? 160 : 32, i[i.indexOf(a)] = null) : (t.__e = n.__e, t.__k = n.__k), B.__e(N, t, n);
      }
    else
      i == null && t.__v === n.__v ? (t.__k = n.__k, t.__e = n.__e) : t.__e = iu(n.__e, t, n, o, r, i, s, c, l);
  (f = B.diffed) && f(t);
}
function Ra(e, t, n) {
  t.__d = void 0;
  for (var o = 0; o < n.length; o++)
    ni(n[o], n[++o], n[++o]);
  B.__c && B.__c(t, e), e.some(function(r) {
    try {
      e = r.__h, r.__h = [], e.some(function(i) {
        i.call(r);
      });
    } catch (i) {
      B.__e(i, r.__v);
    }
  });
}
function iu(e, t, n, o, r, i, s, a, c) {
  var l, f, u, p, h, m, w, v = n.props, _ = t.props, E = t.type;
  if (E === "svg" && (r = true), i != null) {
    for (l = 0; l < i.length; l++)
      if ((h = i[l]) && "setAttribute" in h == !!E && (E ? h.localName === E : h.nodeType === 3)) {
        e = h, i[l] = null;
        break;
      }
  }
  if (e == null) {
    if (E === null)
      return document.createTextNode(_);
    e = r ? document.createElementNS("http://www.w3.org/2000/svg", E) : document.createElement(E, _.is && _), i = null, a = false;
  }
  if (E === null)
    v === _ || a && e.data === _ || (e.data = _);
  else {
    if (i = i && Ln.call(e.childNodes), v = n.props || kn, !a && i != null)
      for (v = {}, l = 0; l < e.attributes.length; l++)
        v[(h = e.attributes[l]).name] = h.value;
    for (l in v)
      h = v[l], l == "children" || (l == "dangerouslySetInnerHTML" ? u = h : l === "key" || l in _ || qn(e, l, null, h, r));
    for (l in _)
      h = _[l], l == "children" ? p = h : l == "dangerouslySetInnerHTML" ? f = h : l == "value" ? m = h : l == "checked" ? w = h : l === "key" || a && typeof h != "function" || v[l] === h || qn(e, l, h, v[l], r);
    if (f)
      a || u && (f.__html === u.__html || f.__html === e.innerHTML) || (e.innerHTML = f.__html), t.__k = [];
    else if (u && (e.innerHTML = ""), xa(e, Ao(p) ? p : [p], t, n, o, r && E !== "foreignObject", i, s, i ? i[0] : n.__k && It(n, 0), a, c), i != null)
      for (l = i.length; l--; )
        i[l] != null && Ma(i[l]);
    a || (l = "value", m !== void 0 && (m !== e[l] || E === "progress" && !m || E === "option" && m !== v[l]) && qn(e, l, m, v[l], false), l = "checked", w !== void 0 && w !== e[l] && qn(e, l, w, v[l], false));
  }
  return e;
}
function ni(e, t, n) {
  try {
    typeof e == "function" ? e(t) : e.current = t;
  } catch (o) {
    B.__e(o, n);
  }
}
function xr(e, t, n) {
  var o, r;
  if (B.unmount && B.unmount(e), (o = e.ref) && (o.current && o.current !== e.__e || ni(o, null, t)), (o = e.__c) != null) {
    if (o.componentWillUnmount)
      try {
        o.componentWillUnmount();
      } catch (i) {
        B.__e(i, t);
      }
    o.base = o.__P = null;
  }
  if (o = e.__k)
    for (r = 0; r < o.length; r++)
      o[r] && xr(o[r], t, n || typeof e.type != "function");
  n || e.__e == null || Ma(e.__e), e.__c = e.__ = e.__e = e.__d = void 0;
}
function su(e, t, n) {
  return this.constructor(e, n);
}
function go(e, t, n) {
  var o, r, i, s;
  B.__ && B.__(e, t), r = (o = typeof n == "function") ? null : n && n.__k || t.__k, i = [], s = [], ti(t, e = (!o && n || t).__k = d(ke, null, [e]), r || kn, kn, t.ownerSVGElement !== void 0, !o && n ? [n] : r ? null : t.firstChild ? Ln.call(t.childNodes) : null, i, !o && n ? n : r ? r.__e : t.firstChild, o, s), Ra(i, e, s);
}
function au(e, t, n) {
  var o, r, i, s, a = ut({}, e.props);
  for (i in e.type && e.type.defaultProps && (s = e.type.defaultProps), t)
    i == "key" ? o = t[i] : i == "ref" ? r = t[i] : a[i] = t[i] === void 0 && s !== void 0 ? s[i] : t[i];
  return arguments.length > 2 && (a.children = arguments.length > 3 ? Ln.call(arguments, 2) : n), Sn(e.type, a, o || e.key, r || e.ref, null);
}
function xo(e, t) {
  var n = { __c: t = "__cC" + Na++, __: e, Consumer: function(o, r) {
    return o.children(r);
  }, Provider: function(o) {
    var r, i;
    return this.getChildContext || (r = [], (i = {})[t] = this, this.getChildContext = function() {
      return i;
    }, this.shouldComponentUpdate = function(s) {
      this.props.value !== s.value && r.some(function(a) {
        a.__e = true, Ar(a);
      });
    }, this.sub = function(s) {
      r.push(s);
      var a = s.componentWillUnmount;
      s.componentWillUnmount = function() {
        r.splice(r.indexOf(s), 1), a && a.call(s);
      };
    }), o.children;
  } };
  return n.Provider.__ = n.Consumer.contextType = n;
}
Ln = Ia.slice, B = { __e: function(e, t, n, o) {
  for (var r, i, s; t = t.__; )
    if ((r = t.__c) && !r.__)
      try {
        if ((i = r.constructor) && i.getDerivedStateFromError != null && (r.setState(i.getDerivedStateFromError(e)), s = r.__d), r.componentDidCatch != null && (r.componentDidCatch(e, o || {}), s = r.__d), s)
          return r.__E = r;
      } catch (a) {
        e = a;
      }
  throw e;
} }, Ca = 0, dt.prototype.setState = function(e, t) {
  var n;
  n = this.__s != null && this.__s !== this.state ? this.__s : this.__s = ut({}, this.state), typeof e == "function" && (e = e(ut({}, n), this.props)), e && ut(n, e), e != null && this.__v && (t && this._sb.push(t), Ar(this));
}, dt.prototype.forceUpdate = function(e) {
  this.__v && (this.__e = true, e && this.__h.push(e), Ar(this));
}, dt.prototype.render = ke, Nt = [], ka = typeof Promise == "function" ? Promise.prototype.then.bind(Promise.resolve()) : setTimeout, Nr = function(e, t) {
  return e.__v.__b - t.__v.__b;
}, mo.__r = 0, ei = 0, Ir = Ds(false), Mr = Ds(true), Na = 0;
var Mt, le, pr, Ss, In = 0, Pa = [], co = [], pe = B, Ts = pe.__b, bs = pe.__r, Cs = pe.diffed, ks = pe.__c, Ns = pe.unmount, Is = pe.__;
function $n(e, t) {
  pe.__h && pe.__h(le, e, In || t), In = 0;
  var n = le.__H || (le.__H = { __: [], __h: [] });
  return e >= n.__.length && n.__.push({ __V: co }), n.__[e];
}
function se(e) {
  return In = 1, oi(La, e);
}
function oi(e, t, n) {
  var o = $n(Mt++, 2);
  if (o.t = e, !o.__c && (o.__ = [n ? n(t) : La(void 0, t), function(a) {
    var c = o.__N ? o.__N[0] : o.__[0], l = o.t(c, a);
    c !== l && (o.__N = [l, o.__[1]], o.__c.setState({}));
  }], o.__c = le, !le.u)) {
    var r = function(a, c, l) {
      if (!o.__c.__H)
        return true;
      var f = o.__c.__H.__.filter(function(p) {
        return !!p.__c;
      });
      if (f.every(function(p) {
        return !p.__N;
      }))
        return !i || i.call(this, a, c, l);
      var u = false;
      return f.forEach(function(p) {
        if (p.__N) {
          var h = p.__[0];
          p.__ = p.__N, p.__N = void 0, h !== p.__[0] && (u = true);
        }
      }), !(!u && o.__c.props === a) && (!i || i.call(this, a, c, l));
    };
    le.u = true;
    var i = le.shouldComponentUpdate, s = le.componentWillUpdate;
    le.componentWillUpdate = function(a, c, l) {
      if (this.__e) {
        var f = i;
        i = void 0, r(a, c, l), i = f;
      }
      s && s.call(this, a, c, l);
    }, le.shouldComponentUpdate = r;
  }
  return o.__N || o.__;
}
function oe(e, t) {
  var n = $n(Mt++, 3);
  !pe.__s && ri(n.__H, t) && (n.__ = e, n.i = t, le.__H.__h.push(n));
}
function _t(e, t) {
  var n = $n(Mt++, 4);
  !pe.__s && ri(n.__H, t) && (n.__ = e, n.i = t, le.__h.push(n));
}
function ee(e) {
  return In = 5, Y(function() {
    return { current: e };
  }, []);
}
function Y(e, t) {
  var n = $n(Mt++, 7);
  return ri(n.__H, t) ? (n.__V = e(), n.i = t, n.__h = e, n.__V) : n.__;
}
function Q(e, t) {
  return In = 8, Y(function() {
    return e;
  }, t);
}
function Mn(e) {
  var t = le.context[e.__c], n = $n(Mt++, 9);
  return n.c = e, t ? (n.__ == null && (n.__ = true, t.sub(le)), t.props.value) : e.__;
}
function cu() {
  for (var e; e = Pa.shift(); )
    if (e.__P && e.__H)
      try {
        e.__H.__h.forEach(lo), e.__H.__h.forEach(Or), e.__H.__h = [];
      } catch (t) {
        e.__H.__h = [], pe.__e(t, e.__v);
      }
}
pe.__b = function(e) {
  le = null, Ts && Ts(e);
}, pe.__ = function(e, t) {
  e && t.__k && t.__k.__m && (e.__m = t.__k.__m), Is && Is(e, t);
}, pe.__r = function(e) {
  bs && bs(e), Mt = 0;
  var t = (le = e.__c).__H;
  t && (pr === le ? (t.__h = [], le.__h = [], t.__.forEach(function(n) {
    n.__N && (n.__ = n.__N), n.__V = co, n.__N = n.i = void 0;
  })) : (t.__h.forEach(lo), t.__h.forEach(Or), t.__h = [], Mt = 0)), pr = le;
}, pe.diffed = function(e) {
  Cs && Cs(e);
  var t = e.__c;
  t && t.__H && (t.__H.__h.length && (Pa.push(t) !== 1 && Ss === pe.requestAnimationFrame || ((Ss = pe.requestAnimationFrame) || lu)(cu)), t.__H.__.forEach(function(n) {
    n.i && (n.__H = n.i), n.__V !== co && (n.__ = n.__V), n.i = void 0, n.__V = co;
  })), pr = le = null;
}, pe.__c = function(e, t) {
  t.some(function(n) {
    try {
      n.__h.forEach(lo), n.__h = n.__h.filter(function(o) {
        return !o.__ || Or(o);
      });
    } catch (o) {
      t.some(function(r) {
        r.__h && (r.__h = []);
      }), t = [], pe.__e(o, n.__v);
    }
  }), ks && ks(e, t);
}, pe.unmount = function(e) {
  Ns && Ns(e);
  var t, n = e.__c;
  n && n.__H && (n.__H.__.forEach(function(o) {
    try {
      lo(o);
    } catch (r) {
      t = r;
    }
  }), n.__H = void 0, t && pe.__e(t, n.__v));
};
var Ms = typeof requestAnimationFrame == "function";
function lu(e) {
  var t, n = function() {
    clearTimeout(o), Ms && cancelAnimationFrame(t), setTimeout(e);
  }, o = setTimeout(n, 100);
  Ms && (t = requestAnimationFrame(n));
}
function lo(e) {
  var t = le, n = e.__c;
  typeof n == "function" && (e.__c = void 0, n()), le = t;
}
function Or(e) {
  var t = le;
  e.__c = e.__(), le = t;
}
function ri(e, t) {
  return !e || e.length !== t.length || t.some(function(n, o) {
    return n !== e[o];
  });
}
function La(e, t) {
  return typeof t == "function" ? t(e) : t;
}
function be(e) {
  for (var t = arguments.length, n = Array(t > 1 ? t - 1 : 0), o = 1; o < t; o++)
    n[o - 1] = arguments[o];
  if (process.env.NODE_ENV !== "production") {
    var r = _u[e], i = r ? typeof r == "function" ? r.apply(null, n) : r : "unknown error nr: " + e;
    throw Error("[Immer] " + i);
  }
  throw Error("[Immer] minified error nr: " + e + (n.length ? " " + n.map(function(s) {
    return "'" + s + "'";
  }).join(",") : "") + ". Find the full error at: https://bit.ly/3cXEKWf");
}
function qt(e) {
  return !!e && !!e[$e];
}
function At(e) {
  var t;
  return !!e && (function(n) {
    if (!n || typeof n != "object")
      return false;
    var o = Object.getPrototypeOf(n);
    if (o === null)
      return true;
    var r = Object.hasOwnProperty.call(o, "constructor") && o.constructor;
    return r === Object || typeof r == "function" && Function.toString.call(r) === vu;
  }(e) || Array.isArray(e) || !!e[Hs] || !!(!((t = e.constructor) === null || t === void 0) && t[Hs]) || ii(e) || si(e));
}
function An(e, t, n) {
  n === void 0 && (n = false), nn(e) === 0 ? (n ? Object.keys : di)(e).forEach(function(o) {
    n && typeof o == "symbol" || t(o, e[o], e);
  }) : e.forEach(function(o, r) {
    return t(r, o, e);
  });
}
function nn(e) {
  var t = e[$e];
  return t ? t.i > 3 ? t.i - 4 : t.i : Array.isArray(e) ? 1 : ii(e) ? 2 : si(e) ? 3 : 0;
}
function Rr(e, t) {
  return nn(e) === 2 ? e.has(t) : Object.prototype.hasOwnProperty.call(e, t);
}
function uu(e, t) {
  return nn(e) === 2 ? e.get(t) : e[t];
}
function $a(e, t, n) {
  var o = nn(e);
  o === 2 ? e.set(t, n) : o === 3 ? e.add(n) : e[t] = n;
}
function du(e, t) {
  return e === t ? e !== 0 || 1 / e == 1 / t : e != e && t != t;
}
function ii(e) {
  return mu && e instanceof Map;
}
function si(e) {
  return gu && e instanceof Set;
}
function kt(e) {
  return e.o || e.t;
}
function ai(e) {
  if (Array.isArray(e))
    return Array.prototype.slice.call(e);
  var t = yu(e);
  delete t[$e];
  for (var n = di(t), o = 0; o < n.length; o++) {
    var r = n[o], i = t[r];
    i.writable === false && (i.writable = true, i.configurable = true), (i.get || i.set) && (t[r] = { configurable: true, writable: true, enumerable: i.enumerable, value: e[r] });
  }
  return Object.create(Object.getPrototypeOf(e), t);
}
function ci(e, t) {
  return t === void 0 && (t = false), li(e) || qt(e) || !At(e) || (nn(e) > 1 && (e.set = e.add = e.clear = e.delete = fu), Object.freeze(e), t && An(e, function(n, o) {
    return ci(o, true);
  }, true)), e;
}
function fu() {
  be(2);
}
function li(e) {
  return e == null || typeof e != "object" || Object.isFrozen(e);
}
function ot(e) {
  var t = wu[e];
  return t || be(18, e), t;
}
function As() {
  return process.env.NODE_ENV === "production" || Zt || be(0), Zt;
}
function hr(e, t) {
  t && (ot("Patches"), e.u = [], e.s = [], e.v = t);
}
function _o(e) {
  Pr(e), e.p.forEach(pu), e.p = null;
}
function Pr(e) {
  e === Zt && (Zt = e.l);
}
function xs(e) {
  return Zt = { p: [], l: Zt, h: e, m: true, _: 0 };
}
function pu(e) {
  var t = e[$e];
  t.i === 0 || t.i === 1 ? t.j() : t.g = true;
}
function mr(e, t) {
  t._ = t.p.length;
  var n = t.p[0], o = e !== void 0 && e !== n;
  return t.h.O || ot("ES5").S(t, e, o), o ? (n[$e].P && (_o(t), be(4)), At(e) && (e = vo(t, e), t.l || yo(t, e)), t.u && ot("Patches").M(n[$e].t, e, t.u, t.s)) : e = vo(t, n, []), _o(t), t.u && t.v(t.u, t.s), e !== Ha ? e : void 0;
}
function vo(e, t, n) {
  if (li(t))
    return t;
  var o = t[$e];
  if (!o)
    return An(t, function(a, c) {
      return Os(e, o, t, a, c, n);
    }, true), t;
  if (o.A !== e)
    return t;
  if (!o.P)
    return yo(e, o.t, true), o.t;
  if (!o.I) {
    o.I = true, o.A._--;
    var r = o.i === 4 || o.i === 5 ? o.o = ai(o.k) : o.o, i = r, s = false;
    o.i === 3 && (i = new Set(r), r.clear(), s = true), An(i, function(a, c) {
      return Os(e, o, r, a, c, n, s);
    }), yo(e, r, false), n && e.u && ot("Patches").N(o, n, e.u, e.s);
  }
  return o.o;
}
function Os(e, t, n, o, r, i, s) {
  if (process.env.NODE_ENV !== "production" && r === n && be(5), qt(r)) {
    var a = vo(e, r, i && t && t.i !== 3 && !Rr(t.R, o) ? i.concat(o) : void 0);
    if ($a(n, o, a), !qt(a))
      return;
    e.m = false;
  } else
    s && n.add(r);
  if (At(r) && !li(r)) {
    if (!e.h.D && e._ < 1)
      return;
    vo(e, r), t && t.A.l || yo(e, r);
  }
}
function yo(e, t, n) {
  n === void 0 && (n = false), !e.l && e.h.D && e.m && ci(t, n);
}
function gr(e, t) {
  var n = e[$e];
  return (n ? kt(n) : e)[t];
}
function Rs(e, t) {
  if (t in e)
    for (var n = Object.getPrototypeOf(e); n; ) {
      var o = Object.getOwnPropertyDescriptor(n, t);
      if (o)
        return o;
      n = Object.getPrototypeOf(n);
    }
}
function Lr(e) {
  e.P || (e.P = true, e.l && Lr(e.l));
}
function _r(e) {
  e.o || (e.o = ai(e.t));
}
function $r(e, t, n) {
  var o = ii(t) ? ot("MapSet").F(t, n) : si(t) ? ot("MapSet").T(t, n) : e.O ? function(r, i) {
    var s = Array.isArray(r), a = { i: s ? 1 : 0, A: i ? i.A : As(), P: false, I: false, R: {}, l: i, t: r, k: null, o: null, j: null, C: false }, c = a, l = Hr;
    s && (c = [a], l = wn);
    var f = Proxy.revocable(c, l), u = f.revoke, p = f.proxy;
    return a.k = p, a.j = u, p;
  }(t, n) : ot("ES5").J(t, n);
  return (n ? n.A : As()).p.push(o), o;
}
function hu(e) {
  return qt(e) || be(22, e), function t(n) {
    if (!At(n))
      return n;
    var o, r = n[$e], i = nn(n);
    if (r) {
      if (!r.P && (r.i < 4 || !ot("ES5").K(r)))
        return r.t;
      r.I = true, o = Ps(n, i), r.I = false;
    } else
      o = Ps(n, i);
    return An(o, function(s, a) {
      r && uu(r.t, s) === a || $a(o, s, t(a));
    }), i === 3 ? new Set(o) : o;
  }(e);
}
function Ps(e, t) {
  switch (t) {
    case 2:
      return new Map(e);
    case 3:
      return Array.from(e);
  }
  return ai(e);
}
var Ls, Zt, ui = typeof Symbol != "undefined" && typeof Symbol("x") == "symbol", mu = typeof Map != "undefined", gu = typeof Set != "undefined", $s = typeof Proxy != "undefined" && Proxy.revocable !== void 0 && typeof Reflect != "undefined", Ha = ui ? Symbol.for("immer-nothing") : ((Ls = {})["immer-nothing"] = true, Ls), Hs = ui ? Symbol.for("immer-draftable") : "__$immer_draftable", $e = ui ? Symbol.for("immer-state") : "__$immer_state", _u = { 0: "Illegal state", 1: "Immer drafts cannot have computed properties", 2: "This object has been frozen and should not be mutated", 3: function(e) {
  return "Cannot use a proxy that has been revoked. Did you pass an object from inside an immer function to an async process? " + e;
}, 4: "An immer producer returned a new value *and* modified its draft. Either return a new value *or* modify the draft.", 5: "Immer forbids circular references", 6: "The first or second argument to `produce` must be a function", 7: "The third argument to `produce` must be a function or undefined", 8: "First argument to `createDraft` must be a plain object, an array, or an immerable object", 9: "First argument to `finishDraft` must be a draft returned by `createDraft`", 10: "The given draft is already finalized", 11: "Object.defineProperty() cannot be used on an Immer draft", 12: "Object.setPrototypeOf() cannot be used on an Immer draft", 13: "Immer only supports deleting array indices", 14: "Immer only supports setting array indices and the 'length' property", 15: function(e) {
  return "Cannot apply patch, path doesn't resolve: " + e;
}, 16: 'Sets cannot have "replace" patches.', 17: function(e) {
  return "Unsupported patch operation: " + e;
}, 18: function(e) {
  return "The plugin for '" + e + "' has not been loaded into Immer. To enable the plugin, import and call `enable" + e + "()` when initializing your application.";
}, 20: "Cannot use proxies if Proxy, Proxy.revocable or Reflect are not available", 21: function(e) {
  return "produce can only be called on things that are draftable: plain objects, arrays, Map, Set or classes that are marked with '[immerable]: true'. Got '" + e + "'";
}, 22: function(e) {
  return "'current' expects a draft, got: " + e;
}, 23: function(e) {
  return "'original' expects a draft, got: " + e;
}, 24: "Patching reserved attributes like __proto__, prototype and constructor is not allowed" }, vu = "" + Object.prototype.constructor, di = typeof Reflect != "undefined" && Reflect.ownKeys ? Reflect.ownKeys : Object.getOwnPropertySymbols !== void 0 ? function(e) {
  return Object.getOwnPropertyNames(e).concat(Object.getOwnPropertySymbols(e));
} : Object.getOwnPropertyNames, yu = Object.getOwnPropertyDescriptors || function(e) {
  var t = {};
  return di(e).forEach(function(n) {
    t[n] = Object.getOwnPropertyDescriptor(e, n);
  }), t;
}, wu = {}, Hr = { get: function(e, t) {
  if (t === $e)
    return e;
  var n = kt(e);
  if (!Rr(n, t))
    return function(r, i, s) {
      var a, c = Rs(i, s);
      return c ? "value" in c ? c.value : (a = c.get) === null || a === void 0 ? void 0 : a.call(r.k) : void 0;
    }(e, n, t);
  var o = n[t];
  return e.I || !At(o) ? o : o === gr(e.t, t) ? (_r(e), e.o[t] = $r(e.A.h, o, e)) : o;
}, has: function(e, t) {
  return t in kt(e);
}, ownKeys: function(e) {
  return Reflect.ownKeys(kt(e));
}, set: function(e, t, n) {
  var o = Rs(kt(e), t);
  if (o != null && o.set)
    return o.set.call(e.k, n), true;
  if (!e.P) {
    var r = gr(kt(e), t), i = r == null ? void 0 : r[$e];
    if (i && i.t === n)
      return e.o[t] = n, e.R[t] = false, true;
    if (du(n, r) && (n !== void 0 || Rr(e.t, t)))
      return true;
    _r(e), Lr(e);
  }
  return e.o[t] === n && (n !== void 0 || t in e.o) || Number.isNaN(n) && Number.isNaN(e.o[t]) || (e.o[t] = n, e.R[t] = true), true;
}, deleteProperty: function(e, t) {
  return gr(e.t, t) !== void 0 || t in e.t ? (e.R[t] = false, _r(e), Lr(e)) : delete e.R[t], e.o && delete e.o[t], true;
}, getOwnPropertyDescriptor: function(e, t) {
  var n = kt(e), o = Reflect.getOwnPropertyDescriptor(n, t);
  return o && { writable: true, configurable: e.i !== 1 || t !== "length", enumerable: o.enumerable, value: n[t] };
}, defineProperty: function() {
  be(11);
}, getPrototypeOf: function(e) {
  return Object.getPrototypeOf(e.t);
}, setPrototypeOf: function() {
  be(12);
} }, wn = {};
An(Hr, function(e, t) {
  wn[e] = function() {
    return arguments[0] = arguments[0][0], t.apply(this, arguments);
  };
}), wn.deleteProperty = function(e, t) {
  return process.env.NODE_ENV !== "production" && isNaN(parseInt(t)) && be(13), wn.set.call(this, e, t, void 0);
}, wn.set = function(e, t, n) {
  return process.env.NODE_ENV !== "production" && t !== "length" && isNaN(parseInt(t)) && be(14), Hr.set.call(this, e[0], t, n, e[0]);
};
var Eu = function() {
  function e(n) {
    var o = this;
    this.O = $s, this.D = true, this.produce = function(r, i, s) {
      if (typeof r == "function" && typeof i != "function") {
        var a = i;
        i = r;
        var c = o;
        return function(w) {
          var v = this;
          w === void 0 && (w = a);
          for (var _ = arguments.length, E = Array(_ > 1 ? _ - 1 : 0), S = 1; S < _; S++)
            E[S - 1] = arguments[S];
          return c.produce(w, function(b) {
            var D;
            return (D = i).call.apply(D, [v, b].concat(E));
          });
        };
      }
      var l;
      if (typeof i != "function" && be(6), s !== void 0 && typeof s != "function" && be(7), At(r)) {
        var f = xs(o), u = $r(o, r, void 0), p = true;
        try {
          l = i(u), p = false;
        } finally {
          p ? _o(f) : Pr(f);
        }
        return typeof Promise != "undefined" && l instanceof Promise ? l.then(function(w) {
          return hr(f, s), mr(w, f);
        }, function(w) {
          throw _o(f), w;
        }) : (hr(f, s), mr(l, f));
      }
      if (!r || typeof r != "object") {
        if ((l = i(r)) === void 0 && (l = r), l === Ha && (l = void 0), o.D && ci(l, true), s) {
          var h = [], m = [];
          ot("Patches").M(r, l, h, m), s(h, m);
        }
        return l;
      }
      be(21, r);
    }, this.produceWithPatches = function(r, i) {
      if (typeof r == "function")
        return function(l) {
          for (var f = arguments.length, u = Array(f > 1 ? f - 1 : 0), p = 1; p < f; p++)
            u[p - 1] = arguments[p];
          return o.produceWithPatches(l, function(h) {
            return r.apply(void 0, [h].concat(u));
          });
        };
      var s, a, c = o.produce(r, i, function(l, f) {
        s = l, a = f;
      });
      return typeof Promise != "undefined" && c instanceof Promise ? c.then(function(l) {
        return [l, s, a];
      }) : [c, s, a];
    }, typeof (n == null ? void 0 : n.useProxies) == "boolean" && this.setUseProxies(n.useProxies), typeof (n == null ? void 0 : n.autoFreeze) == "boolean" && this.setAutoFreeze(n.autoFreeze);
  }
  var t = e.prototype;
  return t.createDraft = function(n) {
    At(n) || be(8), qt(n) && (n = hu(n));
    var o = xs(this), r = $r(this, n, void 0);
    return r[$e].C = true, Pr(o), r;
  }, t.finishDraft = function(n, o) {
    var r = n && n[$e];
    process.env.NODE_ENV !== "production" && (r && r.C || be(9), r.I && be(10));
    var i = r.A;
    return hr(i, o), mr(void 0, i);
  }, t.setAutoFreeze = function(n) {
    this.D = n;
  }, t.setUseProxies = function(n) {
    n && !$s && be(20), this.O = n;
  }, t.applyPatches = function(n, o) {
    var r;
    for (r = o.length - 1; r >= 0; r--) {
      var i = o[r];
      if (i.path.length === 0 && i.op === "replace") {
        n = i.value;
        break;
      }
    }
    r > -1 && (o = o.slice(r + 1));
    var s = ot("Patches").$;
    return qt(n) ? s(n, o) : this.produce(n, function(a) {
      return s(a, o);
    });
  }, e;
}(), He = new Eu(), Du = He.produce;
He.produceWithPatches.bind(He);
He.setAutoFreeze.bind(He);
He.setUseProxies.bind(He);
He.applyPatches.bind(He);
He.createDraft.bind(He);
He.finishDraft.bind(He);
const J = Du;
var Su = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : {};
function Tu(e) {
  return e === void 0;
}
var Fe = Tu, bu = Fe;
function Cu(e, t, n) {
  var o = [], r;
  for (bu(t) && (t = e || 0, e = 0), n = n || 1, r = n < 0 ? -1 : 1, t *= r; e * r < t; e += n)
    o.push(e);
  return o;
}
var vt = Cu;
const ku = "0", Jt = 24, Oo = 2, fi = 3, Ro = 27, vr = 5, Nu = 280, uo = 44, Fr = 12, Iu = 12, Mu = "12px 17px 0", Fa = 42, Ga = 1, Ba = 2, Qt = 72, Fs = {
  color: "#000",
  backgroundColor: "#a1b56c",
  dragBackgroundColor: "#a1b56c",
  borderColor: "#000"
}, wo = 2, Gs = 9;
function Au(e) {
  return typeof e == "boolean" || e instanceof Boolean;
}
var pi = Au;
function xu(e) {
  return typeof e == "number" || e instanceof Number;
}
var fo = xu;
function Ou(e) {
  return e === Object(e);
}
var po = Ou;
function Ru(e) {
  return typeof e == "string" || e instanceof String;
}
var Ie = Ru;
function V(e) {
  return Fe(e) || e === null;
}
function $(e) {
  return !V(e);
}
function Tn(e) {
  return typeof e == "function";
}
const Pu = "toastui-calendar-";
function y(...e) {
  const t = [];
  return e.forEach((n) => {
    !n || (Ie(n) ? t.push(n) : Object.keys(n).forEach((o) => {
      n[o] && t.push(o);
    }));
  }), t.map((n) => `${Pu}${n}`).join(" ");
}
function q(e) {
  return `${e}%`;
}
function Eo(e) {
  return `${e}px`;
}
function Gr(e) {
  const t = /(\d+)%/, n = e.match(t), o = /(-?)\s?(\d+)px/, r = e.match(o);
  return {
    percent: n ? parseInt(n[1], 10) : 0,
    px: r ? parseInt(`${r[1]}${r[2]}`, 10) : 0
  };
}
function za(e, t) {
  const n = e.model.getColors();
  return Object.keys(Fs).reduce((o, r) => {
    var s, a;
    const i = r;
    return o[i] = (a = (s = n[i]) != null ? s : t[i]) != null ? a : Fs[i], o;
  }, {});
}
const Lu = /^(-?(?:[1-9][0-9]*)?[0-9]{4})-(1[0-2]|0[1-9])-(3[01]|0[1-9]|[12][0-9])T(2[0-3]|[01][0-9]):([0-5][0-9]):([0-5][0-9])(\.)?([0-9]+)?([+-]\d\d(?::?\d\d)?|\s*Z)?$/;
function Bs() {
  throw new Error("This operation is not supported.");
}
function $u(e) {
  const t = Lu.exec(e);
  if (t) {
    const [, n, o, r, i, s, a, , c, l] = t;
    return {
      y: Number(n),
      M: Number(o) - 1,
      d: Number(r),
      h: Number(i),
      m: Number(s),
      s: Number(a),
      ms: Number(c) || 0,
      zoneInfo: l
    };
  }
  return null;
}
function Hu(e) {
  const t = $u(e);
  if (t && !t.zoneInfo) {
    const { y: n, M: o, d: r, h: i, m: s, s: a, ms: c } = t;
    return new Date(n, o, r, i, s, a, c);
  }
  return null;
}
class on {
  constructor(...t) {
    const [n] = t;
    n instanceof Date ? this.d = new Date(n.getTime()) : Ie(n) && t.length === 1 && (this.d = Hu(n)), this.d || (this.d = new Date(...t));
  }
  setTimezoneOffset() {
    Bs();
  }
  setTimezoneName() {
    Bs();
  }
  clone() {
    return new on(this.d);
  }
  toDate() {
    return new Date(this.d.getTime());
  }
  toString() {
    return this.d.toString();
  }
}
const Fu = [
  "getTime",
  "getTimezoneOffset",
  "getFullYear",
  "getMonth",
  "getDate",
  "getHours",
  "getMinutes",
  "getSeconds",
  "getMilliseconds",
  "getDay"
], Gu = [
  "setTime",
  "setFullYear",
  "setMonth",
  "setDate",
  "setHours",
  "setMinutes",
  "setSeconds",
  "setMilliseconds"
];
Fu.forEach((e) => {
  on.prototype[e] = function(...t) {
    return this.d[e](...t);
  };
});
Gu.forEach((e) => {
  on.prototype[e] = function(...t) {
    return this.d[e](...t);
  };
});
class Po extends on {
  clone() {
    return new Po(this.d);
  }
  getTimezoneOffset() {
    return 0;
  }
}
const Bu = [
  "FullYear",
  "Month",
  "Date",
  "Hours",
  "Minutes",
  "Seconds",
  "Milliseconds",
  "Day"
], zu = [
  "FullYear",
  "Month",
  "Date",
  "Hours",
  "Minutes",
  "Seconds",
  "Milliseconds"
];
Bu.forEach((e) => {
  const t = `get${e}`;
  Po.prototype[t] = function(...n) {
    return this.d[`getUTC${e}`](...n);
  };
});
zu.forEach((e) => {
  const t = `set${e}`;
  Po.prototype[t] = function(...n) {
    return this.d[`setUTC${e}`](...n);
  };
});
const Uu = "Invalid DateTime Format", Wu = "Invalid IANA Timezone Name", Yu = "Invalid View Type", xn = "@lqjun/calendar: ";
class Vu extends Error {
  constructor(t) {
    super(`${xn}${Wu} - ${t}`), this.name = "InvalidTimezoneNameError";
  }
}
class ju extends Error {
  constructor(t) {
    super(`${xn}${Uu} - ${t}`), this.name = "InvalidDateTimeFormatError";
  }
}
class Xu extends Error {
  constructor(t) {
    super(`${xn}${Yu} - ${t}`), this.name = "InvalidViewTypeError";
  }
}
const Ku = {
  error: (e, ...t) => {
    console.error(`${xn}${e}`, ...t);
  },
  warn: (e, ...t) => {
    console.warn(`${xn}${e}`, ...t);
  }
};
let qu = on;
function zs(...e) {
  return new qu(...e);
}
function Zu() {
  return -new Date().getTimezoneOffset();
}
function bn(e, t = new F()) {
  if (!Ju())
    return Ku.warn(
      `Intl.DateTimeFormat is not fully supported. So It will return the local timezone offset only.
You can use a polyfill to fix this issue.`
    ), -t.toDate().getTimezoneOffset();
  Ua(e);
  const n = td(t, e), o = nd(n);
  return Math.round((o.getTime() - t.getTime()) / 60 / 1e3);
}
function _n(e, t) {
  t && Ua(t);
  const n = new F(e.getFullYear(), 0, 1), o = new F(e.getFullYear(), 6, 1);
  return t ? Math.max(
    -bn(t, n),
    -bn(t, o)
  ) !== -bn(t, e) : Math.max(n.getTimezoneOffset(), o.getTimezoneOffset()) !== e.toDate().getTimezoneOffset();
}
const yr = {}, Us = {};
function Ju() {
  var e, t;
  return Tn((t = (e = Intl == null ? void 0 : Intl.DateTimeFormat) == null ? void 0 : e.prototype) == null ? void 0 : t.formatToParts);
}
function Ua(e) {
  if (Us[e])
    return true;
  try {
    return Intl.DateTimeFormat("en-US", { timeZone: e }), Us[e] = true, true;
  } catch (t) {
    throw new Vu(e);
  }
}
function Qu(e) {
  if (yr[e])
    return yr[e];
  const t = new Intl.DateTimeFormat("en-US", {
    timeZone: e,
    hourCycle: "h23",
    hour12: false,
    year: "numeric",
    month: "numeric",
    day: "numeric",
    hour: "numeric",
    minute: "numeric",
    second: "numeric"
  });
  return yr[e] = t, t;
}
const ed = {
  year: 0,
  month: 1,
  day: 2,
  hour: 3,
  minute: 4,
  second: 5
};
function td(e, t) {
  return Qu(t).formatToParts(e.toDate()).reduce((r, i) => {
    const s = ed[i.type];
    return $(s) && (r[s] = parseInt(i.value, 10)), r;
  }, []);
}
function nd(e) {
  const [t, n, o, r, i, s] = e, a = n - 1;
  return new Date(Date.UTC(t, a, o, r % 24, i, s));
}
function wr(e) {
  return (Zu() - e) * mi;
}
class F {
  constructor(...t) {
    this.tzOffset = null, t[0] instanceof F ? this.d = zs(t[0].getTime()) : this.d = zs(...t);
  }
  toString() {
    return this.d.toString();
  }
  addFullYear(t) {
    return this.setFullYear(this.getFullYear() + t), this;
  }
  addMonth(t) {
    return this.setMonth(this.getMonth() + t), this;
  }
  addDate(t) {
    return this.setDate(this.getDate() + t), this;
  }
  addHours(t) {
    return this.setHours(this.getHours() + t), this;
  }
  addMinutes(t) {
    return this.setMinutes(this.getMinutes() + t), this;
  }
  addSeconds(t) {
    return this.setSeconds(this.getSeconds() + t), this;
  }
  addMilliseconds(t) {
    return this.setMilliseconds(this.getMilliseconds() + t), this;
  }
  setWithRaw(t, n, o, r, i, s, a) {
    return this.setFullYear(t, n, o), this.setHours(r, i, s, a), this;
  }
  toDate() {
    return this.d.toDate();
  }
  valueOf() {
    return this.getTime();
  }
  getTimezoneOffset() {
    var t;
    return (t = this.tzOffset) != null ? t : this.d.getTimezoneOffset();
  }
  getTime() {
    return this.d.getTime();
  }
  getFullYear() {
    return this.d.getFullYear();
  }
  getMonth() {
    return this.d.getMonth();
  }
  getDate() {
    return this.d.getDate();
  }
  getHours() {
    return this.d.getHours();
  }
  getMinutes() {
    return this.d.getMinutes();
  }
  getSeconds() {
    return this.d.getSeconds();
  }
  getMilliseconds() {
    return this.d.getMilliseconds();
  }
  getDay() {
    return this.d.getDay();
  }
  setTime(t) {
    return this.d.setTime(t);
  }
  setFullYear(t, n = this.getMonth(), o = this.getDate()) {
    return this.d.setFullYear(t, n, o);
  }
  setMonth(t, n = this.getDate()) {
    return this.d.setMonth(t, n);
  }
  setDate(t) {
    return this.d.setDate(t);
  }
  setHours(t, n = this.getMinutes(), o = this.getSeconds(), r = this.getMilliseconds()) {
    return this.d.setHours(t, n, o, r);
  }
  setMinutes(t, n = this.getSeconds(), o = this.getMilliseconds()) {
    return this.d.setMinutes(t, n, o);
  }
  setSeconds(t, n = this.getMilliseconds()) {
    return this.d.setSeconds(t, n);
  }
  setMilliseconds(t) {
    return this.d.setMilliseconds(t);
  }
  tz(t) {
    if (t === "Local")
      return new F(this.getTime());
    const n = Ie(t) ? bn(t, this) : t, o = new F(this.getTime() - wr(n));
    return o.tzOffset = n, o;
  }
  local(t) {
    if ($(t)) {
      const n = Ie(t) ? bn(t, this) : t;
      return new F(this.getTime() + wr(n));
    }
    return new F(
      this.getTime() + ($(this.tzOffset) ? wr(this.tzOffset) : 0)
    );
  }
}
function od(e, ...t) {
  return t.reduce((n, o) => (e.hasOwnProperty(o) && (n[o] = e[o]), n), {});
}
function rd(e) {
  return Object.assign(Object.create(Object.getPrototypeOf(e)), e);
}
function qe(e, t = {}) {
  return po(t) && Object.keys(t).forEach((n) => {
    const o = n, r = n;
    !Array.isArray(t[r]) && po(e[o]) && po(t[r]) && !(t[r] instanceof F) ? e[o] = qe(
      e[o],
      t[r]
    ) : e[o] = t[r];
  }), e;
}
const id = [
  "top",
  "left",
  "width",
  "height",
  "exceedLeft",
  "exceedRight",
  "croppedStart",
  "croppedEnd",
  "goingDurationHeight",
  "modelDurationHeight",
  "comingDurationHeight",
  "duplicateEvents",
  "duplicateEventIndex",
  "duplicateStarts",
  "duplicateEnds",
  "duplicateLeft",
  "duplicateWidth",
  "collapse",
  "isMain"
];
class xt {
  constructor(t) {
    this.top = 0, this.left = 0, this.width = 0, this.height = 0, this.exceedLeft = false, this.exceedRight = false, this.croppedStart = false, this.croppedEnd = false, this.goingDurationHeight = 0, this.modelDurationHeight = 100, this.comingDurationHeight = 0, this.duplicateEvents = [], this.duplicateEventIndex = -1, this.duplicateLeft = "", this.duplicateWidth = "", this.collapse = false, this.isMain = false, this.model = t;
  }
  getUIProps() {
    return od(this, ...id);
  }
  setUIProps(t) {
    Object.assign(this, t);
  }
  getStarts() {
    return this.renderStarts ? this.renderStarts : this.model.getStarts();
  }
  getEnds() {
    return this.renderEnds ? this.renderEnds : this.model.getEnds();
  }
  cid() {
    return this.model.cid();
  }
  valueOf() {
    return this.model;
  }
  duration() {
    return this.model.duration();
  }
  collidesWith(t, n = true) {
    const o = [];
    [this, t].forEach((s) => {
      s instanceof xt && s.duplicateEvents.length > 0 ? o.push({
        start: s.duplicateStarts,
        end: s.duplicateEnds,
        goingDuration: 0,
        comingDuration: 0
      }) : o.push({
        start: s.getStarts(),
        end: s.getEnds(),
        goingDuration: s.valueOf().goingDuration,
        comingDuration: s.valueOf().comingDuration
      });
    });
    const [r, i] = o;
    return ja({
      start: r.start.getTime(),
      end: r.end.getTime(),
      targetStart: i.start.getTime(),
      targetEnd: i.end.getTime(),
      goingDuration: r.goingDuration,
      comingDuration: r.comingDuration,
      targetGoingDuration: i.goingDuration,
      targetComingDuration: i.comingDuration,
      usingTravelTime: n
    });
  }
  clone() {
    const t = this.getUIProps(), n = new xt(this.model);
    return n.setUIProps(t), this.renderStarts && (n.renderStarts = new F(this.renderStarts)), this.renderEnds && (n.renderEnds = new F(this.renderEnds)), n;
  }
}
function sd(e, t) {
  return e !== t ? e ? -1 : 1 : 0;
}
function ad(e, t) {
  return Number(e) - Number(t);
}
function cd(e, t) {
  const n = String(e), o = String(t);
  return n === o ? 0 : n > o ? 1 : -1;
}
function ld(e, t) {
  const n = e instanceof xt ? e.model : e, o = t instanceof xt ? t.model : t, r = sd(
    n.isAllday || n.hasMultiDates,
    o.isAllday || o.hasMultiDates
  );
  if (r)
    return r;
  const i = yt(e.getStarts(), t.getStarts());
  if (i)
    return i;
  const s = e.duration(), a = t.duration();
  return s < a ? 1 : s > a ? -1 : n.cid() - o.cid();
}
function ud(e, t, n, o) {
  let r = 0, i = e.length - 1, s, a, c;
  for (o = o || cd; r <= i; )
    if (s = (r + i) / 2 | 0, a = n ? n(e[s]) : e[s], c = o(a, t), c < 0)
      r = s + 1;
    else if (c > 0)
      i = s - 1;
    else
      return s;
  return ~i;
}
const Ot = {
  bsearch: ud,
  compare: {
    event: {
      asc: ld
    },
    num: {
      asc: ad
    }
  }
};
function Br(e) {
  return e[0];
}
function ft(e) {
  return e[e.length - 1];
}
function hi(e, t) {
  for (let n = e.length - 1; n >= 0; n -= 1)
    if (t(e[n]))
      return n;
  return -1;
}
function Ws(e, t) {
  return e > 0 ? Array.from({ length: e }, () => Array.isArray(t) ? t.slice() : t) : [];
}
var rn = /* @__PURE__ */ ((e) => (e[e.SUN = 0] = "SUN", e[e.MON = 1] = "MON", e[e.TUE = 2] = "TUE", e[e.WED = 3] = "WED", e[e.THU = 4] = "THU", e[e.FRI = 5] = "FRI", e[e.SAT = 6] = "SAT", e))(rn || {});
const tt = 7, dd = /^(\d{4}[-|/]*\d{2}[-|/]*\d{2})\s?(\d{2}:\d{2}:\d{2})?$/, fd = {
  millisecondsTo: {},
  millisecondsFrom: {}
}, pd = [24, 60, 60, 1e3];
function xe(e, t) {
  let n = "", o = 0;
  if (String(e).length > t)
    return String(e);
  for (; o < t - 1; o += 1)
    n += "0";
  return (n + e).slice(t * -1);
}
function Ys(e) {
  let t = e.getHours();
  return t === 0 && (t = 12), t > 12 && (t = t % 12), t;
}
const hd = {
  YYYYMMDD(e) {
    return [
      e.getFullYear(),
      xe(e.getMonth() + 1, 2),
      xe(e.getDate(), 2)
    ].join("");
  },
  YYYY(e) {
    return String(e.getFullYear());
  },
  MM(e) {
    return xe(e.getMonth() + 1, 2);
  },
  DD(e) {
    return xe(e.getDate(), 2);
  },
  "HH:mm": function(e) {
    const t = e.getHours(), n = e.getMinutes();
    return `${xe(t, 2)}:${xe(n, 2)}`;
  },
  "hh:mm": function(e) {
    const t = Ys(e), n = e.getMinutes();
    return `${xe(t, 2)}:${xe(n, 2)}`;
  },
  hh(e) {
    const t = Ys(e);
    return String(t);
  },
  tt(e) {
    return e.getHours() < 12 ? "am" : "pm";
  }
}, ht = 864e5, mi = 6e4, Zn = 20 * mi, Wa = 30 * 60 * 1e3;
function ge(e, t) {
  let n = t;
  return Object.entries(hd).forEach(([o, r]) => {
    n = n.replace(o, r(e));
  }), n;
}
function md(e, t, n) {
  const o = {
    date: 0,
    hour: 1,
    minute: 2,
    second: 3
  };
  return !(e in o) || isNaN(t) ? 0 : [t].concat(pd.slice(o[e])).reduce(n);
}
function Jn(e, t) {
  const n = fd.millisecondsFrom, o = e + t;
  if (n[o])
    return n[o];
  const r = md(e, t, (i, s) => i * s);
  return r ? (n[o] = r, n[o]) : 0;
}
function _e(e) {
  const t = e ? new F(e) : new F();
  return t.setHours(0, 0, 0, 0), t;
}
function zr(e, t, n) {
  const o = e.getTime(), r = t.getTime(), i = new F(e), s = [];
  let a = o;
  for (; a <= r && r >= i.getTime(); )
    s.push(new F(i)), a = a + n, i.addMilliseconds(n);
  return s;
}
function sn(e) {
  return new F(e);
}
function yt(e, t) {
  const n = e.getTime(), o = t.getTime();
  return n < o ? -1 : n > o ? 1 : 0;
}
function gd(e, t) {
  return e.getFullYear() === t.getFullYear();
}
function _d(e, t) {
  return gd(e, t) && e.getMonth() === t.getMonth();
}
function Rt(e, t) {
  return _d(e, t) && e.getDate() === t.getDate();
}
function gi(e, t) {
  return yt(e, t) === 1 ? e : t;
}
function Ya(e, t) {
  return yt(e, t) === -1 ? e : t;
}
function Vs(e, t = -1) {
  const n = e.match(dd);
  let o, r, i;
  if (!n)
    throw new ju(e);
  if (e.length > 8) {
    o = ~e.indexOf("/") ? "/" : "-";
    const s = n.splice(1);
    r = s[0].split(o), i = s[1] ? s[1].split(":") : [0, 0, 0];
  } else {
    const [s] = n;
    r = [s.substr(0, 4), s.substr(4, 2), s.substr(6, 2)], i = [0, 0, 0];
  }
  return new F().setWithRaw(
    Number(r[0]),
    Number(r[1]) + t,
    Number(r[2]),
    Number(i[0]),
    Number(i[1]),
    Number(i[2]),
    0
  );
}
function Re(e) {
  const t = e ? new F(e) : new F();
  return t.setHours(23, 59, 59, 999), t;
}
function ze(e) {
  return e === 0 || e === 6;
}
function _i(e) {
  return e === 0;
}
function vi(e) {
  return e === 6;
}
function Va(e) {
  const t = new F(e);
  return t.setDate(1), t.setHours(0, 0, 0, 0), t;
}
function vd(e) {
  const t = Va(e);
  return t.setMonth(t.getMonth() + 1), t.setDate(t.getDate() - 1), t.setHours(23, 59, 59, 999), t;
}
function yi(e, t, n, o) {
  const i = 100 / e, s = e > 5 ? 100 / (e - 1) : i;
  let a = 0;
  const c = vt(n, tt).concat(vt(e)).slice(0, tt);
  t = o ? false : t;
  const l = c.map((p) => {
    let h = t ? s : i;
    e > 5 && t && ze(p) && (h = s / 2);
    const m = {
      width: h,
      left: a
    };
    return a += h, m;
  }), { length: f } = l, u = Ws(f, Ws(f, 0));
  return l.forEach(({ width: p }, h) => {
    for (let m = 0; m <= h; m += 1)
      for (let w = h; w < f; w += 1)
        u[m][w] += p;
  }), u[0][f - 1] = 100, {
    rowStyleInfo: l,
    cellWidthMap: u.map((p) => p.map(q))
  };
}
function Do(e, t) {
  const n = sn(e);
  return n.setMilliseconds(e.getMilliseconds() + t), n;
}
function Oe(e, t) {
  const n = sn(e);
  return n.setMinutes(e.getMinutes() + t), n;
}
function nt(e, t) {
  const n = sn(e);
  return n.setHours(...t.split(":").map(Number)), n;
}
function Pt(e, t) {
  const n = sn(e);
  return n.setDate(e.getDate() + t), n;
}
function yd(e, t) {
  const n = sn(e);
  return n.setDate(e.getDate() - t), n;
}
function wd(e, t = 1) {
  const n = sn(e);
  if (t !== 0) {
    const o = n.getDate(), r = new F(n.getTime());
    r.setMonth(n.getMonth() + t + 1, 0);
    const i = r.getDate();
    if (o >= i)
      return r;
    n.setFullYear(r.getFullYear(), r.getMonth(), o);
  }
  return n;
}
function wi(e, t) {
  const n = new F(e.getFullYear(), e.getMonth(), e.getDate()).getTime(), o = new F(t.getFullYear(), t.getMonth(), t.getDate()).getTime();
  return Math.round((n - o) / ht);
}
function Ed(e, t, n, o) {
  return n > e && n < t || o > e && o < t || n <= e && o >= t;
}
function ja({
  start: e,
  end: t,
  targetStart: n,
  targetEnd: o,
  goingDuration: r,
  comingDuration: i,
  targetGoingDuration: s,
  targetComingDuration: a,
  usingTravelTime: c
}) {
  return Math.abs(t - e) < Zn && (t += Zn), Math.abs(t - e) < Zn && (t += Zn), c && (e -= Jn("minute", r), t += Jn("minute", i), n -= Jn("minute", s), o += Jn("minute", a)), Ed(e, t, n, o);
}
function Dd(e, t, n) {
  return e.id === t && e.calendarId === n;
}
function Sd() {
  let e = 0;
  return {
    next() {
      return e += 1, e;
    }
  };
}
const Td = function() {
  const e = Sd();
  return () => e.next();
}();
function js(e) {
  return e.__fe_id || (e.__fe_id = Td()), e.__fe_id;
}
class Ei {
  constructor(t = {}) {
    this.id = "", this.calendarId = "", this.title = "", this.body = "", this.isAllday = false, this.start = new F(), this.end = new F(), this.goingDuration = 0, this.comingDuration = 0, this.location = "", this.attendees = [], this.category = "time", this.dueDateClass = "", this.recurrenceRule = "", this.state = "Busy", this.isVisible = true, this.isPending = false, this.isFocused = false, this.isReadOnly = false, this.isPrivate = false, this.customStyle = {}, this.raw = null, this.hasMultiDates = false, js(this), this.init(t);
  }
  init({
    id: t = "",
    calendarId: n = "",
    title: o = "",
    body: r = "",
    isAllday: i = false,
    start: s = new F(),
    end: a = new F(),
    goingDuration: c = 0,
    comingDuration: l = 0,
    location: f = "",
    attendees: u = [],
    category: p = "time",
    dueDateClass: h = "",
    recurrenceRule: m = "",
    state: w = "Busy",
    isVisible: v = true,
    isPending: _ = false,
    isFocused: E = false,
    isReadOnly: S = false,
    isPrivate: b = false,
    color: D,
    backgroundColor: A,
    dragBackgroundColor: T,
    borderColor: k,
    customStyle: M = {},
    raw: N = null
  } = {}) {
    this.id = t, this.calendarId = n, this.title = o, this.body = r, this.isAllday = p === "allday" ? true : i, this.goingDuration = c, this.comingDuration = l, this.location = f, this.attendees = u, this.category = p, this.dueDateClass = h, this.recurrenceRule = m, this.state = w, this.isVisible = v, this.isPending = _, this.isFocused = E, this.isReadOnly = S, this.isPrivate = b, this.color = D, this.backgroundColor = A, this.dragBackgroundColor = T, this.borderColor = k, this.customStyle = M, this.raw = N, this.isAllday ? this.setAlldayPeriod(s, a) : this.setTimePeriod(s, a), (p === "milestone" || p === "task") && (this.start = new F(this.end));
  }
  setAlldayPeriod(t, n) {
    let o, r;
    Ie(t) ? o = Vs(t.substring(0, 10)) : o = new F(t || Date.now()), Ie(n) ? r = Vs(n.substring(0, 10)) : r = new F(n || this.start), this.start = o, this.start.setHours(0, 0, 0), this.end = r || new F(this.start), this.end.setHours(23, 59, 59);
  }
  setTimePeriod(t, n) {
    this.start = new F(t || Date.now()), this.end = new F(n || this.start), n || this.end.setMinutes(this.end.getMinutes() + 30), this.hasMultiDates = this.end.getTime() - this.start.getTime() > ht;
  }
  getStarts() {
    return this.start;
  }
  getEnds() {
    return this.end;
  }
  cid() {
    return js(this);
  }
  equals(t) {
    return !(this.id !== t.id || this.title !== t.title || this.body !== t.body || this.isAllday !== t.isAllday || yt(this.getStarts(), t.getStarts()) !== 0 || yt(this.getEnds(), t.getEnds()) !== 0 || this.color !== t.color || this.backgroundColor !== t.backgroundColor || this.dragBackgroundColor !== t.dragBackgroundColor || this.borderColor !== t.borderColor);
  }
  duration() {
    const t = Number(this.getStarts()), n = Number(this.getEnds());
    let o;
    return this.isAllday ? o = Number(Re(n)) - Number(_e(t)) : o = n - t, o;
  }
  valueOf() {
    return this;
  }
  collidesWith(t, n = true) {
    return t = t instanceof xt ? t.model : t, ja({
      start: Number(this.getStarts()),
      end: Number(this.getEnds()),
      targetStart: Number(t.getStarts()),
      targetEnd: Number(t.getEnds()),
      goingDuration: this.goingDuration,
      comingDuration: this.comingDuration,
      targetGoingDuration: t.goingDuration,
      targetComingDuration: t.comingDuration,
      usingTravelTime: n
    });
  }
  toEventObject() {
    return {
      id: this.id,
      calendarId: this.calendarId,
      __cid: this.cid(),
      title: this.title,
      body: this.body,
      isAllday: this.isAllday,
      start: this.start,
      end: this.end,
      goingDuration: this.goingDuration,
      comingDuration: this.comingDuration,
      location: this.location,
      attendees: this.attendees,
      category: this.category,
      dueDateClass: this.dueDateClass,
      recurrenceRule: this.recurrenceRule,
      state: this.state,
      isVisible: this.isVisible,
      isPending: this.isPending,
      isFocused: this.isFocused,
      isReadOnly: this.isReadOnly,
      isPrivate: this.isPrivate,
      color: this.color,
      backgroundColor: this.backgroundColor,
      dragBackgroundColor: this.dragBackgroundColor,
      borderColor: this.borderColor,
      customStyle: this.customStyle,
      raw: this.raw
    };
  }
  getColors() {
    return {
      color: this.color,
      backgroundColor: this.backgroundColor,
      dragBackgroundColor: this.dragBackgroundColor,
      borderColor: this.borderColor
    };
  }
}
Ei.schema = {
  required: ["title"],
  dateRange: ["start", "end"]
};
function bd({ model: e }) {
  const { category: t, isAllday: n, hasMultiDates: o } = e;
  return t === "time" && !n && !o;
}
class rt {
  constructor(t) {
    this.internalMap = /* @__PURE__ */ new Map(), Tn(t) && (this.getItemID = t);
  }
  static and(...t) {
    const { length: n } = t;
    return (o) => {
      for (let r = 0; r < n; r += 1)
        if (!t[r].call(null, o))
          return false;
      return true;
    };
  }
  static or(...t) {
    const { length: n } = t;
    return n ? (o) => {
      let r = t[0].call(null, o);
      for (let i = 1; i < n; i += 1)
        r = r || t[i].call(null, o);
      return r;
    } : () => false;
  }
  getItemID(t) {
    var n;
    return (n = t == null ? void 0 : t._id) != null ? n : "";
  }
  getFirstItem() {
    return this.internalMap.values().next().value;
  }
  add(...t) {
    return t.forEach((n) => {
      const o = this.getItemID(n);
      this.internalMap.set(o, n);
    }), this;
  }
  remove(...t) {
    const n = [];
    return t.forEach((o) => {
      const r = Ie(o) || fo(o) ? o : this.getItemID(o);
      !this.internalMap.has(r) || (n.push(this.internalMap.get(r)), this.internalMap.delete(r));
    }), n.length === 1 ? n[0] : n;
  }
  has(t) {
    const n = Ie(t) || fo(t) ? t : this.getItemID(t);
    return this.internalMap.has(n);
  }
  get(t) {
    var o;
    const n = Ie(t) || fo(t) ? t : this.getItemID(t);
    return (o = this.internalMap.get(n)) != null ? o : null;
  }
  doWhenHas(t, n) {
    const o = this.internalMap.get(t);
    V(o) || n(o);
  }
  filter(t) {
    const n = new rt();
    return this.hasOwnProperty("getItemID") && (n.getItemID = this.getItemID), this.internalMap.forEach((o) => {
      t(o) === true && n.add(o);
    }), n;
  }
  groupBy(t) {
    const n = {};
    return this.internalMap.forEach((o) => {
      let r = Tn(t) ? t(o) : o[t];
      Tn(r) && (r = r.call(o)), n[r] != null || (n[r] = new rt(this.getItemID)), n[r].add(o);
    }), n;
  }
  find(t) {
    let n = null;
    const o = this.internalMap.values();
    let r = o.next();
    for (; r.done === false; ) {
      if (t(r.value)) {
        n = r.value;
        break;
      }
      r = o.next();
    }
    return n;
  }
  sort(t) {
    return this.toArray().sort(t);
  }
  each(t) {
    const n = this.internalMap.entries();
    let o = n.next();
    for (; o.done === false; ) {
      const [r, i] = o.value;
      if (t(i, r) === false)
        break;
      o = n.next();
    }
  }
  clear() {
    this.internalMap.clear();
  }
  toArray() {
    return Array.from(this.internalMap.values());
  }
  get size() {
    return this.internalMap.size;
  }
}
function en(...e) {
  const t = new rt((n) => n.cid());
  return e.length && t.add(...e), t;
}
function Xa(e, t) {
  return zr(_e(e), Re(t), ht);
}
function Cd(e) {
  return e.isAllday || e.category === "time" && Number(e.end) - Number(e.start) > ht;
}
function kd(e) {
  const { model: t } = e;
  return Cd(t) ? "allday" : t.category;
}
function Ka(e, t) {
  Xa(t.getStarts(), t.getEnds()).forEach((o) => {
    const r = ge(o, "YYYYMMDD");
    (e[r] = e[r] || []).push(t.cid());
  });
}
function qa(e, t) {
  const n = t.cid();
  Object.values(e).forEach((o) => {
    const r = o.indexOf(n);
    ~r && o.splice(r, 1);
  });
}
function Nd(e, t) {
  return e.events.add(t), Ka(e.idsOfDay, t), t;
}
function Id(e, t) {
  const n = new Ei(t);
  return Nd(e, n);
}
function Md(e, t = []) {
  return t.map((n) => Id(e, n));
}
function Ad(e, t, n, o) {
  const { idsOfDay: r } = e, i = e.events.find((s) => Dd(s, t, n));
  return i ? (i.init(L(L({}, i), o)), qa(r, i), Ka(r, i), true) : false;
}
function xd(e, t) {
  return qa(e.idsOfDay, t), e.events.remove(t), t;
}
function Od(e) {
  e.idsOfDay = {}, e.events.clear();
}
function Rd(e = []) {
  return {
    calendar: {
      calendars: e,
      events: en(),
      idsOfDay: {}
    }
  };
}
function Pd(e) {
  return {
    createEvents: (t) => e(
      J((n) => {
        Md(n.calendar, t);
      })
    ),
    updateEvent: ({ event: t, eventData: n }) => e(
      J((o) => {
        Ad(
          o.calendar,
          t.id,
          t.calendarId,
          n
        );
      })
    ),
    deleteEvent: (t) => e(
      J((n) => {
        xd(n.calendar, t);
      })
    ),
    clearEvents: () => e(
      J((t) => {
        Od(t.calendar);
      })
    ),
    setCalendars: (t) => e(
      J((n) => {
        n.calendar.calendars = t;
      })
    ),
    setCalendarColor: (t, n) => e(
      J((o) => {
        const r = o.calendar.calendars.map((a) => a.id === t ? L(L({}, a), n) : a), i = o.calendar.events.toArray().map((a) => {
          var c, l, f, u;
          return a.calendarId === t && (a.color = (c = n.color) != null ? c : a.color, a.backgroundColor = (l = n.backgroundColor) != null ? l : a.backgroundColor, a.borderColor = (f = n.borderColor) != null ? f : a.borderColor, a.dragBackgroundColor = (u = n.dragBackgroundColor) != null ? u : a.dragBackgroundColor), a;
        }), s = en(...i);
        o.calendar.calendars = r, o.calendar.events = s;
      })
    ),
    setCalendarVisibility: (t, n) => e(
      J((o) => {
        const r = o.calendar.events.toArray();
        o.calendar.events = en(
          ...r.map((i) => (t.includes(i.calendarId) && (i.isVisible = n), i))
        );
      })
    )
  };
}
var Ze = /* @__PURE__ */ ((e) => (e[e.IDLE = 0] = "IDLE", e[e.INIT = 1] = "INIT", e[e.DRAGGING = 2] = "DRAGGING", e[e.CANCELED = 3] = "CANCELED", e))(Ze || {});
function Ur() {
  return {
    dnd: {
      draggingItemType: null,
      draggingState: 0,
      initX: null,
      initY: null,
      x: null,
      y: null,
      draggingEventUIModel: null
    }
  };
}
function Ld(e) {
  return {
    initDrag: (t) => {
      e(
        J((n) => {
          n.dnd = ce(L(L({}, n.dnd), t), {
            draggingState: 1
          });
        })
      );
    },
    setDragging: (t) => {
      e(
        J((n) => {
          n.dnd = ce(L(L({}, n.dnd), t), {
            draggingState: 2
          });
        })
      );
    },
    cancelDrag: () => {
      e(
        J((t) => {
          t.dnd = Ur().dnd, t.dnd.draggingState = 3;
        })
      );
    },
    reset: () => {
      e(
        J((t) => {
          t.dnd = Ur().dnd;
        })
      );
    },
    setDraggingEventUIModel: (t) => {
      e(
        J((n) => {
          var o;
          n.dnd.draggingEventUIModel = (o = t == null ? void 0 : t.clone()) != null ? o : null;
        })
      );
    }
  };
}
function Za() {
  return {
    gridSelection: {
      dayGridMonth: null,
      dayGridWeek: null,
      timeGrid: null,
      accumulated: {
        dayGridMonth: []
      }
    }
  };
}
function $d(e) {
  return {
    setGridSelection: (t, n) => {
      e(
        J((o) => {
          o.gridSelection[t] = n;
        })
      );
    },
    addGridSelection: (t, n) => {
      e(
        J((o) => {
          t === "dayGridMonth" && n && (o.gridSelection.accumulated[t] = [
            ...o.gridSelection.accumulated[t],
            n
          ], o.gridSelection.dayGridMonth = null);
        })
      );
    },
    clearAll: () => e(
      J((t) => {
        t.gridSelection = Za().gridSelection;
      })
    )
  };
}
const Wr = 3, Lo = -1;
function Qn(e, t, n) {
  return Object.keys(e).reduce((o, r) => r === t ? o : o - e[r].height - Wr, n);
}
function Hd() {
  return {
    layout: 500,
    weekViewLayout: {
      lastPanelType: null,
      dayGridRows: {},
      selectedDuplicateEventCid: Lo
    }
  };
}
function Fd(e) {
  return {
    setLastPanelType: (t) => {
      e(
        J((n) => {
          n.weekViewLayout.lastPanelType = t, t && (n.weekViewLayout.dayGridRows[t].height = Qn(
            n.weekViewLayout.dayGridRows,
            t,
            n.layout
          ));
        })
      );
    },
    updateLayoutHeight: (t) => e(
      J((n) => {
        const { lastPanelType: o } = n.weekViewLayout;
        n.layout = t, o && (n.weekViewLayout.dayGridRows[o].height = Qn(
          n.weekViewLayout.dayGridRows,
          o,
          t
        ));
      })
    ),
    updateDayGridRowHeight: ({ rowName: t, height: n }) => e(
      J((o) => {
        const { lastPanelType: r } = o.weekViewLayout;
        o.weekViewLayout.dayGridRows[t] = { height: n }, r && (o.weekViewLayout.dayGridRows[r].height = Qn(
          o.weekViewLayout.dayGridRows,
          r,
          o.layout
        ));
      })
    ),
    updateDayGridRowHeightByDiff: ({ rowName: t, diff: n }) => e(
      J((o) => {
        var s, a, c;
        const { lastPanelType: r } = o.weekViewLayout, i = (c = (a = (s = o.weekViewLayout.dayGridRows) == null ? void 0 : s[t]) == null ? void 0 : a.height) != null ? c : Qt;
        o.weekViewLayout.dayGridRows[t] = { height: i + n }, r && (o.weekViewLayout.dayGridRows[r].height = Qn(
          o.weekViewLayout.dayGridRows,
          r,
          o.layout
        ));
      })
    ),
    setSelectedDuplicateEventCid: (t) => e(
      J((n) => {
        n.weekViewLayout.selectedDuplicateEventCid = t != null ? t : Lo;
      })
    )
  };
}
function $o(e) {
  return e.charAt(0).toUpperCase() + e.slice(1);
}
const Ja = ["sun", "mon", "tue", "wed", "thu", "fri", "sat"], So = (e) => Ja[e];
function Qa(e, t) {
  return e.map((n) => {
    const o = n.getDay(), r = t.length > 0 ? t[o] : $o(So(o));
    return {
      date: n.getDate(),
      day: n.getDay(),
      dayName: r,
      isToday: true,
      renderDate: "date",
      dateInstance: n
    };
  });
}
function ec(e) {
  if (!e)
    return false;
  const t = {
    getDuplicateEvents: (n, o) => o.filter(
      (r) => r.title === n.title && yt(r.start, n.start) === 0 && yt(r.end, n.end) === 0
    ).sort((r, i) => r.calendarId > i.calendarId ? 1 : -1),
    getMainEvent: (n) => ft(n)
  };
  return pi(e) ? t : L(L({}, t), e);
}
function Gd(e = {}) {
  const t = L({
    startDayOfWeek: rn.SUN,
    dayNames: [],
    narrowWeekend: false,
    workweek: false,
    showNowIndicator: true,
    showTimezoneCollapseButton: false,
    timezonesCollapsed: false,
    hourStart: 0,
    hourEnd: 24,
    eventView: true,
    taskView: true,
    collapseDuplicateEvents: false
  }, e);
  return t.collapseDuplicateEvents = ec(t.collapseDuplicateEvents), t;
}
function Bd(e = {}) {
  return L({
    zones: []
  }, e);
}
function zd(e = {}) {
  const t = L({
    dayNames: [],
    visibleWeeksCount: 0,
    workweek: false,
    narrowWeekend: false,
    startDayOfWeek: rn.SUN,
    isAlways6Weeks: true,
    visibleEventCount: 6
  }, e);
  return t.dayNames.length === 0 && (t.dayNames = Ja.slice()), t;
}
function tc(e) {
  return pi(e) ? {
    enableDblClick: e,
    enableClick: e
  } : L({
    enableDblClick: true,
    enableClick: true
  }, e);
}
const Ud = (e) => !!e.isVisible;
function Wd(e = {}) {
  var t, n, o, r, i, s;
  return {
    options: {
      defaultView: (t = e.defaultView) != null ? t : "week",
      useFormPopup: (n = e.useFormPopup) != null ? n : false,
      useDetailPopup: (o = e.useDetailPopup) != null ? o : false,
      isReadOnly: (r = e.isReadOnly) != null ? r : false,
      week: Gd(e.week),
      month: zd(e.month),
      gridSelection: tc(e.gridSelection),
      usageStatistics: (i = e.usageStatistics) != null ? i : true,
      eventFilter: (s = e.eventFilter) != null ? s : Ud,
      timezone: Bd(e.timezone)
    }
  };
}
function Yd(e) {
  return {
    setOptions: (t = {}) => e(
      J((n) => {
        var o;
        t.gridSelection && (t.gridSelection = tc(t.gridSelection)), (o = t.week) != null && o.collapseDuplicateEvents && (t.week.collapseDuplicateEvents = ec(
          t.week.collapseDuplicateEvents
        )), qe(n.options, t);
      })
    )
  };
}
var Ho = /* @__PURE__ */ ((e) => (e.SeeMore = "seeMore", e.Form = "form", e.Detail = "detail", e))(Ho || {});
function Vd() {
  return {
    popup: {
      seeMore: null,
      form: null,
      detail: null
    }
  };
}
function jd(e) {
  return {
    showSeeMorePopup: (t) => e(
      J((n) => {
        n.popup.seeMore = t, n.popup.form = null, n.popup.detail = null;
      })
    ),
    showFormPopup: (t) => e(
      J((n) => {
        n.popup.form = t, n.popup.seeMore = null, n.popup.detail = null;
      })
    ),
    showDetailPopup: (t, n) => e(
      J((o) => {
        o.popup.detail = t, o.popup.form = null, n || (o.popup.seeMore = null);
      })
    ),
    hideSeeMorePopup: () => e(
      J((t) => {
        t.popup.seeMore = null;
      })
    ),
    hideFormPopup: () => e(
      J((t) => {
        t.popup.form = null;
      })
    ),
    hideDetailPopup: () => e(
      J((t) => {
        t.popup.detail = null;
      })
    ),
    hideAllPopup: () => e(
      J((t) => {
        t.popup.seeMore = null, t.popup.form = null, t.popup.detail = null;
      })
    )
  };
}
const an = () => {
}, Xd = /^auto$|^$|%/;
function Xs(e, t) {
  let n = e.style[t];
  if ((!n || n === "auto") && document.defaultView) {
    const o = document.defaultView.getComputedStyle(e, null);
    n = o ? o[t] : null;
  }
  return n === "auto" ? null : n;
}
function Ks(e) {
  return Ie(e) ? Xd.test(e) : e === null;
}
function nc(e) {
  const t = Xs(e, "width"), n = Xs(e, "height");
  if ((Ks(t) || Ks(n)) && e.getBoundingClientRect) {
    const { width: o, height: r } = e.getBoundingClientRect();
    return {
      width: o || e.offsetWidth,
      height: r || e.offsetHeight
    };
  }
  return {
    width: parseFloat(t != null ? t : "0"),
    height: parseFloat(n != null ? n : "0")
  };
}
const Kd = typeof Element == "undefined" ? an : Element, Er = Kd.prototype;
Er.matches || Er.webkitMatchesSelector || Er.msMatchesSelector;
function eo(e) {
  return e.replace(/<([^>]+)>/gi, "");
}
const Yt = 60, qd = {
  milestone(e) {
    const t = y("icon", "ic-milestone");
    return /* @__PURE__ */ d(ke, null, /* @__PURE__ */ d("span", {
      className: t
    }), /* @__PURE__ */ d("span", {
      style: {
        backgroundColor: e.backgroundColor
      }
    }, eo(e.title)));
  },
  milestoneTitle() {
    return /* @__PURE__ */ d("span", {
      className: y("left-content")
    }, "Milestone");
  },
  task(e) {
    return `#${e.title}`;
  },
  taskTitle() {
    return /* @__PURE__ */ d("span", {
      className: y("left-content")
    }, "Task");
  },
  alldayTitle() {
    return /* @__PURE__ */ d("span", {
      className: y("left-content")
    }, "All Day");
  },
  allday(e) {
    return eo(e.title);
  },
  time(e) {
    const { start: t, title: n } = e;
    return t ? /* @__PURE__ */ d("span", null, /* @__PURE__ */ d("strong", null, ge(t, "HH:mm")), "\xA0", /* @__PURE__ */ d("span", null, eo(n))) : eo(n);
  },
  goingDuration(e) {
    const { goingDuration: t } = e, n = Math.floor(t / Yt), o = t % Yt;
    return `GoingTime ${xe(n, 2)}:${xe(o, 2)}`;
  },
  comingDuration(e) {
    const { comingDuration: t } = e, n = Math.floor(t / Yt), o = t % Yt;
    return `ComingTime ${xe(n, 2)}:${xe(o, 2)}`;
  },
  monthMoreTitleDate(e) {
    const { date: t, day: n } = e, o = y("more-title-date"), r = y("more-title-day"), i = $o(So(n));
    return /* @__PURE__ */ d(ke, null, /* @__PURE__ */ d("span", {
      className: o
    }, t), /* @__PURE__ */ d("span", {
      className: r
    }, i));
  },
  monthMoreClose() {
    return "";
  },
  monthGridHeader(e) {
    const t = parseInt(e.date.split("-")[2], 10), n = y("weekday-grid-date", { "weekday-grid-date-decorator": e.isToday });
    return /* @__PURE__ */ d("span", {
      className: n
    }, t);
  },
  monthGridHeaderExceed(e) {
    const t = y("weekday-grid-more-events");
    return /* @__PURE__ */ d("span", {
      className: t
    }, e, " more");
  },
  monthGridFooter(e) {
    return "";
  },
  monthGridFooterExceed(e) {
    return "";
  },
  monthDayName(e) {
    return e.label;
  },
  weekDayName(e) {
    const t = y("day-name__date"), n = y("day-name__name");
    return /* @__PURE__ */ d(ke, null, /* @__PURE__ */ d("span", {
      className: t
    }, e.date), "\xA0\xA0", /* @__PURE__ */ d("span", {
      className: n
    }, e.dayName));
  },
  weekGridFooterExceed(e) {
    return `+${e}`;
  },
  collapseBtnTitle() {
    const e = y("collapse-btn-icon");
    return /* @__PURE__ */ d("span", {
      className: e
    });
  },
  timezoneDisplayLabel({ displayLabel: e, timezoneOffset: t }) {
    if (V(e) && $(t)) {
      const n = t < 0 ? "-" : "+", o = Math.abs(t / Yt), r = Math.abs(t % Yt);
      return `GMT${n}${xe(o, 2)}:${xe(r, 2)}`;
    }
    return e;
  },
  timegridDisplayPrimaryTime(e) {
    const { time: t } = e;
    return ge(t, "hh tt");
  },
  timegridDisplayTime(e) {
    const { time: t } = e;
    return ge(t, "HH:mm");
  },
  timegridNowIndicatorLabel(e) {
    const { time: t, format: n = "HH:mm" } = e;
    return ge(t, n);
  },
  popupIsAllday() {
    return "All day";
  },
  popupStateFree() {
    return "Free";
  },
  popupStateBusy() {
    return "Busy";
  },
  titlePlaceholder() {
    return "Subject";
  },
  locationPlaceholder() {
    return "Location";
  },
  startDatePlaceholder() {
    return "Start date";
  },
  endDatePlaceholder() {
    return "End date";
  },
  popupSave() {
    return "Save";
  },
  popupUpdate() {
    return "Update";
  },
  popupEdit() {
    return "Edit";
  },
  popupDelete() {
    return "Delete";
  },
  popupDetailTitle({ title: e }) {
    return e;
  },
  popupDetailDate({ isAllday: e, start: t, end: n }) {
    const o = "YYYY.MM.DD", r = "hh:mm tt", i = `${o} ${r}`, s = ge(t, e ? o : r), a = Rt(t, n) ? r : i;
    return e ? `${s}${Rt(t, n) ? "" : ` - ${ge(n, o)}`}` : `${ge(t, i)} - ${ge(n, a)}`;
  },
  popupDetailLocation({ location: e }) {
    return e;
  },
  popupDetailAttendees({ attendees: e = [] }) {
    return e.join(", ");
  },
  popupDetailState({ state: e }) {
    return e || "Busy";
  },
  popupDetailRecurrenceRule({ recurrenceRule: e }) {
    return e;
  },
  popupDetailBody({ body: e }) {
    return e;
  }
};
function Zd(e = {}) {
  return {
    template: L(L({}, qd), e)
  };
}
function Jd(e) {
  return {
    setTemplate: (t) => e(
      J((n) => {
        n.template = L(L({}, n.template), t);
      })
    )
  };
}
function Qd(e = "week") {
  const t = new F();
  return t.setHours(0, 0, 0, 0), {
    view: {
      currentView: e,
      renderDate: t
    }
  };
}
function ef(e) {
  return {
    changeView: (t) => e(
      J((n) => {
        n.view.currentView = t;
      })
    ),
    setRenderDate: (t) => e(
      J((n) => {
        n.view.renderDate = _e(t);
      })
    )
  };
}
const tf = Fe(window) || !window.navigator, qs = tf ? oe : _t;
function oc() {
  const e = xo(null);
  function t({
    children: r,
    store: i
  }) {
    return d(e.Provider, { value: i, children: r });
  }
  return {
    StoreProvider: t,
    useStore: (r, i = Object.is) => {
      const s = Mn(e);
      if (V(s))
        throw new Error("StoreProvider is not found");
      const [, a] = oi((E) => E + 1, 0), c = s.getState(), l = ee(c), f = ee(r), u = ee(i), p = ee(false), h = ee();
      Fe(h.current) && (h.current = r(c));
      let m, w = false;
      (l.current !== c || f.current !== r || u.current !== i || p.current) && (m = r(c), w = !i(h.current, m)), qs(() => {
        w && (h.current = m), l.current = c, f.current = r, u.current = i, p.current = false;
      });
      const _ = ee(c);
      return qs(() => {
        const E = () => {
          try {
            const b = s.getState(), D = f.current(b);
            !u.current(
              h.current,
              D
            ) && (l.current = b, h.current = m, a());
          } catch (b) {
            console.error("[toastui-calendar] failed to update state", b == null ? void 0 : b.message), p.current = true, a();
          }
        }, S = s.subscribe(E);
        return s.getState() !== _.current && E(), S;
      }, []), w ? m : h.current;
    },
    useInternalStore: () => {
      const r = Mn(e);
      if (V(r))
        throw new Error("StoreProvider is not found");
      return Y(() => r, [r]);
    }
  };
}
function rc(e) {
  let t;
  const n = /* @__PURE__ */ new Set(), o = (c) => {
    const l = c(t);
    if (l !== t) {
      const f = t;
      t = L(L({}, t), l), n.forEach((u) => u(t, f));
    }
  }, r = () => t, a = { setState: o, getState: r, subscribe: (c, l, f) => {
    let u = c;
    if (l) {
      let p = l(t);
      const h = f != null ? f : Object.is;
      u = () => {
        const m = l(t);
        if (!h(p, m)) {
          const w = p;
          p = m, c(p, w);
        }
      };
    }
    return n.add(u), () => n.delete(u);
  }, clearListeners: () => n.clear() };
  return t = e(o, r, a), a;
}
const nf = (e) => (t) => ce(L(L(L(L(L(L(L(L({}, Wd(e)), Zd(e.template)), Vd()), Hd()), Rd(e.calendars)), Qd(e.defaultView)), Ur()), Za()), {
  dispatch: {
    options: Yd(t),
    popup: jd(t),
    weekViewLayout: Fd(t),
    calendar: Pd(t),
    view: ef(t),
    dnd: Ld(t),
    gridSelection: $d(t),
    template: Jd(t)
  }
}), of = (e = {}) => rc(nf(e)), { StoreProvider: rf, useStore: W, useInternalStore: ic } = oc();
function Se(e) {
  return W(
    Q(
      (t) => e ? t.dispatch[e] : t.dispatch,
      [e]
    )
  );
}
function Et(e) {
  return (t) => t[e];
}
const Fo = Et("calendar"), sc = Et(
  "weekViewLayout"
), ac = Et("template"), cn = Et("view"), Je = Et("options"), $t = Et("dnd");
var Dr = { exports: {} };
/*! @license DOMPurify 2.5.0 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.5.0/LICENSE */
var Zs;
function Js() {
  return Zs || (Zs = 1, function(e, t) {
    (function(n, o) {
      e.exports = o();
    })(Su, function() {
      function n(x) {
        return n = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(P) {
          return typeof P;
        } : function(P) {
          return P && typeof Symbol == "function" && P.constructor === Symbol && P !== Symbol.prototype ? "symbol" : typeof P;
        }, n(x);
      }
      function o(x, P) {
        return o = Object.setPrototypeOf || function(Z, me) {
          return Z.__proto__ = me, Z;
        }, o(x, P);
      }
      function r() {
        if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
          return false;
        if (typeof Proxy == "function")
          return true;
        try {
          return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
          })), true;
        } catch (x) {
          return false;
        }
      }
      function i(x, P, K) {
        return r() ? i = Reflect.construct : i = function(me, Ge, Pe) {
          var Qe = [null];
          Qe.push.apply(Qe, Ge);
          var Tt = Function.bind.apply(me, Qe), pn = new Tt();
          return Pe && o(pn, Pe.prototype), pn;
        }, i.apply(null, arguments);
      }
      function s(x) {
        return a(x) || c(x) || l(x) || u();
      }
      function a(x) {
        if (Array.isArray(x))
          return f(x);
      }
      function c(x) {
        if (typeof Symbol != "undefined" && x[Symbol.iterator] != null || x["@@iterator"] != null)
          return Array.from(x);
      }
      function l(x, P) {
        if (!!x) {
          if (typeof x == "string")
            return f(x, P);
          var K = Object.prototype.toString.call(x).slice(8, -1);
          if (K === "Object" && x.constructor && (K = x.constructor.name), K === "Map" || K === "Set")
            return Array.from(x);
          if (K === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(K))
            return f(x, P);
        }
      }
      function f(x, P) {
        (P == null || P > x.length) && (P = x.length);
        for (var K = 0, Z = new Array(P); K < P; K++)
          Z[K] = x[K];
        return Z;
      }
      function u() {
        throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
      }
      var p = Object.hasOwnProperty, h = Object.setPrototypeOf, m = Object.isFrozen, w = Object.getPrototypeOf, v = Object.getOwnPropertyDescriptor, _ = Object.freeze, E = Object.seal, S = Object.create, b = typeof Reflect != "undefined" && Reflect, D = b.apply, A = b.construct;
      D || (D = function(P, K, Z) {
        return P.apply(K, Z);
      }), _ || (_ = function(P) {
        return P;
      }), E || (E = function(P) {
        return P;
      }), A || (A = function(P, K) {
        return i(P, s(K));
      });
      var T = ie(Array.prototype.forEach), k = ie(Array.prototype.pop), M = ie(Array.prototype.push), N = ie(String.prototype.toLowerCase), H = ie(String.prototype.toString), G = ie(String.prototype.match), j = ie(String.prototype.replace), I = ie(String.prototype.indexOf), z = ie(String.prototype.trim), R = ie(RegExp.prototype.test), ae = Ue(TypeError);
      function ie(x) {
        return function(P) {
          for (var K = arguments.length, Z = new Array(K > 1 ? K - 1 : 0), me = 1; me < K; me++)
            Z[me - 1] = arguments[me];
          return D(x, P, Z);
        };
      }
      function Ue(x) {
        return function() {
          for (var P = arguments.length, K = new Array(P), Z = 0; Z < P; Z++)
            K[Z] = arguments[Z];
          return A(x, K);
        };
      }
      function X(x, P, K) {
        var Z;
        K = (Z = K) !== null && Z !== void 0 ? Z : N, h && h(x, null);
        for (var me = P.length; me--; ) {
          var Ge = P[me];
          if (typeof Ge == "string") {
            var Pe = K(Ge);
            Pe !== Ge && (m(P) || (P[me] = Pe), Ge = Pe);
          }
          x[Ge] = true;
        }
        return x;
      }
      function he(x) {
        var P = S(null), K;
        for (K in x)
          D(p, x, [K]) === true && (P[K] = x[K]);
        return P;
      }
      function st(x, P) {
        for (; x !== null; ) {
          var K = v(x, P);
          if (K) {
            if (K.get)
              return ie(K.get);
            if (typeof K.value == "function")
              return ie(K.value);
          }
          x = w(x);
        }
        function Z(me) {
          return console.warn("fallback value for", me), null;
        }
        return Z;
      }
      var de = _(["a", "abbr", "acronym", "address", "area", "article", "aside", "audio", "b", "bdi", "bdo", "big", "blink", "blockquote", "body", "br", "button", "canvas", "caption", "center", "cite", "code", "col", "colgroup", "content", "data", "datalist", "dd", "decorator", "del", "details", "dfn", "dialog", "dir", "div", "dl", "dt", "element", "em", "fieldset", "figcaption", "figure", "font", "footer", "form", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hgroup", "hr", "html", "i", "img", "input", "ins", "kbd", "label", "legend", "li", "main", "map", "mark", "marquee", "menu", "menuitem", "meter", "nav", "nobr", "ol", "optgroup", "option", "output", "p", "picture", "pre", "progress", "q", "rp", "rt", "ruby", "s", "samp", "section", "select", "shadow", "small", "source", "spacer", "span", "strike", "strong", "style", "sub", "summary", "sup", "table", "tbody", "td", "template", "textarea", "tfoot", "th", "thead", "time", "tr", "track", "tt", "u", "ul", "var", "video", "wbr"]), We = _(["svg", "a", "altglyph", "altglyphdef", "altglyphitem", "animatecolor", "animatemotion", "animatetransform", "circle", "clippath", "defs", "desc", "ellipse", "filter", "font", "g", "glyph", "glyphref", "hkern", "image", "line", "lineargradient", "marker", "mask", "metadata", "mpath", "path", "pattern", "polygon", "polyline", "radialgradient", "rect", "stop", "style", "switch", "symbol", "text", "textpath", "title", "tref", "tspan", "view", "vkern"]), Ye = _(["feBlend", "feColorMatrix", "feComponentTransfer", "feComposite", "feConvolveMatrix", "feDiffuseLighting", "feDisplacementMap", "feDistantLight", "feFlood", "feFuncA", "feFuncB", "feFuncG", "feFuncR", "feGaussianBlur", "feImage", "feMerge", "feMergeNode", "feMorphology", "feOffset", "fePointLight", "feSpecularLighting", "feSpotLight", "feTile", "feTurbulence"]), gt = _(["animate", "color-profile", "cursor", "discard", "fedropshadow", "font-face", "font-face-format", "font-face-name", "font-face-src", "font-face-uri", "foreignobject", "hatch", "hatchpath", "mesh", "meshgradient", "meshpatch", "meshrow", "missing-glyph", "script", "set", "solidcolor", "unknown", "use"]), St = _(["math", "menclose", "merror", "mfenced", "mfrac", "mglyph", "mi", "mlabeledtr", "mmultiscripts", "mn", "mo", "mover", "mpadded", "mphantom", "mroot", "mrow", "ms", "mspace", "msqrt", "mstyle", "msub", "msup", "msubsup", "mtable", "mtd", "mtext", "mtr", "munder", "munderover"]), ml = _(["maction", "maligngroup", "malignmark", "mlongdiv", "mscarries", "mscarry", "msgroup", "mstack", "msline", "msrow", "semantics", "annotation", "annotation-xml", "mprescripts", "none"]), Ui = _(["#text"]), Wi = _(["accept", "action", "align", "alt", "autocapitalize", "autocomplete", "autopictureinpicture", "autoplay", "background", "bgcolor", "border", "capture", "cellpadding", "cellspacing", "checked", "cite", "class", "clear", "color", "cols", "colspan", "controls", "controlslist", "coords", "crossorigin", "datetime", "decoding", "default", "dir", "disabled", "disablepictureinpicture", "disableremoteplayback", "download", "draggable", "enctype", "enterkeyhint", "face", "for", "headers", "height", "hidden", "high", "href", "hreflang", "id", "inputmode", "integrity", "ismap", "kind", "label", "lang", "list", "loading", "loop", "low", "max", "maxlength", "media", "method", "min", "minlength", "multiple", "muted", "name", "nonce", "noshade", "novalidate", "nowrap", "open", "optimum", "pattern", "placeholder", "playsinline", "poster", "preload", "pubdate", "radiogroup", "readonly", "rel", "required", "rev", "reversed", "role", "rows", "rowspan", "spellcheck", "scope", "selected", "shape", "size", "sizes", "span", "srclang", "start", "src", "srcset", "step", "style", "summary", "tabindex", "title", "translate", "type", "usemap", "valign", "value", "width", "xmlns", "slot"]), Vo = _(["accent-height", "accumulate", "additive", "alignment-baseline", "ascent", "attributename", "attributetype", "azimuth", "basefrequency", "baseline-shift", "begin", "bias", "by", "class", "clip", "clippathunits", "clip-path", "clip-rule", "color", "color-interpolation", "color-interpolation-filters", "color-profile", "color-rendering", "cx", "cy", "d", "dx", "dy", "diffuseconstant", "direction", "display", "divisor", "dur", "edgemode", "elevation", "end", "fill", "fill-opacity", "fill-rule", "filter", "filterunits", "flood-color", "flood-opacity", "font-family", "font-size", "font-size-adjust", "font-stretch", "font-style", "font-variant", "font-weight", "fx", "fy", "g1", "g2", "glyph-name", "glyphref", "gradientunits", "gradienttransform", "height", "href", "id", "image-rendering", "in", "in2", "k", "k1", "k2", "k3", "k4", "kerning", "keypoints", "keysplines", "keytimes", "lang", "lengthadjust", "letter-spacing", "kernelmatrix", "kernelunitlength", "lighting-color", "local", "marker-end", "marker-mid", "marker-start", "markerheight", "markerunits", "markerwidth", "maskcontentunits", "maskunits", "max", "mask", "media", "method", "mode", "min", "name", "numoctaves", "offset", "operator", "opacity", "order", "orient", "orientation", "origin", "overflow", "paint-order", "path", "pathlength", "patterncontentunits", "patterntransform", "patternunits", "points", "preservealpha", "preserveaspectratio", "primitiveunits", "r", "rx", "ry", "radius", "refx", "refy", "repeatcount", "repeatdur", "restart", "result", "rotate", "scale", "seed", "shape-rendering", "specularconstant", "specularexponent", "spreadmethod", "startoffset", "stddeviation", "stitchtiles", "stop-color", "stop-opacity", "stroke-dasharray", "stroke-dashoffset", "stroke-linecap", "stroke-linejoin", "stroke-miterlimit", "stroke-opacity", "stroke", "stroke-width", "style", "surfacescale", "systemlanguage", "tabindex", "targetx", "targety", "transform", "transform-origin", "text-anchor", "text-decoration", "text-rendering", "textlength", "type", "u1", "u2", "unicode", "values", "viewbox", "visibility", "version", "vert-adv-y", "vert-origin-x", "vert-origin-y", "width", "word-spacing", "wrap", "writing-mode", "xchannelselector", "ychannelselector", "x", "x1", "x2", "xmlns", "y", "y1", "y2", "z", "zoomandpan"]), Yi = _(["accent", "accentunder", "align", "bevelled", "close", "columnsalign", "columnlines", "columnspan", "denomalign", "depth", "dir", "display", "displaystyle", "encoding", "fence", "frame", "height", "href", "id", "largeop", "length", "linethickness", "lspace", "lquote", "mathbackground", "mathcolor", "mathsize", "mathvariant", "maxsize", "minsize", "movablelimits", "notation", "numalign", "open", "rowalign", "rowlines", "rowspacing", "rowspan", "rspace", "rquote", "scriptlevel", "scriptminsize", "scriptsizemultiplier", "selection", "separator", "separators", "stretchy", "subscriptshift", "supscriptshift", "symmetric", "voffset", "width", "xmlns"]), Hn = _(["xlink:href", "xml:id", "xlink:title", "xml:space", "xmlns:xlink"]), gl = E(/\{\{[\w\W]*|[\w\W]*\}\}/gm), _l = E(/<%[\w\W]*|[\w\W]*%>/gm), vl = E(/\${[\w\W]*}/gm), yl = E(/^data-[\-\w.\u00B7-\uFFFF]/), wl = E(/^aria-[\-\w]+$/), El = E(
        /^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i
      ), Dl = E(/^(?:\w+script|data):/i), Sl = E(
        /[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g
      ), Tl = E(/^html$/i), bl = E(/^[a-z][.\w]*(-[.\w]+)+$/i), Cl = function() {
        return typeof window == "undefined" ? null : window;
      }, kl = function(P, K) {
        if (n(P) !== "object" || typeof P.createPolicy != "function")
          return null;
        var Z = null, me = "data-tt-policy-suffix";
        K.currentScript && K.currentScript.hasAttribute(me) && (Z = K.currentScript.getAttribute(me));
        var Ge = "dompurify" + (Z ? "#" + Z : "");
        try {
          return P.createPolicy(Ge, {
            createHTML: function(Qe) {
              return Qe;
            },
            createScriptURL: function(Qe) {
              return Qe;
            }
          });
        } catch (Pe) {
          return console.warn("TrustedTypes policy " + Ge + " could not be created."), null;
        }
      };
      function Vi() {
        var x = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : Cl(), P = function(g) {
          return Vi(g);
        };
        if (P.version = "2.5.0", P.removed = [], !x || !x.document || x.document.nodeType !== 9)
          return P.isSupported = false, P;
        var K = x.document, Z = x.document, me = x.DocumentFragment, Ge = x.HTMLTemplateElement, Pe = x.Node, Qe = x.Element, Tt = x.NodeFilter, pn = x.NamedNodeMap, Il = pn === void 0 ? x.NamedNodeMap || x.MozNamedAttrMap : pn, Ml = x.HTMLFormElement, Al = x.DOMParser, Fn = x.trustedTypes, Gn = Qe.prototype, xl = st(Gn, "cloneNode"), Ol = st(Gn, "nextSibling"), Rl = st(Gn, "childNodes"), jo = st(Gn, "parentNode");
        if (typeof Ge == "function") {
          var Xo = Z.createElement("template");
          Xo.content && Xo.content.ownerDocument && (Z = Xo.content.ownerDocument);
        }
        var Ve = kl(Fn, K), Ko = Ve ? Ve.createHTML("") : "", Bn = Z, qo = Bn.implementation, Pl = Bn.createNodeIterator, Ll = Bn.createDocumentFragment, $l = Bn.getElementsByTagName, Hl = K.importNode, ji = {};
        try {
          ji = he(Z).documentMode ? Z.documentMode : {};
        } catch (U) {
        }
        var et = {};
        P.isSupported = typeof jo == "function" && qo && qo.createHTMLDocument !== void 0 && ji !== 9;
        var Zo = gl, Jo = _l, Qo = vl, Fl = yl, Gl = wl, Bl = Dl, Xi = Sl, zl = bl, er = El, ve = null, Ki = X({}, [].concat(s(de), s(We), s(Ye), s(St), s(Ui))), ye = null, qi = X({}, [].concat(s(Wi), s(Vo), s(Yi), s(Hn))), fe = Object.seal(Object.create(null, {
          tagNameCheck: {
            writable: true,
            configurable: false,
            enumerable: true,
            value: null
          },
          attributeNameCheck: {
            writable: true,
            configurable: false,
            enumerable: true,
            value: null
          },
          allowCustomizedBuiltInElements: {
            writable: true,
            configurable: false,
            enumerable: true,
            value: false
          }
        })), hn = null, tr = null, Zi = true, nr = true, Ji = false, Qi = true, Ft = false, es = true, bt = false, or = false, rr = false, Gt = false, zn = false, Un = false, ts = true, ns = false, Ul = "user-content-", ir = true, mn = false, Bt = {}, zt = null, os = X({}, ["annotation-xml", "audio", "colgroup", "desc", "foreignobject", "head", "iframe", "math", "mi", "mn", "mo", "ms", "mtext", "noembed", "noframes", "noscript", "plaintext", "script", "style", "svg", "template", "thead", "title", "video", "xmp"]), rs = null, is = X({}, ["audio", "video", "img", "source", "image", "track"]), sr = null, ss = X({}, ["alt", "class", "for", "id", "label", "name", "pattern", "placeholder", "role", "summary", "title", "value", "style", "xmlns"]), Wn = "http://www.w3.org/1998/Math/MathML", Yn = "http://www.w3.org/2000/svg", at = "http://www.w3.org/1999/xhtml", Ut = at, ar = false, cr = null, Wl = X({}, [Wn, Yn, at], H), Ct, Yl = ["application/xhtml+xml", "text/html"], Vl = "text/html", we, Wt = null, jl = Z.createElement("form"), as = function(g) {
          return g instanceof RegExp || g instanceof Function;
        }, lr = function(g) {
          Wt && Wt === g || ((!g || n(g) !== "object") && (g = {}), g = he(g), Ct = Yl.indexOf(g.PARSER_MEDIA_TYPE) === -1 ? Ct = Vl : Ct = g.PARSER_MEDIA_TYPE, we = Ct === "application/xhtml+xml" ? H : N, ve = "ALLOWED_TAGS" in g ? X({}, g.ALLOWED_TAGS, we) : Ki, ye = "ALLOWED_ATTR" in g ? X({}, g.ALLOWED_ATTR, we) : qi, cr = "ALLOWED_NAMESPACES" in g ? X({}, g.ALLOWED_NAMESPACES, H) : Wl, sr = "ADD_URI_SAFE_ATTR" in g ? X(
            he(ss),
            g.ADD_URI_SAFE_ATTR,
            we
          ) : ss, rs = "ADD_DATA_URI_TAGS" in g ? X(
            he(is),
            g.ADD_DATA_URI_TAGS,
            we
          ) : is, zt = "FORBID_CONTENTS" in g ? X({}, g.FORBID_CONTENTS, we) : os, hn = "FORBID_TAGS" in g ? X({}, g.FORBID_TAGS, we) : {}, tr = "FORBID_ATTR" in g ? X({}, g.FORBID_ATTR, we) : {}, Bt = "USE_PROFILES" in g ? g.USE_PROFILES : false, Zi = g.ALLOW_ARIA_ATTR !== false, nr = g.ALLOW_DATA_ATTR !== false, Ji = g.ALLOW_UNKNOWN_PROTOCOLS || false, Qi = g.ALLOW_SELF_CLOSE_IN_ATTR !== false, Ft = g.SAFE_FOR_TEMPLATES || false, es = g.SAFE_FOR_XML !== false, bt = g.WHOLE_DOCUMENT || false, Gt = g.RETURN_DOM || false, zn = g.RETURN_DOM_FRAGMENT || false, Un = g.RETURN_TRUSTED_TYPE || false, rr = g.FORCE_BODY || false, ts = g.SANITIZE_DOM !== false, ns = g.SANITIZE_NAMED_PROPS || false, ir = g.KEEP_CONTENT !== false, mn = g.IN_PLACE || false, er = g.ALLOWED_URI_REGEXP || er, Ut = g.NAMESPACE || at, fe = g.CUSTOM_ELEMENT_HANDLING || {}, g.CUSTOM_ELEMENT_HANDLING && as(g.CUSTOM_ELEMENT_HANDLING.tagNameCheck) && (fe.tagNameCheck = g.CUSTOM_ELEMENT_HANDLING.tagNameCheck), g.CUSTOM_ELEMENT_HANDLING && as(g.CUSTOM_ELEMENT_HANDLING.attributeNameCheck) && (fe.attributeNameCheck = g.CUSTOM_ELEMENT_HANDLING.attributeNameCheck), g.CUSTOM_ELEMENT_HANDLING && typeof g.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements == "boolean" && (fe.allowCustomizedBuiltInElements = g.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements), Ft && (nr = false), zn && (Gt = true), Bt && (ve = X({}, s(Ui)), ye = [], Bt.html === true && (X(ve, de), X(ye, Wi)), Bt.svg === true && (X(ve, We), X(ye, Vo), X(ye, Hn)), Bt.svgFilters === true && (X(ve, Ye), X(ye, Vo), X(ye, Hn)), Bt.mathMl === true && (X(ve, St), X(ye, Yi), X(ye, Hn))), g.ADD_TAGS && (ve === Ki && (ve = he(ve)), X(ve, g.ADD_TAGS, we)), g.ADD_ATTR && (ye === qi && (ye = he(ye)), X(ye, g.ADD_ATTR, we)), g.ADD_URI_SAFE_ATTR && X(sr, g.ADD_URI_SAFE_ATTR, we), g.FORBID_CONTENTS && (zt === os && (zt = he(zt)), X(zt, g.FORBID_CONTENTS, we)), ir && (ve["#text"] = true), bt && X(ve, ["html", "head", "body"]), ve.table && (X(ve, ["tbody"]), delete hn.tbody), _ && _(g), Wt = g);
        }, cs = X({}, ["mi", "mo", "mn", "ms", "mtext"]), ls = X({}, ["foreignobject", "desc", "title", "annotation-xml"]), Xl = X({}, ["title", "style", "font", "a", "script"]), Vn = X({}, We);
        X(Vn, Ye), X(Vn, gt);
        var ur = X({}, St);
        X(ur, ml);
        var Kl = function(g) {
          var C = jo(g);
          (!C || !C.tagName) && (C = {
            namespaceURI: Ut,
            tagName: "template"
          });
          var O = N(g.tagName), ne = N(C.tagName);
          return cr[g.namespaceURI] ? g.namespaceURI === Yn ? C.namespaceURI === at ? O === "svg" : C.namespaceURI === Wn ? O === "svg" && (ne === "annotation-xml" || cs[ne]) : Boolean(Vn[O]) : g.namespaceURI === Wn ? C.namespaceURI === at ? O === "math" : C.namespaceURI === Yn ? O === "math" && ls[ne] : Boolean(ur[O]) : g.namespaceURI === at ? C.namespaceURI === Yn && !ls[ne] || C.namespaceURI === Wn && !cs[ne] ? false : !ur[O] && (Xl[O] || !Vn[O]) : !!(Ct === "application/xhtml+xml" && cr[g.namespaceURI]) : false;
        }, je = function(g) {
          M(P.removed, {
            element: g
          });
          try {
            g.parentNode.removeChild(g);
          } catch (C) {
            try {
              g.outerHTML = Ko;
            } catch (O) {
              g.remove();
            }
          }
        }, dr = function(g, C) {
          try {
            M(P.removed, {
              attribute: C.getAttributeNode(g),
              from: C
            });
          } catch (O) {
            M(P.removed, {
              attribute: null,
              from: C
            });
          }
          if (C.removeAttribute(g), g === "is" && !ye[g])
            if (Gt || zn)
              try {
                je(C);
              } catch (O) {
              }
            else
              try {
                C.setAttribute(g, "");
              } catch (O) {
              }
        }, us = function(g) {
          var C, O;
          if (rr)
            g = "<remove></remove>" + g;
          else {
            var ne = G(g, /^[\r\n\t ]+/);
            O = ne && ne[0];
          }
          Ct === "application/xhtml+xml" && Ut === at && (g = '<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>' + g + "</body></html>");
          var Ae = Ve ? Ve.createHTML(g) : g;
          if (Ut === at)
            try {
              C = new Al().parseFromString(Ae, Ct);
            } catch (Te) {
            }
          if (!C || !C.documentElement) {
            C = qo.createDocument(Ut, "template", null);
            try {
              C.documentElement.innerHTML = ar ? Ko : Ae;
            } catch (Te) {
            }
          }
          var Ne = C.body || C.documentElement;
          return g && O && Ne.insertBefore(Z.createTextNode(O), Ne.childNodes[0] || null), Ut === at ? $l.call(C, bt ? "html" : "body")[0] : bt ? C.documentElement : Ne;
        }, ds = function(g) {
          return Pl.call(
            g.ownerDocument || g,
            g,
            Tt.SHOW_ELEMENT | Tt.SHOW_COMMENT | Tt.SHOW_TEXT | Tt.SHOW_PROCESSING_INSTRUCTION | Tt.SHOW_CDATA_SECTION,
            null,
            false
          );
        }, ql = function(g) {
          return g instanceof Ml && (typeof g.nodeName != "string" || typeof g.textContent != "string" || typeof g.removeChild != "function" || !(g.attributes instanceof Il) || typeof g.removeAttribute != "function" || typeof g.setAttribute != "function" || typeof g.namespaceURI != "string" || typeof g.insertBefore != "function" || typeof g.hasChildNodes != "function");
        }, gn = function(g) {
          return n(Pe) === "object" ? g instanceof Pe : g && n(g) === "object" && typeof g.nodeType == "number" && typeof g.nodeName == "string";
        }, ct = function(g, C, O) {
          !et[g] || T(et[g], function(ne) {
            ne.call(P, C, O, Wt);
          });
        }, fs = function(g) {
          var C;
          if (ct("beforeSanitizeElements", g, null), ql(g) || R(/[\u0080-\uFFFF]/, g.nodeName))
            return je(g), true;
          var O = we(g.nodeName);
          if (ct("uponSanitizeElement", g, {
            tagName: O,
            allowedTags: ve
          }), g.hasChildNodes() && !gn(g.firstElementChild) && (!gn(g.content) || !gn(g.content.firstElementChild)) && R(/<[/\w]/g, g.innerHTML) && R(/<[/\w]/g, g.textContent) || O === "select" && R(/<template/i, g.innerHTML) || g.nodeType === 7 || es && g.nodeType === 8 && R(/<[/\w]/g, g.data))
            return je(g), true;
          if (!ve[O] || hn[O]) {
            if (!hn[O] && hs(O) && (fe.tagNameCheck instanceof RegExp && R(fe.tagNameCheck, O) || fe.tagNameCheck instanceof Function && fe.tagNameCheck(O)))
              return false;
            if (ir && !zt[O]) {
              var ne = jo(g) || g.parentNode, Ae = Rl(g) || g.childNodes;
              if (Ae && ne)
                for (var Ne = Ae.length, Te = Ne - 1; Te >= 0; --Te)
                  ne.insertBefore(xl(Ae[Te], true), Ol(g));
            }
            return je(g), true;
          }
          return g instanceof Qe && !Kl(g) || (O === "noscript" || O === "noembed" || O === "noframes") && R(/<\/no(script|embed|frames)/i, g.innerHTML) ? (je(g), true) : (Ft && g.nodeType === 3 && (C = g.textContent, C = j(C, Zo, " "), C = j(C, Jo, " "), C = j(C, Qo, " "), g.textContent !== C && (M(P.removed, {
            element: g.cloneNode()
          }), g.textContent = C)), ct("afterSanitizeElements", g, null), false);
        }, ps = function(g, C, O) {
          if (ts && (C === "id" || C === "name") && (O in Z || O in jl))
            return false;
          if (!(nr && !tr[C] && R(Fl, C))) {
            if (!(Zi && R(Gl, C))) {
              if (!ye[C] || tr[C]) {
                if (!(hs(g) && (fe.tagNameCheck instanceof RegExp && R(fe.tagNameCheck, g) || fe.tagNameCheck instanceof Function && fe.tagNameCheck(g)) && (fe.attributeNameCheck instanceof RegExp && R(fe.attributeNameCheck, C) || fe.attributeNameCheck instanceof Function && fe.attributeNameCheck(C)) || C === "is" && fe.allowCustomizedBuiltInElements && (fe.tagNameCheck instanceof RegExp && R(fe.tagNameCheck, O) || fe.tagNameCheck instanceof Function && fe.tagNameCheck(O))))
                  return false;
              } else if (!sr[C]) {
                if (!R(er, j(O, Xi, ""))) {
                  if (!((C === "src" || C === "xlink:href" || C === "href") && g !== "script" && I(O, "data:") === 0 && rs[g])) {
                    if (!(Ji && !R(Bl, j(O, Xi, "")))) {
                      if (O)
                        return false;
                    }
                  }
                }
              }
            }
          }
          return true;
        }, hs = function(g) {
          return g !== "annotation-xml" && G(g, zl);
        }, ms = function(g) {
          var C, O, ne, Ae;
          ct("beforeSanitizeAttributes", g, null);
          var Ne = g.attributes;
          if (!!Ne) {
            var Te = {
              attrName: "",
              attrValue: "",
              keepAttr: true,
              allowedAttributes: ye
            };
            for (Ae = Ne.length; Ae--; ) {
              C = Ne[Ae];
              var jn = C, Ee = jn.name, fr = jn.namespaceURI;
              if (O = Ee === "value" ? C.value : z(C.value), ne = we(Ee), Te.attrName = ne, Te.attrValue = O, Te.keepAttr = true, Te.forceKeepAttr = void 0, ct("uponSanitizeAttribute", g, Te), O = Te.attrValue, !Te.forceKeepAttr && (dr(Ee, g), !!Te.keepAttr)) {
                if (!Qi && R(/\/>/i, O)) {
                  dr(Ee, g);
                  continue;
                }
                Ft && (O = j(O, Zo, " "), O = j(O, Jo, " "), O = j(O, Qo, " "));
                var gs = we(g.nodeName);
                if (!!ps(gs, ne, O)) {
                  if (ns && (ne === "id" || ne === "name") && (dr(Ee, g), O = Ul + O), Ve && n(Fn) === "object" && typeof Fn.getAttributeType == "function" && !fr)
                    switch (Fn.getAttributeType(gs, ne)) {
                      case "TrustedHTML": {
                        O = Ve.createHTML(O);
                        break;
                      }
                      case "TrustedScriptURL": {
                        O = Ve.createScriptURL(O);
                        break;
                      }
                    }
                  try {
                    fr ? g.setAttributeNS(fr, Ee, O) : g.setAttribute(Ee, O), k(P.removed);
                  } catch (Fg) {
                  }
                }
              }
            }
            ct("afterSanitizeAttributes", g, null);
          }
        }, Zl = function U(g) {
          var C, O = ds(g);
          for (ct("beforeSanitizeShadowDOM", g, null); C = O.nextNode(); )
            ct("uponSanitizeShadowNode", C, null), !fs(C) && (C.content instanceof me && U(C.content), ms(C));
          ct("afterSanitizeShadowDOM", g, null);
        };
        return P.sanitize = function(U) {
          var g = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, C, O, ne, Ae, Ne;
          if (ar = !U, ar && (U = "<!-->"), typeof U != "string" && !gn(U))
            if (typeof U.toString == "function") {
              if (U = U.toString(), typeof U != "string")
                throw ae("dirty is not a string, aborting");
            } else
              throw ae("toString is not a function");
          if (!P.isSupported) {
            if (n(x.toStaticHTML) === "object" || typeof x.toStaticHTML == "function") {
              if (typeof U == "string")
                return x.toStaticHTML(U);
              if (gn(U))
                return x.toStaticHTML(U.outerHTML);
            }
            return U;
          }
          if (or || lr(g), P.removed = [], typeof U == "string" && (mn = false), mn) {
            if (U.nodeName) {
              var Te = we(U.nodeName);
              if (!ve[Te] || hn[Te])
                throw ae("root node is forbidden and cannot be sanitized in-place");
            }
          } else if (U instanceof Pe)
            C = us("<!---->"), O = C.ownerDocument.importNode(U, true), O.nodeType === 1 && O.nodeName === "BODY" || O.nodeName === "HTML" ? C = O : C.appendChild(O);
          else {
            if (!Gt && !Ft && !bt && U.indexOf("<") === -1)
              return Ve && Un ? Ve.createHTML(U) : U;
            if (C = us(U), !C)
              return Gt ? null : Un ? Ko : "";
          }
          C && rr && je(C.firstChild);
          for (var jn = ds(mn ? U : C); ne = jn.nextNode(); )
            ne.nodeType === 3 && ne === Ae || fs(ne) || (ne.content instanceof me && Zl(ne.content), ms(ne), Ae = ne);
          if (Ae = null, mn)
            return U;
          if (Gt) {
            if (zn)
              for (Ne = Ll.call(C.ownerDocument); C.firstChild; )
                Ne.appendChild(C.firstChild);
            else
              Ne = C;
            return (ye.shadowroot || ye.shadowrootmod) && (Ne = Hl.call(K, Ne, true)), Ne;
          }
          var Ee = bt ? C.outerHTML : C.innerHTML;
          return bt && ve["!doctype"] && C.ownerDocument && C.ownerDocument.doctype && C.ownerDocument.doctype.name && R(Tl, C.ownerDocument.doctype.name) && (Ee = "<!DOCTYPE " + C.ownerDocument.doctype.name + `>
` + Ee), Ft && (Ee = j(Ee, Zo, " "), Ee = j(Ee, Jo, " "), Ee = j(Ee, Qo, " ")), Ve && Un ? Ve.createHTML(Ee) : Ee;
        }, P.setConfig = function(U) {
          lr(U), or = true;
        }, P.clearConfig = function() {
          Wt = null, or = false;
        }, P.isValidAttribute = function(U, g, C) {
          Wt || lr({});
          var O = we(U), ne = we(g);
          return ps(O, ne, C);
        }, P.addHook = function(U, g) {
          typeof g == "function" && (et[U] = et[U] || [], M(et[U], g));
        }, P.removeHook = function(U) {
          if (et[U])
            return k(et[U]);
        }, P.removeHooks = function(U) {
          et[U] && (et[U] = []);
        }, P.removeAllHooks = function() {
          et = {};
        }, P;
      }
      var Nl = Vi();
      return Nl;
    });
  }(Dr)), Dr.exports;
}
var To = window.DOMPurify || (window.DOMPurify = Js().default || Js());
const to = "data-target-temp";
function sf() {
  To.addHook("beforeSanitizeAttributes", (e) => {
    if (e.tagName === "A") {
      const t = e.getAttribute("target");
      t ? e.setAttribute(to, t) : e.setAttribute("target", "_self");
    }
  }), To.addHook("afterSanitizeAttributes", (e) => {
    e.tagName === "A" && e.hasAttribute(to) && (e.setAttribute("target", e.getAttribute(to)), e.removeAttribute(to), e.getAttribute("target") === "_blank" && e.setAttribute("rel", "noopener"));
  });
}
function af() {
  To.removeAllHooks();
}
function cf(e) {
  return To.sanitize(e);
}
function te({ template: e, param: t, as: n = "div" }) {
  var s;
  const r = W(ac)[e];
  if (V(r))
    return null;
  const i = r(t);
  return Ie(i) ? d(n, {
    className: y(`template-${e}`),
    dangerouslySetInnerHTML: {
      __html: cf(i)
    }
  }) : au(i, {
    className: `${(s = i.props.className) != null ? s : ""} ${y(`template-${e}`)}`
  });
}
const cc = xo(
  null
), lf = cc.Provider, Me = () => {
  const e = Mn(cc);
  if (!e)
    throw new Error("useEventBus must be used within a EventBusProvider");
  return e;
}, Go = (e) => {
  var t, n, o, r, i;
  return (i = (r = (o = (n = (t = e.options) == null ? void 0 : t.timezone) == null ? void 0 : n.zones) == null ? void 0 : o[0]) == null ? void 0 : r.timezoneName) != null ? i : "Local";
}, uf = (e) => {
  var t, n;
  return (n = (t = e.options) == null ? void 0 : t.timezone) == null ? void 0 : n.customOffsetCalculator;
}, lc = (e) => {
  var t;
  return (t = e.options.timezone.zones) != null ? t : [];
};
function Bo() {
  const e = W(uf), t = $(e);
  return Q(
    (n, o = new F()) => o.tz(
      t ? e(n, o.getTime()) : n
    ),
    [e, t]
  );
}
function zo() {
  const e = W(Go), t = Bo(), n = Q(
    () => t(e),
    [e, t]
  );
  return [e, n];
}
function df(e, t) {
  return e === "week";
}
function ff({
  dayName: e,
  theme: t,
  today: n
}) {
  var a, c;
  const { day: o, dateInstance: r } = e, i = Rt(n, r), s = !i && r < n;
  return _i(o) ? t.common.holiday.color : s ? (a = t.week) == null ? void 0 : a.pastDay.color : vi(o) ? t.common.saturday.color : i ? (c = t.week) == null ? void 0 : c.today.color : t.common.dayName.color;
}
function pf({
  dayName: e,
  theme: t
}) {
  const { day: n } = e;
  return _i(n) ? t.common.holiday.color : vi(n) ? t.common.saturday.color : t.common.dayName.color;
}
function hf({ dayName: e, style: t, type: n, theme: o }) {
  const r = Me(), [, i] = zo(), s = i(), { day: a } = e, c = n === "week" ? ff({ dayName: e, theme: o, today: s }) : pf({ dayName: e, theme: o }), l = `${n}DayName`, f = () => {
    df(n) && r.fire("clickDayName", { date: ge(e.dateInstance, "YYYY-MM-DD") });
  };
  return /* @__PURE__ */ d("div", {
    className: y("day-name-item", n),
    style: t
  }, /* @__PURE__ */ d("span", {
    className: y({ [`holiday-${So(a)}`]: ze(a) }),
    style: { color: c },
    onClick: f,
    "data-testid": `dayName-${n}-${So(a)}`
  }, /* @__PURE__ */ d(te, {
    template: l,
    param: e
  })));
}
const uc = Et("common"), mf = Et("month"), dc = (e) => e.week.dayGridLeft, Di = (e) => e.week.timeGridLeft, gf = (e) => e.month.moreView, fc = (e) => e.month.gridCell, _f = {
  border: "1px solid #e5e5e5",
  backgroundColor: "white",
  holiday: {
    color: "#ff4040"
  },
  saturday: {
    color: "#333"
  },
  dayName: {
    color: "#333"
  },
  today: {
    color: "#fff"
  },
  gridSelection: {
    backgroundColor: "rgba(81, 92, 230, 0.05)",
    border: "1px solid #515ce6"
  }
}, vf = {
  dayName: {
    borderLeft: "none",
    borderTop: "1px solid #e5e5e5",
    borderBottom: "1px solid #e5e5e5",
    backgroundColor: "inherit"
  },
  weekend: {
    backgroundColor: "inherit"
  },
  today: {
    color: "inherit",
    backgroundColor: "rgba(81, 92, 230, 0.05)"
  },
  pastDay: {
    color: "#bbb"
  },
  panelResizer: {
    border: "1px solid #e5e5e5"
  },
  dayGrid: {
    borderRight: "1px solid #e5e5e5",
    backgroundColor: "inherit"
  },
  dayGridLeft: {
    borderRight: "1px solid #e5e5e5",
    backgroundColor: "inherit",
    width: "72px"
  },
  timeGrid: {
    borderRight: "1px solid #e5e5e5"
  },
  timeGridLeft: {
    backgroundColor: "inherit",
    borderRight: "1px solid #e5e5e5",
    width: "72px"
  },
  timeGridLeftAdditionalTimezone: {
    backgroundColor: "white"
  },
  timeGridHalfHourLine: {
    borderBottom: "none"
  },
  timeGridHourLine: {
    borderBottom: "1px solid #e5e5e5"
  },
  nowIndicatorLabel: {
    color: "#515ce6"
  },
  nowIndicatorPast: {
    border: "1px dashed #515ce6"
  },
  nowIndicatorBullet: {
    backgroundColor: "#515ce6"
  },
  nowIndicatorToday: {
    border: "1px solid #515ce6"
  },
  nowIndicatorFuture: {
    border: "none"
  },
  pastTime: {
    color: "#bbb"
  },
  futureTime: {
    color: "#333"
  },
  gridSelection: {
    color: "#515ce6"
  }
}, yf = {
  dayName: {
    borderLeft: "none",
    backgroundColor: "inherit"
  },
  holidayExceptThisMonth: {
    color: "rgba(255, 64, 64, 0.4)"
  },
  dayExceptThisMonth: {
    color: "rgba(51, 51, 51, 0.4)"
  },
  weekend: {
    backgroundColor: "inherit"
  },
  moreView: {
    border: "1px solid #d5d5d5",
    boxShadow: "0 2px 6px 0 rgba(0, 0, 0, 0.1)",
    backgroundColor: "white",
    width: null,
    height: null
  },
  gridCell: {
    headerHeight: 31,
    footerHeight: null
  },
  moreViewTitle: {
    backgroundColor: "inherit"
  }
};
function wf(e = {}) {
  return {
    common: qe(_f, e)
  };
}
function Ef(e) {
  return {
    setTheme: (t) => {
      e(
        J((n) => {
          n.common = qe(n.common, t.common), n.week = qe(n.week, t.week), n.month = qe(n.month, t.month);
        })
      );
    },
    setCommonTheme: (t) => {
      e(
        J((n) => {
          n.common = qe(n.common, t);
        })
      );
    },
    setWeekTheme: (t) => {
      e(
        J((n) => {
          n.week = qe(n.week, t);
        })
      );
    },
    setMonthTheme: (t) => {
      e(
        J((n) => {
          n.month = qe(n.month, t);
        })
      );
    }
  };
}
function Df(e = {}) {
  return {
    month: qe(yf, e)
  };
}
function Sf(e = {}) {
  return {
    week: qe(vf, e)
  };
}
const Tf = (e = {}) => (t) => ce(L(L(L({}, wf(e == null ? void 0 : e.common)), Sf(e == null ? void 0 : e.week)), Df(e == null ? void 0 : e.month)), {
  dispatch: L({}, Ef(t))
}), bf = (e = {}) => rc(Tf(e)), {
  StoreProvider: Cf,
  useInternalStore: zg,
  useStore: re
} = oc();
function kf() {
  return re(uc);
}
function pc() {
  return re(mf);
}
function Nf(e) {
  return {
    common: {
      saturday: e.common.saturday,
      holiday: e.common.holiday,
      today: e.common.today,
      dayName: e.common.dayName
    },
    week: {
      pastDay: e.week.pastDay,
      today: e.week.today,
      dayName: e.week.dayName
    }
  };
}
function If(e) {
  return {
    common: {
      saturday: e.common.saturday,
      holiday: e.common.holiday,
      today: e.common.today,
      dayName: e.common.dayName
    },
    month: {
      dayName: e.month.dayName
    }
  };
}
function Si({
  dayNames: e,
  marginLeft: t = ku,
  rowStyleInfo: n,
  type: o = "month"
}) {
  var f, u;
  const r = re(o === "month" ? If : Nf), p = (u = (f = r[o]) == null ? void 0 : f.dayName) != null ? u : {}, { backgroundColor: i = "white", borderLeft: s = null } = p, a = Kn(p, ["backgroundColor", "borderLeft"]), { borderTop: c = null, borderBottom: l = null } = a;
  return /* @__PURE__ */ d("div", {
    "data-testid": `grid-header-${o}`,
    className: y("day-names", o),
    style: {
      backgroundColor: i,
      borderTop: c,
      borderBottom: l
    }
  }, /* @__PURE__ */ d("div", {
    className: y("day-name-container"),
    style: { marginLeft: t }
  }, e.map((h, m) => /* @__PURE__ */ d(hf, {
    type: o,
    key: `dayNames-${h.day}`,
    dayName: h,
    style: {
      width: q(n[m].width),
      left: q(n[m].left),
      borderLeft: s
    },
    theme: r
  }))));
}
const Mf = 6;
var On = /* @__PURE__ */ ((e) => (e.header = "header", e.footer = "footer", e))(On || {});
function Uo(e, t = true) {
  const n = [];
  let o;
  return e.length && (n[0] = [e[0].cid()], e.slice(1).forEach((r, i) => {
    o = e.slice(0, i + 1).reverse();
    const s = o.find(
      (a) => r.collidesWith(a, t)
    );
    s ? n.slice().reverse().some((a) => ~a.indexOf(s.cid()) ? (a.push(r.cid()), true) : false) : n.push([r.cid()]);
  })), n;
}
function Af(e, t) {
  let { length: n } = e;
  for (; n > 0; )
    if (n -= 1, !Fe(e[n][t]))
      return n;
  return -1;
}
function Wo(e, t, n = true) {
  const o = [];
  return t.forEach((r) => {
    const i = [[]];
    r.forEach((s) => {
      const a = e.get(s);
      let c = 0, l = false, f, u;
      for (; !l; )
        u = Af(i, c), u === -1 ? (i[0].push(a), l = true) : a.collidesWith(i[u][c], n) || (f = u + 1, Fe(i[f]) && (i[f] = []), i[f][c] = a, l = true), c += 1;
    }), o.push(i);
  }), o;
}
function hc(e, t) {
  return (n) => {
    const o = n.getStarts();
    return !(n.getEnds() < e || o > t);
  };
}
function mc(e, t, n, o) {
  const r = zr(e, t, ht).map(
    (i) => ge(i, "YYYYMMDD")
  );
  n.forEach((i) => {
    i.forEach((s) => {
      s.forEach((a, c) => {
        if (!a)
          return;
        const l = ge(a.getStarts(), "YYYYMMDD"), f = zr(
          _e(a.getStarts()),
          Re(a.getEnds()),
          ht
        ).length;
        a.top = c, a.left = r.indexOf(l), a.width = f, o == null || o(a);
      });
    });
  });
}
function Qs(e, t, n) {
  return n.getStarts() < e && (n.exceedLeft = true, n.renderStarts = new F(e)), n.getEnds() > t && (n.exceedRight = true, n.renderEnds = new F(t)), n;
}
function gc(e, t, n) {
  return n instanceof rt ? (n.each((o) => (Qs(e, t, o), true)), null) : Qs(e, t, n);
}
function _c(e) {
  const t = new rt((n) => n.cid());
  return e.each(function(n) {
    t.add(new xt(n));
  }), t;
}
function Ti({ model: e }) {
  return e.isAllday || e.hasMultiDates;
}
function vc(e) {
  return !Ti(e);
}
function xf(e) {
  e.top = e.top || 0, e.top += 1;
}
function Of(e, t, n) {
  n.each((o) => {
    (o.model.isAllday || o.model.hasMultiDates) && gc(_e(e), Re(t), o);
  });
}
function Rf(e, t, n) {
  const o = [];
  return e[t].forEach((r) => {
    n.doWhenHas(r, (i) => {
      o.push(i.top);
    });
  }), o.length > 0 ? Math.max(...o) : 0;
}
function Pf(e, t) {
  const n = t.filter(Ti), o = t.filter(vc).sort(Ot.compare.event.asc), r = {};
  o.forEach((i) => {
    const s = ge(i.getStarts(), "YYYYMMDD");
    let a = r[s];
    Fe(a) && (a = r[s] = Rf(
      e,
      s,
      n
    )), r[s] = i.top = a + 1;
  });
}
function Lf(e, t) {
  const n = t.filter(Ti), o = t.filter(vc).sort(Ot.compare.event.asc), r = {};
  o.forEach((i) => {
    const s = ge(i.getStarts(), "YYYYMMDD");
    let a = r[s];
    if (Fe(a) && (a = r[s] = [], e[s].forEach((c) => {
      n.doWhenHas(c, (l) => {
        a.push(l.top);
      });
    })), a.indexOf(i.top) >= 0) {
      const c = Math.max(...a) + 1;
      for (let l = 1; l <= c && (i.top = l, !(a.indexOf(i.top) < 0)); l += 1)
        ;
    }
    a.push(i.top);
  });
}
function $f(e) {
  e.each((t) => {
    const { model: n } = t, o = n.getStarts(), r = n.getEnds();
    n.hasMultiDates = !Rt(o, r), !n.isAllday && n.hasMultiDates && (t.renderStarts = _e(o), t.renderEnds = Re(r));
  });
}
function Hf(e, t) {
  const { start: n, end: o, andFilters: r = [], alldayFirstMode: i = false } = t, { events: s, idsOfDay: a } = e, c = rt.and(...[hc(n, o)].concat(r)), l = s.filter(c), f = _c(l);
  $f(f), Of(n, o, f);
  const u = f.sort(Ot.compare.event.asc), p = false, h = Uo(u, p), m = Wo(f, h, p);
  return mc(n, o, m, xf), i ? Pf(a, f) : Lf(a, f), m;
}
function Ff(e, t) {
  return (n) => {
    const o = n.getStarts(), r = n.getEnds(), i = o.getTime(), s = r.getTime(), a = o.getFullYear(), c = o.getMonth(), l = o.getDate(), f = new F(a, c, l).setHours(e), u = new F(a, c, l).setHours(t);
    return i >= f && i < u || s > f && s <= u || i < f && s > f || s > u && i < u;
  };
}
function Gf(e, t) {
  return e === 0 && t === 24 ? (n) => n.sort(Ot.compare.event.asc) : (n) => n.filter(Ff(e, t)).sort(Ot.compare.event.asc);
}
function Bf(e, t, n, o) {
  const r = {};
  return Xa(t, n).forEach((s) => {
    const a = ge(s, "YYYYMMDD"), c = e[a], l = r[a] = new rt((f) => f.cid());
    c && c.length && c.forEach((f) => {
      o.doWhenHas(f, (u) => {
        l.add(u);
      });
    });
  }, {}), r;
}
function zf(e, t) {
  const { start: n, end: o, uiModelTimeColl: r, hourStart: i, hourEnd: s } = t, a = Bf(e, n, o, r), c = {}, l = Gf(i, s), f = true;
  return Object.entries(a).forEach(([u, p]) => {
    const h = l(p), m = Uo(h, f), w = Wo(p, m, f);
    c[u] = w;
  }), c;
}
function Uf(e) {
  e.each((t) => {
    const { model: n } = t;
    n.hasMultiDates = true, t.renderStarts = _e(n.getStarts()), t.renderEnds = Re(n.getEnds());
  });
}
function Wf(e, t, n) {
  if (!n || !n.size)
    return [];
  Uf(n), gc(e, t, n);
  const o = n.sort(Ot.compare.event.asc), r = true, i = Uo(o, r), s = Wo(n, i, r);
  return mc(e, t, s), s;
}
function Yf(e, t) {
  var m, w;
  const { start: n, end: o, panels: r, andFilters: i = [], options: s } = t, { events: a, idsOfDay: c } = e, l = (m = s == null ? void 0 : s.hourStart) != null ? m : 0, f = (w = s == null ? void 0 : s.hourEnd) != null ? w : 24, u = rt.and(...[hc(n, o)].concat(i)), h = _c(a.filter(u)).groupBy(kd);
  return r.reduce(
    (v, _) => {
      const { name: E, type: S } = _;
      return V(h[E]) ? v : ce(L({}, v), {
        [E]: S === "daygrid" ? Wf(n, o, h[E]) : zf(c, {
          start: n,
          end: o,
          uiModelTimeColl: h[E],
          hourStart: l,
          hourEnd: f
        })
      });
    },
    {
      milestone: [],
      task: [],
      allday: [],
      time: {}
    }
  );
}
function Yr(e, t, n) {
  const o = Math.max(e, ...t);
  return Math.min(o, ...n);
}
function yc(e, t, n) {
  return t * n / e;
}
function wc(e, t, n) {
  return t <= e && e <= n;
}
const it = 22, bi = 100;
function Ec(e, t) {
  e.forEach((n) => {
    n.forEach((o) => {
      o.forEach((r, i) => {
        t(r, i);
      });
    });
  });
}
function Ci(e, t) {
  return ({ top: n }) => e >= n * t;
}
function Vf(e, t) {
  return ({ top: n }) => e < n * t;
}
function Dc(e, t, n) {
  return e.filter(Vf(t, n)).length;
}
const jf = (e) => e.filter((t) => ze(t.getDay())).length;
function ki(e, t, n) {
  const o = jf(e), r = e.length, i = o === r, s = n / (t && !i ? r * 2 - o : r), a = e.map((l) => {
    const f = l.getDay();
    return !t || i || ze(f) ? s : s * 2;
  }), c = a.reduce(
    (l, f, u) => u ? [...l, l[u - 1] + a[u - 1]] : [0],
    []
  );
  return {
    widthList: a,
    leftList: c
  };
}
function bo(e, t, n) {
  return e.reduce((o, r, i) => t <= i && i <= n ? o + r : o, 0);
}
const Xf = (e) => (t) => {
  const n = _e(t.getStarts()), o = _e(t.getEnds());
  return n <= e && e <= o;
};
function Co(e, t) {
  return t.findIndex((n) => e >= _e(n) && e <= Re(n));
}
const Kf = (e, t, n, o) => {
  const { widthList: r } = ki(n, o, bi);
  return {
    left: e ? bo(r, 0, e - 1) : 0,
    width: bo(r, e != null ? e : 0, t < 0 ? n.length - 1 : t)
  };
}, Sc = (e, t, n, o) => {
  const { widthList: r } = ki(n, o, bi);
  let i = 0, s = n.length - 1;
  return n.forEach((a, c) => {
    a <= e && (i = c), a <= t && (s = c);
  }), {
    width: bo(r, i, s),
    left: i ? bo(r, 0, i - 1) : 0
  };
};
function qf(e, t, n = false) {
  const o = e.getStarts(), r = e.getEnds(), { width: i, left: s } = Sc(o, r, t, n);
  return e.width = i, e.left = s, e;
}
function Zf(e, t, n) {
  const { idsOfDay: o } = t, r = Hf(t, {
    start: e[0],
    end: Re(e[e.length - 1])
  }), i = [];
  Ec(r, (a) => {
    const c = a.model.cid();
    i[c] = qf(a, e, n);
  });
  const s = Object.keys(o).reduce(
    (a, c) => {
      const l = o[c];
      return a[c] = l.map((f) => i[f]).filter((f) => !!f), a;
    },
    {}
  );
  return {
    uiModels: Object.values(i),
    gridDateEventModelMap: s
  };
}
const Jf = (e, t, n = false) => (Ec(e, (o) => {
  const r = o.getStarts(), i = o.getEnds(), { width: s, left: a } = Sc(r, i, t, n);
  o.width = s, o.left = a, o.top += 1;
}), Tc(e)), Qf = (e) => e.filter((t) => !!t);
function Tc(e) {
  return e.flatMap((t) => t.flatMap((n) => Qf(n)));
}
const ep = (e) => Array.from(
  new Set(
    Object.values(e).reduce(
      (t, n) => t.concat(...Tc(n)),
      []
    )
  )
), bc = (e, t, {
  narrowWeekend: n,
  hourStart: o,
  hourEnd: r,
  weekStartDate: i,
  weekEndDate: s
}) => {
  const c = Yf(t, {
    start: i,
    end: s,
    panels: [
      {
        name: "milestone",
        type: "daygrid",
        show: true
      },
      {
        name: "task",
        type: "daygrid",
        show: true
      },
      {
        name: "allday",
        type: "daygrid",
        show: true
      },
      {
        name: "time",
        type: "timegrid",
        show: true
      }
    ],
    andFilters: [],
    options: {
      hourStart: o,
      hourEnd: r
    }
  });
  return Object.keys(c).reduce(
    (l, f) => {
      const u = c[f];
      return ce(L({}, l), {
        [f]: Array.isArray(u) ? Jf(u, e, n) : ep(u)
      });
    },
    {
      milestone: [],
      allday: [],
      task: [],
      time: []
    }
  );
};
function Cc(e, {
  workweek: t = false,
  visibleWeeksCount: n = 0,
  startDayOfWeek: o = 0,
  isAlways6Weeks: r = true
}) {
  const i = new F(e), s = n > 0, a = s ? i : Va(i), c = yd(
    a,
    a.getDay() - o + (a.getDay() < o ? tt : 0)
  ), l = c.getDay(), f = vd(i).getDate(), u = wi(c, a), p = f + Math.abs(u);
  let h = Mf;
  return s ? h = n : r === false && (h = Math.ceil(p / tt)), vt(0, h).map(
    (m) => vt(0, tt).reduce((w, v) => {
      const _ = m * tt + v, E = (_ + l) % tt;
      if (!t || t && !ze(E)) {
        const S = Pt(c, _);
        w.push(S);
      }
      return w;
    }, [])
  );
}
function kc(e, { startDayOfWeek: t = rn.SUN, workweek: n }) {
  const o = _e(e), i = o.getDay() - t;
  return (i >= 0 ? vt(-i, tt - i) : vt(-tt - i, -i)).reduce((a, c) => {
    const l = Pt(o, c);
    return n && ze(l.getDay()) || a.push(l), a;
  }, []);
}
function tp(e, t = false) {
  const n = e.length, o = n > 5 && t, r = o ? 100 / (n - 1) : 100 / n;
  return e.map((i) => {
    const s = o && ze(i.getDay()) ? r / 2 : r;
    return {
      date: i,
      width: s
    };
  }).reduce((i, s, a) => {
    const c = i[a - 1];
    return i.push(ce(L({}, s), {
      left: a === 0 ? 0 : c.left + c.width
    })), i;
  }, []);
}
function Nc(e, t) {
  var s;
  const n = tp(e, (s = t.narrowWeekend) != null ? s : false), o = (t.hourEnd - t.hourStart) * 2, r = 100 / o, i = vt(o).map((a, c) => {
    const l = c % 2 === 1, f = t.hourStart + Math.floor(a / 2), u = `${f}:${l ? "30" : "00"}`.padStart(5, "0"), p = (l ? `${f + 1}:00` : `${f}:30`).padStart(
      5,
      "0"
    );
    return {
      top: r * c,
      height: r,
      startTime: u,
      endTime: p
    };
  });
  return {
    columns: n,
    rows: i
  };
}
function np({ clientX: e, clientY: t }, { left: n, top: o, clientLeft: r, clientTop: i }) {
  return [e - n - r, t - o - i];
}
function op(e, t, n) {
  const o = Math.floor(yc(t, e, n));
  return Yr(o, [0], [e - 1]);
}
function Ni({
  rowsCount: e,
  columnsCount: t,
  container: n,
  narrowWeekend: o = false,
  startDayOfWeek: r = rn.SUN
}) {
  if (V(n))
    return () => null;
  const i = vt(r, r + t).map(
    (a) => a % tt
  ), s = o ? i.filter((a) => ze(a)).length : 0;
  return function(c) {
    const {
      left: l,
      top: f,
      width: u,
      height: p
    } = n.getBoundingClientRect(), [h, m] = np(c, {
      left: l,
      top: f,
      clientLeft: n.clientLeft,
      clientTop: n.clientTop
    });
    if (h < 0 || m < 0 || h > u || m > p)
      return null;
    const w = o ? u / (t - s + 1) : u / t, v = i.map(
      (S) => o && ze(S) ? w / 2 : w
    ), _ = [];
    return v.forEach((S, b) => {
      b === 0 ? _.push(0) : _.push(_[b - 1] + v[b - 1]);
    }), {
      columnIndex: hi(_, (S) => h >= S),
      rowIndex: op(e, p, m)
    };
  };
}
function rp(e) {
  return e.common.gridSelection;
}
function Ii({ type: e, gridSelectionData: t, weekDates: n, narrowWeekend: o }) {
  const { backgroundColor: r, border: i } = re(rp), { startCellIndex: s, endCellIndex: a } = t, { left: c, width: l } = Kf(
    Math.min(s, a),
    Math.max(s, a),
    n,
    o
  ), f = {
    left: q(c),
    width: q(l),
    height: q(100),
    backgroundColor: r,
    border: i
  };
  return l > 0 ? /* @__PURE__ */ d("div", {
    className: y(e, "grid-selection"),
    style: f
  }) : null;
}
function Mi(e, t, n) {
  return {
    startColumnIndex: n ? t.columnIndex : e.columnIndex,
    startRowIndex: n ? t.rowIndex : e.rowIndex,
    endColumnIndex: n ? e.columnIndex : t.columnIndex,
    endRowIndex: n ? e.rowIndex : t.rowIndex
  };
}
function ip(e, t, n) {
  if (V(e))
    return null;
  const { startColumnIndex: o, endColumnIndex: r, endRowIndex: i, startRowIndex: s } = e;
  if (!wc(t, o, r))
    return null;
  const l = {
    startRowIndex: s,
    endRowIndex: i,
    isSelectingMultipleColumns: o !== r,
    isStartingColumn: t === o
  };
  return o < t && t < r ? (l.startRowIndex = 0, l.endRowIndex = n) : o !== r && (o === t ? l.endRowIndex = n : r === t && (l.startRowIndex = 0)), l;
}
const Vr = {
  sortSelection: (e, t) => {
    const n = e.columnIndex > t.columnIndex || e.columnIndex === t.columnIndex && e.rowIndex > t.rowIndex;
    return Mi(e, t, n);
  },
  getDateFromCollection: (e, t) => {
    const n = e, o = nt(
      n.columns[t.startColumnIndex].date,
      n.rows[t.startRowIndex].startTime
    ), r = nt(
      n.columns[t.endColumnIndex].date,
      n.rows[t.endRowIndex].endTime
    );
    return [o, r];
  },
  calculateSelection: ip
};
function sp(e, t, n) {
  if (!($(e) && $(t) && $(n)))
    return null;
  const { startRowIndex: o, startColumnIndex: r, endRowIndex: i, endColumnIndex: s } = e;
  if (!wc(
    t,
    Math.min(o, i),
    Math.max(o, i)
  ))
    return null;
  let a = r, c = s;
  return o < t && (a = 0), i > t && (c = n - 1), { startCellIndex: a, endCellIndex: c };
}
const ko = {
  sortSelection: (e, t) => {
    const n = e.rowIndex > t.rowIndex || e.rowIndex === t.rowIndex && e.columnIndex > t.columnIndex;
    return Mi(e, t, n);
  },
  getDateFromCollection: (e, t) => {
    const n = e;
    return [
      n[t.startRowIndex][t.startColumnIndex],
      n[t.endRowIndex][t.endColumnIndex]
    ];
  },
  calculateSelection: sp
};
function ap(e) {
  return $(e) ? {
    startCellIndex: e.startColumnIndex,
    endCellIndex: e.endColumnIndex
  } : null;
}
const jr = {
  sortSelection: (e, t) => {
    const n = e.columnIndex > t.columnIndex;
    return Mi(e, t, n);
  },
  getDateFromCollection: (e, t) => {
    const n = e;
    return [n[t.startColumnIndex], n[t.endColumnIndex]];
  },
  calculateSelection: ap
};
function cp(e) {
  return jr.calculateSelection(e.gridSelection.dayGridWeek);
}
function lp({ weekDates: e, narrowWeekend: t }) {
  const n = W(cp);
  return V(n) ? null : /* @__PURE__ */ d(Ii, {
    type: "allday",
    gridSelectionData: n,
    weekDates: e,
    narrowWeekend: t
  });
}
function Ic(e, t) {
  for (var n in t)
    e[n] = t[n];
  return e;
}
function Xr(e, t) {
  for (var n in e)
    if (n !== "__source" && !(n in t))
      return true;
  for (var o in t)
    if (o !== "__source" && e[o] !== t[o])
      return true;
  return false;
}
function ea(e, t) {
  this.props = e, this.context = t;
}
function ln(e, t) {
  function n(r) {
    var i = this.props.ref, s = i == r.ref;
    return !s && i && (i.call ? i(null) : i.current = null), t ? !t(this.props, r) || !s : Xr(this.props, r);
  }
  function o(r) {
    return this.shouldComponentUpdate = n, d(e, r);
  }
  return o.displayName = "Memo(" + (e.displayName || e.name) + ")", o.prototype.isReactComponent = true, o.__f = true, o;
}
(ea.prototype = new dt()).isPureReactComponent = true, ea.prototype.shouldComponentUpdate = function(e, t) {
  return Xr(this.props, e) || Xr(this.state, t);
};
var ta = B.__b;
B.__b = function(e) {
  e.type && e.type.__f && e.ref && (e.props.ref = e.ref, e.ref = null), ta && ta(e);
};
var up = typeof Symbol != "undefined" && Symbol.for && Symbol.for("react.forward_ref") || 3911;
function Mc(e) {
  function t(n) {
    var o = Ic({}, n);
    return delete o.ref, e(o, n.ref || null);
  }
  return t.$$typeof = up, t.render = t, t.prototype.isReactComponent = t.__f = true, t.displayName = "ForwardRef(" + (e.displayName || e.name) + ")", t;
}
var dp = B.__e;
B.__e = function(e, t, n, o) {
  if (e.then) {
    for (var r, i = t; i = i.__; )
      if ((r = i.__c) && r.__c)
        return t.__e == null && (t.__e = n.__e, t.__k = n.__k), r.__c(e, t);
  }
  dp(e, t, n, o);
};
var na = B.unmount;
function Ac(e, t, n) {
  return e && (e.__c && e.__c.__H && (e.__c.__H.__.forEach(function(o) {
    typeof o.__c == "function" && o.__c();
  }), e.__c.__H = null), (e = Ic({}, e)).__c != null && (e.__c.__P === n && (e.__c.__P = t), e.__c = null), e.__k = e.__k && e.__k.map(function(o) {
    return Ac(o, t, n);
  })), e;
}
function xc(e, t, n) {
  return e && n && (e.__v = null, e.__k = e.__k && e.__k.map(function(o) {
    return xc(o, t, n);
  }), e.__c && e.__c.__P === t && (e.__e && n.appendChild(e.__e), e.__c.__e = true, e.__c.__P = n)), e;
}
function Sr() {
  this.__u = 0, this.t = null, this.__b = null;
}
function Oc(e) {
  var t = e.__.__c;
  return t && t.__a && t.__a(e);
}
function no() {
  this.u = null, this.o = null;
}
B.unmount = function(e) {
  var t = e.__c;
  t && t.__R && t.__R(), t && 32 & e.__u && (e.type = null), na && na(e);
}, (Sr.prototype = new dt()).__c = function(e, t) {
  var n = t.__c, o = this;
  o.t == null && (o.t = []), o.t.push(n);
  var r = Oc(o.__v), i = false, s = function() {
    i || (i = true, n.__R = null, r ? r(a) : a());
  };
  n.__R = s;
  var a = function() {
    if (!--o.__u) {
      if (o.state.__a) {
        var c = o.state.__a;
        o.__v.__k[0] = xc(c, c.__c.__P, c.__c.__O);
      }
      var l;
      for (o.setState({ __a: o.__b = null }); l = o.t.pop(); )
        l.forceUpdate();
    }
  };
  o.__u++ || 32 & t.__u || o.setState({ __a: o.__b = o.__v.__k[0] }), e.then(s, s);
}, Sr.prototype.componentWillUnmount = function() {
  this.t = [];
}, Sr.prototype.render = function(e, t) {
  if (this.__b) {
    if (this.__v.__k) {
      var n = document.createElement("div"), o = this.__v.__k[0].__c;
      this.__v.__k[0] = Ac(this.__b, n, o.__O = o.__P);
    }
    this.__b = null;
  }
  var r = t.__a && d(ke, null, e.fallback);
  return r && (r.__u &= -33), [d(ke, null, t.__a ? null : e.children), r];
};
var oa = function(e, t, n) {
  if (++n[1] === n[0] && e.o.delete(t), e.props.revealOrder && (e.props.revealOrder[0] !== "t" || !e.o.size))
    for (n = e.u; n; ) {
      for (; n.length > 3; )
        n.pop()();
      if (n[1] < n[0])
        break;
      e.u = n = n[2];
    }
};
function fp(e) {
  return this.getChildContext = function() {
    return e.context;
  }, e.children;
}
function pp(e) {
  var t = this, n = e.i;
  t.componentWillUnmount = function() {
    go(null, t.l), t.l = null, t.i = null;
  }, t.i && t.i !== n && t.componentWillUnmount(), t.l || (t.i = n, t.l = { nodeType: 1, parentNode: n, childNodes: [], appendChild: function(o) {
    this.childNodes.push(o), t.i.appendChild(o);
  }, insertBefore: function(o, r) {
    this.childNodes.push(o), t.i.appendChild(o);
  }, removeChild: function(o) {
    this.childNodes.splice(this.childNodes.indexOf(o) >>> 1, 1), t.i.removeChild(o);
  } }), go(d(fp, { context: t.context }, e.__v), t.l);
}
function Ai(e, t) {
  var n = d(pp, { __v: e, i: t });
  return n.containerInfo = t, n;
}
(no.prototype = new dt()).__a = function(e) {
  var t = this, n = Oc(t.__v), o = t.o.get(e);
  return o[0]++, function(r) {
    var i = function() {
      t.props.revealOrder ? (o.push(r), oa(t, e, o)) : r();
    };
    n ? n(i) : i();
  };
}, no.prototype.render = function(e) {
  this.u = null, this.o = /* @__PURE__ */ new Map();
  var t = Nn(e.children);
  e.revealOrder && e.revealOrder[0] === "b" && t.reverse();
  for (var n = t.length; n--; )
    this.o.set(t[n], this.u = [1, 0, this.u]);
  return e.children;
}, no.prototype.componentDidUpdate = no.prototype.componentDidMount = function() {
  var e = this;
  this.o.forEach(function(t, n) {
    oa(e, n, t);
  });
};
var hp = typeof Symbol != "undefined" && Symbol.for && Symbol.for("react.element") || 60103, mp = /^(?:accent|alignment|arabic|baseline|cap|clip(?!PathU)|color|dominant|fill|flood|font|glyph(?!R)|horiz|image(!S)|letter|lighting|marker(?!H|W|U)|overline|paint|pointer|shape|stop|strikethrough|stroke|text(?!L)|transform|underline|unicode|units|v|vector|vert|word|writing|x(?!C))[A-Z]/, gp = /^on(Ani|Tra|Tou|BeforeInp|Compo)/, _p = /[A-Z0-9]/g, vp = typeof document != "undefined", yp = function(e) {
  return (typeof Symbol != "undefined" && typeof Symbol() == "symbol" ? /fil|che|rad/ : /fil|che|ra/).test(e);
};
dt.prototype.isReactComponent = {}, ["componentWillMount", "componentWillReceiveProps", "componentWillUpdate"].forEach(function(e) {
  Object.defineProperty(dt.prototype, e, { configurable: true, get: function() {
    return this["UNSAFE_" + e];
  }, set: function(t) {
    Object.defineProperty(this, e, { configurable: true, writable: true, value: t });
  } });
});
var ra = B.event;
function wp() {
}
function Ep() {
  return this.cancelBubble;
}
function Dp() {
  return this.defaultPrevented;
}
B.event = function(e) {
  return ra && (e = ra(e)), e.persist = wp, e.isPropagationStopped = Ep, e.isDefaultPrevented = Dp, e.nativeEvent = e;
};
var Sp = { enumerable: false, configurable: true, get: function() {
  return this.class;
} }, ia = B.vnode;
B.vnode = function(e) {
  typeof e.type == "string" && function(t) {
    var n = t.props, o = t.type, r = {};
    for (var i in n) {
      var s = n[i];
      if (!(i === "value" && "defaultValue" in n && s == null || vp && i === "children" && o === "noscript" || i === "class" || i === "className")) {
        var a = i.toLowerCase();
        i === "defaultValue" && "value" in n && n.value == null ? i = "value" : i === "download" && s === true ? s = "" : a === "translate" && s === "no" ? s = false : a === "ondoubleclick" ? i = "ondblclick" : a !== "onchange" || o !== "input" && o !== "textarea" || yp(n.type) ? a === "onfocus" ? i = "onfocusin" : a === "onblur" ? i = "onfocusout" : gp.test(i) ? i = a : o.indexOf("-") === -1 && mp.test(i) ? i = i.replace(_p, "-$&").toLowerCase() : s === null && (s = void 0) : a = i = "oninput", a === "oninput" && r[i = a] && (i = "oninputCapture"), r[i] = s;
      }
    }
    o == "select" && r.multiple && Array.isArray(r.value) && (r.value = Nn(n.children).forEach(function(c) {
      c.props.selected = r.value.indexOf(c.props.value) != -1;
    })), o == "select" && r.defaultValue != null && (r.value = Nn(n.children).forEach(function(c) {
      c.props.selected = r.multiple ? r.defaultValue.indexOf(c.props.value) != -1 : r.defaultValue == c.props.value;
    })), n.class && !n.className ? (r.class = n.class, Object.defineProperty(r, "className", Sp)) : (n.className && !n.class || n.class && n.className) && (r.class = r.className = n.className), t.props = r;
  }(e), e.$$typeof = hp, ia && ia(e);
};
var sa = B.__r;
B.__r = function(e) {
  sa && sa(e), e.__c;
};
var aa = B.diffed;
B.diffed = function(e) {
  aa && aa(e);
  var t = e.props, n = e.__e;
  n != null && e.type === "textarea" && "value" in t && t.value !== n.value && (n.value = t.value == null ? "" : t.value);
};
function Tp(e) {
  return !!e.__k && (go(null, e), true);
}
function bp({ index: e, exceedCount: t, isClicked: n, onClickExceedCount: o }) {
  const r = () => o(e), i = { display: n ? "none" : "" };
  return t && !n ? /* @__PURE__ */ d("span", {
    className: y("weekday-exceed-in-week"),
    onClick: r,
    style: i
  }, /* @__PURE__ */ d(te, {
    template: "weekGridFooterExceed",
    param: t
  })) : null;
}
function Cp({ isClicked: e, isClickedIndex: t, onClickCollapseButton: n }) {
  return e && t ? /* @__PURE__ */ d("span", {
    className: y("weekday-exceed-in-week"),
    onClick: n
  }, /* @__PURE__ */ d(te, {
    template: "collapseBtnTitle"
  })) : null;
}
function kp({
  width: e,
  left: t,
  index: n,
  exceedCount: o,
  isClicked: r,
  onClickExceedCount: i,
  isClickedIndex: s,
  onClickCollapseButton: a,
  isLastCell: c
}) {
  const { borderRight: l, backgroundColor: f } = re(Q((p) => p.week.dayGrid, [])), u = {
    width: e,
    left: t,
    borderRight: c ? "none" : l,
    backgroundColor: f
  };
  return /* @__PURE__ */ d("div", {
    className: y("panel-grid"),
    style: u
  }, /* @__PURE__ */ d(bp, {
    index: n,
    exceedCount: o,
    isClicked: r,
    onClickExceedCount: i
  }), /* @__PURE__ */ d(Cp, {
    isClickedIndex: s,
    isClicked: r,
    onClickCollapseButton: a
  }));
}
const Rc = ln(function({
  uiModels: t,
  weekDates: n,
  narrowWeekend: o,
  height: r,
  clickedIndex: i,
  isClickedCount: s,
  onClickExceedCount: a,
  onClickCollapseButton: c
}) {
  const { widthList: f, leftList: u } = ki(
    n,
    o,
    bi
  ), p = n.length - 1;
  return /* @__PURE__ */ d(ke, null, n.map((h, m) => {
    const w = q(f[m]), v = q(u[m]), _ = t.filter(Xf(h)), E = Dc(_, r, it + 2), S = m === i, b = m === p;
    return /* @__PURE__ */ d(kp, {
      key: `panel-grid-${h.getDate()}`,
      width: w,
      left: v,
      index: m,
      exceedCount: E,
      isClicked: s,
      onClickExceedCount: a,
      isClickedIndex: S,
      onClickCollapseButton: c,
      isLastCell: b
    });
  }));
});
function Np({ onMouseDown: e }) {
  return /* @__PURE__ */ d("span", {
    className: `${y("weekday-resize-handle")} ${y("handle-y")}`,
    onMouseDown: e,
    "data-testid": "horizontal-event-resize-icon"
  }, /* @__PURE__ */ d("i", {
    className: `${y("icon")} ${y("ic-handle-y")}`
  }));
}
const Pc = xo(null), Ip = Pc.Provider, Ht = () => {
  const e = Mn(Pc);
  if (Fe(e))
    throw new Error("LayoutContainerProvider is not found");
  return e;
}, Mp = {
  panelResizer: "panelResizer"
}, Rn = {
  resizeEvent: (e, t) => `event/${e}/resize/${t}`,
  moveEvent: (e, t) => `event/${e}/move/${t}`,
  gridSelection: (e) => `gridSelection/${e}`
};
function Lc(e) {
  return W(
    Q(
      (t) => t.calendar.calendars.find((n) => n.id === e),
      [e]
    )
  );
}
function xi(e) {
  var n;
  const t = Lc((n = e == null ? void 0 : e.calendarId) != null ? n : null);
  return Y(
    () => ({
      color: t == null ? void 0 : t.color,
      borderColor: t == null ? void 0 : t.borderColor,
      backgroundColor: t == null ? void 0 : t.backgroundColor,
      dragBackgroundColor: t == null ? void 0 : t.dragBackgroundColor
    }),
    [t]
  );
}
var $c = /* @__PURE__ */ ((e) => (e.ESCAPE = "Escape", e))($c || {});
const Ap = {
  Escape: 27
}, ca = 3;
function wt(e, t) {
  const n = ic(), o = ee(e), r = ee(t);
  oe(() => {
    o.current = e, r.current = t;
  }, [e, t]), oe(
    () => n.subscribe(
      (i) => r.current(i),
      (i) => o.current(i)
    ),
    [e, n]
  );
}
function xp(e, t) {
  return e.key ? e.key === t : e.keyCode === Ap[t];
}
function Op(e) {
  return e === 0;
}
function Rp(e, t, n, o) {
  return Math.abs(e - n) >= ca || Math.abs(t - o) >= ca;
}
function tn(e, { onInit: t, onDragStart: n, onDrag: o, onMouseUp: r, onPressESCKey: i } = {}) {
  const { initDrag: s, setDragging: a, cancelDrag: c, reset: l } = Se("dnd"), f = ic(), u = ee(f.getState().dnd);
  wt($t, (D) => {
    u.current = D;
  });
  const [p, h] = se(false), m = ee(null), w = ee(null), v = ee(null), _ = Q(
    (D) => {
      !Op(D.button) || (D.currentTarget && (D.currentTarget.ondragstart = function() {
        return false;
      }), D.preventDefault(), h(true), s({
        draggingItemType: e,
        initX: D.clientX,
        initY: D.clientY
      }), t == null || t(D, u.current));
    },
    [t, e, s]
  ), E = Q(
    (D) => {
      const {
        initX: A,
        initY: T,
        draggingState: k,
        draggingItemType: M
      } = u.current;
      if (M !== e) {
        h(false), l();
        return;
      }
      if (!($(A) && $(T) && !Rp(A, T, D.clientX, D.clientY))) {
        if (k <= Ze.INIT) {
          a({ x: D.clientX, y: D.clientY }), n == null || n(D, u.current);
          return;
        }
        a({ x: D.clientX, y: D.clientY }), o == null || o(D, u.current);
      }
    },
    [e, o, n, a, l]
  ), S = Q(
    (D) => {
      D.stopPropagation(), p && (r == null || r(D, u.current), h(false), l());
    },
    [p, r, l]
  ), b = Q(
    (D) => {
      xp(D, $c.ESCAPE) && (h(false), c(), i == null || i(D, u.current));
    },
    [i, c]
  );
  return oe(() => {
    m.current = E, w.current = S, v.current = b;
  }, [b, E, S]), oe(() => {
    const D = (k) => {
      var M;
      return (M = m.current) == null ? void 0 : M.call(m, k);
    }, A = (k) => {
      var M;
      return (M = w.current) == null ? void 0 : M.call(w, k);
    }, T = (k) => {
      var M;
      return (M = v.current) == null ? void 0 : M.call(v, k);
    };
    return p ? (document.addEventListener("mousemove", D), document.addEventListener("mouseup", A), document.addEventListener("keydown", T), () => {
      document.removeEventListener("mousemove", D), document.removeEventListener("mouseup", A), document.removeEventListener("keydown", T);
    }) : an;
  }, [p, l]), _;
}
function Oi(e, t) {
  return e ? t : void 0;
}
function Hc(e) {
  return {
    vertical: e ? 5 : 2,
    horizontal: 8
  };
}
function Pp(e, t) {
  const n = e ? 0 : "2px", o = t ? 0 : "2px";
  return `${n} ${o} ${o} ${n}`;
}
function Lp({
  uiModel: e,
  flat: t,
  eventHeight: n,
  isDraggingTarget: o,
  calendarColor: r
}) {
  const { exceedLeft: i, exceedRight: s } = e, { color: a, backgroundColor: c, dragBackgroundColor: l, borderColor: f } = za(
    e,
    r
  ), u = {
    color: a,
    backgroundColor: o ? l : c,
    borderLeft: i ? "none" : `3px solid ${f}`,
    borderRadius: Pp(i, s),
    overflow: "hidden",
    height: n,
    lineHeight: Eo(n),
    opacity: o ? 0.5 : 1
  }, p = Hc(t);
  return L(t ? {
    marginTop: p.vertical
  } : {
    marginLeft: i ? 0 : p.horizontal,
    marginRight: s ? 0 : p.horizontal
  }, u);
}
function $p({
  flat: e,
  uiModel: t,
  resizingWidth: n,
  movingLeft: o,
  eventHeight: r,
  headerHeight: i
}) {
  const { top: s, left: a, width: c, model: l } = t, f = Hc(e), u = e ? {} : {
    width: n || q(c),
    left: q(o != null ? o : a),
    top: (s - 1) * (r + f.vertical) + i,
    position: "absolute"
  };
  return Object.assign(u, l.customStyle);
}
function Hp({ model: e }) {
  const t = e.calendarId ? `${e.calendarId}-` : "", n = e.id ? `${e.id}-` : "";
  return `${t}${n}${e.title}`;
}
const lt = {
  eventBody: y("weekday-event"),
  eventTitle: y("weekday-event-title"),
  eventDot: y("weekday-event-dot"),
  moveEvent: y("dragging--move-event"),
  resizeEvent: y("dragging--resize-horizontal-event")
};
function Dt({
  flat: e = false,
  uiModel: t,
  eventHeight: n,
  headerHeight: o,
  resizingWidth: r = null,
  movingLeft: i = null
}) {
  const { currentView: s } = W(cn), { useDetailPopup: a, isReadOnly: c } = W(Je), { setDraggingEventUIModel: l } = Se("dnd"), { showDetailPopup: f } = Se("popup"), u = Ht(), p = Me(), h = xi(t.model), [m, w] = se(false), v = ee(null), { isReadOnly: _, id: E, calendarId: S } = t.model, b = $(r) || $(i), D = !c && !_ && !b, A = (R) => {
    l(t), u == null || u.classList.add(R);
  }, T = (R) => {
    w(false), u == null || u.classList.remove(R);
  };
  wt($t, ({ draggingEventUIModel: R, draggingState: ae }) => {
    ae === Ze.DRAGGING && (R == null ? void 0 : R.cid()) === t.cid() && !b ? w(true) : w(false);
  }), oe(() => {
    b || p.fire("afterRenderEvent", t.model.toEventObject());
  }, []);
  const k = tn(Rn.resizeEvent("dayGrid", `${t.cid()}`), {
    onDragStart: () => A(lt.resizeEvent),
    onMouseUp: () => T(lt.resizeEvent),
    onPressESCKey: () => T(lt.resizeEvent)
  }), M = tn(Rn.moveEvent("dayGrid", `${t.cid()}`), {
    onDragStart: () => {
      D && A(lt.moveEvent);
    },
    onMouseUp: (R, { draggingState: ae }) => {
      T(lt.moveEvent);
      const ie = ae <= Ze.INIT;
      ie && a && v.current && f(
        {
          event: t.model,
          eventRect: v.current.getBoundingClientRect()
        },
        e
      ), ie && p.fire("clickEvent", { event: t.model.toEventObject(), nativeEvent: R });
    },
    onPressESCKey: () => T(lt.moveEvent)
  }), N = (R) => {
    R.stopPropagation(), D && k(R);
  }, H = (R) => {
    R.stopPropagation(), M(R);
  }, G = !m && s === "month" && t.model.category === "time" && Rt(t.model.start, t.model.end), j = !D || e || m || t.exceedRight, I = $p({
    uiModel: t,
    eventHeight: n,
    headerHeight: o,
    flat: e,
    movingLeft: i,
    resizingWidth: r
  }), z = Lp({
    uiModel: t,
    flat: e,
    eventHeight: n,
    isDraggingTarget: m,
    calendarColor: h
  });
  return /* @__PURE__ */ d("div", {
    className: y("weekday-event-block", {
      "weekday-exceed-left": t.exceedLeft,
      "weekday-exceed-right": t.exceedRight
    }),
    style: I,
    "data-testid": Oi(D, Hp(t)),
    "data-calendar-id": S,
    "data-event-id": E,
    ref: v
  }, /* @__PURE__ */ d("div", {
    className: lt.eventBody,
    style: ce(L({}, z), {
      backgroundColor: G ? null : z.backgroundColor,
      borderLeft: G ? null : z.borderLeft
    }),
    onMouseDown: H
  }, G ? /* @__PURE__ */ d("span", {
    className: lt.eventDot,
    style: { backgroundColor: z.backgroundColor }
  }) : null, /* @__PURE__ */ d("span", {
    className: lt.eventTitle
  }, /* @__PURE__ */ d(te, {
    template: t.model.category,
    param: t.model
  })), j ? null : /* @__PURE__ */ d(Np, {
    onMouseDown: N
  })));
}
function un(e, t) {
  const n = ee(e);
  oe(() => {
    n.current = e;
  }, [e]), oe(() => {
    t && (() => n.current())();
  }, [t]);
}
function dn(e) {
  const [t, n] = se(null);
  wt($t, (r) => {
    if ($(r.x) && $(r.y)) {
      const i = e({
        clientX: r.x,
        clientY: r.y
      });
      i && n(i);
    }
  });
  const o = Q(() => n(null), []);
  return [t, o];
}
const Fp = (e, t, n) => {
  function o(r) {
    return new RegExp(`^event/${t}/${n}/\\d+$`).test(r);
  }
  return V(e) ? null : o(e) ? ft(e.split("/")) : null;
};
function fn(e, t) {
  const [n, o] = se(false), [r, i] = se(false), [s, a] = se(null);
  return wt($t, ({ draggingItemType: l, draggingEventUIModel: f, draggingState: u }) => {
    const p = Fp(l, e, t), h = Number(p) === (f == null ? void 0 : f.cid()), m = u === Ze.IDLE, w = u === Ze.CANCELED;
    V(s) && h && a(f), $(s) && (m || w) && (o(true), i(w));
  }), {
    isDraggingEnd: n,
    isDraggingCanceled: r,
    draggingEvent: s,
    clearDraggingEvent: () => {
      a(null), o(false), i(false);
    }
  };
}
function Gp({ rowStyleInfo: e, gridPositionFinder: t }) {
  const n = Me(), {
    isDraggingEnd: o,
    isDraggingCanceled: r,
    draggingEvent: i,
    clearDraggingEvent: s
  } = fn("dayGrid", "move"), a = ee(null), [c, l] = dn(t), { columnIndex: f } = c != null ? c : {}, u = Y(
    () => V(i) ? null : e.findIndex(({ left: h }) => h === i.left),
    [e, i]
  ), p = Y(() => {
    if (V(f) || V(a.current) || V(u))
      return null;
    const h = u + f - a.current;
    return h < 0 ? -e[-h].left : e[h].left;
  }, [f, e, u]);
  return oe(() => {
    V(a.current) && $(f) && (a.current = f);
  }, [f]), un(() => {
    if (!r && $(i) && $(f) && $(p) && f !== a.current && $(a.current)) {
      const m = f - a.current, w = new F(i.model.getStarts()), v = new F(i.model.getEnds());
      w.addDate(m), v.addDate(m), n.fire("beforeUpdateEvent", {
        event: i.model.toEventObject(),
        changes: {
          start: w,
          end: v
        }
      });
    }
    s(), l(), a.current = null;
  }, o), Y(
    () => ({
      movingEvent: i,
      movingLeft: p
    }),
    [p, i]
  );
}
function Bp({
  rowStyleInfo: e,
  gridPositionFinder: t
}) {
  const { movingEvent: n, movingLeft: o } = Gp({
    rowStyleInfo: e,
    gridPositionFinder: t
  });
  return V(n) ? null : /* @__PURE__ */ d(Dt, {
    uiModel: n,
    eventHeight: it,
    headerHeight: 0,
    movingLeft: o
  });
}
function zp(e, t) {
  const n = Co(e.getStarts(), t), o = Co(e.getEnds(), t);
  return { start: n, end: o };
}
function Up({
  weekDates: e,
  gridColWidthMap: t,
  gridPositionFinder: n
}) {
  const o = Me(), {
    isDraggingEnd: r,
    isDraggingCanceled: i,
    draggingEvent: s,
    clearDraggingEvent: a
  } = fn("dayGrid", "resize"), [c, l] = dn(n), { columnIndex: f } = c != null ? c : {}, u = Y(() => s ? zp(s, e) : { start: -1, end: -1 }, [e, s]), p = Y(() => u.start > -1 && $(f) ? t[u.start][f] : null, [f, t, u.start]);
  return un(() => {
    if (!i && $(s) && $(f) && u.start <= f && u.end !== f) {
      const m = e[f];
      o.fire("beforeUpdateEvent", {
        event: s.model.toEventObject(),
        changes: { end: m }
      });
    }
    l(), a();
  }, r), Y(
    () => ({
      resizingEvent: s,
      resizingWidth: p
    }),
    [p, s]
  );
}
function Wp({ weekDates: e, gridColWidthMap: t, gridPositionFinder: n }) {
  const { resizingEvent: o, resizingWidth: r } = Up({
    weekDates: e,
    gridColWidthMap: t,
    gridPositionFinder: n
  });
  return V(o) ? null : /* @__PURE__ */ d(Dt, {
    uiModel: o,
    eventHeight: it,
    headerHeight: 0,
    resizingWidth: r
  });
}
function Be() {
  const [e, t] = se(null), n = Q((o) => {
    o && t(o);
  }, []);
  return [e, n];
}
function Fc(e, t) {
  const [n, o] = se(0), [r, i] = se(false), { updateDayGridRowHeight: s } = Se("weekViewLayout"), a = Q(
    (l) => {
      i(true), o(l), s({
        rowName: t,
        height: (e + 1) * it
      });
    },
    [t, e, s]
  ), c = Q(() => {
    i(false), s({
      rowName: t,
      height: Qt
    });
  }, [t, s]);
  return {
    clickedIndex: n,
    isClickedCount: r,
    onClickExceedCount: a,
    onClickCollapseButton: c
  };
}
function Yp(e, t, n) {
  let o;
  const r = (s) => {
    if (o || (o = s), s - o >= t) {
      e(), n(an);
      return;
    }
    const c = requestAnimationFrame(r);
    n(() => cancelAnimationFrame(c));
  }, i = requestAnimationFrame(r);
  n(() => cancelAnimationFrame(i));
}
function Vp({
  onClick: e,
  onDblClick: t,
  delay: n = 300
}) {
  const o = ee(an), r = (c) => {
    o.current = c;
  }, i = () => {
    o.current();
  };
  return oe(() => i, []), [(c) => {
    i(), Yp(e.bind(null, c), n, r);
  }, (c) => {
    i(), t(c);
  }];
}
const jp = {
  dayGridMonth: "month",
  dayGridWeek: "allday",
  timeGrid: "time"
};
function Xp(e, t) {
  return e < t ? [e, t] : [t, e];
}
function Ri({
  type: e,
  selectionSorter: t,
  dateGetter: n,
  dateCollection: o,
  gridPositionFinder: r
}) {
  const { useFormPopup: i, gridSelection: s } = W(Je), { enableDblClick: a, enableClick: c } = s, { setGridSelection: l, addGridSelection: f, clearAll: u } = Se("gridSelection"), { hideAllPopup: p, showFormPopup: h } = Se("popup"), m = Me(), w = Ht(), [v, _] = se(null), [E, S] = se(null), b = ee(false), D = ee(null);
  wt(
    Q((I) => I.gridSelection[e], [e]),
    (I) => {
      D.current = I;
    }
  ), wt($t, ({ draggingState: I, draggingItemType: z }) => {
    b.current = z === A && I >= Ze.INIT;
  });
  const A = Rn.gridSelection(e), T = (I) => {
    const z = r(I);
    $(E) && $(z) && l(e, t(E, z));
  }, [k, M] = Vp({
    onClick: (I) => {
      c && H(I, true);
    },
    onDblClick: (I) => {
      a && H(I, true);
    },
    delay: 250
  }), N = (I) => {
    const z = I.detail <= 1;
    if (!(!c && (!a || z))) {
      if (c) {
        z ? k(I) : M(I);
        return;
      }
      H(I, true);
    }
  }, H = (I, z) => {
    var R;
    if (z && T(I), $(D.current)) {
      const [ae, ie] = Xp(
        ...n(o, D.current)
      );
      if (i && $(v)) {
        const he = {
          top: (I.clientY + v.y) / 2,
          left: (I.clientX + v.x) / 2
        };
        h({
          isCreationPopup: true,
          title: "",
          location: "",
          start: ae,
          end: ie,
          isAllday: e !== "timeGrid",
          isPrivate: false,
          popupArrowPointPosition: he,
          close: u
        });
      }
      const Ue = `.${y(jp[e])}.${y(
        "grid-selection"
      )}`, X = Array.from(
        (R = w == null ? void 0 : w.querySelectorAll(Ue)) != null ? R : []
      );
      m.fire("selectDateTime", {
        start: ae.toDate(),
        end: ie.toDate(),
        isAllday: e !== "timeGrid",
        nativeEvent: I,
        gridSelectionElements: X
      });
    }
  }, G = Q(() => {
    _(null), S(null), l(e, null);
  }, [l, e]), j = tn(A, {
    onInit: (I) => {
      i && (_({
        x: I.clientX,
        y: I.clientY
      }), p());
      const z = r(I);
      $(z) && S(z), i || f(e, D.current);
    },
    onDragStart: (I) => {
      T(I);
    },
    onDrag: (I) => {
      b.current && T(I);
    },
    onMouseUp: (I, { draggingState: z }) => {
      I.stopPropagation();
      const R = z <= Ze.INIT;
      R ? N(I) : H(I, R);
    },
    onPressESCKey: G
  });
  return oe(() => G, [G]), j;
}
const Kp = "alldayTitle";
function Gc({
  events: e,
  weekDates: t,
  height: n = Qt,
  options: o = {},
  rowStyleInfo: r,
  gridColWidthMap: i
}) {
  const { isReadOnly: s } = W(Je), a = re(dc), [c, l] = Be(), { narrowWeekend: f = false, startDayOfWeek: u = rn.SUN } = o, p = Y(() => Math.max(0, ...e.map(({ top: D }) => D)), [e]), h = Y(
    () => Ni({
      container: c,
      rowsCount: 1,
      columnsCount: t.length,
      narrowWeekend: f,
      startDayOfWeek: u
    }),
    [c, t.length, f, u]
  ), { clickedIndex: m, isClickedCount: w, onClickExceedCount: v, onClickCollapseButton: _ } = Fc(p, "allday"), E = Y(
    () => e.filter(Ci(n, it + Ba)).map((D) => /* @__PURE__ */ d(Dt, {
      key: `allday-DayEvent-${D.cid()}`,
      uiModel: D,
      eventHeight: it,
      headerHeight: 0
    })),
    [e, n]
  ), S = Ri({
    type: "dayGridWeek",
    gridPositionFinder: h,
    dateCollection: t,
    selectionSorter: jr.sortSelection,
    dateGetter: jr.getDateFromCollection
  }), b = (D) => {
    const A = D.target;
    s || !A.classList.contains(y("panel-grid")) || S(D);
  };
  return /* @__PURE__ */ d(ke, null, /* @__PURE__ */ d("div", {
    className: y("panel-title"),
    style: a
  }, /* @__PURE__ */ d(te, {
    template: Kp,
    param: "alldayTitle"
  })), /* @__PURE__ */ d("div", {
    className: y("allday-panel"),
    ref: l,
    onMouseDown: b
  }, /* @__PURE__ */ d("div", {
    className: y("panel-grid-wrapper")
  }, /* @__PURE__ */ d(Rc, {
    uiModels: e,
    weekDates: t,
    narrowWeekend: f,
    height: n,
    clickedIndex: m,
    isClickedCount: w,
    onClickExceedCount: v,
    onClickCollapseButton: _
  })), /* @__PURE__ */ d("div", {
    className: y("panel-allday-events")
  }, E), /* @__PURE__ */ d(Wp, {
    weekDates: t,
    gridPositionFinder: h,
    gridColWidthMap: i
  }), /* @__PURE__ */ d(Bp, {
    rowStyleInfo: r,
    gridPositionFinder: h
  }), /* @__PURE__ */ d(lp, {
    weekDates: t,
    narrowWeekend: f
  })));
}
function Bc({
  events: e,
  weekDates: t,
  category: n,
  height: o = Qt,
  options: r = {}
}) {
  const i = re(dc), s = Y(() => Math.max(0, ...e.map(({ top: m }) => m)), [e]), { narrowWeekend: a = false } = r, c = `${n}Title`, { clickedIndex: l, isClickedCount: f, onClickExceedCount: u, onClickCollapseButton: p } = Fc(s, n), h = Y(
    () => e.filter(Ci(o, it + Ba)).map((m) => /* @__PURE__ */ d(Dt, {
      key: `${n}-DayEvent-${m.cid()}`,
      uiModel: m,
      eventHeight: it,
      headerHeight: 0
    })),
    [n, e, o]
  );
  return /* @__PURE__ */ d(ke, null, /* @__PURE__ */ d("div", {
    className: y("panel-title"),
    style: i
  }, /* @__PURE__ */ d(te, {
    template: c,
    param: n
  })), /* @__PURE__ */ d("div", {
    className: y("allday-panel")
  }, /* @__PURE__ */ d("div", {
    className: y("panel-grid-wrapper")
  }, /* @__PURE__ */ d(Rc, {
    uiModels: e,
    weekDates: t,
    narrowWeekend: a,
    height: o,
    clickedIndex: l,
    isClickedCount: f,
    onClickExceedCount: u,
    onClickCollapseButton: p
  })), /* @__PURE__ */ d("div", {
    className: y(`panel-${n}-events`)
  }, h)));
}
const De = {
  detailItem: y("detail-item"),
  detailItemIndent: y("detail-item", "detail-item-indent"),
  detailItemSeparate: y("detail-item", "detail-item-separate"),
  sectionDetail: y("popup-section", "section-detail"),
  content: y("content"),
  locationIcon: y("icon", "ic-location-b"),
  repeatIcon: y("icon", "ic-repeat-b"),
  userIcon: y("icon", "ic-user-b"),
  stateIcon: y("icon", "ic-state-b"),
  calendarDotIcon: y("icon", "calendar-dot")
};
function qp({ event: e }) {
  var c, l;
  const { location: t, recurrenceRule: n, attendees: o, state: r, calendarId: i, body: s } = e, a = Lc(i);
  return /* @__PURE__ */ d("div", {
    className: De.sectionDetail
  }, t && /* @__PURE__ */ d("div", {
    className: De.detailItem
  }, /* @__PURE__ */ d("span", {
    className: De.locationIcon
  }), /* @__PURE__ */ d("span", {
    className: De.content
  }, /* @__PURE__ */ d(te, {
    template: "popupDetailLocation",
    param: e,
    as: "span"
  }))), n && /* @__PURE__ */ d("div", {
    className: De.detailItem
  }, /* @__PURE__ */ d("span", {
    className: De.repeatIcon
  }), /* @__PURE__ */ d("span", {
    className: De.content
  }, /* @__PURE__ */ d(te, {
    template: "popupDetailRecurrenceRule",
    param: e,
    as: "span"
  }))), o && /* @__PURE__ */ d("div", {
    className: De.detailItemIndent
  }, /* @__PURE__ */ d("span", {
    className: De.userIcon
  }), /* @__PURE__ */ d("span", {
    className: De.content
  }, /* @__PURE__ */ d(te, {
    template: "popupDetailAttendees",
    param: e,
    as: "span"
  }))), r && /* @__PURE__ */ d("div", {
    className: De.detailItem
  }, /* @__PURE__ */ d("span", {
    className: De.stateIcon
  }), /* @__PURE__ */ d("span", {
    className: De.content
  }, /* @__PURE__ */ d(te, {
    template: "popupDetailState",
    param: e,
    as: "span"
  }))), a && /* @__PURE__ */ d("div", {
    className: De.detailItem
  }, /* @__PURE__ */ d("span", {
    className: De.calendarDotIcon,
    style: {
      backgroundColor: (c = a == null ? void 0 : a.backgroundColor) != null ? c : ""
    }
  }), /* @__PURE__ */ d("span", {
    className: De.content
  }, (l = a == null ? void 0 : a.name) != null ? l : "")), s && /* @__PURE__ */ d("div", {
    className: De.detailItemSeparate
  }, /* @__PURE__ */ d("span", {
    className: De.content
  }, /* @__PURE__ */ d(te, {
    template: "popupDetailBody",
    param: e,
    as: "span"
  }))));
}
const Tr = {
  sectionHeader: y("popup-section", "section-header"),
  content: y("content"),
  eventTitle: y("event-title")
};
function Zp({ event: e }) {
  return /* @__PURE__ */ d("div", {
    className: Tr.sectionHeader
  }, /* @__PURE__ */ d("div", {
    className: Tr.eventTitle
  }, /* @__PURE__ */ d(te, {
    template: "popupDetailTitle",
    param: e,
    as: "span"
  })), /* @__PURE__ */ d("div", {
    className: Tr.content
  }, /* @__PURE__ */ d(te, {
    template: "popupDetailDate",
    param: e,
    as: "span"
  })));
}
const Jp = y("see-more-popup-slot"), Qp = y("event-form-popup-slot"), eh = y("event-detail-popup-slot"), Kr = 8, th = [
  "isPrivate",
  "isAllday",
  "isPending",
  "isFocused",
  "isVisible",
  "isReadOnly"
];
var jt = /* @__PURE__ */ ((e) => (e.right = "right", e.left = "left", e))(jt || {}), Xt = /* @__PURE__ */ ((e) => (e.top = "top", e.bottom = "bottom", e))(Xt || {});
const zc = xo(null);
function nh({ children: e }) {
  const [t, n] = Be(), [o, r] = Be(), [i, s] = Be(), [a, c] = Be(), l = {
    container: t,
    seeMorePopupSlot: o,
    formPopupSlot: i,
    detailPopupSlot: a
  };
  return /* @__PURE__ */ d(zc.Provider, {
    value: l
  }, e, /* @__PURE__ */ d("div", {
    ref: n,
    className: y("floating-layer")
  }, /* @__PURE__ */ d("div", {
    ref: r,
    className: Jp
  }), /* @__PURE__ */ d("div", {
    ref: s,
    className: Qp
  }), /* @__PURE__ */ d("div", {
    ref: c,
    className: eh
  })));
}
const Pi = (e) => {
  var n;
  const t = Mn(zc);
  if (Fe(t))
    throw new Error("FloatingLayerProvider is not found");
  return (n = t == null ? void 0 : t[e]) != null ? n : null;
};
function Uc(e, t, n) {
  return e + n.height > t.top + t.height;
}
function Wc(e, t, n) {
  return e + n.width > t.left + t.width;
}
const oh = (e) => e.popup[Ho.Form], rh = (e) => e.popup[Ho.Detail], ih = (e) => e.popup[Ho.SeeMore], Le = {
  popupContainer: y("popup-container"),
  detailContainer: y("detail-container"),
  topLine: y("popup-top-line"),
  border: y("popup-arrow-border"),
  fill: y("popup-arrow-fill"),
  sectionButton: y("popup-section", "section-button"),
  content: y("content"),
  editIcon: y("icon", "ic-edit"),
  deleteIcon: y("icon", "ic-delete"),
  editButton: y("edit-button"),
  deleteButton: y("delete-button"),
  verticalLine: y("vertical-line")
};
function sh(e, t, n) {
  let o = e.top + e.height / 2 - n.height / 2, r = e.left + e.width;
  return Uc(o, t, n) && (o = t.top + t.height - n.height), Wc(r, t, n) && (r = e.left - n.width), [
    Math.max(o, t.top) + window.scrollY,
    Math.max(r, t.left) + window.scrollX
  ];
}
function ah(e, t, n) {
  const o = e.top + e.height / 2 + window.scrollY, s = e.left + e.width + n.width > t.left + t.width ? jt.right : jt.left;
  return { top: o, direction: s };
}
function ch() {
  const { useFormPopup: e } = W(Je), t = W(rh), { event: n, eventRect: o } = t != null ? t : {}, { showFormPopup: r, hideDetailPopup: i } = Se("popup"), s = xi(n), a = Ht(), c = Pi("detailPopupSlot"), l = Me(), f = ee(null), [u, p] = se({}), [h, m] = se(0), [w, v] = se(
    jt.left
  ), _ = Y(() => {
    const j = w === jt.right, I = w === jt.left;
    return y("popup-arrow", { right: j, left: I });
  }, [w]);
  if (_t(() => {
    if (f.current && o && a) {
      const j = a.getBoundingClientRect(), I = f.current.getBoundingClientRect(), [z, R] = sh(o, j, I), { top: ae, direction: ie } = ah(
        o,
        j,
        I
      );
      p({ top: z, left: R }), m(ae - z - Kr), v(ie);
    }
  }, [o, a]), V(n) || V(o) || V(c))
    return null;
  const {
    title: E = "",
    isAllday: S = false,
    start: b = new F(),
    end: D = new F(),
    location: A,
    state: T,
    isReadOnly: k,
    isPrivate: M
  } = n, N = {
    top: o.top + o.height / 2,
    left: o.left + o.width / 2
  }, H = () => {
    e ? r({
      isCreationPopup: false,
      event: n,
      title: E,
      location: A,
      start: b,
      end: D,
      isAllday: S,
      isPrivate: M,
      eventState: T,
      popupArrowPointPosition: N
    }) : l.fire("beforeUpdateEvent", { event: n.toEventObject(), changes: {} });
  }, G = () => {
    l.fire("beforeDeleteEvent", n.toEventObject()), i();
  };
  return Ai(
    /* @__PURE__ */ d("div", {
      role: "dialog",
      className: Le.popupContainer,
      ref: f,
      style: u
    }, /* @__PURE__ */ d("div", {
      className: Le.detailContainer
    }, /* @__PURE__ */ d(Zp, {
      event: n
    }), /* @__PURE__ */ d(qp, {
      event: n
    }), !k && /* @__PURE__ */ d("div", {
      className: Le.sectionButton
    }, /* @__PURE__ */ d("button", {
      type: "button",
      className: Le.editButton,
      onClick: H
    }, /* @__PURE__ */ d("span", {
      className: Le.editIcon
    }), /* @__PURE__ */ d("span", {
      className: Le.content
    }, /* @__PURE__ */ d(te, {
      template: "popupEdit",
      as: "span"
    }))), /* @__PURE__ */ d("div", {
      className: Le.verticalLine
    }), /* @__PURE__ */ d("button", {
      type: "button",
      className: Le.deleteButton,
      onClick: G
    }, /* @__PURE__ */ d("span", {
      className: Le.deleteIcon
    }), /* @__PURE__ */ d("span", {
      className: Le.content
    }, /* @__PURE__ */ d(te, {
      template: "popupDelete",
      as: "span"
    }))))), /* @__PURE__ */ d("div", {
      className: Le.topLine,
      style: { backgroundColor: s.backgroundColor }
    }), /* @__PURE__ */ d("div", {
      className: _
    }, /* @__PURE__ */ d("div", {
      className: Le.border,
      style: { top: h }
    }, /* @__PURE__ */ d("div", {
      className: Le.fill
    })))),
    c
  );
}
const ho = {
  dropdownMenu: y("dropdown-menu"),
  dropdownMenuItem: y("dropdown-menu-item"),
  dotIcon: y("icon", "dot"),
  content: y("content")
};
function lh({ index: e, name: t, backgroundColor: n, onClick: o }) {
  return /* @__PURE__ */ d("li", {
    className: ho.dropdownMenuItem,
    onClick: (r) => o(r, e)
  }, /* @__PURE__ */ d("span", {
    className: ho.dotIcon,
    style: { backgroundColor: n }
  }), /* @__PURE__ */ d("span", {
    className: ho.content
  }, t));
}
function uh({ calendars: e, setOpened: t, onChangeIndex: n }) {
  const o = (r, i) => {
    r.stopPropagation(), t(false), n(i);
  };
  return /* @__PURE__ */ d("ul", {
    className: ho.dropdownMenu
  }, e.map(({ name: r, backgroundColor: i = "000" }, s) => /* @__PURE__ */ d(lh, {
    key: `dropdown-${r}-${s}`,
    index: s,
    name: r,
    backgroundColor: i,
    onClick: o
  })));
}
function Lt({
  children: e,
  classNames: t = [],
  onClick: n = an
}) {
  return /* @__PURE__ */ d("div", {
    className: y("popup-section", ...t),
    onClick: n
  }, e);
}
function Yc() {
  const [e, t] = se(false);
  return { isOpened: e, setOpened: t, toggleDropdown: () => t((o) => !o) };
}
var mt = /* @__PURE__ */ ((e) => (e.init = "init", e.setCalendarId = "setCalendarId", e.setTitle = "setTitle", e.setLocation = "setLocation", e.setPrivate = "setPrivate", e.setAllday = "setAllday", e.setState = "setState", e.reset = "reset", e))(mt || {});
const qr = {
  title: "",
  location: "",
  isAllday: false,
  isPrivate: false,
  state: "Busy"
};
function dh(e, t) {
  switch (t.type) {
    case "init":
      return L(L({}, qr), t.event);
    case "setCalendarId":
      return ce(L({}, e), { calendarId: t.calendarId });
    case "setTitle":
      return ce(L({}, e), { title: t.title });
    case "setLocation":
      return ce(L({}, e), { location: t.location });
    case "setPrivate":
      return ce(L({}, e), { isPrivate: t.isPrivate });
    case "setAllday":
      return ce(L({}, e), { isAllday: t.isAllday });
    case "setState":
      return ce(L({}, e), { state: t.state });
    case "reset":
      return L(L({}, e), qr);
    default:
      return e;
  }
}
function fh(e) {
  return oi(dh, L({ calendarId: e }, qr));
}
const oo = {
  popupSection: ["dropdown-section", "calendar-section"],
  popupSectionItem: y("popup-section-item", "popup-button"),
  dotIcon: y("icon", "dot"),
  content: y("content", "event-calendar")
};
function ph({ calendars: e, selectedCalendarId: t, formStateDispatch: n }) {
  const { isOpened: o, setOpened: r, toggleDropdown: i } = Yc(), s = e.find((f) => f.id === t), { backgroundColor: a = "", name: c = "" } = s != null ? s : {}, l = (f) => n({ type: mt.setCalendarId, calendarId: e[f].id });
  return /* @__PURE__ */ d(Lt, {
    onClick: i,
    classNames: oo.popupSection
  }, /* @__PURE__ */ d("button", {
    type: "button",
    className: oo.popupSectionItem
  }, /* @__PURE__ */ d("span", {
    className: oo.dotIcon,
    style: { backgroundColor: a }
  }), /* @__PURE__ */ d("span", {
    className: oo.content
  }, c), /* @__PURE__ */ d("span", {
    className: y("icon", "ic-dropdown-arrow", { open: o })
  })), o && /* @__PURE__ */ d(uh, {
    calendars: e,
    setOpened: r,
    onChangeIndex: l
  }));
}
const la = {
  closeButton: y("popup-button", "popup-close"),
  closeIcon: y("icon", "ic-close")
};
function Vc({ type: e, close: t }) {
  const { hideAllPopup: n } = Se("popup"), o = () => {
    n(), Tn(t) && t();
  };
  return /* @__PURE__ */ d("button", {
    type: "button",
    className: la.closeButton,
    onClick: o
  }, e === "moreEvents" ? /* @__PURE__ */ d(te, {
    template: "monthMoreClose"
  }) : /* @__PURE__ */ d("i", {
    className: la.closeIcon
  }));
}
const hh = {
  confirmButton: y("popup-button", "popup-confirm")
};
function mh({ children: e }) {
  return /* @__PURE__ */ d("button", {
    type: "submit",
    className: hh.confirmButton
  }, /* @__PURE__ */ d("span", null, e));
}
function No({
  template: e,
  model: t,
  defaultValue: n = ""
}) {
  const r = W(ac)[e];
  if (V(r))
    return n;
  let i = r(t);
  return Ie(i) || (i = n), i;
}
const Xe = {
  datePickerContainer: y("datepicker-container"),
  datePicker: y("popup-section-item", "popup-date-picker"),
  allday: y("popup-section-item", "popup-section-allday"),
  dateIcon: y("icon", "ic-date"),
  dateDash: y("popup-date-dash"),
  content: y("content")
}, gh = Mc(function({ start: t, end: n, isAllday: o = false, formStateDispatch: r }, i) {
  const { usageStatistics: s } = W(Je), a = ee(null), c = ee(null), l = ee(null), f = ee(null), u = No({
    template: "startDatePlaceholder",
    defaultValue: "Start Date"
  }), p = No({
    template: "endDatePlaceholder",
    defaultValue: "End Date"
  }), h = () => r({ type: mt.setAllday, isAllday: !o });
  return oe(() => {
    if (a.current && c.current && l.current && f.current) {
      const m = new F(t), w = new F(n);
      o && (m.setHours(12, 0, 0), w.setHours(13, 0, 0)), i.current = tu.createRangePicker({
        startpicker: {
          date: m.toDate(),
          input: c.current,
          container: a.current
        },
        endpicker: {
          date: w.toDate(),
          input: f.current,
          container: l.current
        },
        format: o ? "yyyy-MM-dd" : "yyyy-MM-dd HH:mm",
        timePicker: o ? false : {
          showMeridiem: false,
          usageStatistics: s
        },
        usageStatistics: s
      });
    }
  }, [t, n, o, s, i]), /* @__PURE__ */ d(Lt, null, /* @__PURE__ */ d("div", {
    className: Xe.datePicker
  }, /* @__PURE__ */ d("span", {
    className: Xe.dateIcon
  }), /* @__PURE__ */ d("input", {
    name: "start",
    className: Xe.content,
    placeholder: u,
    ref: c
  }), /* @__PURE__ */ d("div", {
    className: Xe.datePickerContainer,
    ref: a
  })), /* @__PURE__ */ d("span", {
    className: Xe.dateDash
  }, "-"), /* @__PURE__ */ d("div", {
    className: Xe.datePicker
  }, /* @__PURE__ */ d("span", {
    className: Xe.dateIcon
  }), /* @__PURE__ */ d("input", {
    name: "end",
    className: Xe.content,
    placeholder: p,
    ref: f
  }), /* @__PURE__ */ d("div", {
    className: Xe.datePickerContainer,
    ref: l
  })), /* @__PURE__ */ d("div", {
    className: Xe.allday,
    onClick: h
  }, /* @__PURE__ */ d("span", {
    className: y("icon", {
      "ic-checkbox-normal": !o,
      "ic-checkbox-checked": o
    })
  }), /* @__PURE__ */ d("span", {
    className: Xe.content
  }, /* @__PURE__ */ d(te, {
    template: "popupIsAllday"
  })), /* @__PURE__ */ d("input", {
    name: "isAllday",
    type: "checkbox",
    className: y("hidden-input"),
    value: o ? "true" : "false",
    checked: o
  })));
}), _h = ["Busy", "Free"], ro = {
  popupSectionItem: y("popup-section-item", "dropdown-menu-item"),
  dropdownMenu: y("dropdown-menu"),
  icon: y("icon"),
  content: y("content")
};
function vh({ setOpened: e, setEventState: t }) {
  const n = (o, r) => {
    o.stopPropagation(), e(false), t(r);
  };
  return /* @__PURE__ */ d("ul", {
    className: ro.dropdownMenu
  }, _h.map((o) => /* @__PURE__ */ d("li", {
    key: o,
    className: ro.popupSectionItem,
    onClick: (r) => n(r, o)
  }, /* @__PURE__ */ d("span", {
    className: ro.icon
  }), /* @__PURE__ */ d("span", {
    className: ro.content
  }, o === "Busy" ? /* @__PURE__ */ d(te, {
    template: "popupStateBusy"
  }) : /* @__PURE__ */ d(te, {
    template: "popupStateFree"
  })))));
}
const vn = {
  popupSection: ["dropdown-section", "state-section"],
  popupSectionItem: y("popup-section-item", "popup-button"),
  stateIcon: y("icon", "ic-state"),
  arrowIcon: y("icon", "ic-dropdown-arrow"),
  content: y("content", "event-state")
};
function yh({ eventState: e = "Busy", formStateDispatch: t }) {
  const { isOpened: n, setOpened: o, toggleDropdown: r } = Yc(), i = (s) => t({ type: mt.setState, state: s });
  return /* @__PURE__ */ d(Lt, {
    onClick: r,
    classNames: vn.popupSection
  }, /* @__PURE__ */ d("button", {
    type: "button",
    className: vn.popupSectionItem
  }, /* @__PURE__ */ d("span", {
    className: vn.stateIcon
  }), /* @__PURE__ */ d("span", {
    className: vn.content
  }, e === "Busy" ? /* @__PURE__ */ d(te, {
    template: "popupStateBusy"
  }) : /* @__PURE__ */ d(te, {
    template: "popupStateFree"
  })), /* @__PURE__ */ d("span", {
    className: vn.arrowIcon
  })), n && /* @__PURE__ */ d(vh, {
    setOpened: o,
    setEventState: i
  }));
}
const br = {
  popupSectionItem: y("popup-section-item", "popup-section-location"),
  locationIcon: y("icon", "ic-location"),
  content: y("content")
};
function wh({ location: e, formStateDispatch: t }) {
  const n = No({
    template: "locationPlaceholder",
    defaultValue: "Location"
  }), o = (r) => {
    t({ type: mt.setLocation, location: r.currentTarget.value });
  };
  return /* @__PURE__ */ d(Lt, null, /* @__PURE__ */ d("div", {
    className: br.popupSectionItem
  }, /* @__PURE__ */ d("span", {
    className: br.locationIcon
  }), /* @__PURE__ */ d("input", {
    name: "location",
    className: br.content,
    placeholder: n,
    value: e,
    onChange: o
  })));
}
const io = {
  popupSectionItem: y("popup-section-item", "popup-section-title"),
  privateButton: y("popup-section-item", "popup-section-private", "popup-button"),
  titleIcon: y("icon", "ic-title"),
  content: y("content")
};
function Eh({ title: e, isPrivate: t = false, formStateDispatch: n }) {
  const o = No({
    template: "titlePlaceholder",
    defaultValue: "Subject"
  }), r = () => n({ type: mt.setPrivate, isPrivate: !t }), i = (s) => {
    n({ type: mt.setTitle, title: s.currentTarget.value });
  };
  return /* @__PURE__ */ d(Lt, null, /* @__PURE__ */ d("div", {
    className: io.popupSectionItem
  }, /* @__PURE__ */ d("span", {
    className: io.titleIcon
  }), /* @__PURE__ */ d("input", {
    name: "title",
    className: io.content,
    placeholder: o,
    value: e,
    onChange: i,
    required: true
  })), /* @__PURE__ */ d("button", {
    type: "button",
    className: io.privateButton,
    onClick: r
  }, /* @__PURE__ */ d("span", {
    className: y("icon", { "ic-private": t, "ic-public": !t })
  }), /* @__PURE__ */ d("input", {
    name: "isPrivate",
    type: "checkbox",
    className: y("hidden-input"),
    value: t ? "true" : "false",
    checked: t
  })));
}
const so = {
  popupContainer: y("popup-container"),
  formContainer: y("form-container"),
  popupArrowBorder: y("popup-arrow-border"),
  popupArrowFill: y("popup-arrow-fill")
};
function Dh(e, t, n) {
  let o = e.top - n.height - Kr, r = e.left - n.width / 2, i = Xt.bottom;
  return o < t.top && (i = Xt.top, o = e.top + Kr), Uc(o, t, n) && (o = t.top + t.height - n.height), Wc(r, t, n) && (r = t.left + t.width - n.width), {
    top: o + window.scrollY,
    left: Math.max(r, t.left) + window.scrollX,
    direction: i
  };
}
function Sh(e) {
  return th.indexOf(e) !== -1;
}
function Th(e, t) {
  return Object.entries(t).reduce((n, [o, r]) => {
    const i = o;
    return e[i] instanceof F ? yt(e[i], r) !== 0 && (n[i] = r) : e[i] !== r && (n[i] = r), n;
  }, {});
}
function bh() {
  var k;
  const { calendars: e } = W(Fo), { hideAllPopup: t } = Se("popup"), n = W(oh), { start: o, end: r, popupArrowPointPosition: i, close: s, isCreationPopup: a, event: c } = n != null ? n : {}, l = Me(), f = Pi("formPopupSlot"), [u, p] = fh((k = e[0]) == null ? void 0 : k.id), h = ee(null), m = ee(null), [w, v] = se({}), [_, E] = se(0), [S, b] = se(
    Xt.bottom
  ), D = Ht(), A = Y(() => {
    const M = S === Xt.top, N = S === Xt.bottom;
    return y("popup-arrow", { top: M, bottom: N });
  }, [S]);
  if (_t(() => {
    if (m.current && i && D) {
      const M = D.getBoundingClientRect(), N = m.current.getBoundingClientRect(), { top: H, left: G, direction: j } = Dh(
        i,
        M,
        N
      ), I = i.left - G;
      v({ left: G, top: H }), E(I), b(j);
    }
  }, [D, i]), oe(() => {
    $(n) && $(c) && p({
      type: mt.init,
      event: {
        title: n.title,
        location: n.location,
        isAllday: n.isAllday,
        isPrivate: n.isPrivate,
        calendarId: c.calendarId,
        state: n.eventState
      }
    });
  }, [e, c, p, n]), oe(() => {
    V(n) && p({ type: mt.reset });
  }, [p, n]), V(o) || V(r) || V(f))
    return null;
  const T = (M) => {
    var G, j;
    M.preventDefault();
    const N = new FormData(M.target), H = L({}, u);
    if (N.forEach((I, z) => {
      H[z] = Sh(z) ? I === "true" : I;
    }), H.start = new F((G = h.current) == null ? void 0 : G.getStartDate()), H.end = new F((j = h.current) == null ? void 0 : j.getEndDate()), a)
      l.fire("beforeCreateEvent", H);
    else if (c) {
      const I = Th(c, H);
      l.fire("beforeUpdateEvent", { event: c.toEventObject(), changes: I });
    }
    t();
  };
  return Ai(
    /* @__PURE__ */ d("div", {
      role: "dialog",
      className: so.popupContainer,
      ref: m,
      style: w
    }, /* @__PURE__ */ d("form", {
      onSubmit: T
    }, /* @__PURE__ */ d("div", {
      className: so.formContainer
    }, e != null && e.length ? /* @__PURE__ */ d(ph, {
      selectedCalendarId: u.calendarId,
      calendars: e,
      formStateDispatch: p
    }) : /* @__PURE__ */ d(Lt, null), /* @__PURE__ */ d(Eh, {
      title: u.title,
      isPrivate: u.isPrivate,
      formStateDispatch: p
    }), /* @__PURE__ */ d(wh, {
      location: u.location,
      formStateDispatch: p
    }), /* @__PURE__ */ d(gh, {
      start: o,
      end: r,
      isAllday: u.isAllday,
      formStateDispatch: p,
      ref: h
    }), /* @__PURE__ */ d(yh, {
      eventState: u.state,
      formStateDispatch: p
    }), /* @__PURE__ */ d(Vc, {
      type: "form",
      close: s
    }), /* @__PURE__ */ d(Lt, null, /* @__PURE__ */ d(mh, null, a ? /* @__PURE__ */ d(te, {
      template: "popupSave"
    }) : /* @__PURE__ */ d(te, {
      template: "popupUpdate"
    })))), /* @__PURE__ */ d("div", {
      className: A
    }, /* @__PURE__ */ d("div", {
      className: so.popupArrowBorder,
      style: { left: _ }
    }, /* @__PURE__ */ d("div", {
      className: so.popupArrowFill
    }))))),
    f
  );
}
function Ch(e) {
  return Object.values(e.popup).find((t) => $(t));
}
function kh() {
  const e = W(Ch), { hideAllPopup: t } = Se("popup"), n = $(e), o = (r) => {
    var i;
    r.stopPropagation(), (i = e == null ? void 0 : e.close) == null || i.call(e), t();
  };
  return /* @__PURE__ */ d("div", {
    className: y("popup-overlay"),
    style: { display: n ? "block" : "none" },
    onClick: o
  });
}
const ao = {
  container: y("see-more-container"),
  seeMore: y("see-more"),
  header: y("see-more-header"),
  list: y("month-more-list")
};
function Nh() {
  const e = W(ih), { date: t, events: n = [], popupPosition: o } = e != null ? e : {}, { moreView: r, moreViewTitle: i } = pc(), s = Pi("seeMorePopupSlot"), a = Me(), c = ee(null), l = V(t) || V(o) || V(s);
  if (oe(() => {
    !l && c.current && a.fire("clickMoreEventsBtn", {
      date: t.toDate(),
      target: c.current
    });
  }, [t, a, l]), l)
    return null;
  const f = {
    height: uo,
    marginBottom: Fr,
    padding: Mu,
    backgroundColor: i.backgroundColor
  }, u = {
    ymd: ge(t, "YYYY-MM-DD"),
    day: t.getDay(),
    date: t.getDate().toString().padStart(2, "0")
  }, p = {
    height: `calc(100% - ${uo + Fr + Iu}px)`
  };
  return Ai(
    /* @__PURE__ */ d("div", {
      role: "dialog",
      className: ao.container,
      style: o,
      ref: c
    }, /* @__PURE__ */ d("div", {
      className: ao.seeMore,
      style: r
    }, /* @__PURE__ */ d("div", {
      className: ao.header,
      style: f
    }, /* @__PURE__ */ d(te, {
      template: "monthMoreTitleDate",
      param: u
    }), /* @__PURE__ */ d(Vc, {
      type: "moreEvents"
    })), /* @__PURE__ */ d("div", {
      className: ao.list,
      style: p
    }, n.map((h) => /* @__PURE__ */ d(Dt, {
      key: `see-more-event-item-${h.cid()}`,
      uiModel: h,
      eventHeight: Jt,
      headerHeight: uo,
      flat: true
    }))))),
    s
  );
}
function Ih(e, t) {
  const n = { height: q(100) };
  return e && (n.width = e), t && (n.height = t), n;
}
function Li({
  children: e,
  width: t,
  height: n,
  className: o = "",
  autoAdjustPanels: r = false
}) {
  const { backgroundColor: i } = re(uc), [s, a] = Be(), { setLastPanelType: c, updateLayoutHeight: l } = Se("weekViewLayout"), f = Y(() => `${y("layout")} ${o}`, [o]);
  return _t(() => {
    if (s) {
      const u = () => l(s.offsetHeight);
      return u(), window.addEventListener("resize", u), () => window.removeEventListener("resize", u);
    }
    return an;
  }, [s, l]), _t(() => {
    if (s && r) {
      const u = Nn(e), p = u[u.length - 1];
      !Ie(p) && !fo(p) && !V(p) && c(p.props.name);
    }
  }, [e, c, r, s]), /* @__PURE__ */ d(Ip, {
    value: s
  }, /* @__PURE__ */ d("div", {
    ref: a,
    className: f,
    style: ce(L({}, Ih(t, n)), { backgroundColor: i })
  }, s ? e : null), /* @__PURE__ */ d(bh, null), /* @__PURE__ */ d(ch, null), /* @__PURE__ */ d(Nh, null), /* @__PURE__ */ d(kh, null));
}
function Mh(e, t) {
  return {
    height: e,
    width: "100%",
    cursor: "row-resize",
    borderTop: t,
    borderBottom: t
  };
}
function Ah({ name: e, height: t }) {
  const n = re(Q((f) => f.week.panelResizer.border, [])), o = Mh(t, n), r = ce(L({}, o), {
    display: "none",
    border: "none",
    backgroundColor: "#999"
  }), [i, s] = se(r), a = ee(null), { updateDayGridRowHeightByDiff: c } = Se("weekViewLayout"), l = tn(Mp.panelResizer, {
    onDragStart: (f) => {
      a.current = { left: f.pageX, top: f.pageY };
    },
    onDrag: (f) => {
      if (a.current) {
        const u = f.pageY - a.current.top;
        s((p) => ce(L({}, p), { top: u, display: null }));
      }
    },
    onMouseUp: (f) => {
      if (a.current) {
        const u = f.pageY - a.current.top;
        a.current = null, s(r), c({ rowName: e, diff: u });
      }
    }
  });
  return /* @__PURE__ */ d("div", {
    style: { position: "relative" }
  }, /* @__PURE__ */ d("div", {
    className: y("panel-resizer"),
    style: o,
    onMouseDown: l
  }), /* @__PURE__ */ d("div", {
    className: y("panel-resizer-guide"),
    style: i
  }));
}
function ua(e, t) {
  return t ? Math.min(t, e) : e;
}
function xh({
  initialHeight: e,
  initialWidth: t,
  overflowX: n,
  overflowY: o,
  maxExpandableWidth: r,
  maxExpandableHeight: i,
  minHeight: s,
  maxHeight: a,
  minWidth: c,
  maxWidth: l
}) {
  const f = {};
  return t && (f.width = ua(t, r), f.height = "100%"), e && (f.width = "100%", f.height = ua(e, i)), n && (f.overflowX = "auto"), o && (f.overflowY = "auto"), ce(L({}, f), { minHeight: s, maxHeight: a, minWidth: c, maxWidth: l });
}
const Kt = Mc(function({
  name: t,
  initialWidth: n = Qt,
  initialHeight: o = Qt,
  overflowX: r,
  overflowY: i,
  maxExpandableWidth: s,
  maxExpandableHeight: a,
  minHeight: c,
  maxHeight: l,
  minWidth: f,
  maxWidth: u,
  resizerWidth: p = Wr,
  resizerHeight: h = Wr,
  resizable: m,
  children: w
}, v) {
  const { updateDayGridRowHeight: _ } = Se("weekViewLayout"), { height: E } = W(
    Q((A) => {
      var T;
      return (T = A.weekViewLayout.dayGridRows[t]) != null ? T : {};
    }, [t])
  ), S = E != null ? E : o;
  _t(() => {
    _({ rowName: t, height: o });
  }, [o, t, _]);
  const b = xh({
    initialWidth: n,
    initialHeight: S,
    overflowX: r,
    overflowY: i,
    maxExpandableWidth: s,
    maxExpandableHeight: a,
    minHeight: c,
    maxHeight: l,
    minWidth: f,
    maxWidth: u
  }), D = Y(() => V(m) || pi(m) ? !!m : m.includes(t), [m, t]);
  return /* @__PURE__ */ d(ke, null, /* @__PURE__ */ d("div", {
    className: y("panel", t),
    style: b,
    ref: v
  }, w), D ? /* @__PURE__ */ d(Ah, {
    name: t,
    width: p,
    height: h
  }) : null);
}), jc = "timegrid", Ce = (e) => `${jc}-${e}`, Oh = {
  second: "HH:mm:ss",
  minute: "HH:mm",
  hour: "HH:mm",
  date: "HH:mm",
  month: "MM.DD",
  year: "YYYY.MM.DD"
}, Ke = {
  time: y("event-time"),
  content: y("event-time-content"),
  travelTime: y("travel-time"),
  resizeHandleX: y("resize-handler-x"),
  moveEvent: y("dragging--move-event"),
  resizeEvent: y("dragging--resize-vertical-event")
};
function Rh(e) {
  const { percent: t, px: n } = Gr(`${e}`);
  return e > 0 || t > 0 || n > 0 ? wo : 0;
}
function Ph(e, t) {
  return Ie(e) ? e : e >= 0 ? `calc(${q(e)} - ${t}px)` : "";
}
function Lh({
  uiModel: e,
  isDraggingTarget: t,
  hasNextStartTime: n,
  calendarColor: o,
  minHeight: r
}) {
  const {
    top: i,
    left: s,
    height: a,
    width: c,
    duplicateLeft: l,
    duplicateWidth: f,
    goingDurationHeight: u,
    modelDurationHeight: p,
    comingDurationHeight: h,
    croppedStart: m,
    croppedEnd: w
  } = e, v = "white", _ = 2, E = 2, S = Rh(s), { color: b, backgroundColor: D, borderColor: A, dragBackgroundColor: T } = za(
    e,
    o
  ), k = {
    width: Ph(f || c, S),
    height: `calc(${q(Math.max(a, r))} - ${E}px)`,
    top: q(i),
    left: l || q(s),
    borderRadius: _,
    borderLeft: `3px solid ${A}`,
    marginLeft: S,
    color: b,
    backgroundColor: t ? T : D,
    opacity: t ? 0.5 : 1,
    zIndex: n ? 1 : 0
  }, M = {
    height: q(u),
    borderBottom: `1px dashed ${v}`
  }, N = {
    height: q(p)
  }, H = {
    height: q(h),
    borderTop: `1px dashed ${v}`
  };
  return m && (k.borderTopLeftRadius = 0, k.borderTopRightRadius = 0), w && (k.borderBottomLeftRadius = 0, k.borderBottomRightRadius = 0), {
    containerStyle: k,
    goingDurationStyle: M,
    modelDurationStyle: N,
    comingDurationStyle: H
  };
}
function $h({
  uiModel: e,
  isReadOnlyCalendar: t,
  isDraggingTarget: n,
  hasNextStartTime: o
}) {
  const { model: r } = e;
  return !t && !r.isReadOnly && !n && !o;
}
function $i({
  uiModel: e,
  nextStartTime: t,
  isResizingGuide: n = false,
  minHeight: o = 0
}) {
  const {
    useDetailPopup: r,
    isReadOnly: i,
    week: s
  } = W(Je), a = xi(e.model), { collapseDuplicateEvents: c } = s, l = Ht(), { showDetailPopup: f } = Se("popup"), { setDraggingEventUIModel: u } = Se("dnd"), { setSelectedDuplicateEventCid: p } = Se("weekViewLayout"), h = Me(), m = ee(null), [w, v] = se(false), { model: _, goingDurationHeight: E, modelDurationHeight: S, comingDurationHeight: b, croppedEnd: D } = e, { id: A, calendarId: T, customStyle: k } = _, M = $(t), { containerStyle: N, goingDurationStyle: H, modelDurationStyle: G, comingDurationStyle: j } = Lh(
    { uiModel: e, isDraggingTarget: w, hasNextStartTime: M, calendarColor: a, minHeight: o }
  ), I = M || n;
  wt($t, ({ draggingEventUIModel: de, draggingState: We }) => {
    We === Ze.DRAGGING && (de == null ? void 0 : de.cid()) === e.cid() && !M && !n ? v(true) : v(false);
  }), oe(() => {
    n || h.fire("afterRenderEvent", e.model.toEventObject());
  }, []);
  const z = (de) => {
    u(e), l == null || l.classList.add(de);
  }, R = (de) => {
    v(false), l == null || l.classList.remove(de);
  }, ae = tn(Rn.moveEvent("timeGrid", `${e.cid()}`), {
    onDragStart: () => {
      he && z(Ke.moveEvent);
    },
    onMouseUp: (de, { draggingState: We }) => {
      R(Ke.moveEvent);
      const Ye = We <= Ze.INIT;
      if (Ye && c) {
        const gt = e.duplicateEvents.length > 0 ? e.cid() : Lo;
        p(gt);
      }
      Ye && r && m.current && f(
        {
          event: e.model,
          eventRect: m.current.getBoundingClientRect()
        },
        false
      ), Ye && h.fire("clickEvent", { event: e.model.toEventObject(), nativeEvent: de });
    },
    onPressESCKey: () => R(Ke.moveEvent)
  }), ie = (de) => {
    de.stopPropagation(), ae(de);
  }, Ue = tn(
    Rn.resizeEvent("timeGrid", `${e.cid()}`),
    {
      onDragStart: () => z(Ke.resizeEvent),
      onMouseUp: () => R(Ke.resizeEvent),
      onPressESCKey: () => R(Ke.resizeEvent)
    }
  ), X = (de) => {
    de.stopPropagation(), Ue(de);
  }, he = $h({
    uiModel: e,
    isReadOnlyCalendar: i,
    isDraggingTarget: w,
    hasNextStartTime: M
  }), st = he && !D;
  return /* @__PURE__ */ d("div", {
    "data-testid": `${I ? "guide-" : ""}time-event-${_.title}-${e.cid()}`,
    "data-calendar-id": T,
    "data-event-id": A,
    className: Ke.time,
    style: L(L({}, N), k),
    onMouseDown: ie,
    ref: m
  }, E ? /* @__PURE__ */ d("div", {
    className: Ke.travelTime,
    style: H
  }, /* @__PURE__ */ d(te, {
    template: "goingDuration",
    param: _
  })) : null, S ? /* @__PURE__ */ d("div", {
    className: Ke.content,
    style: G
  }, /* @__PURE__ */ d(te, {
    template: "time",
    param: ce(L({}, _.toEventObject()), {
      start: M ? t : _.start
    })
  })) : null, b ? /* @__PURE__ */ d("div", {
    className: Ke.travelTime,
    style: j
  }, /* @__PURE__ */ d(te, {
    template: "comingDuration",
    param: _
  })) : null, st ? /* @__PURE__ */ d("div", {
    className: Ke.resizeHandleX,
    onMouseDown: X
  }) : null);
}
function Hh({ top: e, height: t, text: n }) {
  const { backgroundColor: o, border: r } = re(
    Q((a) => a.common.gridSelection, [])
  ), i = re(Q((a) => a.week.gridSelection.color, [])), s = {
    top: q(e),
    height: q(t),
    backgroundColor: o,
    border: r
  };
  return /* @__PURE__ */ d("div", {
    className: y("time", "grid-selection"),
    style: s,
    "data-testid": `time-grid-selection-${e}-${t}`
  }, n.length > 0 ? /* @__PURE__ */ d("span", {
    className: y("grid-selection-label"),
    style: { color: i }
  }, n) : null);
}
function Fh({ columnIndex: e, timeGridRows: t }) {
  const n = W(
    Q(
      (r) => Vr.calculateSelection(
        r.gridSelection.timeGrid,
        e,
        t.length - 1
      ),
      [e, t]
    )
  ), o = Y(() => {
    if (!n)
      return null;
    const { startRowIndex: r, endRowIndex: i, isStartingColumn: s, isSelectingMultipleColumns: a } = n, { top: c, startTime: l } = t[r], {
      top: f,
      height: u,
      endTime: p
    } = t[i], h = f + u - c;
    let m = `${l} - ${p}`;
    return a && (m = s ? l : ""), {
      top: c,
      height: h,
      text: m
    };
  }, [n, t]);
  return V(o) ? null : /* @__PURE__ */ d(Hh, L({}, o));
}
function Gh({
  gridPositionFinder: e,
  totalUIModels: t,
  columnIndex: n,
  timeGridData: o
}) {
  const r = Me(), {
    isDraggingEnd: i,
    isDraggingCanceled: s,
    draggingEvent: a,
    clearDraggingEvent: c
  } = fn("timeGrid", "resize"), [l, f] = dn(e), [u, p] = se(null), h = Q(() => {
    p(null), c(), f();
  }, [f, c]), m = Y(() => {
    if (V(a))
      return null;
    const { columns: _, rows: E } = o, S = t.map(
      (z) => z.filter(
        (R) => R.cid() === a.cid()
      )
    ), b = (z, R) => (ae) => {
      const ie = nt(_[R].date, ae.startTime), Ue = nt(
        o.columns[R].date,
        ae.endTime
      );
      return ie <= z && z < Ue;
    }, D = S.findIndex((z) => z.length > 0), A = S[D][0], { goingDuration: T = 0 } = A.model, k = Oe(A.getStarts(), -T), M = Math.max(
      E.findIndex(b(k, D)),
      0
    ), N = hi(
      S,
      (z) => z.length > 0
    ), H = S[N][0], { comingDuration: G = 0 } = H.model, j = Oe(H.getStarts(), G);
    let I = E.findIndex(b(j, N));
    return I = I >= 0 ? I : E.length - 1, {
      eventStartDateColumnIndex: D,
      eventStartDateRowIndex: M,
      eventEndDateColumnIndex: N,
      eventEndDateRowIndex: I,
      resizeTargetUIModelColumns: S
    };
  }, [a, o, t]), w = $(m) && $(a) && $(l), v = Y(
    () => m ? o.rows[0].height : 0,
    [m, o.rows]
  );
  return oe(() => {
    if (w) {
      const { eventStartDateRowIndex: _, eventStartDateColumnIndex: E, eventEndDateColumnIndex: S } = m;
      if (n === S && E === S) {
        const b = a.clone(), { height: D, goingDurationHeight: A, comingDurationHeight: T } = b, k = Math.max(
          v + A * D / 100 + T * D / 100,
          o.rows[l.rowIndex].top - o.rows[_].top + v
        ), M = A * D / k, N = T * D / k;
        b.setUIProps({
          height: k,
          goingDurationHeight: M,
          comingDurationHeight: N,
          modelDurationHeight: 100 - (M + N)
        }), p(b);
      }
    }
  }, [
    m,
    w,
    n,
    l,
    a,
    o.rows,
    v
  ]), oe(() => {
    if (w) {
      const { resizeTargetUIModelColumns: _, eventStartDateColumnIndex: E, eventEndDateColumnIndex: S } = m;
      if ((n === E || n === S) && E !== S) {
        let b;
        n === E ? b = _[n][0].clone() : (b = a.clone(), b.setUIProps({
          height: o.rows[l.rowIndex].top + v
        })), p(b);
      }
    }
  }, [
    m,
    w,
    n,
    l,
    a,
    o.rows,
    v
  ]), un(() => {
    if (!s && $(m) && $(l) && $(a) && m.eventEndDateColumnIndex === n) {
      const { comingDuration: E = 0 } = a.model, S = Oe(
        nt(
          o.columns[n].date,
          o.rows[l.rowIndex].endTime
        ),
        -E
      ), b = Oe(a.getStarts(), 30);
      r.fire("beforeUpdateEvent", {
        event: a.model.toEventObject(),
        changes: {
          end: gi(b, S)
        }
      });
    }
    h();
  }, i), u;
}
function Bh({
  gridPositionFinder: e,
  totalUIModels: t,
  columnIndex: n,
  timeGridData: o
}) {
  const r = Gh({
    gridPositionFinder: e,
    totalUIModels: t,
    columnIndex: n,
    timeGridData: o
  });
  return V(r) ? null : /* @__PURE__ */ d($i, {
    uiModel: r,
    isResizingGuide: true
  });
}
const Xc = {
  column: y("column"),
  backgrounds: y("background-events"),
  events: y("events")
};
function zh({
  eventUIModels: e,
  minEventHeight: t
}) {
  const n = { marginRight: 8 };
  return /* @__PURE__ */ d("div", {
    className: Xc.events,
    style: n
  }, e.map((o) => /* @__PURE__ */ d($i, {
    key: `${o.valueOf()}-${o.cid()}`,
    uiModel: o,
    minHeight: t
  })));
}
function Uh(e) {
  return {
    defaultBackgroundColor: e.week.dayGrid.backgroundColor,
    todayBackgroundColor: e.week.today.backgroundColor,
    weekendBackgroundColor: e.week.weekend.backgroundColor
  };
}
function Wh({
  today: e,
  columnDate: t,
  defaultBackgroundColor: n,
  todayBackgroundColor: o,
  weekendBackgroundColor: r
}) {
  const i = Rt(e, t), s = ze(t.getDay());
  return i ? o : s ? r : n;
}
const Yh = ln(function({
  columnDate: t,
  columnWidth: n,
  columnIndex: o,
  totalUIModels: r,
  gridPositionFinder: i,
  timeGridData: s,
  isLastColumn: a
}) {
  const { rows: c } = s, l = re(Q((_) => _.week.timeGrid.borderRight, [])), f = re(Uh), [, u] = zo(), p = u(), h = Wh(L({ today: p, columnDate: t }, f)), m = {
    width: n,
    backgroundColor: h,
    borderRight: a ? "none" : l
  }, w = r[o], v = c[0].height;
  return /* @__PURE__ */ d("div", {
    className: Xc.column,
    style: m,
    "data-testid": `timegrid-column-${t.getDay()}`
  }, /* @__PURE__ */ d(zh, {
    eventUIModels: w,
    minEventHeight: v
  }), /* @__PURE__ */ d(Bh, {
    gridPositionFinder: i,
    totalUIModels: r,
    columnIndex: o,
    timeGridData: s
  }), /* @__PURE__ */ d(Fh, {
    columnIndex: o,
    timeGridRows: c
  }));
});
function Vh(e) {
  return {
    halfHourLineBorder: e.week.timeGridHalfHourLine.borderBottom,
    hourLineBorder: e.week.timeGridHourLine.borderBottom
  };
}
const jh = ln(function({
  timeGridRows: t
}) {
  const { halfHourLineBorder: n, hourLineBorder: o } = re(Vh);
  return /* @__PURE__ */ d("div", {
    className: y("gridlines")
  }, t.map((r, i) => {
    const s = i % 2 === 0;
    return /* @__PURE__ */ d("div", {
      key: `gridline-${r.startTime}-${r.endTime}`,
      className: y("gridline-half"),
      style: {
        top: q(r.top),
        height: q(r.height),
        borderBottom: s ? n : o
      },
      "data-testid": `gridline-${r.startTime}-${r.endTime}`
    });
  }));
}), Xh = 30;
function da(e, t) {
  const n = e.getHours() - t, o = e.getMinutes();
  return n * 2 + Math.floor(o / Xh);
}
function Kh({
  draggingEvent: e,
  columnDiff: t,
  rowDiff: n,
  timeGridDataRows: o,
  currentDate: r
}) {
  const i = o[0].height, s = i * o.length, a = n * Wa + t * ht, c = Number(o[0].startTime.split(":")[0]), { goingDuration: l = 0, comingDuration: f = 0 } = e.model, u = Oe(e.getStarts(), -l), p = Oe(e.getEnds(), f), h = Do(u, a), m = Do(p, a), w = Math.max(da(h, c), 0), v = Math.min(da(m, c), o.length - 1), _ = h.getFullYear() < r.getFullYear() || h.getMonth() < r.getMonth() || h.getDate() < r.getDate(), E = m.getFullYear() > r.getFullYear() || m.getMonth() > r.getMonth() || m.getDate() > r.getDate(), S = v - (_ ? 0 : w), b = _ ? 0 : o[w].top, D = E ? s : Math.max(S, 1) * i;
  return { top: b, height: D };
}
const qh = (e) => e.dnd.initX, Zh = (e) => e.dnd.initY;
function Jh({
  gridPositionFinder: e,
  timeGridData: t
}) {
  const n = W(qh), o = W(Zh), r = Me(), { isDraggingEnd: i, isDraggingCanceled: s, draggingEvent: a, clearDraggingEvent: c } = fn(
    "timeGrid",
    "move"
  ), [l, f] = dn(e), u = ee(null);
  oe(() => {
    $(n) && $(o) && (u.current = e({
      clientX: n,
      clientY: o
    }));
  }, [e, n, o]);
  const p = Y(() => V(u.current) || V(l) ? null : {
    columnDiff: l.columnIndex - u.current.columnIndex,
    rowDiff: l.rowIndex - u.current.rowIndex
  }, [l]), h = Y(() => V(a) ? null : a.getStarts(), [a]), m = Q(() => {
    f(), c(), u.current = null;
  }, [f, c]), w = Y(() => V(p) || V(h) ? null : Do(
    h,
    p.rowDiff * Wa + p.columnDiff * ht
  ), [p, h]), v = Y(() => {
    if (V(a) || V(l) || V(p))
      return null;
    const _ = a.clone(), { top: E, height: S } = Kh({
      draggingEvent: _,
      columnDiff: p.columnDiff,
      rowDiff: p.rowDiff,
      timeGridDataRows: t.rows,
      currentDate: t.columns[l.columnIndex].date
    });
    return _.setUIProps({
      left: t.columns[l.columnIndex].left,
      width: t.columns[l.columnIndex].width,
      top: E,
      height: S
    }), _;
  }, [l, a, p, t.columns, t.rows]);
  return un(() => {
    if (!s && $(a) && $(l) && $(p) && $(w) && (p.rowDiff !== 0 || p.columnDiff !== 0)) {
      const E = a.duration(), S = Do(w, E);
      r.fire("beforeUpdateEvent", {
        event: a.model.toEventObject(),
        changes: {
          start: w,
          end: S
        }
      });
    }
    m();
  }, i), {
    movingEvent: v,
    nextStartTime: w
  };
}
function Qh({
  gridPositionFinder: e,
  timeGridData: t
}) {
  const { movingEvent: n, nextStartTime: o } = Jh({
    gridPositionFinder: e,
    timeGridData: t
  });
  return V(n) ? null : /* @__PURE__ */ d($i, {
    uiModel: n,
    nextStartTime: o
  });
}
const Kc = {
  NOW_INDICATOR: "timegrid-now-indicator",
  NOW_INDICATOR_LABEL: "timegrid-now-indicator-label"
}, yn = {
  line: y(Ce("now-indicator")),
  left: y(Ce("now-indicator-left")),
  marker: y(Ce("now-indicator-marker")),
  today: y(Ce("now-indicator-today")),
  right: y(Ce("now-indicator-right"))
};
function em(e) {
  return {
    pastBorder: e.week.nowIndicatorPast.border,
    todayBorder: e.week.nowIndicatorToday.border,
    futureBorder: e.week.nowIndicatorFuture.border,
    bulletBackgroundColor: e.week.nowIndicatorBullet.backgroundColor
  };
}
function tm({ top: e, columnWidth: t, columnCount: n, columnIndex: o }) {
  const { pastBorder: r, todayBorder: i, futureBorder: s, bulletBackgroundColor: a } = re(em), c = Ht(), l = Me(), f = ee(null), u = {
    left: q(t * o),
    width: q(t * o)
  }, p = {
    left: q(t * (o + 1)),
    width: q(t * (n - o + 1))
  };
  return oe(() => {
    const h = (m) => {
      var v;
      const w = (v = c == null ? void 0 : c.querySelector(`.${y("panel")}.${y("time")}`)) != null ? v : null;
      if (w && f.current) {
        const { offsetHeight: _ } = w, { offsetTop: E } = f.current, S = E - _ / 2;
        w.scrollTo ? w.scrollTo({ top: S, behavior: m }) : w.scrollTop = S;
      }
    };
    return l.on("scrollToNow", h), () => l.off("scrollToNow", h);
  }, [l, c]), oe(() => {
    l.fire("scrollToNow", "smooth");
  }, [l]), /* @__PURE__ */ d("div", {
    ref: f,
    className: yn.line,
    style: { top: q(e) },
    "data-testid": Kc.NOW_INDICATOR
  }, /* @__PURE__ */ d("div", {
    className: yn.left,
    style: { width: u.width, borderTop: r }
  }), /* @__PURE__ */ d("div", {
    className: yn.marker,
    style: { left: u.left, backgroundColor: a }
  }), /* @__PURE__ */ d("div", {
    className: yn.today,
    style: {
      left: u.left,
      width: q(t),
      borderTop: i
    }
  }), /* @__PURE__ */ d("div", {
    className: yn.right,
    style: {
      left: p.left,
      borderTop: s
    }
  }));
}
const fa = {
  now: Ce("current-time"),
  dayDifference: Ce("day-difference")
};
function nm({ unit: e, top: t, now: n, zonedNow: o }) {
  const r = re(Q((a) => a.week.nowIndicatorLabel.color, [])), i = Y(() => wi(o, n), [o, n]), s = {
    unit: e,
    time: o,
    format: Oh[e]
  };
  return /* @__PURE__ */ d("div", {
    className: y(fa.now),
    style: { top: q(t), color: r },
    "data-testid": Kc.NOW_INDICATOR_LABEL
  }, i !== 0 && /* @__PURE__ */ d("span", {
    className: y(fa.dayDifference)
  }, `[${i > 0 ? "+" : "-"}${Math.abs(i)}]`), /* @__PURE__ */ d(te, {
    template: "timegridNowIndicatorLabel",
    param: s,
    as: "span"
  }));
}
const om = (e) => {
  var t;
  return (t = e.options.month.visibleEventCount) != null ? t : 6;
}, Hi = (e) => e.options.week.showNowIndicator, rm = (e) => {
  var t;
  return (t = e.options.week.showTimezoneCollapseButton) != null ? t : false;
}, qc = (e) => {
  var t;
  return (t = e.options.week.timezonesCollapsed) != null ? t : false;
}, Vt = {
  timeColumn: Ce("time-column"),
  hourRows: Ce("hour-rows"),
  time: Ce("time"),
  timeLabel: Ce("time-label"),
  first: Ce("time-first"),
  last: Ce("time-last"),
  hidden: Ce("time-hidden")
};
function im(e) {
  return {
    primaryTimezoneBackgroundColor: e.week.timeGridLeft.backgroundColor,
    subTimezoneBackgroundColor: e.week.timeGridLeftAdditionalTimezone.backgroundColor
  };
}
function sm(e) {
  return {
    pastTimeColor: e.week.pastTime.color,
    futureTimeColor: e.week.futureTime.color
  };
}
function pa({ rowsInfo: e, isPrimary: t, borderRight: n, width: o, nowIndicatorState: r }) {
  var p;
  const i = W(Hi), { primaryTimezoneBackgroundColor: s, subTimezoneBackgroundColor: a } = re(im), { pastTimeColor: c, futureTimeColor: l } = re(sm), f = $(r) ? Oe(r.now, (p = e[0].diffFromPrimaryTimezone) != null ? p : 0) : null, u = t ? s : a;
  return /* @__PURE__ */ d("div", {
    role: "rowgroup",
    className: y(Vt.hourRows),
    style: { width: q(o), borderRight: n, backgroundColor: u }
  }, e.map(({ date: h, top: m, className: w }) => {
    const _ = $(f) && h < f ? c : l;
    return /* @__PURE__ */ d("div", {
      key: h.getTime(),
      className: w,
      style: {
        top: q(m),
        color: _
      },
      role: "row"
    }, /* @__PURE__ */ d(te, {
      template: `timegridDisplay${t ? "Primary" : ""}Time`,
      param: { time: h },
      as: "span"
    }));
  }), i && $(r) && $(f) && /* @__PURE__ */ d(nm, {
    unit: "hour",
    top: r.top,
    now: r.now,
    zonedNow: f
  }));
}
const am = ln(function({ timeGridRows: t, nowIndicatorState: n }) {
  const o = W(Hi), r = W(lc), i = W(qc), s = Bo(), { width: a, borderRight: c } = re(Di), l = Y(
    () => t.filter((v, _) => _ % 2 === 0 || _ === t.length - 1),
    [t]
  ), f = Q(
    (v, _, E) => {
      const S = ({ top: k, height: M }) => {
        if (!o || V(n))
          return false;
        const N = n.top;
        return k - M <= N && N <= k + M;
      }, b = _ === 0, D = _ === l.length - 1, A = y(Vt.time, {
        [Vt.first]: b,
        [Vt.last]: D,
        [Vt.hidden]: S(v)
      });
      let T = nt(new F(), D ? v.endTime : v.startTime);
      return $(E) && (T = Oe(T, E)), {
        date: T,
        top: v.top,
        className: A,
        diffFromPrimaryTimezone: E
      };
    },
    [l, n, o]
  ), [u, ...p] = r, h = p.length > 0 ? 100 / (p.length + 1) : 100, m = l.map(
    (v, _) => f(v, _)
  ), w = Y(() => p.length === 0 ? [] : p.reverse().map((v) => {
    const { timezoneName: _ } = v, E = s(u.timezoneName).getTimezoneOffset(), b = s(_).getTimezoneOffset() - E;
    return l.map(
      (D, A) => f(D, A, b)
    );
  }), [f, p, u, l, s]);
  return /* @__PURE__ */ d("div", {
    className: y(Vt.timeColumn),
    style: { width: a },
    "data-testid": "timegrid-time-column"
  }, !i && w.map((v) => /* @__PURE__ */ d(pa, {
    key: v[0].diffFromPrimaryTimezone,
    rowsInfo: v,
    isPrimary: false,
    borderRight: c,
    width: h,
    nowIndicatorState: n
  })), /* @__PURE__ */ d(pa, {
    rowsInfo: m,
    isPrimary: true,
    borderRight: c,
    width: i ? 100 : h,
    nowIndicatorState: n
  }));
});
function Zr(e, t, n) {
  const o = t.getTime(), r = n.getTime(), i = Yr(e.getTime(), [o], [r]) - o, s = r - o, a = yc(s, 100, i);
  return Yr(a, [0], [100]);
}
function Jr(e, t, n, o) {
  const r = Zr(e, n, o), s = Zr(t, n, o) - r;
  return {
    top: r,
    height: s
  };
}
const cm = 1;
function Zc(e, t) {
  return (n) => {
    const { goingDuration: o = 0, comingDuration: r = 0 } = n.model, i = Oe(n.getStarts(), -o);
    return !(Oe(n.getEnds(), r) <= e || i >= t);
  };
}
function lm(e, t) {
  const { renderStart: n, renderEnd: o, modelStart: r, modelEnd: i } = t, { goingDuration: s = 0, comingDuration: a = 0 } = e.model;
  let c = 100;
  if (s > 0) {
    const { height: l } = Jr(
      n,
      r,
      n,
      o
    );
    e.goingDurationHeight = l, c -= l;
  }
  if (a > 0) {
    const { height: l } = Jr(
      i,
      o,
      n,
      o
    );
    e.comingDurationHeight = l, c -= l;
  }
  e.modelDurationHeight = c;
}
function um(e, t) {
  const { goingStart: n, comingEnd: o, startColumnTime: r, endColumnTime: i } = t;
  n < r && (e.croppedStart = true), o > i && (e.croppedEnd = true);
}
function dm(e, t) {
  const { duplicateEvents: n, duplicateEventIndex: o } = e, r = n[o - 1];
  let i = t;
  if (r) {
    const { percent: s, px: a } = Gr(`${r.duplicateLeft}`), { percent: c, px: l } = Gr(`${r.duplicateWidth}`), f = s + c, u = a + l + wo;
    f !== 0 ? i = `calc(${q(f)} ${u > 0 ? "+" : "-"} ${Eo(Math.abs(u))})` : i = Eo(u);
  } else
    i = q(i);
  return i;
}
function fm(e, t) {
  const { collapse: n } = e;
  return n ? `${Gs}px` : `calc(${q(t)} - ${Eo(
    (Gs + wo) * (e.duplicateEvents.length - 1) + wo
  )})`;
}
function pm(e, t) {
  const { startColumnTime: n, endColumnTime: o, baseWidth: r, columnIndex: i, renderStart: s, renderEnd: a } = t, { duplicateEvents: c } = e, { top: l, height: f } = Jr(
    s,
    a,
    n,
    o
  ), u = {
    top: l,
    left: r * i,
    width: r,
    height: Math.max(cm, f),
    duplicateLeft: "",
    duplicateWidth: ""
  };
  c.length > 0 && (u.duplicateLeft = dm(e, u.left), u.duplicateWidth = fm(e, u.width)), e.setUIProps(u);
}
function hm(e, t, n, o, r) {
  const { goingDuration: i = 0, comingDuration: s = 0 } = e.model, a = e.getStarts(), c = e.getEnds(), l = Oe(a, -i), f = Oe(c, s), u = gi(l, o), p = Ya(f, r);
  return {
    baseWidth: n,
    columnIndex: t,
    modelStart: a,
    modelEnd: c,
    renderStart: u,
    renderEnd: p,
    goingStart: l,
    comingEnd: f,
    startColumnTime: o,
    endColumnTime: r,
    duplicateEvents: e.duplicateEvents
  };
}
function Jc({
  uiModel: e,
  columnIndex: t,
  baseWidth: n,
  startColumnTime: o,
  endColumnTime: r,
  isDuplicateEvent: i = false
}) {
  if (!i && e.duplicateEvents.length > 0) {
    e.duplicateEvents.forEach((a) => {
      Jc({
        uiModel: a,
        columnIndex: t,
        baseWidth: n,
        startColumnTime: o,
        endColumnTime: r,
        isDuplicateEvent: true
      });
    });
    return;
  }
  const s = hm(
    e,
    t,
    n,
    o,
    r
  );
  pm(e, s), lm(e, s), um(e, s);
}
function mm(e, t, n) {
  const { getDuplicateEvents: o, getMainEvent: r } = t, i = e.map((s) => s.model.toEventObject());
  return e.forEach((s) => {
    if (s.collapse || s.duplicateEvents.length > 0)
      return;
    const a = o(s.model.toEventObject(), i);
    if (a.length <= 1)
      return;
    const c = r(a), l = a.map(
      (h) => e.find((m) => m.cid() === h.__cid)
    ), f = !!(n > Lo && a.find((h) => h.__cid === n)), u = a.reduce((h, { start: m, goingDuration: w }) => {
      const v = Oe(m, -w);
      return Ya(h, v);
    }, a[0].start), p = a.reduce((h, { end: m, comingDuration: w }) => {
      const v = Oe(m, w);
      return gi(h, v);
    }, a[0].end);
    l.forEach((h, m) => {
      const w = h.cid() === c.__cid, v = !(f && h.cid() === n || !f && w);
      h.setUIProps({
        duplicateEvents: l,
        duplicateEventIndex: m,
        collapse: v,
        isMain: w,
        duplicateStarts: u,
        duplicateEnds: p
      });
    });
  }), e;
}
function gm(e, t, n, o, r) {
  const i = e.filter(bd).filter(Zc(t, n)).sort(Ot.compare.event.asc);
  r && mm(i, r, o);
  const s = i.filter((u) => !u.collapse), a = en(...s), c = true, l = Uo(s, c);
  return Wo(a, l, c).forEach((u) => {
    const p = Math.max(...u.map((m) => m.length)), h = Math.round(100 / p);
    u.forEach((m) => {
      m.forEach((w, v) => {
        Jc({ uiModel: w, columnIndex: v, baseWidth: h, startColumnTime: t, endColumnTime: n });
      });
    });
  }), i;
}
function _m(e, t) {
  const n = ee(e);
  oe(() => {
    n.current = e;
  }, [e]), oe(() => {
    const o = () => n.current(), r = t != null ? t : -1;
    if (r > 0) {
      const i = setInterval(o, r);
      return () => clearInterval(i);
    }
  }, [t]);
}
function vm() {
  const e = ee(true);
  return oe(() => () => {
    e.current = false;
  }, []), Q(() => e.current, []);
}
const ha = {
  timegrid: y(jc),
  scrollArea: y(Ce("scroll-area"))
};
function Qc({ timeGridData: e, events: t }) {
  const {
    isReadOnly: n,
    week: { narrowWeekend: o, startDayOfWeek: r, collapseDuplicateEvents: i }
  } = W(Je), s = W(Hi), a = W(
    (T) => T.weekViewLayout.selectedDuplicateEventCid
  ), [, c] = zo(), l = vm(), { width: f } = re(Di), [u, p] = se(null), { columns: h, rows: m } = e, w = h.length - 1, v = Y(
    () => h.map(
      ({ date: T }) => t.filter(Zc(_e(T), Re(T))).map((k) => k.clone())
    ).map(
      (T, k) => gm(
        T,
        nt(h[k].date, Br(m).startTime),
        nt(h[k].date, ft(m).endTime),
        a,
        i
      )
    ),
    [h, m, t, a, i]
  ), _ = Y(() => {
    const T = c(), k = h.findIndex((H) => Rt(H.date, T));
    if (k < 0)
      return null;
    const M = nt(
      h[k].date,
      e.rows[0].startTime
    ), N = nt(
      h[k].date,
      ft(e.rows).endTime
    );
    return {
      startTime: M,
      endTime: N,
      currentDateIndex: k
    };
  }, [h, c, e.rows]), [E, S] = Be(), b = Y(
    () => Ni({
      rowsCount: m.length,
      columnsCount: h.length,
      container: E,
      narrowWeekend: o,
      startDayOfWeek: r
    }),
    [h.length, E, o, m.length, r]
  ), D = Ri({
    type: "timeGrid",
    gridPositionFinder: b,
    selectionSorter: Vr.sortSelection,
    dateGetter: Vr.getDateFromCollection,
    dateCollection: e
  }), A = Q(() => {
    if ($(_)) {
      const { startTime: T, endTime: k } = _, M = c();
      T <= M && M <= k && p({
        top: Zr(M, T, k),
        now: M
      });
    }
  }, [_, c]);
  return _t(() => {
    var T;
    l() && (((T = _ == null ? void 0 : _.currentDateIndex) != null ? T : -1) >= 0 ? A() : p(null));
  }, [_, l, A]), _m(A, $(_) ? mi : null), /* @__PURE__ */ d("div", {
    className: ha.timegrid
  }, /* @__PURE__ */ d("div", {
    className: ha.scrollArea
  }, /* @__PURE__ */ d(am, {
    timeGridRows: m,
    nowIndicatorState: u
  }), /* @__PURE__ */ d("div", {
    className: y("columns"),
    style: { left: f },
    ref: S,
    onMouseDown: Oi(!n, D)
  }, /* @__PURE__ */ d(jh, {
    timeGridRows: m
  }), /* @__PURE__ */ d(Qh, {
    gridPositionFinder: b,
    timeGridData: e
  }), h.map((T, k) => /* @__PURE__ */ d(Yh, {
    key: T.date.toString(),
    timeGridData: e,
    columnDate: T.date,
    columnWidth: q(T.width),
    columnIndex: k,
    totalUIModels: v,
    gridPositionFinder: b,
    isLastColumn: k === w
  })), s && $(_) && $(u) ? /* @__PURE__ */ d(tm, {
    top: u.top,
    columnWidth: h[0].width,
    columnCount: h.length,
    columnIndex: _.currentDateIndex
  }) : null)));
}
function ym({ isCollapsed: e }) {
  const t = Me(), n = y("icon", {
    "ic-arrow-right": e,
    "ic-arrow-left": !e
  });
  return /* @__PURE__ */ d("button", {
    className: y(Ce("timezone-collapse-button")),
    "aria-expanded": !e,
    onClick: () => t.fire("clickTimezonesCollapseBtn", e)
  }, /* @__PURE__ */ d("span", {
    className: n,
    role: "img"
  }));
}
function ma({ label: e, offset: t, tooltip: n, width: o = 100, left: r }) {
  return /* @__PURE__ */ d("div", {
    title: n,
    className: y(Ce("timezone-label")),
    style: {
      width: q(o),
      height: q(100),
      left: q(r)
    },
    role: "gridcell"
  }, /* @__PURE__ */ d(te, {
    template: "timezoneDisplayLabel",
    param: { displayLabel: e, timezoneOffset: t },
    as: "span"
  }));
}
function wm() {
  const e = W(rm), t = W(qc);
  return Y(() => ({
    showTimezoneCollapseButton: e,
    timezonesCollapsed: t
  }), [e, t]);
}
function el({ top: e }) {
  const t = W(lc), { width: n } = re(Di), o = Bo(), { showTimezoneCollapseButton: r, timezonesCollapsed: i } = wm();
  if (t.length <= 1)
    return null;
  const s = t.map(({ displayLabel: p, timezoneName: h, tooltip: m }) => Fe(p) ? {
    label: null,
    offset: o(h).getTimezoneOffset(),
    tooltip: m != null ? m : h
  } : { label: p, offset: null, tooltip: m != null ? m : h }), [a, ...c] = s, l = c.reverse(), f = i ? 1 : t.length, u = 100 / f;
  return /* @__PURE__ */ d("div", {
    style: {
      top: e,
      width: n
    },
    role: "columnheader",
    className: y("timezone-labels-slot")
  }, !i && l.map((p, h) => {
    var m;
    return /* @__PURE__ */ d(ma, L({
      key: `subTimezone-${(m = p.label) != null ? m : p.offset}`,
      width: u,
      left: u * h
    }, p));
  }), r && /* @__PURE__ */ d(ym, {
    isCollapsed: i
  }), /* @__PURE__ */ d(ma, L({
    width: u,
    left: u * l.length
  }, a)));
}
const Em = {
  MONTH: "month",
  WEEK: "week",
  DAY: "day"
}, Dm = ["milestone", "task"], Sm = ["allday", "time"];
function tl(e, t) {
  const n = [];
  return e === true ? n.push(...Dm) : Array.isArray(e) && n.push(...e), t === true ? n.push(...Sm) : Array.isArray(t) && n.push(...t), n;
}
function Tm(e) {
  const t = W(Go), n = Bo();
  return Y(() => {
    if (t === "Local")
      return e;
    const o = _n(new F()), {
      timedEvents: r = en(),
      totalEvents: i = en()
    } = e.groupBy(
      (s) => s.category === "time" ? "timedEvents" : "totalEvents"
    );
    return r.each((s) => {
      const a = rd(s);
      let c = n(t, a.start), l = n(t, a.end);
      o ? (_n(c) || (c = c.addHours(1)), _n(l) || (l = l.addHours(1))) : (_n(c) && (c = c.addHours(-1)), _n(l) && (l = l.addHours(-1))), a.start = c, a.end = l, i.add(a);
    }), i;
  }, [e, t, n]);
}
function Fi(e, ...t) {
  const n = Y(
    () => e.events.filter(rt.and(...t)),
    [e.events, t]
  ), o = Tm(n);
  return Y(
    () => ce(L({}, e), {
      events: o
    }),
    [e, o]
  );
}
function bm(e) {
  return /^(event|gridSelection)\/timeGrid/.test(e != null ? e : "");
}
function nl(e, t) {
  wt($t, ({ y: n, draggingItemType: o, draggingState: r }) => {
    if ($(e) && bm(o) && r === Ze.DRAGGING && $(n)) {
      const { offsetTop: i, offsetHeight: s, scrollHeight: a } = e, c = Math.floor(a / t), l = i + s;
      if (n < i + c) {
        const f = n - (i + c);
        e.scrollTop = Math.max(0, e.scrollTop + f);
      } else if (n > l - c) {
        const f = n - (l - c);
        e.scrollTop = Math.min(s, e.scrollTop + f);
      }
    }
  });
}
function Cm(e) {
  var t, n, o;
  return (o = (n = (t = e.weekViewLayout) == null ? void 0 : t.dayGridRows) == null ? void 0 : n.time) == null ? void 0 : o.height;
}
function ol(e) {
  const t = W(Cm), [n, o] = se(null);
  return _t(() => {
    $(t) && e && o(e.offsetTop);
  }, [t, e]), n;
}
function km() {
  const e = W(Fo), t = W(Je), { dayGridRows: n, lastPanelType: o } = W(sc), { renderDate: r } = W(cn);
  return Y(
    () => ({
      calendar: e,
      options: t,
      gridRowLayout: n,
      lastPanelType: o,
      renderDate: r
    }),
    [e, t, n, o, r]
  );
}
function rl() {
  var H, G;
  const { calendar: e, options: t, gridRowLayout: n, lastPanelType: o, renderDate: r } = km(), i = W(Go), s = re(Q((j) => j.week.dayGridLeft.width, [])), [a, c] = Be(), l = t.week, { narrowWeekend: f, startDayOfWeek: u, workweek: p, hourStart: h, hourEnd: m, eventView: w, taskView: v } = l, _ = Y(() => [r], [r]), E = Qa(_, (G = (H = t.week) == null ? void 0 : H.dayNames) != null ? G : []), { rowStyleInfo: S, cellWidthMap: b } = yi(
    _.length,
    f,
    u,
    p
  ), D = Fi(e, t.eventFilter), A = Y(() => {
    const j = () => i === "Local" ? [_e(_[0]), Re(_[0])] : [_e(Pt(_[0], -1)), Re(Pt(_[0], 1))], [I, z] = j();
    return bc(_, D, {
      narrowWeekend: f,
      hourStart: h,
      hourEnd: m,
      weekStartDate: I,
      weekEndDate: z
    });
  }, [D, _, m, h, f, i]), T = Y(
    () => Nc(_, {
      hourStart: h,
      hourEnd: m,
      narrowWeekend: f
    }),
    [_, m, h, f]
  ), k = tl(v, w), M = k.map((j) => {
    var z, R;
    if (j === "time")
      return null;
    const I = j;
    return /* @__PURE__ */ d(Kt, {
      key: I,
      name: I,
      resizable: I !== o
    }, I === "allday" ? /* @__PURE__ */ d(Gc, {
      events: A[I],
      rowStyleInfo: S,
      gridColWidthMap: b,
      weekDates: _,
      height: (z = n[I]) == null ? void 0 : z.height,
      options: l
    }) : /* @__PURE__ */ d(Bc, {
      category: I,
      events: A[I],
      weekDates: _,
      height: (R = n[I]) == null ? void 0 : R.height,
      options: l,
      gridColWidthMap: b
    }));
  });
  nl(a, T.rows.length);
  const N = ol(a);
  return /* @__PURE__ */ d(Li, {
    className: y("day-view"),
    autoAdjustPanels: true
  }, /* @__PURE__ */ d(Kt, {
    name: "day-view-day-names",
    initialHeight: Fa + Ga
  }, /* @__PURE__ */ d(Si, {
    type: "week",
    dayNames: E,
    marginLeft: s,
    rowStyleInfo: S
  })), M, k.includes("time") ? /* @__PURE__ */ d(Kt, {
    name: "time",
    autoSize: 1,
    ref: c
  }, /* @__PURE__ */ d(Qc, {
    events: A.time,
    timeGridData: T
  }), /* @__PURE__ */ d(el, {
    top: N
  })) : null);
}
function Nm({ rowIndex: e, weekDates: t, narrowWeekend: n }) {
  const o = W(
    Q(
      (r) => r.gridSelection.accumulated.dayGridMonth.map(
        (i) => ko.calculateSelection(i, e, t.length)
      ),
      [e, t]
    )
  );
  return /* @__PURE__ */ d("div", {
    className: y("accumulated-grid-selection")
  }, o.map(
    (r) => r ? /* @__PURE__ */ d(Ii, {
      type: "accumulated",
      gridSelectionData: r,
      weekDates: t,
      narrowWeekend: n
    }) : null
  ));
}
function Im({ type: e, number: t, onClickButton: n, className: o }) {
  const { reset: r } = Se("dnd"), i = (c) => {
    c.stopPropagation();
  }, s = () => {
    r(), n();
  }, a = `monthGrid${e === On.header ? "Header" : "Footer"}Exceed`;
  return /* @__PURE__ */ d("button", {
    type: "button",
    onMouseDown: i,
    onClick: s,
    className: o
  }, /* @__PURE__ */ d(te, {
    template: a,
    param: t
  }));
}
function Mm({
  date: e,
  theme: t,
  renderDate: n,
  isToday: o
}) {
  const r = e.getDay(), s = n.getMonth() === e.getMonth(), {
    common: { holiday: a, saturday: c, today: l, dayName: f },
    month: { dayExceptThisMonth: u, holidayExceptThisMonth: p }
  } = t;
  return o ? l.color : _i(r) ? s ? a.color : p.color : vi(r) ? s ? c.color : u.color : s ? f.color : u.color;
}
function Am() {
  const e = kf(), t = pc();
  return Y(() => ({ common: e, month: t }), [e, t]);
}
function ga({
  type: e = On.header,
  exceedCount: t = 0,
  date: n,
  onClickExceedCount: o
}) {
  const { renderDate: r } = W(cn), [, i] = zo(), s = Am(), a = s.month.gridCell[`${e}Height`], c = ge(n, "YYYYMMDD"), l = ge(i(), "YYYYMMDD"), f = c === l, u = {
    date: ge(n, "YYYY-MM-DD"),
    day: n.getDay(),
    hiddenEventCount: t,
    isOtherMonth: n.getMonth() !== r.getMonth(),
    isToday: c === l,
    month: n.getMonth(),
    ymd: c
  }, p = { color: Mm({ date: n, theme: s, isToday: f, renderDate: r }) }, h = `monthGrid${$o(e)}`;
  return V(a) ? null : /* @__PURE__ */ d("div", {
    className: y(`grid-cell-${e}`),
    style: { height: a }
  }, /* @__PURE__ */ d("span", {
    className: y("grid-cell-date"),
    style: p
  }, /* @__PURE__ */ d(te, {
    template: h,
    param: u
  })), t ? /* @__PURE__ */ d(Im, {
    type: e,
    number: t,
    onClickButton: o,
    className: y("grid-cell-more-events")
  }) : null);
}
function xm({
  grid: e,
  offsetWidth: t,
  eventLength: n,
  layerSize: o
}) {
  const r = nc(e).height + vr * 2;
  let i = t + vr * 2;
  const { width: s, height: a } = o, c = 10;
  i = Math.max(i, Nu);
  let l = uo + Fr + vr;
  const f = Jt + Oo;
  return n <= c ? l += f * n : l += f * c, s && (i = s), a && (l = a), (isNaN(l) || l < r) && (l = r), { width: i, height: l };
}
function Om(e, t, n) {
  const {
    width: o,
    height: r,
    left: i,
    top: s
  } = t, { width: a, height: c } = e, l = i + o, f = s + r;
  let u = n.left + n.width / 2 - a / 2, { top: p } = n;
  const h = u < i, m = u + a > l, w = p < s, v = p + c > f;
  return h && (u = i), m && (u = l - a), w && (p = s), v && (p = f - c), { top: p + window.scrollY, left: u + window.scrollX };
}
function Rm({
  layoutContainer: e,
  cell: t,
  popupSize: n
}) {
  const o = e.getBoundingClientRect(), r = t.getBoundingClientRect(), i = Om(n, o, r);
  return L(L({}, n), i);
}
function Pm(e, t, n) {
  const { width: o, height: r } = re(gf), [i, s] = Be(), [a, c] = se(null);
  return oe(() => {
    if (n && t && i) {
      const l = xm({
        grid: t,
        offsetWidth: i.offsetWidth,
        eventLength: e,
        layerSize: {
          width: o,
          height: r
        }
      }), f = Rm({
        cell: i,
        layoutContainer: n,
        popupSize: l
      });
      c(f);
    }
  }, [n, i, e, t, o, r]), { popupPosition: a, containerRefCallback: s };
}
function Lm(e) {
  return e.month.weekend.backgroundColor;
}
function $m({ date: e, events: t = [], style: n, parentContainer: o, contentAreaHeight: r }) {
  const i = Ht(), { showSeeMorePopup: s } = Se("popup"), a = re(Lm), { popupPosition: c, containerRefCallback: l } = Pm(
    t.length,
    o,
    i
  ), f = Q(() => {
    c && s({
      date: e,
      popupPosition: c,
      events: t
    });
  }, [e, t, c, s]), u = Dc(
    t,
    r,
    Jt + Oo
  );
  return /* @__PURE__ */ d("div", {
    className: y("daygrid-cell"),
    style: ce(L({}, n), { backgroundColor: ze(e.getDay()) ? a : "inherit" }),
    ref: l
  }, /* @__PURE__ */ d(ga, {
    type: On.header,
    exceedCount: u,
    date: e,
    onClickExceedCount: f
  }), /* @__PURE__ */ d(ga, {
    type: On.footer,
    exceedCount: u,
    date: e,
    onClickExceedCount: f
  }));
}
const Hm = ln(function({
  week: t,
  rowInfo: n,
  gridDateEventModelMap: o = {},
  contentAreaHeight: r
}) {
  const [i, s] = Be(), a = re(Q((c) => c.common.border, []));
  return /* @__PURE__ */ d("div", {
    className: y("weekday-grid"),
    style: { borderTop: a },
    ref: s
  }, t.map((c, l) => {
    const f = c.getDay(), { width: u, left: p } = n[l], h = ge(_e(c), "YYYYMMDD");
    return /* @__PURE__ */ d($m, {
      key: `daygrid-cell-${f}`,
      date: c,
      style: {
        width: q(u),
        left: q(p)
      },
      parentContainer: i,
      events: o[h],
      contentAreaHeight: r
    });
  }));
});
function Fm({ weekDates: e, narrowWeekend: t, rowIndex: n }) {
  const o = W(
    Q(
      (r) => ko.calculateSelection(
        r.gridSelection.dayGridMonth,
        n,
        e.length
      ),
      [n, e.length]
    )
  );
  return V(o) ? null : /* @__PURE__ */ d(Ii, {
    type: "month",
    gridSelectionData: o,
    weekDates: e,
    narrowWeekend: t
  });
}
const Gm = ln(function({
  contentAreaHeight: t,
  eventHeight: n = it,
  events: o,
  name: r,
  className: i
}) {
  const { headerHeight: s } = re(fc), a = o.filter(Ci(t, n + Oo)).map((c) => /* @__PURE__ */ d(Dt, {
    key: `${r}-DayEvent-${c.cid()}`,
    uiModel: c,
    eventHeight: n,
    headerHeight: s != null ? s : Ro
  }));
  return /* @__PURE__ */ d("div", {
    className: i
  }, a);
});
function Bm({
  dateMatrix: e,
  rowInfo: t,
  gridPositionFinder: n,
  rowIndex: o
}) {
  const r = Me(), {
    isDraggingEnd: i,
    isDraggingCanceled: s,
    draggingEvent: a,
    clearDraggingEvent: c
  } = fn("dayGrid", "move"), [l, f] = dn(n), u = Y(() => {
    var h, m;
    let p = null;
    return a && (l == null ? void 0 : l.rowIndex) === o && (p = a, p.left = t[(h = l == null ? void 0 : l.columnIndex) != null ? h : 0].left, p.width = t[(m = l == null ? void 0 : l.columnIndex) != null ? m : 0].width), p;
  }, [a, l == null ? void 0 : l.rowIndex, l == null ? void 0 : l.columnIndex, o, t]);
  return un(() => {
    if (!s && $(u) && $(l)) {
      const h = u.model.getStarts(), m = u.duration(), w = e[l.rowIndex][l.columnIndex], v = wi(w, h) * ht, _ = new F(h.getTime() + v), E = new F(_.getTime() + m);
      r.fire("beforeUpdateEvent", {
        event: u.model.toEventObject(),
        changes: {
          start: _,
          end: E
        }
      });
    }
    c(), f();
  }, i), u;
}
function zm({ dateMatrix: e, gridPositionFinder: t, rowInfo: n, rowIndex: o }) {
  const r = Bm({
    dateMatrix: e,
    rowInfo: n,
    gridPositionFinder: t,
    rowIndex: o
  });
  return V(r) ? null : /* @__PURE__ */ d(Dt, {
    uiModel: r,
    movingLeft: r.left,
    eventHeight: it,
    headerHeight: fi + Ro
  });
}
function _a(e, t) {
  const n = Math.max(Co(e.getStarts(), t), 0), o = Co(e.getEnds(), t);
  return {
    startColumnIndex: n,
    endColumnIndex: o
  };
}
function Um({
  dateMatrix: e,
  gridPositionFinder: t,
  renderedUIModels: n,
  cellWidthMap: o,
  rowIndex: r
}) {
  const i = Me(), {
    isDraggingEnd: s,
    isDraggingCanceled: a,
    draggingEvent: c,
    clearDraggingEvent: l
  } = fn("dayGrid", "resize"), [f, u] = dn(t), [p, h] = se(null), m = Q(() => {
    h(null), u(), l();
  }, [u, l]), w = Y(() => {
    if (V(c))
      return null;
    const _ = n.map(
      ({ uiModels: A }) => A.filter(
        (T) => T.cid() === c.cid()
      )
    ), E = _.findIndex((A) => A.length > 0), S = hi(_, (A) => A.length > 0), b = _a(
      _[E][0],
      e[E]
    ), D = _a(
      _[S][0],
      e[S]
    );
    return {
      eventStartDateColumnIndex: b.startColumnIndex,
      eventStartDateRowIndex: E,
      eventEndDateColumnIndex: D.endColumnIndex,
      eventEndDateRowIndex: S,
      resizeTargetUIModelRows: _
    };
  }, [e, n, c]), v = $(w) && $(c) && $(f);
  return oe(() => {
    if (v && r === w.eventStartDateRowIndex) {
      const { eventStartDateRowIndex: _, eventStartDateColumnIndex: E } = w, S = w.resizeTargetUIModelRows[_][0].clone();
      let b;
      _ === f.rowIndex ? b = o[E][Math.max(E, f.columnIndex)] : _ > f.rowIndex ? b = o[E][E] : (b = o[E][e[r].length - 1], S.setUIProps({ exceedRight: true })), h([S, b]);
    }
  }, [w, v, o, f, e, r]), oe(() => {
    if (v && w.eventStartDateRowIndex < r && r < f.rowIndex) {
      const _ = c.clone();
      _.setUIProps({ left: 0, exceedLeft: true, exceedRight: true }), h([_, "100%"]);
    }
  }, [w, v, f, c, r]), oe(() => {
    if (v && w.eventStartDateRowIndex < f.rowIndex && r === f.rowIndex) {
      const _ = c.clone();
      _.setUIProps({ left: 0, exceedLeft: true }), h([_, o[0][f.columnIndex]]);
    }
  }, [
    w,
    v,
    o,
    f,
    c,
    r
  ]), oe(() => {
    v && r > w.eventStartDateRowIndex && r > f.rowIndex && h(null);
  }, [v, f, w, r]), un(() => {
    if (v) {
      const { eventStartDateColumnIndex: _, eventStartDateRowIndex: E } = w;
      if (!a && (f.rowIndex === E && f.columnIndex >= _ || f.rowIndex > E)) {
        const b = e[f.rowIndex][f.columnIndex];
        i.fire("beforeUpdateEvent", {
          event: c.model.toEventObject(),
          changes: {
            end: b
          }
        });
      }
    }
    m();
  }, s), p;
}
function Wm({
  dateMatrix: e,
  cellWidthMap: t,
  gridPositionFinder: n,
  renderedUIModels: o,
  rowIndex: r
}) {
  const i = Um({
    dateMatrix: e,
    gridPositionFinder: n,
    cellWidthMap: t,
    renderedUIModels: o,
    rowIndex: r
  });
  if (V(i))
    return null;
  const [s, a] = i;
  return /* @__PURE__ */ d("div", {
    className: y("weekday-events")
  }, /* @__PURE__ */ d(Dt, {
    key: `resizing-event-${s.cid()}`,
    uiModel: s,
    eventHeight: Jt,
    headerHeight: fi + Ro,
    resizingWidth: a
  }));
}
const Ym = 100;
function Vm(e) {
  const t = W(om), { headerHeight: n, footerHeight: o } = re(fc), r = ee(null), [i, s] = se(0);
  return oe(() => {
    if (r.current) {
      const a = nc(r.current).height, c = fi + (n != null ? n : Ro), l = o != null ? o : 0, f = a - c - l, u = t * (e + Oo);
      s(Math.min(f, u));
    }
  }, [o, n, e, t]), { ref: r, cellContentAreaHeight: i };
}
function jm({ dateMatrix: e = [], rowInfo: t = [], cellWidthMap: n = [] }) {
  const [o, r] = Be(), i = W(Fo), { ref: s, cellContentAreaHeight: a } = Vm(Jt), { eventFilter: c, month: l, isReadOnly: f } = W(Je), { narrowWeekend: u, startDayOfWeek: p } = l, h = Ym / e.length, m = Y(
    () => Ni({
      container: o,
      rowsCount: e.length,
      columnsCount: e[0].length,
      narrowWeekend: u,
      startDayOfWeek: p
    }),
    [e, o, u, p]
  ), w = Fi(i, c), v = Y(
    () => e.map((E) => Zf(E, w, u)),
    [w, e, u]
  ), _ = Ri({
    type: "dayGridMonth",
    gridPositionFinder: m,
    dateCollection: e,
    dateGetter: ko.getDateFromCollection,
    selectionSorter: ko.sortSelection
  });
  return /* @__PURE__ */ d("div", {
    ref: r,
    onMouseDown: Oi(!f, _),
    className: y("month-daygrid")
  }, e.map((E, S) => {
    const { uiModels: b, gridDateEventModelMap: D } = v[S];
    return /* @__PURE__ */ d("div", {
      key: `dayGrid-events-${S}`,
      className: y("month-week-item"),
      style: { height: q(h) },
      ref: s
    }, /* @__PURE__ */ d("div", {
      className: y("weekday")
    }, /* @__PURE__ */ d(Hm, {
      gridDateEventModelMap: D,
      week: E,
      rowInfo: t,
      contentAreaHeight: a
    }), /* @__PURE__ */ d(Gm, {
      name: "month",
      events: b,
      contentAreaHeight: a,
      eventHeight: Jt,
      className: y("weekday-events")
    }), /* @__PURE__ */ d(Fm, {
      weekDates: E,
      narrowWeekend: u,
      rowIndex: S
    }), /* @__PURE__ */ d(Nm, {
      rowIndex: S,
      weekDates: E,
      narrowWeekend: u
    })), /* @__PURE__ */ d(Wm, {
      dateMatrix: e,
      gridPositionFinder: m,
      rowIndex: S,
      cellWidthMap: n,
      renderedUIModels: v
    }), /* @__PURE__ */ d(zm, {
      dateMatrix: e,
      gridPositionFinder: m,
      rowIndex: S,
      rowInfo: t
    }));
  }));
}
function Xm(e) {
  const { dayNames: t, startDayOfWeek: n, workweek: o } = e.month;
  return [...Array(7)].map((s, a) => (n + a) % 7).map((s) => ({
    day: s,
    label: $o(t[s])
  })).filter((s) => o ? !ze(s.day) : true);
}
function il() {
  const e = W(Je), { renderDate: t } = W(cn), n = Xm(e), o = e.month, { narrowWeekend: r, startDayOfWeek: i, workweek: s } = o, a = Y(
    () => Cc(t, o),
    [o, t]
  ), { rowStyleInfo: c, cellWidthMap: l } = Y(
    () => yi(n.length, r, i, s),
    [n.length, r, i, s]
  ), f = c.map((u, p) => ce(L({}, u), {
    date: a[0][p]
  }));
  return /* @__PURE__ */ d(Li, {
    className: y("month")
  }, /* @__PURE__ */ d(Si, {
    type: "month",
    dayNames: n,
    options: o,
    rowStyleInfo: c
  }), /* @__PURE__ */ d(jm, {
    dateMatrix: a,
    rowInfo: f,
    cellWidthMap: l
  }));
}
function Km() {
  const e = W(Je), t = W(Fo), { dayGridRows: n, lastPanelType: o } = W(sc), { renderDate: r } = W(cn);
  return Y(
    () => ({
      options: e,
      calendar: t,
      gridRowLayout: n,
      lastPanelType: o,
      renderDate: r
    }),
    [t, n, o, e, r]
  );
}
function sl() {
  var G, j;
  const { options: e, calendar: t, gridRowLayout: n, lastPanelType: o, renderDate: r } = Km(), i = re(Q((I) => I.week.dayGridLeft.width, [])), s = W(Go), [a, c] = Be(), l = e.week, { narrowWeekend: f, startDayOfWeek: u, workweek: p, hourStart: h, hourEnd: m, eventView: w, taskView: v } = l, _ = Y(() => kc(r, l), [r, l]), E = Qa(_, (j = (G = e.week) == null ? void 0 : G.dayNames) != null ? j : []), { rowStyleInfo: S, cellWidthMap: b } = yi(
    _.length,
    f,
    u,
    p
  ), D = Fi(t, e.eventFilter), A = Y(() => {
    const I = () => s === "Local" ? [_e(Br(_)), Re(ft(_))] : [_e(Pt(Br(_), -1)), Re(Pt(ft(_), 1))], [z, R] = I();
    return bc(_, D, {
      narrowWeekend: f,
      hourStart: h,
      hourEnd: m,
      weekStartDate: z,
      weekEndDate: R
    });
  }, [D, m, h, f, s, _]), T = Y(
    () => Nc(_, {
      hourStart: h,
      hourEnd: m,
      narrowWeekend: f
    }),
    [m, h, f, _]
  ), k = tl(v, w), M = k.map((I) => {
    var R, ae;
    if (I === "time")
      return null;
    const z = I;
    return /* @__PURE__ */ d(Kt, {
      name: z,
      key: z,
      resizable: z !== o
    }, z === "allday" ? /* @__PURE__ */ d(Gc, {
      events: A[z],
      rowStyleInfo: S,
      gridColWidthMap: b,
      weekDates: _,
      height: (R = n[z]) == null ? void 0 : R.height,
      options: l
    }) : /* @__PURE__ */ d(Bc, {
      category: z,
      events: A[z],
      weekDates: _,
      height: (ae = n[z]) == null ? void 0 : ae.height,
      options: l,
      gridColWidthMap: b
    }));
  }), N = Y(() => k.includes("time"), [k]);
  nl(a, T.rows.length);
  const H = ol(a);
  return /* @__PURE__ */ d(Li, {
    className: y("week-view"),
    autoAdjustPanels: true
  }, /* @__PURE__ */ d(Kt, {
    name: "week-view-day-names",
    initialHeight: Fa + Ga * 2
  }, /* @__PURE__ */ d(Si, {
    type: "week",
    dayNames: E,
    marginLeft: i,
    options: l,
    rowStyleInfo: S
  })), M, N ? /* @__PURE__ */ d(Kt, {
    name: "time",
    autoSize: 1,
    ref: c
  }, /* @__PURE__ */ d(Qc, {
    events: A.time,
    timeGridData: T
  }), /* @__PURE__ */ d(el, {
    top: H
  })) : null);
}
const qm = {
  month: il,
  week: sl,
  day: rl
};
function Zm() {
  const { currentView: e } = W(cn), t = Y(() => qm[e] || (() => null), [e]);
  return /* @__PURE__ */ d(t, null);
}
var Jm = /acit|ex(?:s|g|n|p|$)|rph|grid|ows|mnc|ntw|ine[ch]|zoo|^ord|^--/i, al = /^(area|base|br|col|embed|hr|img|input|link|meta|param|source|track|wbr)$/, Io = /[\s\n\\/='"\0<>]/, cl = /^xlink:?./, Qm = /["&<]/;
function Cn(e) {
  if (Qm.test(e += "") === false)
    return e;
  for (var t = 0, n = 0, o = "", r = ""; n < e.length; n++) {
    switch (e.charCodeAt(n)) {
      case 34:
        r = "&quot;";
        break;
      case 38:
        r = "&amp;";
        break;
      case 60:
        r = "&lt;";
        break;
      default:
        continue;
    }
    n !== t && (o += e.slice(t, n)), o += r, t = n + 1;
  }
  return n !== t && (o += e.slice(t, n)), o;
}
var va = function(e, t) {
  return String(e).replace(/(\n+)/g, "$1" + (t || "	"));
}, ya = function(e, t, n) {
  return String(e).length > (t || 40) || !n && String(e).indexOf(`
`) !== -1 || String(e).indexOf("<") !== -1;
}, wa = {}, eg = /([A-Z])/g;
function ll(e) {
  var t = "";
  for (var n in e) {
    var o = e[n];
    o != null && o !== "" && (t && (t += " "), t += n[0] == "-" ? n : wa[n] || (wa[n] = n.replace(eg, "-$1").toLowerCase()), t = typeof o == "number" && Jm.test(n) === false ? t + ": " + o + "px;" : t + ": " + o + ";");
  }
  return t || void 0;
}
function Qr(e, t) {
  return Array.isArray(t) ? t.reduce(Qr, e) : t != null && t !== false && e.push(t), e;
}
function Ea() {
  this.__d = true;
}
function ul(e, t) {
  return { __v: e, context: t, props: e.props, setState: Ea, forceUpdate: Ea, __d: true, __h: [] };
}
function Mo(e, t) {
  var n = e.contextType, o = n && t[n.__c];
  return n != null ? o ? o.props.value : n.__ : t;
}
var Cr = [];
function En(e, t, n, o, r, i) {
  if (e == null || typeof e == "boolean")
    return "";
  if (typeof e != "object")
    return typeof e == "function" ? "" : Cn(e);
  var s = n.pretty, a = s && typeof s == "string" ? s : "	";
  if (Array.isArray(e)) {
    for (var c = "", l = 0; l < e.length; l++)
      s && l > 0 && (c += `
`), c += En(e[l], t, n, o, r, i);
    return c;
  }
  if (e.constructor !== void 0)
    return "";
  var f, u = e.type, p = e.props, h = false;
  if (typeof u == "function") {
    if (h = true, !n.shallow || !o && n.renderRootComponent !== false) {
      if (u === ke) {
        var m = [];
        return Qr(m, e.props.children), En(m, t, n, n.shallowHighOrder !== false, r, i);
      }
      var w, v = e.__c = ul(e, t);
      B.__b && B.__b(e);
      var _ = B.__r;
      if (u.prototype && typeof u.prototype.render == "function") {
        var E = Mo(u, t);
        (v = e.__c = new u(p, E)).__v = e, v._dirty = v.__d = true, v.props = p, v.state == null && (v.state = {}), v._nextState == null && v.__s == null && (v._nextState = v.__s = v.state), v.context = E, u.getDerivedStateFromProps ? v.state = Object.assign({}, v.state, u.getDerivedStateFromProps(v.props, v.state)) : v.componentWillMount && (v.componentWillMount(), v.state = v._nextState !== v.state ? v._nextState : v.__s !== v.state ? v.__s : v.state), _ && _(e), w = v.render(v.props, v.state, v.context);
      } else
        for (var S = Mo(u, t), b = 0; v.__d && b++ < 25; )
          v.__d = false, _ && _(e), w = u.call(e.__c, p, S);
      return v.getChildContext && (t = Object.assign({}, t, v.getChildContext())), B.diffed && B.diffed(e), En(w, t, n, n.shallowHighOrder !== false, r, i);
    }
    u = (f = u).displayName || f !== Function && f.name || function(We) {
      var Ye = (Function.prototype.toString.call(We).match(/^\s*function\s+([^( ]+)/) || "")[1];
      if (!Ye) {
        for (var gt = -1, St = Cr.length; St--; )
          if (Cr[St] === We) {
            gt = St;
            break;
          }
        gt < 0 && (gt = Cr.push(We) - 1), Ye = "UnnamedComponent" + gt;
      }
      return Ye;
    }(f);
  }
  var D, A, T = "<" + u;
  if (p) {
    var k = Object.keys(p);
    n && n.sortAttributes === true && k.sort();
    for (var M = 0; M < k.length; M++) {
      var N = k[M], H = p[N];
      if (N !== "children") {
        if (!Io.test(N) && (n && n.allAttributes || N !== "key" && N !== "ref" && N !== "__self" && N !== "__source")) {
          if (N === "defaultValue")
            N = "value";
          else if (N === "defaultChecked")
            N = "checked";
          else if (N === "defaultSelected")
            N = "selected";
          else if (N === "className") {
            if (p.class !== void 0)
              continue;
            N = "class";
          } else
            r && cl.test(N) && (N = N.toLowerCase().replace(/^xlink:?/, "xlink:"));
          if (N === "htmlFor") {
            if (p.for)
              continue;
            N = "for";
          }
          N === "style" && H && typeof H == "object" && (H = ll(H)), N[0] === "a" && N[1] === "r" && typeof H == "boolean" && (H = String(H));
          var G = n.attributeHook && n.attributeHook(N, H, t, n, h);
          if (G || G === "")
            T += G;
          else if (N === "dangerouslySetInnerHTML")
            A = H && H.__html;
          else if (u === "textarea" && N === "value")
            D = H;
          else if ((H || H === 0 || H === "") && typeof H != "function") {
            if (!(H !== true && H !== "" || (H = N, n && n.xml))) {
              T = T + " " + N;
              continue;
            }
            if (N === "value") {
              if (u === "select") {
                i = H;
                continue;
              }
              u === "option" && i == H && p.selected === void 0 && (T += " selected");
            }
            T = T + " " + N + '="' + Cn(H) + '"';
          }
        }
      } else
        D = H;
    }
  }
  if (s) {
    var j = T.replace(/\n\s*/, " ");
    j === T || ~j.indexOf(`
`) ? s && ~T.indexOf(`
`) && (T += `
`) : T = j;
  }
  if (T += ">", Io.test(u))
    throw new Error(u + " is not a valid HTML tag name in " + T);
  var I, z = al.test(u) || n.voidElements && n.voidElements.test(u), R = [];
  if (A)
    s && ya(A) && (A = `
` + a + va(A, a)), T += A;
  else if (D != null && Qr(I = [], D).length) {
    for (var ae = s && ~T.indexOf(`
`), ie = false, Ue = 0; Ue < I.length; Ue++) {
      var X = I[Ue];
      if (X != null && X !== false) {
        var he = En(X, t, n, true, u === "svg" || u !== "foreignObject" && r, i);
        if (s && !ae && ya(he) && (ae = true), he)
          if (s) {
            var st = he.length > 0 && he[0] != "<";
            ie && st ? R[R.length - 1] += he : R.push(he), ie = st;
          } else
            R.push(he);
      }
    }
    if (s && ae)
      for (var de = R.length; de--; )
        R[de] = `
` + a + va(R[de], a);
  }
  if (R.length || A)
    T += R.join("");
  else if (n && n.xml)
    return T.substring(0, T.length - 1) + " />";
  return !z || I || A ? (s && ~T.indexOf(`
`) && (T += `
`), T = T + "</" + u + ">") : T = T.replace(/>$/, " />"), T;
}
var tg = { shallow: true };
Pn.render = Pn;
var ng = function(e, t) {
  return Pn(e, t, tg);
}, Da = [];
function Pn(e, t, n) {
  t = t || {};
  var o = B.__s;
  B.__s = true;
  var r, i = d(ke, null);
  return i.__k = [e], r = n && (n.pretty || n.voidElements || n.sortAttributes || n.shallow || n.allAttributes || n.xml || n.attributeHook) ? En(e, t, n) : Dn(e, t, false, void 0, i), B.__c && B.__c(e, Da), B.__s = o, Da.length = 0, r;
}
function kr(e) {
  return e == null || typeof e == "boolean" ? null : typeof e == "string" || typeof e == "number" || typeof e == "bigint" ? d(null, null, e) : e;
}
function og(e, t) {
  return e === "className" ? "class" : e === "htmlFor" ? "for" : e === "defaultValue" ? "value" : e === "defaultChecked" ? "checked" : e === "defaultSelected" ? "selected" : t && cl.test(e) ? e.toLowerCase().replace(/^xlink:?/, "xlink:") : e;
}
function rg(e, t) {
  return e === "style" && t != null && typeof t == "object" ? ll(t) : e[0] === "a" && e[1] === "r" && typeof t == "boolean" ? String(t) : t;
}
var Sa = Array.isArray, Ta = Object.assign;
function Dn(e, t, n, o, r) {
  if (e == null || e === true || e === false || e === "")
    return "";
  if (typeof e != "object")
    return typeof e == "function" ? "" : Cn(e);
  if (Sa(e)) {
    var i = "";
    r.__k = e;
    for (var s = 0; s < e.length; s++)
      i += Dn(e[s], t, n, o, r), e[s] = kr(e[s]);
    return i;
  }
  if (e.constructor !== void 0)
    return "";
  e.__ = r, B.__b && B.__b(e);
  var a = e.type, c = e.props;
  if (typeof a == "function") {
    var l;
    if (a === ke)
      l = c.children;
    else {
      l = a.prototype && typeof a.prototype.render == "function" ? function(k, M) {
        var N = k.type, H = Mo(N, M), G = new N(k.props, H);
        k.__c = G, G.__v = k, G.__d = true, G.props = k.props, G.state == null && (G.state = {}), G.__s == null && (G.__s = G.state), G.context = H, N.getDerivedStateFromProps ? G.state = Ta({}, G.state, N.getDerivedStateFromProps(G.props, G.state)) : G.componentWillMount && (G.componentWillMount(), G.state = G.__s !== G.state ? G.__s : G.state);
        var j = B.__r;
        return j && j(k), G.render(G.props, G.state, G.context);
      }(e, t) : function(k, M) {
        var N, H = ul(k, M), G = Mo(k.type, M);
        k.__c = H;
        for (var j = B.__r, I = 0; H.__d && I++ < 25; )
          H.__d = false, j && j(k), N = k.type.call(H, k.props, G);
        return N;
      }(e, t);
      var f = e.__c;
      f.getChildContext && (t = Ta({}, t, f.getChildContext()));
    }
    var u = Dn(l = l != null && l.type === ke && l.key == null ? l.props.children : l, t, n, o, e);
    return B.diffed && B.diffed(e), e.__ = void 0, B.unmount && B.unmount(e), u;
  }
  var p, h, m = "<";
  if (m += a, c)
    for (var w in p = c.children, c) {
      var v = c[w];
      if (!(w === "key" || w === "ref" || w === "__self" || w === "__source" || w === "children" || w === "className" && "class" in c || w === "htmlFor" && "for" in c || Io.test(w))) {
        if (v = rg(w = og(w, n), v), w === "dangerouslySetInnerHTML")
          h = v && v.__html;
        else if (a === "textarea" && w === "value")
          p = v;
        else if ((v || v === 0 || v === "") && typeof v != "function") {
          if (v === true || v === "") {
            v = w, m = m + " " + w;
            continue;
          }
          if (w === "value") {
            if (a === "select") {
              o = v;
              continue;
            }
            a !== "option" || o != v || "selected" in c || (m += " selected");
          }
          m = m + " " + w + '="' + Cn(v) + '"';
        }
      }
    }
  var _ = m;
  if (m += ">", Io.test(a))
    throw new Error(a + " is not a valid HTML tag name in " + m);
  var E = "", S = false;
  if (h)
    E += h, S = true;
  else if (typeof p == "string")
    E += Cn(p), S = true;
  else if (Sa(p)) {
    e.__k = p;
    for (var b = 0; b < p.length; b++) {
      var D = p[b];
      if (p[b] = kr(D), D != null && D !== false) {
        var A = Dn(D, t, a === "svg" || a !== "foreignObject" && n, o, e);
        A && (E += A, S = true);
      }
    }
  } else if (p != null && p !== false && p !== true) {
    e.__k = [kr(p)];
    var T = Dn(p, t, a === "svg" || a !== "foreignObject" && n, o, e);
    T && (E += T, S = true);
  }
  if (B.diffed && B.diffed(e), e.__ = void 0, B.unmount && B.unmount(e), S)
    m += E;
  else if (al.test(a))
    return _ + " />";
  return m + "</" + a + ">";
}
Pn.shallowRender = ng;
function ig(e, t, n) {
  var o;
  n = n || null;
  for (o in e)
    if (e.hasOwnProperty(o) && t.call(n, e[o], o, e) === false)
      break;
}
var dl = ig, sg = dl;
function ag(e, t) {
  var n = document.createElement("img"), o = "";
  return sg(t, function(r, i) {
    o += "&" + i + "=" + r;
  }), o = o.substring(1), n.src = e + "?" + o, n.style.display = "none", document.body.appendChild(n), document.body.removeChild(n), n;
}
var cg = ag, lg = Fe, ug = cg, dg = 7 * 24 * 60 * 60 * 1e3;
function fg(e) {
  var t = new Date().getTime();
  return t - e > dg;
}
function pg(e, t) {
  var n = "https://www.google-analytics.com/collect", o = location.hostname, r = "event", i = "use", s = "TOAST UI " + e + " for " + o + ": Statistics", a = window.localStorage.getItem(s);
  !lg(window.tui) && window.tui.usageStatistics === false || a && !fg(a) || (window.localStorage.setItem(s, new Date().getTime()), setTimeout(function() {
    (document.readyState === "interactive" || document.readyState === "complete") && ug(n, {
      v: 1,
      t: r,
      tid: t,
      cid: o,
      dp: o,
      dh: e,
      el: e,
      ec: i
    });
  }, 1e3));
}
var hg = pg;
function ba({ theme: e, store: t, eventBus: n, children: o }) {
  return /* @__PURE__ */ d(lf, {
    value: n
  }, /* @__PURE__ */ d(Cf, {
    store: e
  }, /* @__PURE__ */ d(rf, {
    store: t
  }, /* @__PURE__ */ d(nh, null, o))));
}
const mg = "UA-129951699-1";
function gg(e, t) {
  var n = Object.prototype.hasOwnProperty, o, r, i, s;
  for (i = 1, s = arguments.length; i < s; i += 1) {
    o = arguments[i];
    for (r in o)
      n.call(o, r) && (e[r] = o[r]);
  }
  return e;
}
var _g = gg;
function vg(e) {
  return e === null;
}
var yg = vg, wg = Fe, Eg = yg;
function Dg(e) {
  return !wg(e) && !Eg(e);
}
var Sg = Dg;
function Tg(e) {
  return e instanceof Array;
}
var fl = Tg;
function bg(e) {
  return e instanceof Function;
}
var Cg = bg;
function kg(e, t, n) {
  var o = 0, r = e.length;
  for (n = n || null; o < r && t.call(n, e[o], o, e) !== false; o += 1)
    ;
}
var Ng = kg, Ig = fl, Mg = Ng, Ag = dl;
function xg(e, t, n) {
  Ig(e) ? Mg(e, t, n) : Ag(e, t, n);
}
var Og = xg, Rg = _g, pl = Sg, Gi = Ie, Bi = po, Pg = fl, zi = Cg, pt = Og, hl = /\s+/g;
function ue() {
  this.events = null, this.contexts = null;
}
ue.mixin = function(e) {
  Rg(e.prototype, ue.prototype);
};
ue.prototype._getHandlerItem = function(e, t) {
  var n = { handler: e };
  return t && (n.context = t), n;
};
ue.prototype._safeEvent = function(e) {
  var t = this.events, n;
  return t || (t = this.events = {}), e && (n = t[e], n || (n = [], t[e] = n), t = n), t;
};
ue.prototype._safeContext = function() {
  var e = this.contexts;
  return e || (e = this.contexts = []), e;
};
ue.prototype._indexOfContext = function(e) {
  for (var t = this._safeContext(), n = 0; t[n]; ) {
    if (e === t[n][0])
      return n;
    n += 1;
  }
  return -1;
};
ue.prototype._memorizeContext = function(e) {
  var t, n;
  !pl(e) || (t = this._safeContext(), n = this._indexOfContext(e), n > -1 ? t[n][1] += 1 : t.push([e, 1]));
};
ue.prototype._forgetContext = function(e) {
  var t, n;
  !pl(e) || (t = this._safeContext(), n = this._indexOfContext(e), n > -1 && (t[n][1] -= 1, t[n][1] <= 0 && t.splice(n, 1)));
};
ue.prototype._bindEvent = function(e, t, n) {
  var o = this._safeEvent(e);
  this._memorizeContext(n), o.push(this._getHandlerItem(t, n));
};
ue.prototype.on = function(e, t, n) {
  var o = this;
  Gi(e) ? (e = e.split(hl), pt(e, function(r) {
    o._bindEvent(r, t, n);
  })) : Bi(e) && (n = t, pt(e, function(r, i) {
    o.on(i, r, n);
  }));
};
ue.prototype.once = function(e, t, n) {
  var o = this;
  if (Bi(e)) {
    n = t, pt(e, function(i, s) {
      o.once(s, i, n);
    });
    return;
  }
  function r() {
    t.apply(n, arguments), o.off(e, r, n);
  }
  this.on(e, r, n);
};
ue.prototype._spliceMatches = function(e, t) {
  var n = 0, o;
  if (!!Pg(e))
    for (o = e.length; n < o; n += 1)
      t(e[n]) === true && (e.splice(n, 1), o -= 1, n -= 1);
};
ue.prototype._matchHandler = function(e) {
  var t = this;
  return function(n) {
    var o = e === n.handler;
    return o && t._forgetContext(n.context), o;
  };
};
ue.prototype._matchContext = function(e) {
  var t = this;
  return function(n) {
    var o = e === n.context;
    return o && t._forgetContext(n.context), o;
  };
};
ue.prototype._matchHandlerAndContext = function(e, t) {
  var n = this;
  return function(o) {
    var r = e === o.handler, i = t === o.context, s = r && i;
    return s && n._forgetContext(o.context), s;
  };
};
ue.prototype._offByEventName = function(e, t) {
  var n = this, o = zi(t), r = n._matchHandler(t);
  e = e.split(hl), pt(e, function(i) {
    var s = n._safeEvent(i);
    o ? n._spliceMatches(s, r) : (pt(s, function(a) {
      n._forgetContext(a.context);
    }), n.events[i] = []);
  });
};
ue.prototype._offByHandler = function(e) {
  var t = this, n = this._matchHandler(e);
  pt(this._safeEvent(), function(o) {
    t._spliceMatches(o, n);
  });
};
ue.prototype._offByObject = function(e, t) {
  var n = this, o;
  this._indexOfContext(e) < 0 ? pt(e, function(r, i) {
    n.off(i, r);
  }) : Gi(t) ? (o = this._matchContext(e), n._spliceMatches(this._safeEvent(t), o)) : zi(t) ? (o = this._matchHandlerAndContext(t, e), pt(this._safeEvent(), function(r) {
    n._spliceMatches(r, o);
  })) : (o = this._matchContext(e), pt(this._safeEvent(), function(r) {
    n._spliceMatches(r, o);
  }));
};
ue.prototype.off = function(e, t) {
  Gi(e) ? this._offByEventName(e, t) : arguments.length ? zi(e) ? this._offByHandler(e) : Bi(e) && this._offByObject(e, t) : (this.events = {}, this.contexts = []);
};
ue.prototype.fire = function(e) {
  this.invoke.apply(this, arguments);
};
ue.prototype.invoke = function(e) {
  var t, n, o, r;
  if (!this.hasListener(e))
    return true;
  for (t = this._safeEvent(e), n = Array.prototype.slice.call(arguments, 1), o = 0; t[o]; ) {
    if (r = t[o], r.handler.apply(r.context, n) === false)
      return false;
    o += 1;
  }
  return true;
};
ue.prototype.hasListener = function(e) {
  return this.getListenerLength(e) > 0;
};
ue.prototype.getListenerLength = function(e) {
  var t = this._safeEvent(e);
  return t.length;
};
var Lg = ue;
class $g extends Lg {
  on(t, n) {
    return super.on(t, n), this;
  }
  off(t, n) {
    return super.off(t, n), this;
  }
  fire(t, ...n) {
    return super.fire(t, ...n), this;
  }
  once(t, n) {
    return super.once(t, n), this;
  }
}
class Yo {
  constructor(t, n = {}) {
    var o;
    this.container = Ie(t) ? (o = document == null ? void 0 : document.querySelector(t)) != null ? o : null : t, this.theme = bf(n.theme), this.eventBus = new $g(), this.store = of(n), this.renderRange = this.calculateRenderRange(_e()), sf(), this.getStoreState().options.usageStatistics === true && hg("calendar", mg);
  }
  getStoreState(t) {
    const n = this.store.getState();
    return t ? n[t] : n;
  }
  getStoreDispatchers(t) {
    const n = this.store.getState().dispatch;
    return t ? n[t] : n;
  }
  destroy() {
    this.container && Tp(this.container), this.store.clearListeners(), this.theme.clearListeners(), this.eventBus.off(), af();
    for (const t in this)
      this.hasOwnProperty(t) && delete this[t];
  }
  calculateMonthRenderDate({
    renderDate: t,
    offset: n,
    monthOptions: o
  }) {
    let r = new F(t);
    const { visibleWeeksCount: i } = o;
    i > 0 ? r = Pt(r, n * 7 * i) : r = wd(r, n);
    const s = Cc(r, o), [[a]] = s, c = ft(ft(s));
    return {
      renderDate: r,
      renderRange: { start: a, end: c }
    };
  }
  calculateWeekRenderDate({
    renderDate: t,
    offset: n,
    weekOptions: o
  }) {
    const r = new F(t);
    r.addDate(n * 7);
    const i = kc(r, o), [s] = i, a = ft(i);
    return {
      renderDate: r,
      renderRange: { start: s, end: a }
    };
  }
  calculateDayRenderDate({ renderDate: t, offset: n }) {
    const o = new F(t);
    o.addDate(n);
    const r = _e(o), i = Re(o);
    return {
      renderDate: o,
      renderRange: { start: r, end: i }
    };
  }
  move(t) {
    if (V(t))
      return;
    const { currentView: n, renderDate: o } = this.getStoreState().view, { options: r } = this.getStoreState(), { setRenderDate: i } = this.getStoreDispatchers().view, s = new F(o);
    let a = {
      renderDate: s,
      renderRange: { start: new F(s), end: new F(s) }
    };
    n === "month" ? a = this.calculateMonthRenderDate({
      renderDate: o,
      offset: t,
      monthOptions: r.month
    }) : n === "week" ? a = this.calculateWeekRenderDate({
      renderDate: o,
      offset: t,
      weekOptions: r.week
    }) : n === "day" && (a = this.calculateDayRenderDate({ renderDate: o, offset: t })), i(a.renderDate), this.renderRange = a.renderRange;
  }
  createEvents(t) {
    const { createEvents: n } = this.getStoreDispatchers("calendar");
    n(t);
  }
  getEventModel(t, n) {
    const { events: o } = this.getStoreState("calendar");
    return o.find(
      ({ id: r, calendarId: i }) => r === t && i === n
    );
  }
  getEvent(t, n) {
    var o, r;
    return (r = (o = this.getEventModel(t, n)) == null ? void 0 : o.toEventObject()) != null ? r : null;
  }
  updateEvent(t, n, o) {
    const { updateEvent: r } = this.getStoreDispatchers("calendar"), i = this.getEventModel(t, n);
    i && r({ event: i, eventData: o });
  }
  deleteEvent(t, n) {
    const { deleteEvent: o } = this.getStoreDispatchers("calendar"), r = this.getEventModel(t, n);
    r && o(r);
  }
  setCalendarVisibility(t, n) {
    const { setCalendarVisibility: o } = this.getStoreDispatchers("calendar"), r = Array.isArray(t) ? t : [t];
    o(r, n);
  }
  render() {
    return $(this.container) && go(
      /* @__PURE__ */ d(ba, {
        theme: this.theme,
        store: this.store,
        eventBus: this.eventBus
      }, this.getComponent()),
      this.container
    ), this;
  }
  renderToString() {
    return Pn(
      /* @__PURE__ */ d(ba, {
        theme: this.theme,
        store: this.store,
        eventBus: this.eventBus
      }, this.getComponent())
    );
  }
  clear() {
    const { clearEvents: t } = this.getStoreDispatchers("calendar");
    t();
  }
  scrollToNow(t = "auto") {
    this.eventBus.fire("scrollToNow", t);
  }
  calculateRenderRange(t) {
    const { currentView: n } = this.getStoreState().view, { options: o } = this.getStoreState(), r = new F(t);
    let i = { start: new F(r), end: new F(r) };
    return n === "month" ? i = this.calculateMonthRenderDate({
      renderDate: t,
      offset: 0,
      monthOptions: o.month
    }).renderRange : n === "week" ? i = this.calculateWeekRenderDate({
      renderDate: t,
      offset: 0,
      weekOptions: o.week
    }).renderRange : n === "day" && (i = this.calculateDayRenderDate({ renderDate: t, offset: 0 }).renderRange), i;
  }
  today() {
    const { setRenderDate: t } = this.getStoreDispatchers().view, n = new F();
    t(n), this.renderRange = this.calculateRenderRange(n);
  }
  setDate(t) {
    const { setRenderDate: n } = this.getStoreDispatchers("view"), o = new F(t);
    n(o), this.renderRange = this.calculateRenderRange(o);
  }
  next() {
    this.move(1);
  }
  prev() {
    this.move(-1);
  }
  setCalendarColor(t, n) {
    const { setCalendarColor: o } = this.getStoreDispatchers().calendar;
    o(t, n);
  }
  changeView(t) {
    const { changeView: n } = this.getStoreDispatchers("view");
    n(t), this.renderRange = this.calculateRenderRange(this.getDate());
  }
  getElement(t, n) {
    return this.getEvent(t, n) && this.container ? this.container.querySelector(
      `[data-event-id="${t}"][data-calendar-id="${n}"]`
    ) : null;
  }
  setTheme(t) {
    const { setTheme: n } = this.theme.getState().dispatch;
    n(t);
  }
  getOptions() {
    const { options: t, template: n } = this.getStoreState(), i = this.theme.getState(), r = Kn(i, ["dispatch"]);
    return ce(L({}, t), {
      template: n,
      theme: r
    });
  }
  setOptions(t) {
    const c = t, { theme: n, template: o } = c, r = Kn(c, ["theme", "template"]), { setTheme: i } = this.theme.getState().dispatch, {
      options: { setOptions: s },
      template: { setTemplate: a }
    } = this.getStoreDispatchers();
    $(n) && i(n), $(o) && a(o), s(r);
  }
  getDate() {
    const { renderDate: t } = this.getStoreState().view;
    return t;
  }
  getDateRangeStart() {
    return this.renderRange.start;
  }
  getDateRangeEnd() {
    return this.renderRange.end;
  }
  getViewName() {
    const { currentView: t } = this.getStoreState("view");
    return t;
  }
  setCalendars(t) {
    const { setCalendars: n } = this.getStoreDispatchers().calendar;
    n(t);
  }
  openFormPopup(t) {
    const { showFormPopup: n } = this.getStoreDispatchers().popup, o = new Ei(t), { title: r, location: i, start: s, end: a, isAllday: c, isPrivate: l, state: f } = o;
    n({
      isCreationPopup: true,
      event: o,
      title: r,
      location: i,
      start: s,
      end: a,
      isAllday: c,
      isPrivate: l,
      eventState: f
    });
  }
  clearGridSelections() {
    const { clearAll: t } = this.getStoreDispatchers().gridSelection;
    t();
  }
  fire(t, ...n) {
    return this.eventBus.fire(t, ...n), this;
  }
  off(t, n) {
    return this.eventBus.off(t, n), this;
  }
  on(t, n) {
    return this.eventBus.on(t, n), this;
  }
  once(t, n) {
    return this.eventBus.once(t, n), this;
  }
}
function Hg(e) {
  return !!Object.values(Em).find((t) => t === e);
}
class Ug extends Yo {
  constructor(t, n = {}) {
    super(t, n);
    const { defaultView: o = "week" } = n;
    if (!Hg(o))
      throw new Xu(o);
    this.render();
  }
  getComponent() {
    return /* @__PURE__ */ d(Zm, null);
  }
}
const Calendar = Vue.component("ToastUICalendar", {
  name: "ToastUICalendar",
  props: {
    view: String,
    useFormPopup: {
      type: Boolean,
      default: () => void 0
    },
    useDetailPopup: {
      type: Boolean,
      default: () => void 0
    },
    isReadOnly: {
      type: Boolean,
      default: () => void 0
    },
    usageStatistics: {
      type: Boolean,
      default: () => void 0
    },
    eventFilter: Function,
    week: Object,
    month: Object,
    gridSelection: {
      type: [Object, Boolean],
      default: () => void 0
    },
    timezone: Object,
    theme: Object,
    template: Object,
    calendars: Array,
    events: Array
  },
  data() {
    return {
      calendarInstance: null
    };
  },
  watch: {
    view(value) {
      this.calendarInstance.changeView(value);
    },
    useFormPopup(value) {
      this.calendarInstance.setOptions({ useFormPopup: value });
    },
    useDetailPopup(value) {
      this.calendarInstance.setOptions({ useDetailPopup: value });
    },
    isReadOnly(value) {
      this.calendarInstance.setOptions({ isReadOnly: value });
    },
    eventFilter(value) {
      this.calendarInstance.setOptions({ eventFilter: value });
    },
    week(value) {
      this.calendarInstance.setOptions({ week: value });
    },
    month(value) {
      this.calendarInstance.setOptions({ month: value });
    },
    gridSelection(value) {
      this.calendarInstance.setOptions({ gridSelection: value });
    },
    timezone(value) {
      this.calendarInstance.setOptions({ timezone: value });
    },
    theme(value) {
      this.calendarInstance.setTheme(value);
    },
    template(value) {
      this.calendarInstance.setOptions({ template: value });
    },
    calendars(value) {
      this.calendarInstance.setCalendars(value);
    },
    events(value) {
      this.calendarInstance.clear();
      this.calendarInstance.createEvents(value);
    }
  },
  mounted() {
    this.calendarInstance = new Ug(this.$refs.container, {
      defaultView: this.view,
      useFormPopup: this.useFormPopup,
      useDetailPopup: this.useDetailPopup,
      isReadOnly: this.isReadOnly,
      usageStatistics: this.usageStatistics,
      eventFilter: this.eventFilter,
      week: this.week,
      month: this.month,
      gridSelection: this.gridSelection,
      timezone: this.timezone,
      theme: this.theme,
      template: this.template,
      calendars: this.calendars
    });
    this.addEventListeners();
    this.calendarInstance.createEvents(this.events);
  },
  beforeDestroy() {
    this.calendarInstance.off();
    this.calendarInstance.destroy();
  },
  methods: {
    addEventListeners() {
      Object.keys(this.$listeners).forEach((eventName) => {
        this.calendarInstance.on(eventName, (...args) => this.$emit(eventName, ...args));
      });
    },
    getRootElement() {
      return this.$refs.container;
    },
    getInstance() {
      return this.calendarInstance;
    }
  },
  template: '<div ref="container" class="toastui-vue-calendar" />'
});
export {
  Calendar as default
};
